var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head><script src=\"../scripts/yepnope.1.5.4-min.js\" type=\"text/javascript\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><meta name=\"product\" content=\"MOBPRO\"><meta name=\"release\" content=\"2019\"><meta name=\"book\" content=\"Developer\"><meta name=\"created\" content=\"2019-01-07\"><meta name=\"topicid\" content=\"GUID-00E7F4B8-99DF-4F3F-AFE2-7A95D3046EE3\"><meta name=\"topic-type\" content=\"concept\">\n\
      <title>Tasks/MatchAuxiliaryEffectors.py</title>\n\
   \n\
\n\
<meta name=\"topic-subtype\" content=\"Python\"></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><link rel=\"stylesheet\" type=\"text/css\" href=\"py_ref/navtree.css\"><link rel=\"stylesheet\" type=\"text/css\" href=\"py_ref/doxygen.css\"><link rel=\"stylesheet\" type=\"text/css\" href=\"py_ref/tabs.css\"><link rel=\"stylesheet\" type=\"text/css\" href=\"style/adsk.cpm.css\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script type=\"text/javascript\">\n\
var tocSystemNeedsToBeLoaded = typeof(py_ref_adsk_ref_toc) == \'undefined\';\n\
var weAreIn21 = $(\'div#main.view-active\').length;\n\
var tocPrefix = \'\';\n\
if (weAreIn21)\n\
{ tocPrefix = \'py_ref/\'; }\n\
function py_ref_initializeToc(forceTrigger) {\n\
    py_ref_adsk_ref_toc.initResizable();\n\
    py_ref_adsk_ref_toc.initNavTree(\'_tasks_2_match_auxiliary_effectors_8py-example.html\', tocPrefix);\n\
    dQuery(document).trigger(\'toc_initialized\');\n\
}\n\
if (tocSystemNeedsToBeLoaded)\n\
{\n\
	yepnope([{\n\
	load:[tocPrefix + \'json3.min.js\', tocPrefix + \'jquery.js\', tocPrefix + \'ref-toc-controller.js\', tocPrefix + \'dynsections.js\'],\n\
	complete: function() {\n\
	  if (typeof(dQuery) == \'undefined\')\n\
	  {\n\
	    dQuery = jQuery.noConflict(true);\n\
	  }\n\
	  else { jQuery.noConflict(true); }\n\
	  $(document).ready(py_ref_initializeToc);\n\
	}\n\
 	}])\n\
}\n\
if (!weAreIn21) { // if in AKN...\n\
$(window).load( function() {\n\
    setTimeout( function() {\n\
        var content = $(\'body > div\').not(\'#body-content\');     // take any divs under body that are not id=body-content\n\
        content.each( function() { \n\
            $(this).css( { \'padding-left\': $(this).css(\'margin-left\') } );       // and if they have any padding-left already, move it to margin-left.\n\
        } );\n\
        var width = py_ref_adsk_ref_toc.readFromStorage(\'width\');\n\
        content.css({marginLeft:parseInt(width)+6+\"px\"});\n\
    }, 100);\n\
} ); \n\
}\n\
</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script>\n\
 if (!tocSystemNeedsToBeLoaded) { py_ref_initializeToc(); }\n\
 </script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Tasks/MatchAuxiliaryEffectors.py</h1>\n\
         </div>\n\
\n\
    <div id=\"top\"><!-- Generated by Doxygen 1.8.10 -->\n\
  <div id=\"navrow1\" class=\"tabs\">\n\
    <ul class=\"tablist\">\n\
      <li><a href=\"#!/url=./py_ref/index.html\"><span>Main&#160;Page</span></a></li>\n\
      <li><a href=\"#!/url=./py_ref/modules.html\"><span>Groups</span></a></li>\n\
      <li><a href=\"#!/url=./py_ref/annotated.html\"><span>Classes</span></a></li>\n\
      <li><a href=\"#!/url=./py_ref/examples.html\"><span>Examples</span></a></li>\n\
    </ul>\n\
  </div>\n\
</div><!-- top -->\n\
<div id=\"side-nav\" class=\"ui-resizable side-nav-resizable\">\n\
  <div id=\"nav-tree\">\n\
    <div id=\"nav-tree-contents\">\n\
      <div id=\"nav-sync\" class=\"sync\"></div>\n\
    </div>\n\
  </div>\n\
  <div id=\"splitbar\" style=\"-moz-user-select:none;\" class=\"ui-resizable-handle\">\n\
  </div>\n\
</div>\n\
\n\
<div id=\"doc-content\">\n\
<div class=\"header\">\n\
  <div class=\"headertitle\">\n\
<div class=\"title\">Tasks/MatchAuxiliaryEffectors.py</div>  </div>\n\
</div><!--header-->\n\
<div class=\"contents\">\n\
<div class=\"fragment\"><div class=\"line\"><a name=\"l00001\"></a><span class=\"lineno\">    1</span>&#160;<span class=\"comment\"># Copyright 2010 Autodesk, Inc.  All rights reserved.</span></div>\n\
<div class=\"line\"><a name=\"l00002\"></a><span class=\"lineno\">    2</span>&#160;<span class=\"comment\"># Use of this software is subject to the terms of the Autodesk license agreement </span></div>\n\
<div class=\"line\"><a name=\"l00003\"></a><span class=\"lineno\">    3</span>&#160;<span class=\"comment\"># provided at the time of installation or download, or which otherwise accompanies</span></div>\n\
<div class=\"line\"><a name=\"l00004\"></a><span class=\"lineno\">    4</span>&#160;<span class=\"comment\"># this software in either electronic or hard copy form.</span></div>\n\
<div class=\"line\"><a name=\"l00005\"></a><span class=\"lineno\">    5</span>&#160;<span class=\"comment\">#</span></div>\n\
<div class=\"line\"><a name=\"l00006\"></a><span class=\"lineno\">    6</span>&#160;<span class=\"comment\"># Topic: Auxiliary effectors</span></div>\n\
<div class=\"line\"><a name=\"l00007\"></a><span class=\"lineno\">    7</span>&#160;<span class=\"comment\">#</span></div>\n\
<div class=\"line\"><a name=\"l00008\"></a><span class=\"lineno\">    8</span>&#160;</div>\n\
<div class=\"line\"><a name=\"l00009\"></a><span class=\"lineno\">    9</span>&#160;<span class=\"keyword\">from</span> pyfbsdk <span class=\"keyword\">import</span> *</div>\n\
<div class=\"line\"><a name=\"l00010\"></a><span class=\"lineno\">   10</span>&#160;<span class=\"keyword\">from</span> pyfbsdk_additions <span class=\"keyword\">import</span> *</div>\n\
<div class=\"line\"><a name=\"l00011\"></a><span class=\"lineno\">   11</span>&#160;</div>\n\
<div class=\"line\"><a name=\"l00012\"></a><span class=\"lineno\">   12</span>&#160;<span class=\"comment\"># Function</span></div>\n\
<div class=\"line\"><a name=\"l00013\"></a><span class=\"lineno\">   13</span>&#160;<span class=\"keyword\">def </span>IsAuxIKPivot(pModel):</div>\n\
<div class=\"line\"><a name=\"l00014\"></a><span class=\"lineno\">   14</span>&#160;    <span class=\"keywordflow\">if</span> pModel <span class=\"keywordflow\">and</span> pModel.Is(<a class=\"code\" href=\"#!/url=./py_ref/group__pyfbsdk.html#ga113dbd3cde6a7f5dd0177ce31bcc8675\">FBModelMarker_TypeInfo</a>()):</div>\n\
<div class=\"line\"><a name=\"l00015\"></a><span class=\"lineno\">   15</span>&#160;        lIKSyncProp = pModel.PropertyList.Find(<span class=\"stringliteral\">&quot;IKSync&quot;</span>,<span class=\"keyword\">False</span>)</div>\n\
<div class=\"line\"><a name=\"l00016\"></a><span class=\"lineno\">   16</span>&#160;        lIKDrawLink = pModel.PropertyList.Find(<span class=\"stringliteral\">&quot;DrawLink&quot;</span>,<span class=\"keyword\">False</span>)</div>\n\
<div class=\"line\"><a name=\"l00017\"></a><span class=\"lineno\">   17</span>&#160;        <span class=\"keywordflow\">if</span> lIKSyncProp <span class=\"keywordflow\">and</span> lIKDrawLink <span class=\"keywordflow\">and</span> lIKSyncProp.Data <span class=\"keywordflow\">and</span> lIKDrawLink.Data:</div>\n\
<div class=\"line\"><a name=\"l00018\"></a><span class=\"lineno\">   18</span>&#160;            <span class=\"keywordflow\">return</span> <span class=\"keyword\">True</span></div>\n\
<div class=\"line\"><a name=\"l00019\"></a><span class=\"lineno\">   19</span>&#160;    <span class=\"keywordflow\">return</span> <span class=\"keyword\">False</span></div>\n\
<div class=\"line\"><a name=\"l00020\"></a><span class=\"lineno\">   20</span>&#160;</div>\n\
<div class=\"line\"><a name=\"l00021\"></a><span class=\"lineno\">   21</span>&#160;<span class=\"comment\"># Clear all auxiliary on given effector </span></div>\n\
<div class=\"line\"><a name=\"l00022\"></a><span class=\"lineno\">   22</span>&#160;<span class=\"keyword\">def </span>ClearAuxEffectors(pCharacter, pEffectorId):</div>\n\
<div class=\"line\"><a name=\"l00023\"></a><span class=\"lineno\">   23</span>&#160;    lAuxToClear = []</div>\n\
<div class=\"line\"><a name=\"l00024\"></a><span class=\"lineno\">   24</span>&#160;    <span class=\"keywordflow\">for</span> lSetId <span class=\"keywordflow\">in</span> FBEffectorSetID.values.values():</div>\n\
<div class=\"line\"><a name=\"l00025\"></a><span class=\"lineno\">   25</span>&#160;        <span class=\"comment\"># Default set should not be deleted.</span></div>\n\
<div class=\"line\"><a name=\"l00026\"></a><span class=\"lineno\">   26</span>&#160;        <span class=\"keywordflow\">if</span> lSetId == FBEffectorSetID.FBEffectorSetDefault: <span class=\"keywordflow\">continue</span></div>\n\
<div class=\"line\"><a name=\"l00027\"></a><span class=\"lineno\">   27</span>&#160;</div>\n\
<div class=\"line\"><a name=\"l00028\"></a><span class=\"lineno\">   28</span>&#160;        lAuxEffector = pCharacter.GetEffectorModel(pEffectorId,lSetId)</div>\n\
<div class=\"line\"><a name=\"l00029\"></a><span class=\"lineno\">   29</span>&#160;        <span class=\"keywordflow\">if</span> lAuxEffector: </div>\n\
<div class=\"line\"><a name=\"l00030\"></a><span class=\"lineno\">   30</span>&#160;            lAuxToClear.append(lAuxEffector)</div>\n\
<div class=\"line\"><a name=\"l00031\"></a><span class=\"lineno\">   31</span>&#160;        <span class=\"keywordflow\">else</span>:  <span class=\"keywordflow\">break</span></div>\n\
<div class=\"line\"><a name=\"l00032\"></a><span class=\"lineno\">   32</span>&#160;    </div>\n\
<div class=\"line\"><a name=\"l00033\"></a><span class=\"lineno\">   33</span>&#160;    <span class=\"comment\"># Clear the list</span></div>\n\
<div class=\"line\"><a name=\"l00034\"></a><span class=\"lineno\">   34</span>&#160;    <span class=\"keywordflow\">for</span> lModel <span class=\"keywordflow\">in</span> reversed(lAuxToClear):</div>\n\
<div class=\"line\"><a name=\"l00035\"></a><span class=\"lineno\">   35</span>&#160;        lModel.FBDelete()</div>\n\
<div class=\"line\"><a name=\"l00036\"></a><span class=\"lineno\">   36</span>&#160;</div>\n\
<div class=\"line\"><a name=\"l00037\"></a><span class=\"lineno\">   37</span>&#160;<span class=\"comment\"># Match auxiliary on dst to src character for given effector</span></div>\n\
<div class=\"line\"><a name=\"l00038\"></a><span class=\"lineno\">   38</span>&#160;<span class=\"keyword\">def </span>MatchEffector(pSrcCharacter, pDstCharacter, pEffectorId):</div>\n\
<div class=\"line\"><a name=\"l00039\"></a><span class=\"lineno\">   39</span>&#160;    lDstEffectorModel = pDstCharacter.GetEffectorModel(pEffectorId)</div>\n\
<div class=\"line\"><a name=\"l00040\"></a><span class=\"lineno\">   40</span>&#160;    <span class=\"keywordflow\">if</span> lDstEffectorModel:</div>\n\
<div class=\"line\"><a name=\"l00041\"></a><span class=\"lineno\">   41</span>&#160;        ClearAuxEffectors(pDstCharacter,pEffectorId)</div>\n\
<div class=\"line\"><a name=\"l00042\"></a><span class=\"lineno\">   42</span>&#160;        <span class=\"keywordflow\">for</span> lSetId <span class=\"keywordflow\">in</span> FBEffectorSetID.values.values():</div>\n\
<div class=\"line\"><a name=\"l00043\"></a><span class=\"lineno\">   43</span>&#160;            <span class=\"keywordflow\">if</span> lSetId == FBEffectorSetID.FBEffectorSetDefault: <span class=\"keywordflow\">continue</span></div>\n\
<div class=\"line\"><a name=\"l00044\"></a><span class=\"lineno\">   44</span>&#160;            </div>\n\
<div class=\"line\"><a name=\"l00045\"></a><span class=\"lineno\">   45</span>&#160;            lSrcAuxEffectorModel = pSrcCharacter.GetEffectorModel(pEffectorId,lSetId)</div>\n\
<div class=\"line\"><a name=\"l00046\"></a><span class=\"lineno\">   46</span>&#160;            <span class=\"keywordflow\">if</span> lSrcAuxEffectorModel:</div>\n\
<div class=\"line\"><a name=\"l00047\"></a><span class=\"lineno\">   47</span>&#160;                lIsAuxPivot = IsAuxIKPivot(lSrcAuxEffectorModel)</div>\n\
<div class=\"line\"><a name=\"l00048\"></a><span class=\"lineno\">   48</span>&#160;                <span class=\"keywordflow\">if</span> pDstCharacter.CreateAuxiliary(pEffectorId,lIsAuxPivot) == <span class=\"keyword\">False</span>:</div>\n\
<div class=\"line\"><a name=\"l00049\"></a><span class=\"lineno\">   49</span>&#160;                    <span class=\"keywordflow\">print</span> <span class=\"stringliteral\">&quot;Error!&quot;</span></div>\n\
<div class=\"line\"><a name=\"l00050\"></a><span class=\"lineno\">   50</span>&#160;                    <span class=\"keywordflow\">break</span></div>\n\
<div class=\"line\"><a name=\"l00051\"></a><span class=\"lineno\">   51</span>&#160;                    </div>\n\
<div class=\"line\"><a name=\"l00052\"></a><span class=\"lineno\">   52</span>&#160;                <span class=\"keywordflow\">if</span> lIsAuxPivot:</div>\n\
<div class=\"line\"><a name=\"l00053\"></a><span class=\"lineno\">   53</span>&#160;                    pDstCharacter.GetEffectorModel(pEffectorId,lSetId).IKPivot = lSrcAuxEffectorModel.IKPivot</div>\n\
<div class=\"line\"><a name=\"l00054\"></a><span class=\"lineno\">   54</span>&#160;            <span class=\"keywordflow\">else</span>:</div>\n\
<div class=\"line\"><a name=\"l00055\"></a><span class=\"lineno\">   55</span>&#160;                <span class=\"keywordflow\">break</span></div>\n\
<div class=\"line\"><a name=\"l00056\"></a><span class=\"lineno\">   56</span>&#160;</div>\n\
<div class=\"line\"><a name=\"l00057\"></a><span class=\"lineno\">   57</span>&#160;<span class=\"comment\"># Match dst character auxiliary effectors to src character</span></div>\n\
<div class=\"line\"><a name=\"l00058\"></a><span class=\"lineno\">   58</span>&#160;<span class=\"keyword\">def </span>MatchAuxiliary(pSrcCharacter, pDstCharacter):</div>\n\
<div class=\"line\"><a name=\"l00059\"></a><span class=\"lineno\">   59</span>&#160;    <span class=\"keywordflow\">if</span> pSrcCharacter <span class=\"keywordflow\">and</span> pDstCharacter:</div>\n\
<div class=\"line\"><a name=\"l00060\"></a><span class=\"lineno\">   60</span>&#160;        <span class=\"keywordflow\">for</span> lEffectorId <span class=\"keywordflow\">in</span> FBEffectorId.values.values():</div>\n\
<div class=\"line\"><a name=\"l00061\"></a><span class=\"lineno\">   61</span>&#160;            <span class=\"keywordflow\">if</span> pSrcCharacter.GetEffectorModel(lEffectorId): </div>\n\
<div class=\"line\"><a name=\"l00062\"></a><span class=\"lineno\">   62</span>&#160;                MatchEffector(pSrcCharacter, pDstCharacter,lEffectorId)</div>\n\
<div class=\"line\"><a name=\"l00063\"></a><span class=\"lineno\">   63</span>&#160;        <span class=\"keywordflow\">return</span> <span class=\"keyword\">True</span></div>\n\
<div class=\"line\"><a name=\"l00064\"></a><span class=\"lineno\">   64</span>&#160;    <span class=\"keywordflow\">else</span>:</div>\n\
<div class=\"line\"><a name=\"l00065\"></a><span class=\"lineno\">   65</span>&#160;        <span class=\"keywordflow\">print</span> <span class=\"stringliteral\">&quot;Missing params&quot;</span></div>\n\
<div class=\"line\"><a name=\"l00066\"></a><span class=\"lineno\">   66</span>&#160;    <span class=\"keywordflow\">return</span> <span class=\"keyword\">False</span></div>\n\
<div class=\"line\"><a name=\"l00067\"></a><span class=\"lineno\">   67</span>&#160;</div>\n\
<div class=\"line\"><a name=\"l00068\"></a><span class=\"lineno\">   68</span>&#160;<span class=\"comment\"># Tool</span></div>\n\
<div class=\"line\"><a name=\"l00069\"></a><span class=\"lineno\">   69</span>&#160;gToolName = <span class=\"stringliteral\">&quot;MatchAuxiliaries&quot;</span></div>\n\
<div class=\"line\"><a name=\"l00070\"></a><span class=\"lineno\">   70</span>&#160;gSystem = <a class=\"code\" href=\"#!/url=./py_ref/class_f_b_system.html\">FBSystem</a>()</div>\n\
<div class=\"line\"><a name=\"l00071\"></a><span class=\"lineno\">   71</span>&#160;gScene = gSystem.Scene</div>\n\
<div class=\"line\"><a name=\"l00072\"></a><span class=\"lineno\">   72</span>&#160;gDevelopment = <span class=\"keyword\">True</span></div>\n\
<div class=\"line\"><a name=\"l00073\"></a><span class=\"lineno\">   73</span>&#160;</div>\n\
<div class=\"line\"><a name=\"l00074\"></a><span class=\"lineno\">   74</span>&#160;<span class=\"keyword\">class </span>MatchAuxiliariesTool(<a class=\"code\" href=\"#!/url=./py_ref/class_f_b_tool.html\">FBTool</a>):</div>\n\
<div class=\"line\"><a name=\"l00075\"></a><span class=\"lineno\">   75</span>&#160;    <span class=\"keyword\">def </span>SrcDrop(self,pEvent,pControl):</div>\n\
<div class=\"line\"><a name=\"l00076\"></a><span class=\"lineno\">   76</span>&#160;        <span class=\"keywordflow\">if</span> pEvent.State == FBDragAndDropState.kFBDragAndDropDrag:</div>\n\
<div class=\"line\"><a name=\"l00077\"></a><span class=\"lineno\">   77</span>&#160;            <span class=\"keywordflow\">if</span> pEvent.Components[0].Is(<a class=\"code\" href=\"#!/url=./py_ref/group__pyfbsdk.html#gad0133f3d18aa23715ed0a8d8ae1b43e3\">FBCharacter_TypeInfo</a>()):</div>\n\
<div class=\"line\"><a name=\"l00078\"></a><span class=\"lineno\">   78</span>&#160;                pEvent.Accept()</div>\n\
<div class=\"line\"><a name=\"l00079\"></a><span class=\"lineno\">   79</span>&#160;        <span class=\"keywordflow\">elif</span> pEvent.State == FBDragAndDropState.kFBDragAndDropDrop:</div>\n\
<div class=\"line\"><a name=\"l00080\"></a><span class=\"lineno\">   80</span>&#160;            self.mSrcChar = pEvent.Components[0]</div>\n\
<div class=\"line\"><a name=\"l00081\"></a><span class=\"lineno\">   81</span>&#160;            pControl.Items.removeAll()</div>\n\
<div class=\"line\"><a name=\"l00082\"></a><span class=\"lineno\">   82</span>&#160;            pControl.Items.append(self.mSrcChar.Name)</div>\n\
<div class=\"line\"><a name=\"l00083\"></a><span class=\"lineno\">   83</span>&#160;            </div>\n\
<div class=\"line\"><a name=\"l00084\"></a><span class=\"lineno\">   84</span>&#160;    <span class=\"keyword\">def </span>DstDrop(self,pEvent,pControl):</div>\n\
<div class=\"line\"><a name=\"l00085\"></a><span class=\"lineno\">   85</span>&#160;        <span class=\"keywordflow\">if</span> pEvent.State == FBDragAndDropState.kFBDragAndDropDrag:</div>\n\
<div class=\"line\"><a name=\"l00086\"></a><span class=\"lineno\">   86</span>&#160;            <span class=\"keywordflow\">if</span> pEvent.Components[0].Is(<a class=\"code\" href=\"#!/url=./py_ref/group__pyfbsdk.html#gad0133f3d18aa23715ed0a8d8ae1b43e3\">FBCharacter_TypeInfo</a>()):</div>\n\
<div class=\"line\"><a name=\"l00087\"></a><span class=\"lineno\">   87</span>&#160;                pEvent.Accept()</div>\n\
<div class=\"line\"><a name=\"l00088\"></a><span class=\"lineno\">   88</span>&#160;        <span class=\"keywordflow\">elif</span> pEvent.State == FBDragAndDropState.kFBDragAndDropDrop:</div>\n\
<div class=\"line\"><a name=\"l00089\"></a><span class=\"lineno\">   89</span>&#160;            self.mDstChar = pEvent.Components[0]</div>\n\
<div class=\"line\"><a name=\"l00090\"></a><span class=\"lineno\">   90</span>&#160;            pControl.Items.removeAll()</div>\n\
<div class=\"line\"><a name=\"l00091\"></a><span class=\"lineno\">   91</span>&#160;            pControl.Items.append(self.mDstChar.Name)</div>\n\
<div class=\"line\"><a name=\"l00092\"></a><span class=\"lineno\">   92</span>&#160;            </div>\n\
<div class=\"line\"><a name=\"l00093\"></a><span class=\"lineno\">   93</span>&#160;    <span class=\"keyword\">def </span>__init__(self):</div>\n\
<div class=\"line\"><a name=\"l00094\"></a><span class=\"lineno\">   94</span>&#160;        <a class=\"code\" href=\"#!/url=./py_ref/class_f_b_tool.html#a02929db8bcee91b786c26ef8137b3b1e\">FBTool.__init__</a>(self,gToolName)</div>\n\
<div class=\"line\"><a name=\"l00095\"></a><span class=\"lineno\">   95</span>&#160;        <a class=\"code\" href=\"#!/url=./py_ref/group__pyfbsdk__additions.html#ga56df1c530dbf5a5e7dcf4cf67022b8ff\">FBAddTool</a>(self)</div>\n\
<div class=\"line\"><a name=\"l00096\"></a><span class=\"lineno\">   96</span>&#160;</div>\n\
<div class=\"line\"><a name=\"l00097\"></a><span class=\"lineno\">   97</span>&#160;        self.mSrcChar = <span class=\"keywordtype\">None</span></div>\n\
<div class=\"line\"><a name=\"l00098\"></a><span class=\"lineno\">   98</span>&#160;        self.mDstChar = <span class=\"keywordtype\">None</span></div>\n\
<div class=\"line\"><a name=\"l00099\"></a><span class=\"lineno\">   99</span>&#160;        </div>\n\
<div class=\"line\"><a name=\"l00100\"></a><span class=\"lineno\">  100</span>&#160;        lLblSrcCharacter = <a class=\"code\" href=\"#!/url=./py_ref/class_f_b_label.html\">FBLabel</a>()</div>\n\
<div class=\"line\"><a name=\"l00101\"></a><span class=\"lineno\">  101</span>&#160;        lLblDstCharacter = <a class=\"code\" href=\"#!/url=./py_ref/class_f_b_label.html\">FBLabel</a>()</div>\n\
<div class=\"line\"><a name=\"l00102\"></a><span class=\"lineno\">  102</span>&#160;        lCntSrcCharacter = <a class=\"code\" href=\"#!/url=./py_ref/class_f_b_visual_container.html\">FBVisualContainer</a>()</div>\n\
<div class=\"line\"><a name=\"l00103\"></a><span class=\"lineno\">  103</span>&#160;        lCntDstCharacter = <a class=\"code\" href=\"#!/url=./py_ref/class_f_b_visual_container.html\">FBVisualContainer</a>()</div>\n\
<div class=\"line\"><a name=\"l00104\"></a><span class=\"lineno\">  104</span>&#160;        lBtnMatch = <a class=\"code\" href=\"#!/url=./py_ref/class_f_b_button.html\">FBButton</a>()</div>\n\
<div class=\"line\"><a name=\"l00105\"></a><span class=\"lineno\">  105</span>&#160;        </div>\n\
<div class=\"line\"><a name=\"l00106\"></a><span class=\"lineno\">  106</span>&#160;        lLblSrcCharacter.Caption = <span class=\"stringliteral\">&quot;Source Character:&quot;</span></div>\n\
<div class=\"line\"><a name=\"l00107\"></a><span class=\"lineno\">  107</span>&#160;        lLblDstCharacter.Caption = <span class=\"stringliteral\">&quot;Destination Character:&quot;</span></div>\n\
<div class=\"line\"><a name=\"l00108\"></a><span class=\"lineno\">  108</span>&#160;        lBtnMatch.Caption = <span class=\"stringliteral\">&quot;Match auxiliary&quot;</span></div>\n\
<div class=\"line\"><a name=\"l00109\"></a><span class=\"lineno\">  109</span>&#160;        </div>\n\
<div class=\"line\"><a name=\"l00110\"></a><span class=\"lineno\">  110</span>&#160;        lVLt = <a class=\"code\" href=\"#!/url=./py_ref/class_f_b_v_box_layout.html\">FBVBoxLayout</a>()</div>\n\
<div class=\"line\"><a name=\"l00111\"></a><span class=\"lineno\">  111</span>&#160;        x = <a class=\"code\" href=\"#!/url=./py_ref/class_f_b_add_region_param.html\">FBAddRegionParam</a>(5,FBAttachType.kFBAttachLeft,<span class=\"stringliteral\">&quot;&quot;</span>)</div>\n\
<div class=\"line\"><a name=\"l00112\"></a><span class=\"lineno\">  112</span>&#160;        y = <a class=\"code\" href=\"#!/url=./py_ref/class_f_b_add_region_param.html\">FBAddRegionParam</a>(5,FBAttachType.kFBAttachTop,<span class=\"stringliteral\">&quot;&quot;</span>)</div>\n\
<div class=\"line\"><a name=\"l00113\"></a><span class=\"lineno\">  113</span>&#160;        w = <a class=\"code\" href=\"#!/url=./py_ref/class_f_b_add_region_param.html\">FBAddRegionParam</a>(-5,FBAttachType.kFBAttachRight,<span class=\"stringliteral\">&quot;&quot;</span>)</div>\n\
<div class=\"line\"><a name=\"l00114\"></a><span class=\"lineno\">  114</span>&#160;        h = <a class=\"code\" href=\"#!/url=./py_ref/class_f_b_add_region_param.html\">FBAddRegionParam</a>(-5,FBAttachType.kFBAttachBottom,<span class=\"stringliteral\">&quot;&quot;</span>)</div>\n\
<div class=\"line\"><a name=\"l00115\"></a><span class=\"lineno\">  115</span>&#160;        self.AddRegion(<span class=\"stringliteral\">&quot;Main&quot;</span> ,<span class=\"stringliteral\">&quot;Main&quot;</span> , x, y, w, h)</div>\n\
<div class=\"line\"><a name=\"l00116\"></a><span class=\"lineno\">  116</span>&#160;        self.SetControl(<span class=\"stringliteral\">&quot;Main&quot;</span> ,lVLt)</div>\n\
<div class=\"line\"><a name=\"l00117\"></a><span class=\"lineno\">  117</span>&#160;        </div>\n\
<div class=\"line\"><a name=\"l00118\"></a><span class=\"lineno\">  118</span>&#160;        lHLt = <a class=\"code\" href=\"#!/url=./py_ref/class_f_b_h_box_layout.html\">FBHBoxLayout</a>(FBAttachType.kFBAttachLeft)</div>\n\
<div class=\"line\"><a name=\"l00119\"></a><span class=\"lineno\">  119</span>&#160;        lHLt.AddRelative(lLblSrcCharacter,0.5)</div>\n\
<div class=\"line\"><a name=\"l00120\"></a><span class=\"lineno\">  120</span>&#160;        lHLt.AddRelative(lCntSrcCharacter,0.5)</div>\n\
<div class=\"line\"><a name=\"l00121\"></a><span class=\"lineno\">  121</span>&#160;        lVLt.Add(lHLt,20)</div>\n\
<div class=\"line\"><a name=\"l00122\"></a><span class=\"lineno\">  122</span>&#160;        lHLt = <a class=\"code\" href=\"#!/url=./py_ref/class_f_b_h_box_layout.html\">FBHBoxLayout</a>(FBAttachType.kFBAttachLeft)</div>\n\
<div class=\"line\"><a name=\"l00123\"></a><span class=\"lineno\">  123</span>&#160;        lHLt.AddRelative(lLblDstCharacter,0.5)</div>\n\
<div class=\"line\"><a name=\"l00124\"></a><span class=\"lineno\">  124</span>&#160;        lHLt.AddRelative(lCntDstCharacter,0.5)</div>\n\
<div class=\"line\"><a name=\"l00125\"></a><span class=\"lineno\">  125</span>&#160;        lVLt.Add(lHLt,20)</div>\n\
<div class=\"line\"><a name=\"l00126\"></a><span class=\"lineno\">  126</span>&#160;        lVLt.Add(lBtnMatch,20)</div>\n\
<div class=\"line\"><a name=\"l00127\"></a><span class=\"lineno\">  127</span>&#160;        </div>\n\
<div class=\"line\"><a name=\"l00128\"></a><span class=\"lineno\">  128</span>&#160;        lCntSrcCharacter.OnDragAndDrop.Add(<span class=\"keyword\">lambda</span> control = <span class=\"keywordtype\">None</span>, event = <span class=\"keywordtype\">None</span> : self.SrcDrop(event,control))</div>\n\
<div class=\"line\"><a name=\"l00129\"></a><span class=\"lineno\">  129</span>&#160;        lCntDstCharacter.OnDragAndDrop.Add(<span class=\"keyword\">lambda</span> control = <span class=\"keywordtype\">None</span>, event = <span class=\"keywordtype\">None</span> : self.DstDrop(event,control))</div>\n\
<div class=\"line\"><a name=\"l00130\"></a><span class=\"lineno\">  130</span>&#160;        lBtnMatch.OnClick.Add(<span class=\"keyword\">lambda</span> control = <span class=\"keywordtype\">None</span>, event = <span class=\"keywordtype\">None</span> : MatchAuxiliary(self.mSrcChar,self.mDstChar))</div>\n\
<div class=\"line\"><a name=\"l00131\"></a><span class=\"lineno\">  131</span>&#160;        </div>\n\
<div class=\"line\"><a name=\"l00132\"></a><span class=\"lineno\">  132</span>&#160;        <span class=\"keywordflow\">if</span> len(gScene.Characters):</div>\n\
<div class=\"line\"><a name=\"l00133\"></a><span class=\"lineno\">  133</span>&#160;            self.mSrcChar = gScene.Characters[0]</div>\n\
<div class=\"line\"><a name=\"l00134\"></a><span class=\"lineno\">  134</span>&#160;            lCntSrcCharacter.Items.append(self.mSrcChar.Name)</div>\n\
<div class=\"line\"><a name=\"l00135\"></a><span class=\"lineno\">  135</span>&#160;            <span class=\"keywordflow\">if</span> len(gScene.Characters)&gt;1:</div>\n\
<div class=\"line\"><a name=\"l00136\"></a><span class=\"lineno\">  136</span>&#160;                self.mDstChar = gScene.Characters[1]</div>\n\
<div class=\"line\"><a name=\"l00137\"></a><span class=\"lineno\">  137</span>&#160;                lCntDstCharacter.Items.append(self.mDstChar.Name)</div>\n\
<div class=\"line\"><a name=\"l00138\"></a><span class=\"lineno\">  138</span>&#160;</div>\n\
<div class=\"line\"><a name=\"l00139\"></a><span class=\"lineno\">  139</span>&#160;        self.StartSizeX = 250</div>\n\
<div class=\"line\"><a name=\"l00140\"></a><span class=\"lineno\">  140</span>&#160;        self.StartSizeY = 115</div>\n\
<div class=\"line\"><a name=\"l00141\"></a><span class=\"lineno\">  141</span>&#160;        </div>\n\
<div class=\"line\"><a name=\"l00142\"></a><span class=\"lineno\">  142</span>&#160;<span class=\"comment\"># Display</span></div>\n\
<div class=\"line\"><a name=\"l00143\"></a><span class=\"lineno\">  143</span>&#160;<span class=\"keywordflow\">if</span> gDevelopment:</div>\n\
<div class=\"line\"><a name=\"l00144\"></a><span class=\"lineno\">  144</span>&#160;    <a class=\"code\" href=\"#!/url=./py_ref/group__pyfbsdk__additions.html#gad52f8c17f15847639d8f249ab4904814\">FBDestroyToolByName</a>(gToolName)</div>\n\
<div class=\"line\"><a name=\"l00145\"></a><span class=\"lineno\">  145</span>&#160;</div>\n\
<div class=\"line\"><a name=\"l00146\"></a><span class=\"lineno\">  146</span>&#160;<span class=\"keywordflow\">if</span> gToolName <span class=\"keywordflow\">in</span> FBToolList:</div>\n\
<div class=\"line\"><a name=\"l00147\"></a><span class=\"lineno\">  147</span>&#160;    tool = FBToolList[gToolName]</div>\n\
<div class=\"line\"><a name=\"l00148\"></a><span class=\"lineno\">  148</span>&#160;    <a class=\"code\" href=\"#!/url=./py_ref/group__pyfbsdk.html#ga620297507a1a55c277fef7bb738449ec\">ShowTool</a>(tool)</div>\n\
<div class=\"line\"><a name=\"l00149\"></a><span class=\"lineno\">  149</span>&#160;<span class=\"keywordflow\">else</span>:</div>\n\
<div class=\"line\"><a name=\"l00150\"></a><span class=\"lineno\">  150</span>&#160;    tool=MatchAuxiliariesTool()</div>\n\
<div class=\"line\"><a name=\"l00151\"></a><span class=\"lineno\">  151</span>&#160;    <span class=\"keywordflow\">if</span> gDevelopment:</div>\n\
<div class=\"line\"><a name=\"l00152\"></a><span class=\"lineno\">  152</span>&#160;        <a class=\"code\" href=\"#!/url=./py_ref/group__pyfbsdk.html#ga620297507a1a55c277fef7bb738449ec\">ShowTool</a>(tool)</div>\n\
</div><!-- fragment --> </div><!-- contents -->\n\
</div><!-- doc-content -->\n\
          <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";