var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-0C6F6BA3-E9A2-40D0-87AE-F4F8CF20A66C\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Requirements</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-0C6F6BA3-E9A2-40D0-87AE-F4F8CF20A66C\"></a><div class=\"head\">\n\
            <h1>Requirements</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_67C746241F554BF3981A3F79A93FB8AC\"></a> \n\
            <h2><a name=\"GUID-AA61FFAE-B1C0-4526-B79E-2F720C35142D\"></a>MotionBuilder SDK Requirements\n\
            </h2> \n\
            <p><a name=\"GUID-2F6ADEFD-7B74-4BF4-9425-52DA0D776F53\"></a>The MotionBuilder SDK requires that the Autodesk MotionBuilder software be installed\n\
               on your computer. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_33D1BC255DFA4B24B816D38ABA2630D4\"></a> \n\
            <h2><a name=\"GUID-695692B9-3FB7-4B6A-B755-00D1FA52E2B8\"></a>C++ Requirements\n\
            </h2> \n\
            <p><a name=\"GUID-A2039E33-FEFF-48DA-B9F6-A84B18EA76A0\"></a>Development in C++ for MotionBuilder is compatible with the <em class=\"strong\"> Visual Studio 2012</em> development environment. \n\
            </p> \n\
            <p><a name=\"GUID-3BA03A39-77AE-4C71-A23E-F18E4BFE6F4E\"></a>To develop additional user-interface elements with your C++ plug-in, you must install\n\
               <em class=\"strong\">QT 4.8.6</em> for including the necessary Qt header files. \n\
            </p> \n\
            <p><a name=\"GUID-2F533B76-8689-47AC-8466-DE0D304A8CB1\"></a>Binary compatibility of your C++ plugins across different versions of MotionBuilder\n\
               is not guaranteed. It is recommended that you recompile your C++ plugins according\n\
               to the targeted version of MotionBuilder. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_F2672FBACC734FA8A014414C6E208022\"></a> \n\
            <h2><a name=\"GUID-DD971954-B51D-4410-B816-EF71FA18AD4D\"></a>Python Requirements\n\
            </h2> \n\
            <p><a name=\"GUID-35D0CB70-2985-4179-82FF-B16D5C78740D\"></a>MotionBuilder contains its own Python interpreter. Currently, MotionBuilder supports\n\
               <em class=\"strong\">Python version 2.7.6</em>. Your Python programs must therefore be compatible with this version of Python. \n\
            </p> \n\
            <p><a name=\"GUID-CA276BAB-6090-4917-8E91-668D8D5CA9B1\"></a>The embedded Python interpreter might also change as new versions of MotionBuilder\n\
               are released. It is recommended to adapt your Python code accordingly to ensure forward\n\
               compatibility. \n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";