var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-0D3D5186-8BA1-433A-A7B0-44E7C10DD352\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Accessing the Custom Renderer in the User Interface</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-0D3D5186-8BA1-433A-A7B0-44E7C10DD352\"></a><div class=\"head\">\n\
            <h1>Accessing the Custom Renderer in the User Interface</h1>\n\
         </div>\n\
         <p><a name=\"GUID-21728E63-3F26-4E5E-899D-62B2555C4F2D\"></a> This topic describes how you can access the custom renderer in the user interface\n\
            after deploying the <span class=\"filePath\" translate=\"no\">CustomRenderer</span> sample. For information about the <span class=\"filePath\" translate=\"no\">CustomRenderer</span> sample, see the <span class=\"char_link\"><a href=\"#!/url=./files/GUID-EBB95B3D-E75B-4033-ABB4-29EE7B1F9F4A.htm#GUID-9DAAFF4B-A44B-4E07-84C3-55062F862F06\">Quick Start</a></span> section in the <span class=\"char_link\"><a href=\"#!/url=./files/GUID-EBB95B3D-E75B-4033-ABB4-29EE7B1F9F4A.htm\">Custom Renderer API</a></span> topic. \n\
         </p>\n\
         <p><a name=\"GUID-136F420E-2AEC-46E9-8032-07D08007FB26\"></a> You can access the custom renderer plug-in from the user interface in the following\n\
            ways: \n\
         </p>\n\
         <p><a name=\"GUID-86B1A387-9CE4-4CCF-93AB-78C3E1F50FE4\"></a> <a name=\"UL_C60AC1787C4A4A238F0145A6A9147950\"></a><ul>\n\
               <li><em class=\"strong\"> Menu</em> – As shown in the following figure a new <span class=\"MenuCascade\" id=\"GUID-44159C0A-0225-4B07-B057-E082BD44FC45\">Renderer</span> menu is displayed above the viewer. You can choose the custom renderer settings in\n\
                  the <span class=\"MenuCascade\" id=\"GUID-2EFB1E30-BDC1-439E-8FBC-18E4E8FF6D62\">Renderer</span> menu. It lists the available renderers and the user defined presets. The <span class=\"MenuCascade\" id=\"GUID-2ACE8265-E868-4F27-9FF4-B3E6C890BA30\">Default</span> option refers to the MotionBuilder’s default renderer. The <span class=\"MenuCascade\" id=\"GUID-602C39D2-498A-4702-A13B-B26E08999B82\">OR – Sample Renderer Callback</span> option refers to the sample custom renderer plug-in, and its sub menu options <span class=\"MenuCascade\" id=\"GUID-FCBDA1A1-8701-40CA-8409-AE38EDBBD785\">PointCloud</span>, <span class=\"MenuCascade\" id=\"GUID-3B927C2D-1E2F-46BD-BF07-269C4AC013D1\">WireFrame</span>, and <span class=\"MenuCascade\" id=\"GUID-3A068A27-2A7F-4DC5-8645-D231A2F99864\">Solid</span> refer to the user defined presets in the sample. \n\
                  <p><a name=\"GUID-95DCAE3F-1F38-4914-BE2C-445F5F97F4BD\"></a> <a name=\"FIG_2688EDFF22FF40EC9D659E2021575BE5\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-99659A4B-65F9-4F9A-80C8-942AE60D78B9-low.png\"></div> \n\
                  </p> \n\
                  <div><a name=\"GUID-C1003D1C-6EC9-4003-B78C-B65B3F5939FD\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>The <span class=\"MenuCascade\" id=\"GUID-103B4B13-4531-4DF5-A208-B8926C2265A3\">Renderer</span> menu appears only when a custom renderer plug-in is deployed in one of the plug-in\n\
                        paths. \n\
                     </div>\n\
                  </div> \n\
               </li>\n\
               <li><em class=\"strong\">Asset Settings</em> – You can control the asset settings panel for the renderer by subclassing <span class=\"code\" translate=\"no\">FBRendererCallbackLayout</span>. The asset settings panel appears when you select the custom renderer in the <span class=\"MenuCascade\" id=\"GUID-FD44C2C6-8698-4CC4-95B2-F4AC1C23F9C9\">Renderer</span> menu, or when you double-click the custom renderer option that is listed in the <span class=\"MenuCascade\" id=\"GUID-B7830540-09B9-4C5C-A746-DC46E87DA168\">Navigator</span> tab under <span class=\"MenuCascade\" id=\"GUID-208CCD3A-7AB5-478E-9DC2-B055A516B3AF\">System <img src=\"images/ac.menuaro.gif\"> Core <img src=\"images/ac.menuaro.gif\"> Renderer</span> as shown in the following figure. \n\
                  <p><a name=\"GUID-F06E4F47-4511-4B06-836D-C658BFB774CF\"></a> <a name=\"FIG_EB2EDFF985F84E4E906A0E734CF3869F\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-F93E6E3E-B589-4236-B616-3BCE6CAB5D3C-low.png\"></div> \n\
                  </p> \n\
                  <p><a name=\"GUID-CBED21CC-FCF3-448D-89ED-204D180B416F\"></a>You can design your own asset settings panel for the custom renderer. \n\
                  </p> \n\
               </li>\n\
               <li><em class=\"strong\">Property View</em> – You can access the renderer properties through the property view as shown in the\n\
                  following figure. \n\
                  <p><a name=\"GUID-B9A0BDD2-D693-4B5B-83A5-E921C360474A\"></a> <a name=\"FIG_38459E8D52A3442BB0178CE24A0C78AB\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-A08BDAD4-AB16-42A1-8375-F2A1E267FA75-low.png\"></div> \n\
                  </p> \n\
                  <p><a name=\"GUID-670DA504-B5F1-4F1C-B70A-A6D3DBCFBE06\"></a>The property view changes to display the renderer’s properties when you select the\n\
                     renderer from the <span class=\"MenuCascade\" id=\"GUID-EE753103-E86D-489A-AFB2-1DD407DE5E3E\">Renderer</span> menu. \n\
                  </p> \n\
               </li>\n\
            </ul> \n\
         </p>\n\
         <p><a name=\"GUID-40864FF6-BEED-4769-B1F6-28518EBF2CE5\"></a>Additionally, the camera title is expanded to include the custom renderer name and\n\
            its current preset setting, if selected. The following figure shows how the renderer\n\
            and preset are displayed alongside the camera title in the viewport. \n\
         </p><a name=\"FIG_FC22BFFE08CA452F902B077DA74CF663\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-F13002BC-7A01-4433-8559-95F28D3468EC-low.png\"></div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";