var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-1358FC40-DD19-4C4E-AFD3-DA73BA326B95\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Directory Structure</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-1358FC40-DD19-4C4E-AFD3-DA73BA326B95\"></a><div class=\"head\">\n\
            <h1>Directory Structure</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_6420FCA5915E44F39EDCAB2F243221A8\"></a> \n\
            <h2><a name=\"GUID-DFA79FE9-838B-46FC-8290-DA96C469F570\"></a>Installation Directory\n\
            </h2> \n\
            <p><a name=\"GUID-325814B8-5DA1-4D44-8796-D6C0FA64FD62\"></a>MotionBuilder is available for 64-bit architectures. By default, MotionBuilder is\n\
               installed in the following directory: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">C:\\Program Files\\Autodesk\\MotionBuilder &lt;year&gt;</pre></div> \n\
            <p><a name=\"GUID-7690EBB4-0712-42E5-AEBE-91D0ECC2855D\"></a>This installation path will be referred to as <span class=\"filePath\" translate=\"no\">[MotionBuilder]</span> in the remainder of this topic to represent the path of your MotionBuilder installation\n\
               directory. \n\
            </p> \n\
            <div class=\"section\"><a name=\"SECTION_693B642C20C24EA7A847EC2E4F7A0910\"></a> \n\
               <h3><a name=\"GUID-73C11B65-9547-47B1-9013-A62AB2F2AF62\"></a>C++ Directories\n\
               </h3> <a name=\"TABLE_96B11C9E702D4890B7B7D1EE54475718\"></a><div class=\"table-ruled\">\n\
                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
                     <colgroup>\n\
                        <col width=\"28.729066597429576%\">\n\
                        <col width=\"71.27093340257042%\">\n\
                     </colgroup>\n\
                     <tr class=\"ruled-heading\">\n\
                        <th class=\"table-heading\">Path </th>\n\
                        <th class=\"table-heading\">Description </th>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> <span class=\"filePath\" translate=\"no\">[MotionBuilder]\\OpenRealitySDK\\include</span> \n\
                        </td>\n\
                        <td class=\"table-body\">Header files. </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> <span class=\"filePath\" translate=\"no\">[MotionBuilder]\\OpenRealitySDK\\lib\\x64</span> \n\
                        </td>\n\
                        <td class=\"table-body\">Library files. </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> <span class=\"filePath\" translate=\"no\">[MotionBuilder]\\OpenRealitySDK\\samples</span> \n\
                        </td>\n\
                        <td class=\"table-body\">C++ samples, including Visual Studio solution files. </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> <span class=\"filePath\" translate=\"no\">[MotionBuilder]\\OpenRealitySDK\\scenes</span> \n\
                        </td>\n\
                        <td class=\"table-body\">Sample scene data. </td>\n\
                     </tr>\n\
                  </table>\n\
               </div> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_2C1C6D3358A942539A1D51254842C32D\"></a> \n\
               <h3><a name=\"GUID-F4D2CEE6-7284-4395-A2A8-2BBB07C47F70\"></a>C++ Libraries\n\
               </h3> <a name=\"TABLE_D79DC66D880541449CFC95F1B7FAABB9\"></a><div class=\"table-ruled\">\n\
                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
                     <colgroup>\n\
                        <col width=\"28.729066597429576%\">\n\
                        <col width=\"71.27093340257042%\">\n\
                     </colgroup>\n\
                     <tr class=\"ruled-heading\">\n\
                        <th class=\"table-heading\">Library Name </th>\n\
                        <th class=\"table-heading\">Description </th>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> <span class=\"filePath\" translate=\"no\">cg.lib</span>, <span class=\"filePath\" translate=\"no\">cgGL.lib</span> \n\
                        </td>\n\
                        <td class=\"table-body\">Cg header files and libraries provided by the Cg Toolkit 3.0. </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> <span class=\"filePath\" translate=\"no\">fbsdk.lib</span> \n\
                        </td>\n\
                        <td class=\"table-body\">MotionBuilder SDK. </td>\n\
                     </tr>\n\
                  </table>\n\
               </div> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_DF3080C6B445491EB4E7B5243D617635\"></a> \n\
               <h3><a name=\"GUID-629723E4-AF3C-4A5E-84A2-DA1EE9579944\"></a>Python Subdirectories\n\
               </h3> <a name=\"TABLE_7D7E99906B934B8F8D8428B7D5AF2812\"></a><div class=\"table-ruled\">\n\
                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
                     <colgroup>\n\
                        <col width=\"28.729066597429576%\">\n\
                        <col width=\"71.27093340257042%\">\n\
                     </colgroup>\n\
                     <tr class=\"ruled-heading\">\n\
                        <th class=\"table-heading\">Path </th>\n\
                        <th class=\"table-heading\">Description </th>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> <span class=\"filePath\" translate=\"no\">[MotionBuilder]\\bin\\config\\Python</span> \n\
                        </td>\n\
                        <td class=\"table-body\">Contains Python modules used in MotionBuilder. Also contains keyboard configuration\n\
                           file. For more information on customizing keyboard shortcuts, see <span class=\"char_link\"><a href=\"#!/url=./files/GUID-34FB0BD6-6FE8-479F-86C8-929E0FC09244.htm\">Managing Python Tools</a></span>. \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> <span class=\"filePath\" translate=\"no\">[MotionBuilder]\\bin\\config\\Scripts</span> \n\
                        </td>\n\
                        <td class=\"table-body\">Sample Python scripts. These are described in the <span class=\"char_link\"><a href=\"#!/url=./files/GUID-E3631806-1B7C-419E-A7BA-0B1FBA8CED8C.htm\">Sample Programs</a></span> topic. \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> <span class=\"filePath\" translate=\"no\">[MotionBuilder]\\bin\\x64\\python\\lib\\plat-win\\pyfbsdk.pyd</span> \n\
                        </td>\n\
                        <td class=\"table-body\">The <em class=\"strong\">pyfbsdk</em> Python module, which encapsulates the majority of the MotionBuilder SDK Python functionality.\n\
                           \n\
                        </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\"> <span class=\"filePath\" translate=\"no\">[MotionBuilder]\\bin\\config\\Python\\pyfbsdk_additions.py</span> \n\
                        </td>\n\
                        <td class=\"table-body\">Contains Python code used to bridge functionality between the OpenReality C++ SDK\n\
                           and Python. It contains tool management functions and some UI creation helper classes.\n\
                           \n\
                        </td>\n\
                     </tr>\n\
                  </table>\n\
               </div> \n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_812CF9587F784C55A925B18C360C167B\"></a> \n\
            <h2><a name=\"GUID-0E13140C-1E7B-4139-89B1-460616D1F8A1\"></a>User Configuration Directory\n\
            </h2> \n\
            <p><a name=\"GUID-7B9063B3-7D33-43F3-BF50-C85BFD0A0627\"></a>In the latest versions of Windows, only administrative users have the permission to\n\
               write to the <span class=\"filePath\" translate=\"no\">Program Files</span> directory. To enable non-administrative users to customize MotionBuilder\'s configuration\n\
               files, MotionBuilder creates the following directory for each user that opens MotionBuilder:\n\
               \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">C:\\Users\\&lt;user_name&gt;\\Documents\\MB\\&lt;year&gt;-x64\\config\\</pre></div> \n\
            <p><a name=\"GUID-F14DF0DD-2C19-4366-ABC0-DAACD6B14F36\"></a>This user configuration directory, which we will refer to as <span class=\"filePath\" translate=\"no\">[config]</span>, allows each user to specify his or her own keyboard shortcuts, Python startup programs\n\
               and scripts, character templates, and layouts. The <span class=\"filePath\" translate=\"no\">[config]</span> directory is created using the <span class=\"filePath\" translate=\"no\">[MotionBuilder]\\bin\\config\\</span> directory as a template. \n\
            </p> \n\
            <p><a name=\"GUID-046F977C-842A-4A51-B0B0-4F4D1BE615F4\"></a> Users can place Python scripts in the <span class=\"filePath\" translate=\"no\">[config]\\PythonStartup</span> directory to have their scripts run when MotionBuilder starts up. For more information,\n\
               see <span class=\"char_link\"><a href=\"#!/url=./files/GUID-391A97C9-35B9-4C98-A8CE-5CD718A7D70A.htm\">Running Python Scripts</a></span> and <span class=\"char_link\"><a href=\"#!/url=./files/GUID-989682FC-305F-4925-8B37-66490BC45C4C.htm\">Command Line Options</a></span>. \n\
            </p> \n\
            <p><a name=\"GUID-0252EDC4-4CFE-4DFB-9FC6-539ED1987CAC\"></a> \n\
               <div><a name=\"GUID-DEAA198C-F49A-421F-B765-EE1D534B2372\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>MotionBuilder will run the scripts in both the user\'s <span class=\"filePath\" translate=\"no\">[config]</span> directory, as well as the <span class=\"filePath\" translate=\"no\">[MotionBuilder]\\bin\\config\\</span> directory. \n\
                  </div>\n\
               </div> \n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";