var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-1E06CAC4-A61A-41A6-8B61-47128DF7355F\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Using Python to Implement a Custom Renderer</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-1E06CAC4-A61A-41A6-8B61-47128DF7355F\"></a><div class=\"head\">\n\
            <h1> Using Python to Implement a Custom Renderer</h1>\n\
         </div>\n\
         <p><a name=\"GUID-6EDCBFB9-B84B-470D-85C5-B1C5A208CA15\"></a> The following Python script demonstrates how you can use Python to implement a custom\n\
            renderer: \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">From pyfbsdk import *\n\
\n\
class MyRenderCallback (<a href=\"javascript:void(0)\" data-symbol=\"FBRendererCallback\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_renderer_callback.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBRendererCallback</a>):   \n\
    def __init__(<a href=\"javascript:void(0)\" data-symbol=\"self\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/modsupport_8h.html#a0180ca1808366e5da641475e8bf8cca3&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">self</a>, <a href=\"javascript:void(0)\" data-symbol=\"name\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#afcd1706c9144e6d6eee6127661ae3be2&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">name</a>):\n\
        super(MyRenderCallback, <a href=\"javascript:void(0)\" data-symbol=\"self\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/modsupport_8h.html#a0180ca1808366e5da641475e8bf8cca3&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">self</a>).__init__(<a href=\"javascript:void(0)\" data-symbol=\"name\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#afcd1706c9144e6d6eee6127661ae3be2&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">name</a>)\n\
                                       \n\
    def GetCallbackName(<a href=\"javascript:void(0)\" data-symbol=\"self\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/modsupport_8h.html#a0180ca1808366e5da641475e8bf8cca3&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">self</a>):\n\
        return “My Python Renderer”\n\
\n\
    def GetCallbackDesc(<a href=\"javascript:void(0)\" data-symbol=\"self\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/modsupport_8h.html#a0180ca1808366e5da641475e8bf8cca3&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">self</a>):\n\
        return “This is a python render”\n\
    \n\
    def GetCallbackPrefCount(<a href=\"javascript:void(0)\" data-symbol=\"self\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/modsupport_8h.html#a0180ca1808366e5da641475e8bf8cca3&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">self</a>):\n\
        return 2\n\
        \n\
    def GetCallbackPrefName(<a href=\"javascript:void(0)\" data-symbol=\"self\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/modsupport_8h.html#a0180ca1808366e5da641475e8bf8cca3&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">self</a>, pIndex):\n\
        if pIndex == 0:\n\
            return “Setting One”\n\
        else: \n\
            return “Setting Two”                \n\
            \n\
    def Attach(<a href=\"javascript:void(0)\" data-symbol=\"self\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/modsupport_8h.html#a0180ca1808366e5da641475e8bf8cca3&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">self</a>):\n\
        pass\n\
        \n\
    def Detach(<a href=\"javascript:void(0)\" data-symbol=\"self\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/modsupport_8h.html#a0180ca1808366e5da641475e8bf8cca3&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">self</a>):\n\
        pass        \n\
        \n\
    def DetachDisplayContext(<a href=\"javascript:void(0)\" data-symbol=\"self\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/modsupport_8h.html#a0180ca1808366e5da641475e8bf8cca3&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">self</a>, options):\n\
        pass\n\
                \n\
    def Render(<a href=\"javascript:void(0)\" data-symbol=\"self\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/modsupport_8h.html#a0180ca1808366e5da641475e8bf8cca3&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">self</a>, options):\n\
        lRender = <a href=\"javascript:void(0)\" data-symbol=\"FBSystem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem</a>().Renderer\n\
        lCount = lRender.DisplayableGeometryCount – 1\n\
        while(lCount &gt;= 0) :                \n\
            lModel = lRender.GetDisplayableGeometry(lCount)\n\
            lRender.OGLModelDisplay(options, lModel)\n\
            lCount = lCount – 1\n\
\n\
# Create python renderer\n\
lMyRender = MyRenderCallback(“My Python Renderer”)\n\
# Register this custom render to system\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBSystem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem</a>().Renderer.RendererCallbacks.append(lMyRender)\n\
# Turn it on\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBSystem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem</a>().Renderer.CurrentPaneCallbackIndex = <a href=\"javascript:void(0)\" data-symbol=\"len\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#abc8b352d6723c361fc39710e5b10b502&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">len</a> (<a href=\"javascript:void(0)\" data-symbol=\"FBSystem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem</a>().Renderer.RendererCallbacks) – 1  \n\
\n\
# Unregister and delete the python renderer\n\
‘’’\n\
if(<a href=\"javascript:void(0)\" data-symbol=\"len\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#abc8b352d6723c361fc39710e5b10b502&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">len</a>(<a href=\"javascript:void(0)\" data-symbol=\"FBSystem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem</a>().Renderer.RendererCallbacks)):\n\
    lMyRender = <a href=\"javascript:void(0)\" data-symbol=\"FBSystem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem</a>().Renderer.RendererCallbacks.pop()           \n\
    lMyRender.FBDelete()\n\
‘’’</pre></div> \n\
         </p>\n\
         <p><a name=\"GUID-DF6CE298-5C3F-4A67-A557-28AD9CC9905C\"></a>Although, this script looks trivial from a production perspective at first, but it\n\
            actually indicates how to achieve greater flexibility. You can choose to use the PyOpenGL\n\
            Python package to implement a more useful rendering. You can also implement the performance\n\
            demanding routines in C++ first and then expose them in Python. You can eventually\n\
            use them inside this Python based custom renderer. In this way, the flexibility of\n\
            Python and efficiency of C++ can be utilized. The following figure shows the Python\n\
            implementation of the custom renderer. \n\
         </p><a name=\"FIG_46C7B43167444EFE91A9134D1B474E46\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-0040499B-25D8-46D2-82C2-23BF4B803197-low.png\"></div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";