var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-20B10B92-5A15-4A6C-B434-B83F0363BD0D\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Reducing Keys using Filters</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-20B10B92-5A15-4A6C-B434-B83F0363BD0D\"></a><div class=\"head\">\n\
            <h1>Reducing Keys using Filters</h1>\n\
         </div>\n\
         <p><a name=\"GUID-11EEF591-84D9-4304-9337-644374A2785E\"></a> This topic shows how to reduce keys using filters. To follow the instructions, download\n\
            the file and script from <a href=\"http://area.autodesk.com/downloads/scripts/motionbuilder-animation-scripts\" target=\"_blank\">http://area.autodesk.com/downloads/scripts/motionbuilder-animation-scripts</a>. <a name=\"OL_75B52A1C0CC043C2B8C17F85AAFDD496\"></a><ol type=\"1\" start=\"1\">\n\
               <li>Open the <span class=\"filePath\" translate=\"no\">filters_key_reducer.fbx</span> file in MotionBuilder. The cube\'s FCurves appear as shown in the following figure.\n\
                  <a name=\"FIG_A5AC91B6BDF64337B164B843165D134D\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-A63B871B-EB0E-47E8-A92D-DA7408698615-low.png\"></div> \n\
               </li>\n\
               <li>Run the <span class=\"filePath\" translate=\"no\">filters_constant_key_reducer.py</span> script to reduce the constant keys on the FCurve. The x FCurve for translation is\n\
                  modified as shown in the following figure. <a name=\"FIG_0297636BE66A4881BE84D441A3B41A7B\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-EF9EEBFF-68CE-4518-B0EC-66B44C815E16-low.png\"></div> \n\
               </li>\n\
            </ol>\n\
            <p><a name=\"GUID-26F2A8C1-9AE9-43B5-A9A3-F471642ADDE9\"></a>Following are the points to keep in mind: <a name=\"UL_2E1F5D381BD8434A9CB7832AD97E13D3\"></a><ul>\n\
                  <li> <span class=\"code\" translate=\"no\">FBFilterManager()</span> is the entrance to all filters. \n\
                  </li>\n\
                  <li><span class=\"code\" translate=\"no\"> FBFilterManager().CreateFilter (\'Constant Key Reducer\')</span> creates a constant key reducer. \n\
                  </li>\n\
                  <li> A filter always has two inputs: start time and stop time. </li>\n\
                  <li><span class=\"code\" translate=\"no\">lFilter.Apply (lModel.Translation.GetAnimationNode(), True)</span> applies the filter to the model’s animation node. \n\
                  </li>\n\
               </ul> \n\
            </p> \n\
         </p>\n\
         <p><a name=\"GUID-029532E3-DF92-4A80-BBC2-A0731EF1E940\"></a>Follow these instructions to retain the FCurve shape. <a name=\"OL_F8BCDF3046F94CC1B96A410565EBB551\"></a><ol type=\"1\" start=\"1\">\n\
               <li>Open the <span class=\"code\" translate=\"no\">filters_key_reducer.fbx</span> file in MotionBuilder. The FCurves appear as shown in the following figure. <a name=\"FIG_9245701C32264E51A95F16531BC723FB\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-FF80C727-8422-41AF-8D40-5EA589FA6929-low.png\"></div> \n\
               </li>\n\
               <li>Run the <span class=\"filePath\" translate=\"no\">filters_key_reducer.py</span> script to reduce the keys on the FCurves. The shape does not change as shown in the\n\
                  following figure. <a name=\"FIG_5AFFB52C76234F208642212DE66C1B8F\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-E39A36E5-FD19-45CA-B8DA-FB6C743648DF-low.png\"></div> \n\
               </li>\n\
            </ol> \n\
         </p>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";