var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-22252E01-F32A-4063-A78B-FDF8B8421297\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Unloading and Reloading a Referenced Object</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-22252E01-F32A-4063-A78B-FDF8B8421297\"></a><div class=\"head\">\n\
            <h1>Unloading and Reloading a Referenced Object</h1>\n\
         </div>\n\
         <p><a name=\"GUID-C59B27D4-9EE4-4A99-A39D-5A2A44A0070D\"></a> When you unload a loaded referenced object, it frees the memory but does not delete\n\
            the reference. \n\
         </p><a name=\"UL_345563698D244C2BB4A9FC4531D235DB\"></a><ul>\n\
            <li><em class=\"strong\">Unload</em> – If you have a reference object named NS, you can set its <span class=\"code\" translate=\"no\">IsLoaded</span> attribute to False to unload all the referenced items as follows: \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">lFileReference = <a href=\"javascript:void(0)\" data-symbol=\"FBFindObjectByFullName\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga980a7ebfc02171f683b0bfed6527faa2&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFindObjectByFullName</a>( \"FileReference::NS\" )\n\
lFileReference.IsLoaded = False\n\
</pre></div> \n\
            </li>\n\
            <li><em class=\"strong\">Reload</em> – You can reload the reference object by setting its <span class=\"code\" translate=\"no\">IsLoaded</span> attribute to True as follows: \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">lFileReference = <a href=\"javascript:void(0)\" data-symbol=\"FBFindObjectByFullName\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga980a7ebfc02171f683b0bfed6527faa2&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFindObjectByFullName</a>( \"FileReference::NS\" )\n\
lFileReference.IsLoaded = True\n\
</pre></div> \n\
            </li>\n\
         </ul>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";