var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-286414C1-4969-4BC5-9506-CB5FE8AED544\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>FBLight - Lights</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-286414C1-4969-4BC5-9506-CB5FE8AED544\"></a><div class=\"head\">\n\
            <h1>FBLight - Lights</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_9F22E61CF5784ED58BBCA01A95E2BB13\"></a> \n\
            <h2><a name=\"GUID-C519D487-D58B-4991-ABC5-3624EC3C2C89\"></a>Lights\n\
            </h2> \n\
            <p><a name=\"GUID-9EA2F5E1-3498-4312-A4F6-53A162317A2D\"></a>Lights are encapsulated by the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBLight\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_light.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_light.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLight</a></span> class. An <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBLight\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_light.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_light.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLight</a></span> is created using the <span class=\"code\" translate=\"no\">FBLight()</span> constructor. The light\'s diffuse color <span class=\"code\" translate=\"no\">FBLight.Diffuse</span> property controls the color of the light being emitted into the scene. A light\'s\n\
               behavior (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBLight.LightType\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_light.html#aa828e1b58ac55275a29bf27482de6869&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLight.LightType</a></span>) can be assigned to a value of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBLightType\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a6a60cd4271e15999ec13cfc452adaf18&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_light_type.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLightType</a></span>. The enumeration values of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBLightType\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a6a60cd4271e15999ec13cfc452adaf18&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_light_type.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLightType</a></span> are described in the following table. \n\
            </p> <a name=\"TABLE_D79DC66D880541449CFC95F1B7FAABB9\"></a><div class=\"table-ruled\">\n\
               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
                  <colgroup>\n\
                     <col width=\"28.729066597429576%\">\n\
                     <col width=\"71.27093340257042%\">\n\
                  </colgroup>\n\
                  <tr class=\"ruled-heading\">\n\
                     <th class=\"table-heading\">Light Type </th>\n\
                     <th class=\"table-heading\">Description </th>\n\
                  </tr>\n\
                  <tr class=\"ruled-odd-row\">\n\
                     <td class=\"table-body\"> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBLightType.kFBLightTypePoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_light_type.html#afb89168cd53ca8e308eda25111006f15&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLightType.kFBLightTypePoint</a></span> \n\
                     </td>\n\
                     <td class=\"table-body\"><em class=\"strong\">Point Light.</em> Light radiates from the center of the light, illuminating models in the scene. The\n\
                        <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBLight.ConeAngle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_light.html#a7bd9c5730d857fec5f9375653b473f01&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLight.ConeAngle</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBLight.FogIntensity\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_light.html#ab8be8ea10e91ccd85aa52d242f5edf19&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLight.FogIntensity</a></span> properties do not apply to point lights. \n\
                     </td>\n\
                  </tr>\n\
                  <tr class=\"ruled-even-row\">\n\
                     <td class=\"table-body\"> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBLightType.kFBLightTypeInfinite\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_light_type.html#a7556b1a639da61c192e55d9cb7f6bc7f&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLightType.kFBLightTypeInfinite</a></span> \n\
                     </td>\n\
                     <td class=\"table-body\"><em class=\"strong\">Infinite Light.</em> Light shines uniformly onto the scene, based on its rotation vector. The light\'s\n\
                        direction is not affected by its translation vector. The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBLight.ConeAngle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_light.html#a7bd9c5730d857fec5f9375653b473f01&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLight.ConeAngle</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBLight.FogIntensity\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_light.html#ab8be8ea10e91ccd85aa52d242f5edf19&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLight.FogIntensity</a></span> properties do not apply to infinite lights. \n\
                     </td>\n\
                  </tr>\n\
                  <tr class=\"ruled-odd-row\">\n\
                     <td class=\"table-body\"> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBLightType.kFBLightTypeSpot\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_light_type.html#af07c35ca56cecfa119612a4f3b328bdb&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLightType.kFBLightTypeSpot</a></span> \n\
                     </td>\n\
                     <td class=\"table-body\"><em class=\"strong\">Spot Light.</em> Light shines from a position in the scene. The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBLight.ConeAngle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_light.html#a7bd9c5730d857fec5f9375653b473f01&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLight.ConeAngle</a></span> affects the size of the cone, while the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBLight.FogIntensity\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_light.html#ab8be8ea10e91ccd85aa52d242f5edf19&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLight.FogIntensity</a></span> property affects the opacity of the fog emitted from the light source. \n\
                     </td>\n\
                  </tr>\n\
               </table>\n\
            </div> \n\
            <p><a name=\"GUID-7F89DF43-026F-4D26-9678-1D46634AE071\"></a> \n\
               <div><a name=\"GUID-82FFE728-6EA9-4C4C-BBE9-E6188CE7739D\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>The attenuation type of a light (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBLight.AttenuationType\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_light.html#a6e1292c09cfe3859d783dbbdfe0c8058&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLight.AttenuationType</a></span>) can be set to no attenuation (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBAttenuationType.kFBAttenuationNone\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_attenuation_type.html#a03e3ff4a5464686873f1d2bddcacd525&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBAttenuationType.kFBAttenuationNone</a></span>), linear (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBAttenuationType.kFBAttenuationLinear\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_attenuation_type.html#aa4a0a65fd1f089b0dba98b276272bab5&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBAttenuationType.kFBAttenuationLinear</a></span>), or quadratic (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBAttenuationType.kFBAttenuationQuadratic\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_attenuation_type.html#abe385e8ddfbd94a468f2eb1b41d12e41&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBAttenuationType.kFBAttenuationQuadratic</a></span>). However, the attenuation is only visible if a dynamic lighting shader has been\n\
                     applied to the models in the scene. For more information, consult the <span class=\"char_link\"><a href=\"#!/url=./files/GUID-286414C1-4969-4BC5-9506-CB5FE8AED544.htm#SECTION_4DA37F7224984044A6C507CC4F5BE52B\">Example: Dynamic Lighting</a></span> section below. \n\
                  </div>\n\
               </div> \n\
            </p> \n\
            <p><a name=\"GUID-F5B053F3-8D16-40FA-BACC-EC5208F48B01\"></a>In the following program, an infinite light (red), a point light (green), and a spot\n\
               light (blue) project their light onto a sphere in the scene. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">from pyfbsdk import *\n\
\n\
\n\
###############################################################\n\
# Helper Function(<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a>).                                         #\n\
###############################################################\n\
\n\
# Create an infinite light.\n\
def createInfiniteLight():\n\
    infLight = <a href=\"javascript:void(0)\" data-symbol=\"FBLight\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_light.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLight</a>(\'myInfiniteLight\')\n\
    infLight.LightType = <a href=\"javascript:void(0)\" data-symbol=\"FBLightType.kFBLightTypeInfinite\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_light_type.html#a7556b1a639da61c192e55d9cb7f6bc7f&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLightType.kFBLightTypeInfinite</a>\n\
    infLight.Translation = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(-100, 75, 0)\n\
    infLight.Rotation = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(0, 0, 145)\n\
    infLight.DiffuseColor = <a href=\"javascript:void(0)\" data-symbol=\"FBColor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_color.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBColor</a>(1, 0, 0)\n\
    infLight.Show = True\n\
\n\
# Create a point light.\n\
def createPointLight():\n\
    pointLight = <a href=\"javascript:void(0)\" data-symbol=\"FBLight\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_light.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLight</a>(\'myPointLight\')\n\
    pointLight.LightType = <a href=\"javascript:void(0)\" data-symbol=\"FBLightType.kFBLightTypePoint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_light_type.html#afb89168cd53ca8e308eda25111006f15&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLightType.kFBLightTypePoint</a>\n\
    pointLight.Translation = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(100, 75, 0)\n\
    pointLight.DiffuseColor = <a href=\"javascript:void(0)\" data-symbol=\"FBColor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_color.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBColor</a>(0, 1, 0)\n\
    pointLight.Show = True\n\
\n\
# Create a spotlight.\n\
def createSpotLight():\n\
    spotLight = <a href=\"javascript:void(0)\" data-symbol=\"FBLight\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_light.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLight</a>(\'mySpotLight\')\n\
    spotLight.LightType = <a href=\"javascript:void(0)\" data-symbol=\"FBLightType.kFBLightTypeSpot\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_light_type.html#af07c35ca56cecfa119612a4f3b328bdb&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLightType.kFBLightTypeSpot</a>\n\
    spotLight.Translation = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(0, 150, 0)\n\
    spotLight.DiffuseColor = <a href=\"javascript:void(0)\" data-symbol=\"FBColor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_color.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBColor</a>(0, 0, 1)\n\
    spotLight.Intensity = 200\n\
    spotLight.ConeAngle = 90\n\
    spotLight.Show = True\n\
\n\
# Create a sphere.\n\
def createSphere():\n\
    sphere = <a href=\"javascript:void(0)\" data-symbol=\"FBCreateObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga6698333c163da7c3bc077537889b6c33&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCreateObject</a>( \'Browsing/Templates/Elements/Primitives\', \'Sphere\', \'Sphere\' )\n\
    sphere.Name = \'mySphere\'\n\
    sphere.Translation = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(0, 50, 0)\n\
    sphere.Scaling = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(4, 4, 4)\n\
    sphere.Show = True\n\
    \n\
    \n\
###############################################################\n\
# Main.                                                       #\n\
###############################################################\n\
# Clear the scene.\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a>().FileNew()\n\
\n\
# Create a sphere and the various light types.\n\
createSphere()\n\
createInfiniteLight()\n\
createPointLight()\n\
createSpotLight()\n\
</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_39285516CC0946E28DCF068D91A0C73F\"></a> \n\
            <h2><a name=\"GUID-C3CA87A1-7E21-465B-9B53-626EB906C0AE\"></a>Ambient Light\n\
            </h2> \n\
            <p><a name=\"GUID-2353D52A-8E53-4668-AFE3-80EE999D7786\"></a>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBGlobalLight\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_global_light.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_global_light.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBGlobalLight</a></span> object represents the <em class=\"strong\">ambient light</em> in the scene. A reference to the ambient light can be obtained via <span class=\"code\" translate=\"no\">FBGlobalLight()</span>. The ambient light color (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBGlobalLight.AmbientColor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_global_light.html#a9c4cd52264bcc2db60234116c6b09245&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBGlobalLight.AmbientColor</a></span>), and fog properties (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBGlobalLight.FogEnable\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_global_light.html#ae9c919c888c79eb58bf7195ba3e17dd1&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBGlobalLight.FogEnable</a></span>, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBGlobalLight.FogColor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_global_light.html#accd9535df694a0b297cbbbb8e400f630&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBGlobalLight.FogColor</a></span>, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBGlobalLight.FogDensity\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_global_light.html#a4ae3eb444514788a524b26ed12730a88&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBGlobalLight.FogDensity</a></span>) can be accessed through this object. \n\
            </p> \n\
            <p><a name=\"GUID-00EB4925-BC58-4A12-B9BE-C0FDCB99767C\"></a>In the following program, we set the ambient light\'s color, and enable the fog. The\n\
               white fog is visible as the depth increases along the plane. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">from pyfbsdk import *\n\
\n\
# Clear the scene.\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a>().FileNew()\n\
\n\
# Get a reference to the global light.\n\
globalLight = <a href=\"javascript:void(0)\" data-symbol=\"FBGlobalLight\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_global_light.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBGlobalLight</a>()\n\
globalLight.AmbientColor = <a href=\"javascript:void(0)\" data-symbol=\"FBColor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_color.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBColor</a>(0, 1, 1) # Turquoise\n\
globalLight.FogEnable = True\n\
\n\
# Create a plane.\n\
plane = <a href=\"javascript:void(0)\" data-symbol=\"FBModelPlane\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_plane.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelPlane</a>(\'myPlane\')\n\
plane.Translation = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(0, 1, 0)\n\
plane.Scaling = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(10, 10, 10)\n\
plane.Show = True\n\
\n\
# Create a cone.\n\
model = <a href=\"javascript:void(0)\" data-symbol=\"FBCreateObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga6698333c163da7c3bc077537889b6c33&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCreateObject</a>( \'Browsing/Templates/Elements/Primitives\', \'Cone\', \'Cone\' )\n\
model.Scaling = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(10, 5, 10)\n\
model.Translation = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(0, 50, 0)\n\
model.Show = True</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_4DA37F7224984044A6C507CC4F5BE52B\"></a> \n\
            <h2><a name=\"GUID-99797737-8ECC-4507-845A-6F91504297AC\"></a>Example: Dynamic Lighting\n\
            </h2> \n\
            <p><a name=\"GUID-60E820E6-CA52-4E53-9A78-DB2C61A3CA8D\"></a> <em class=\"strong\">Sample Viewport Output:</em> \n\
            </p> \n\
            <p><a name=\"GUID-3AED1A9E-D8CE-4CD2-B1C6-BC59F9AF5D35\"></a></p> <img src=\"images/GUID-9D7D61D6-0720-4181-8C7B-DB9F1A7CC607-low.png\"> \n\
            <p><a name=\"GUID-2E348666-0AEE-4033-817E-9A1918730F07\"></a><em class=\"strong\">Program Summary:</em> The program below creates a plane (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelPlane\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_plane.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_plane.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelPlane</a></span>), a blue cylinder (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a></span>), and a spotlight (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBLight\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_light.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_light.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLight</a></span>) pointing at the cylinder. The <span class=\"code\" translate=\"no\">Dynamic Lighting</span> shader is bound to the plane and the cylinder to allow the light to project onto\n\
               their surfaces. The <span class=\"code\" translate=\"no\">Live Shadow</span> shader is bound to the plane to allow the cylinder\'s shadow to project onto the plane\'s\n\
               surface. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">from pyfbsdk import *\n\
\n\
\n\
###############################################################\n\
# Helper Function(<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a>).                                         #\n\
###############################################################\n\
\n\
# Create a spotlight positioned at pTranslation, which will\n\
# shine light on pModel.\n\
def createSpotlight(pTranslation, pModel):\n\
    light = <a href=\"javascript:void(0)\" data-symbol=\"FBLight\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_light.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLight</a>(\'myLight\')\n\
    light.LightType = <a href=\"javascript:void(0)\" data-symbol=\"FBLightType.kFBLightTypeSpot\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_light_type.html#af07c35ca56cecfa119612a4f3b328bdb&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLightType.kFBLightTypeSpot</a>\n\
    light.Intensity = 200\n\
    light.ConeAngle = 70\n\
    light.FogIntensity = 20\n\
    light.Show = True\n\
    light.Translation = pTranslation\n\
    light.LookAt = pModel\n\
    return light\n\
\n\
# Create a large plane.\n\
def createPlane():\n\
    plane = <a href=\"javascript:void(0)\" data-symbol=\"FBModelPlane\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_plane.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelPlane</a>(\'myPlane\')\n\
    plane.Translation = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(0, 1, 0)\n\
    plane.Scaling = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(5, 0, 5)\n\
    plane.Show = True\n\
    return plane\n\
\n\
# Create a cylinder.\n\
def createCylinder():\n\
    cylinder = <a href=\"javascript:void(0)\" data-symbol=\"FBCreateObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga6698333c163da7c3bc077537889b6c33&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCreateObject</a>( \'Browsing/Templates/Elements/Primitives\', \'Cylinder\', \'Cylinder\' )\n\
    cylinder.Scaling = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(5, 3, 5)\n\
    cylinder.Translation = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(0, 30, 0)\n\
    cylinder.Show = True\n\
    return cylinder\n\
\n\
# Create a blue material.\n\
def createMaterial():\n\
    material = <a href=\"javascript:void(0)\" data-symbol=\"FBMaterial\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_material.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMaterial</a>(\'myMaterial\')\n\
    material.Diffuse = <a href=\"javascript:void(0)\" data-symbol=\"FBColor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_color.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBColor</a>(0.25, 0.56, 0.8)\n\
    return material\n\
\n\
# Create a live shadow shader. This shader projects the shadow of an occluding\n\
# <a href=\"javascript:void(0)\" data-symbol=\"object\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#a904fdf014f8cdbefe8320ca2bfd6daf6&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">object</a> onto a surface.\n\
def createLiveShadowShader():\n\
    shader = <a href=\"javascript:void(0)\" data-symbol=\"FBCreateObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga6698333c163da7c3bc077537889b6c33&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCreateObject</a>(\'Browsing/Templates/Shading Elements/Shaders\', \'Live Shadow\', \'myLiveShadowShader\')\n\
    return shader\n\
\n\
# Create a dynamic lighting shader. This shader projects light dynamically\n\
# onto surfaces.\n\
def createDynamicLightingShader():\n\
    shader = <a href=\"javascript:void(0)\" data-symbol=\"FBCreateObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga6698333c163da7c3bc077537889b6c33&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCreateObject</a>(\'Browsing/Templates/Shading Elements/Shaders\', \'Dynamic Lighting\', \'myDynamicLightingShader\')\n\
    return shader\n\
    \n\
\n\
\n\
###############################################################\n\
# Main.                                                       #\n\
###############################################################\n\
# Clear the scene.\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a>().FileNew()\n\
\n\
# Create a plane and a cylinder.\n\
plane = createPlane()\n\
cylinder = createCylinder()\n\
\n\
# Create a material to apply to the cylinder.\n\
material = createMaterial()\n\
cylinder.Materials.append(material)\n\
\n\
# Create a spotlight looking at the cylinder.\n\
light = createSpotlight(<a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(-150, 150, -20), cylinder)\n\
\n\
# Create the live shadow and dynamic lighting shaders.\n\
liveShadow = createLiveShadowShader()\n\
dynamicLighting = createDynamicLightingShader()\n\
\n\
# Apply the shaders to the plane.\n\
plane.Shaders.append(liveShadow)\n\
plane.Shaders.append(dynamicLighting)\n\
plane.ShadingMode = <a href=\"javascript:void(0)\" data-symbol=\"FBModelShadingMode.kFBModelShadingDefault\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_shading_mode.html#aca9ba938464abeaf4480fcd049f41d78&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelShadingMode.kFBModelShadingDefault</a>\n\
\n\
# Apply the dynamic lighting shader to the cylinder.\n\
cylinder.Shaders.append(dynamicLighting)\n\
cylinder.ShadingMode = <a href=\"javascript:void(0)\" data-symbol=\"FBModelShadingMode.kFBModelShadingDefault\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_shading_mode.html#aca9ba938464abeaf4480fcd049f41d78&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelShadingMode.kFBModelShadingDefault</a></pre></div> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";