var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-301B65DC-1205-4AA1-AB0C-F6855FE9465A\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Adjusting the Extraction</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-301B65DC-1205-4AA1-AB0C-F6855FE9465A\"></a><div class=\"head\">\n\
            <h1>Adjusting the Extraction</h1>\n\
         </div>\n\
         <p><a name=\"GUID-61372C96-6616-4FFD-A1E5-AFE2075AFF88\"></a>You can adjust or override the extraction to prevent locking of the elbows/knees.\n\
            You can refer to the <span class=\"filePath\" translate=\"no\">constraintextraction</span> sample at <a href=\"http://area.autodesk.com/downloads/plugins/sample_plug_ins_for_the_flexible_mocap_workflow\" target=\"_blank\">http://area.autodesk.com/downloads/plugins/sample_plug_ins_for_the_flexible_mocap_workflow</a>. \n\
         </p>\n\
         <p><a name=\"GUID-C6ED0F32-66BF-40D1-92F7-0B54F7961417\"></a>The sample shows how to read the original extraction and decide whether to override\n\
            the extraction. \n\
         </p>\n\
         <div class=\"codeBlock\"><a name=\"LANG-CPP\"></a><pre class=\"prettyprint lang-cpp\">void ORConstraintExtraction::SetupAllAnimationNodes()\n\
{\n\
  if(Character.GetSrcCount() &gt; 0)\n\
  {\n\
    <a href=\"javascript:void(0)\" data-symbol=\"FBCharacter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_character.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacter</a>* lCharacter = (<a href=\"javascript:void(0)\" data-symbol=\"FBCharacter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_character.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacter</a>*)Character.GetSrc(0);\n\
    <a href=\"javascript:void(0)\" data-symbol=\"FBCharacterMarkerSet\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_character_marker_set.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacterMarkerSet</a>* lMarkerSet = lCharacter ? lCharacter-&gt;GetCharacterMarkerSet():<a href=\"javascript:void(0)\" data-symbol=\"NULL\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/kaydara_8h.html#a070d2ce7b6bb7e5c05602aa8c308d0c4&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">NULL</a>;\n\
\n\
    if(lMarkerSet)\n\
    {\n\
      for(<a href=\"javascript:void(0)\" data-symbol=\"int\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/code_8h.html#aa4332194bf83cd22038ee4511e4decea&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">int</a> <a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a> = 0; <a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a> &lt; mNodes.GetCount(); <a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a>++)\n\
      {\n\
        mNodes[<a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a>]-&gt;Setup(lCharacter, this, <a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a>); \n\
      }\n\
    }\n\
  }\n\
}\n\
 \n\
void ORConstraintExtraction::Node::Setup(<a href=\"javascript:void(0)\" data-symbol=\"FBCharacter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_character.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacter</a>* pCharacter, <a href=\"javascript:void(0)\" data-symbol=\"FBConstraint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_constraint.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConstraint</a>* pConstraint, <a href=\"javascript:void(0)\" data-symbol=\"int\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/code_8h.html#aa4332194bf83cd22038ee4511e4decea&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">int</a> pIndex)\n\
{\n\
  <a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a>* lStartGoalModel = pCharacter-&gt;GetGoalModel(mStartNode);\n\
  <a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a>* lEndGoalModel = pCharacter-&gt;GetGoalModel(mEndNode);\n\
\n\
  if(lStartGoalModel &amp;&amp; lEndGoalModel)\n\
  {\n\
    FBTVector lT_A,lT_B,lV;\n\
    \n\
    // Get the characterization stance pose to calculate the maximum length.\n\
    pCharacter-&gt;GetTOffset(mStartNode, &amp;lT_A);\n\
    pCharacter-&gt;GetTOffset(mEndNode, &amp;lT_B);\n\
\n\
    <a href=\"javascript:void(0)\" data-symbol=\"FBSub\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#gace259831e0b3096ffd8293f2f177325b&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSub</a>(lV, lT_B, lT_A);\n\
    // Calculate the maximum allowed <a href=\"javascript:void(0)\" data-symbol=\"length\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/sliceobject_8h.html#abbd88c7a30e7a4643b0fc1675646d4a8&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">length</a> per body part.\n\
    mLength = <a href=\"javascript:void(0)\" data-symbol=\"FBLength\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#gaa9ef7e1aa8b2b5bb860081c038e60b68&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLength</a>(lV);\n\
 \n\
    mReadT = lEndGoalModel-&gt;Translation.GetAnimationNode();\n\
    // Create the input connector to end the effector translation (global data)\n\
    mWriteT = pConstraint-&gt;AnimationNodeInCreate  (pIndex+1, lEndGoalModel, <a href=\"javascript:void(0)\" data-symbol=\"ANIMATIONNODE_TYPE_TRANSLATION\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/fbdata_8h.html#ad028286cbd5236e6861369feb0458a0b&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">ANIMATIONNODE_TYPE_TRANSLATION</a>);\n\
  }\n\
}\n\
\n\
void ORConstraintExtraction::Node::Solve(<a href=\"javascript:void(0)\" data-symbol=\"FBCharacter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_character.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacter</a>* pCharacter, <a href=\"javascript:void(0)\" data-symbol=\"FBConstraint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_constraint.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConstraint</a>* pConstraint, <a href=\"javascript:void(0)\" data-symbol=\"FBEvaluateInfo\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_evaluate_info.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBEvaluateInfo</a>* pEvaluateInfo)\n\
{\n\
  if(mReadT == <a href=\"javascript:void(0)\" data-symbol=\"NULL\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/kaydara_8h.html#a070d2ce7b6bb7e5c05602aa8c308d0c4&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">NULL</a> || mWriteT == <a href=\"javascript:void(0)\" data-symbol=\"NULL\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/kaydara_8h.html#a070d2ce7b6bb7e5c05602aa8c308d0c4&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">NULL</a>) return;\n\
\n\
  <a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a>* lStart = pCharacter-&gt;GetGoalModel(mStartNode);\n\
  <a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a>* lEnd = pCharacter-&gt;GetGoalModel(mEndNode);\n\
\n\
  if(lStart &amp;&amp; lEnd)\n\
  {\n\
    FBTVector lT_A,lT_B,lV;\n\
\n\
    lStart-&gt;GetVector(*(<a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>*)(lT_A.mValue), kModelTranslation, <a href=\"javascript:void(0)\" data-symbol=\"true\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#af6a258d8f3ee5206d682d799316314b1a08f175a5505a10b9ed657defeb050e4b&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">true</a>, pEvaluateInfo);\n\
    // <a href=\"javascript:void(0)\" data-symbol=\"Read\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_h_i_k2014_2humanik_2hikdump_8h.html#a10af876bf533fd4d8cabb45e159d8704&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Read</a> from the connector directly, knowing that data over there is always \n\
    // written globally by the Character Marker <a href=\"javascript:void(0)\" data-symbol=\"Set\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a8b39bad9fda6bc73af75e4d6085bcf91&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Set</a> solver.\n\
    mReadT-&gt;ReadData(lT_B.mValue, pEvaluateInfo);\n\
\n\
    <a href=\"javascript:void(0)\" data-symbol=\"FBSub\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#gace259831e0b3096ffd8293f2f177325b&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSub</a>(lV, lT_B, lT_A);\n\
    double lCurrentLength = <a href=\"javascript:void(0)\" data-symbol=\"FBLength\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#gaa9ef7e1aa8b2b5bb860081c038e60b68&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLength</a>(lV);\n\
\n\
    // Very simple <a href=\"javascript:void(0)\" data-symbol=\"test\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/graminit_8h.html#af04af1bc6d042a68a2b24d6e1312d253&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">test</a> that can be expanded to more sophisticated logic.\n\
    if(lCurrentLength &gt; mLength)\n\
    {\n\
      <a href=\"javascript:void(0)\" data-symbol=\"FBMult\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga5681901b5a13f9a59efbb3b6317a730e&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMult</a>(lV,lV,mLength/lCurrentLength);\n\
\n\
      <a href=\"javascript:void(0)\" data-symbol=\"FBAdd\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga3d89e7ebf98292cb4e4a9092d15dc236&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBAdd</a>(lT_B, lT_A, lV);\n\
\n\
      // <a href=\"javascript:void(0)\" data-symbol=\"Write\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_h_i_k2014_2humanik_2hikdump_8h.html#a1d1ad5167f4ec48974c454e18a0a4ca9&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Write</a> the clamp global translation.\n\
      mWriteT-&gt;WriteData(lT_B.mValue, pEvaluateInfo);\n\
    }\n\
  }\n\
}\n\
\n\
<a href=\"javascript:void(0)\" data-symbol=\"bool\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#af6a258d8f3ee5206d682d799316314b1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">bool</a> ORConstraintExtraction::AnimationNodeNotify(<a href=\"javascript:void(0)\" data-symbol=\"FBAnimationNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_animation_node.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBAnimationNode</a>* pConnector,\n\
     <a href=\"javascript:void(0)\" data-symbol=\"FBEvaluateInfo\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_evaluate_info.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBEvaluateInfo</a>* pEvaluateInfo,<a href=\"javascript:void(0)\" data-symbol=\"FBConstraintInfo\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_constraint_info.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConstraintInfo</a>* pConstraintInfo)\n\
{\n\
  // <a href=\"javascript:void(0)\" data-symbol=\"If\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a3caa32cf8ff8db15e5835f5e40e6c6f8&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">If</a> any character is connected (Just in case, as it is used blindly afterwards)\n\
  if(Character.GetSrcCount() &gt; 0)\n\
  {\n\
    <a href=\"javascript:void(0)\" data-symbol=\"FBCharacter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_character.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacter</a>* lCharacter = (<a href=\"javascript:void(0)\" data-symbol=\"FBCharacter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_character.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacter</a>*)Character.GetSrc(0);\n\
\n\
    // Solve all the constraints.\n\
    for(<a href=\"javascript:void(0)\" data-symbol=\"int\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/code_8h.html#aa4332194bf83cd22038ee4511e4decea&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">int</a> <a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a> = 0; <a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a> &lt; mNodes.GetCount(); <a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a>++)\n\
    {\n\
      mNodes[<a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a>]-&gt;Solve(lCharacter, this, pEvaluateInfo); \n\
    }\n\
  }\n\
  // Disable all the animation nodes that you did not write to.\n\
  // This optimization stops the evaluation engine\n\
  // from calling AnimationNodeNotify again in the same evaluation ID\n\
  AnimationNodesOutDisableIfNotWritten(pEvaluateInfo);\n\
\n\
  return <a href=\"javascript:void(0)\" data-symbol=\"true\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#af6a258d8f3ee5206d682d799316314b1a08f175a5505a10b9ed657defeb050e4b&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">true</a>;\n\
}</pre></div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";