var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-31143776-6E20-4A4E-B082-E3F2DDFFE841\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Instancing a Referenced Object</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-31143776-6E20-4A4E-B082-E3F2DDFFE841\"></a><div class=\"head\">\n\
            <h1>Instancing a Referenced Object</h1>\n\
         </div>\n\
         <p><a name=\"GUID-943FB45F-6E7C-4489-85A3-744B454E6C87\"></a> You can instance a referenced object after it is loaded into MotionBuilder, or upon\n\
            load. You need to specify the number of instances. This is useful in some cases, for\n\
            example, when a layout artist wants to populate a set with many identical objects.\n\
            \n\
         </p>\n\
         <p><a name=\"GUID-9EB342F6-82E9-4324-A1BF-2B381FF77D32\"></a>The following script creates a couple of cloned reference objects using the names\n\
            in the <span class=\"code\" translate=\"no\">lNameList</span>. The second parameter of the function <span class=\"code\" translate=\"no\">DuplicateFileRef</span> is set to <span class=\"code\" translate=\"no\">True</span> to apply the reference edit that the original reference object has after the instancing\n\
            is done. \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">lNameList = <a href=\"javascript:void(0)\" data-symbol=\"FBStringList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_string_list.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBStringList</a>()\n\
lNameList.Add( \"NS_CLONE\" ) \n\
lFileReference.DuplicateFileRef( lNameList, True )\n\
</pre></div> \n\
         </p>\n\
         <p><a name=\"GUID-247F4918-645F-4926-8476-DC4E81CF7A6B\"></a>The following code snippet demonstrates how to instance multiple objects on load.\n\
            This is helpful if you want to bring in many of the same objects and share the same\n\
            geometry. \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"FBSystem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem</a>().Scene.NamespaceImport( \"NS~NS2~NS3\", \"abc.fbx\", True )\n\
# Reference three instances of the same file. </pre></div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";