var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-34FB0BD6-6FE8-479F-86C8-929E0FC09244\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Managing Python Tools</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-34FB0BD6-6FE8-479F-86C8-929E0FC09244\"></a><div class=\"head\">\n\
            <h1>Managing Python Tools</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_DBDCE008F66042C8AF61F354AE71B8C1\"></a> \n\
            <h2><a name=\"GUID-A87F28B4-431C-492A-A47C-849D8D2C2812\"></a>Python Tool Manager\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F48755-57AF30D311C79E97FC3E02\"></a>The <em class=\"mild\">Python Tool Manager</em> is a dialog containing a button for each running Python tool. It uses functionality\n\
               in pyfbsdk_additions to listen for Python tools being created or destroyed and updates\n\
               the buttons accordingly. To open the Tool Manager, click Tool Manager tool in the\n\
               <span class=\"char_link\"><a href=\"#!/url=./files/GUID-6B00DBAE-EC34-4958-86F5-A5B644C2DB00.htm\">Python Editor</a></span>. The Tool Manager script is itself a Python tool and is found in <span class=\"filePath\" translate=\"no\">config\\Python</span>. \n\
            </p> \n\
            <p><a name=\"WS73099CC142F48755-57AF30D311C79E97FC3E01\"></a>If you close the tool by using the X button in the right corner, use the Tool Manager\n\
               to restart it. \n\
            </p> \n\
            <p><a name=\"WS1A9193826455F5FF-E569A0121D1945C08DE\"></a>You can write your own tool manager. See the <span class=\"filePath\" translate=\"no\">ToolManager.py</span> script for details. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_DC58867995C7417998CD74C13C1E7BF4\"></a> \n\
            <h2><a name=\"GUID-811722C4-87AE-4585-A86E-4E6944B98411\"></a>Binding Keyboard Shortcuts to a Python Tool\n\
            </h2> \n\
            <p><a name=\"GUID-C27E780B-6EE7-42D9-9D2F-B5D1A7F7ECA2\"></a>There are two types of Python shortcuts: \n\
            </p> <a name=\"WS1A9193826455F5FF603F1A63123AB7A861F-72AF\"></a><ul>\n\
               <li>Shortcuts which apply from within the Python editor, e.g. <span class=\"code\" translate=\"no\">F5</span> to execute the current script, or <span class=\"code\" translate=\"no\">F10</span> to launch the tool manager. \n\
               </li>\n\
               <li>Global shortcuts which can be used to access Python scripts from anywhere in MotionBuilder.\n\
                  \n\
               </li>\n\
            </ul> \n\
            <p><a name=\"WS1A9193826455F5FF603F1A63123AB7A861F-72AB\"></a>You can create up to 12 global shortcuts that can be mapped to scripts. Some shortcuts\n\
               are already mapped by default. For example, <span class=\"code\" translate=\"no\">Shift+F1</span> is bound to the execution of <span class=\"filePath\" translate=\"no\">NewCamera.py</span>. Pressing <span class=\"code\" translate=\"no\">Shift+F1</span> from the MotionBuilder interface will therefore create a new camera. \n\
            </p> <a name=\"WS1A9193826455F5FF603F1A63123AB7A861F-72AA\"></a><p class=\"list-intro\"><a name=\"WS1A9193826455F5FF603F1A63123AB7A861F-72A9\"></a>Bindings between shortcuts and scripts are configured in two steps:\n\
            </p>\n\
            <ol type=\"1\" start=\"1\">\n\
               <li>Add the scripts to the <span class=\"code\" translate=\"no\">[ScriptFiles]</span> section of <span class=\"filePath\" translate=\"no\">config\\Scripts\\ActionScript.txt</span>. \n\
               </li>\n\
               <li>Define the shortcuts in <span class=\"filePath\" translate=\"no\">config\\Keyboard\\</span>. This can be done by editing the files with a text editor or by using the graphical\n\
                  editor provided by the script <span class=\"filePath\" translate=\"no\">KeyboardMapper.py</span>. \n\
               </li>\n\
            </ol> \n\
            <p><a name=\"WS1A9193826455F5FF603F1A63123AB7A861F-72A6\"></a> <span class=\"filePath\" translate=\"no\">config\\Scripts\\ActionScript.txt</span> contains a list of scripts to execute: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">[ScriptFiles]\n\
Script1 = Basic/OperationsNewCamera.py\n\
Script2 = ActionScriptKeyIK.py\n\
Script3 = ActionScriptKeyFK.py\n\
Script4 = ActionScriptKeyEffector.py\n\
Script5 = ActionScriptKeySelected.py\n\
Script6 = \n\
Script7 = \n\
Script8 = \n\
Script9 = \n\
Script10 = \n\
Script11 = \n\
Script12 = </pre></div> \n\
            <p><a name=\"GUID-C401C6F4-2659-4C4B-9B84-EAEC2403BEFC\"></a>The path to the script can be: \n\
            </p> <a name=\"WS1A9193826455F5FF603F1A63123AB7A861F-72A5\"></a><ul>\n\
               <li>Relative to the location of <span class=\"filePath\" translate=\"no\">ActionScript.txt</span>, e.g. <span class=\"filePath\" translate=\"no\">..\\myScript.py</span> \n\
               </li>\n\
               <li>An absolute path, e.g. <span class=\"filePath\" translate=\"no\">c:\\scripts\\myScript.py</span>. \n\
               </li>\n\
               <li>A path to a server, e.g. <span class=\"filePath\" translate=\"no\">\\\\someserver\\scripts\\myScript.py</span>. \n\
               </li>\n\
            </ul> \n\
            <p><a name=\"WS1A9193826455F5FF-E569A0121D1945C08EA\"></a>Files in <span class=\"filePath\" translate=\"no\">config\\Keyboard\\</span> map the keyboard shortcuts to their respective script name. These files contain entries\n\
               for all of the keyboard shortcuts in MotionBuilder. There are several files; you use\n\
               one at a time according to the menu <span class=\"code\" translate=\"no\">Settings &gt; Keyboard Configuration</span>. You can also use the <span class=\"filePath\" translate=\"no\">KeyboardMapper.py</span> script as a graphical interface to the keyboard configuration text files. \n\
            </p> \n\
            <p><a name=\"WS1A9193826455F5FF603F1A63123AB7A861F-72A0\"></a>Python script bindings are of the form: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">action.global.script1 = {SHFT:F1*DN}</pre></div> \n\
            <p><a name=\"WS1A9193826455F5FF-E569A0121D1945C08EB\"></a>Do not to assign the same shortcut to two different actions. If you do, neither will\n\
               work. \n\
            </p> \n\
            <p><a name=\"WS1A9193826455F5FF603F1A63123AB7A861F-729F\"></a>You can create your own keyboard.txt files. In the example below, \"MyKeyboardConfig\"\n\
               would appear in the <span class=\"code\" translate=\"no\">Settings &gt; Keyboard Configuration</span> menu after MotionBuilder restart. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">[Config]\n\
<a href=\"javascript:void(0)\" data-symbol=\"Name\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a3e9f22c154a65956ebd413d2d8dafc0f&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Name</a> = MyKeyboardConfig</pre></div> \n\
            <p><a name=\"WS1A9193826455F5FF-E569A0121D1945C08ED\"></a>Following are codes used in <span class=\"filePath\" translate=\"no\">Keyboard\\*.txt</span>. See the existing keyboard files for examples of usage. \n\
            </p> \n\
            <p><a name=\"WS1A9193826455F5FF603F1A63123AB7A861F-729E\"></a>Note that a key is specified, and not a character. For example, on a standard American\n\
               keyboard there is no \"@\" key, since this character is made by using the modifier key\n\
               <span class=\"code\" translate=\"no\">Shift+2</span>. \n\
            </p> \n\
            <div class=\"section\"><a name=\"SECTION_38D1DC2AF0B84909ABD02F22A0ACF359\"></a> \n\
               <h3><a name=\"GUID-6970AC77-2F18-4919-96D2-BA453175F0C2\"></a>Numpad Modifiers\n\
               </h3> <a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6C23\"></a><div class=\"table-ruled\">\n\
                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
                     <colgroup>\n\
                        <col width=\"28.729066597429576%\">\n\
                        <col width=\"71.27093340257042%\">\n\
                     </colgroup>\n\
                     <tr class=\"ruled-heading\">\n\
                        <th class=\"table-heading\">Key Name </th>\n\
                        <th class=\"table-heading\">Code </th>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> Num lock </td>\n\
                        <td class=\"table-body\">NUML </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\">Division </td>\n\
                        <td class=\"table-body\">NDIV </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\">Subtraction </td>\n\
                        <td class=\"table-body\">NSUB </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\">Decimal point </td>\n\
                        <td class=\"table-body\">NDEC </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\">Numpad 0 </td>\n\
                        <td class=\"table-body\">N0 </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\">Numpad 1 </td>\n\
                        <td class=\"table-body\">N1 </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\">Numpad 2 </td>\n\
                        <td class=\"table-body\">N2 </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\">Numpad 3 </td>\n\
                        <td class=\"table-body\">N3 </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\">Numpad 4 </td>\n\
                        <td class=\"table-body\">N4 </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\">Numpad 5 </td>\n\
                        <td class=\"table-body\">N5 </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\">Numpad 6 </td>\n\
                        <td class=\"table-body\">N6 </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\">Numpad 7 </td>\n\
                        <td class=\"table-body\">N7 </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\">Numpad 8 </td>\n\
                        <td class=\"table-body\">N8 </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\">Numpad 9 </td>\n\
                        <td class=\"table-body\">N9 </td>\n\
                     </tr>\n\
                  </table>\n\
               </div> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_8A5D8CA9368243A790972EE034A00A52\"></a> \n\
               <h3><a name=\"GUID-05D285DB-ABEE-4936-A1EA-8080C9E9AAB7\"></a>Keyboard Modifiers\n\
               </h3> <a name=\"TABLE_41DF83B87F964E8B995CE007C9880B1F\"></a><div class=\"table-ruled\">\n\
                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
                     <colgroup>\n\
                        <col width=\"28.729066597429576%\">\n\
                        <col width=\"71.27093340257042%\">\n\
                     </colgroup>\n\
                     <tr class=\"ruled-heading\">\n\
                        <th class=\"table-heading\">Key Name </th>\n\
                        <th class=\"table-heading\">Code </th>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\">Shift </td>\n\
                        <td class=\"table-body\">SHFT </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\">Ctrl </td>\n\
                        <td class=\"table-body\">CTRL </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\">Alt </td>\n\
                        <td class=\"table-body\">ALT </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\">Alt+Ctrl </td>\n\
                        <td class=\"table-body\">ALCT </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\">Alt+Shift </td>\n\
                        <td class=\"table-body\">ALSH </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\">Alt+Control+Shift </td>\n\
                        <td class=\"table-body\">ALCTSH </td>\n\
                     </tr>\n\
                  </table>\n\
               </div> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_2277A2311F3F435A9C14DEC2BECD35B7\"></a> \n\
               <h3><a name=\"GUID-EA3943B0-2B41-4AFD-903B-CEDB0D10406A\"></a>Keyboard Keys\n\
               </h3> <a name=\"TABLE_F5888974E2F6413D9785CEC96D74AB7D\"></a><div class=\"table-ruled\">\n\
                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
                     <colgroup>\n\
                        <col width=\"28.729066597429576%\">\n\
                        <col width=\"71.27093340257042%\">\n\
                     </colgroup>\n\
                     <tr class=\"ruled-heading\">\n\
                        <th class=\"table-heading\">Key Name </th>\n\
                        <th class=\"table-heading\">Code </th>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\"> Tab </td>\n\
                        <td class=\"table-body\">TAB </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\">Caps Lock </td>\n\
                        <td class=\"table-body\">CAPS </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\">Backspace </td>\n\
                        <td class=\"table-body\">BKSP </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\">Left Bracket </td>\n\
                        <td class=\"table-body\">LBR </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\">Right Bracket </td>\n\
                        <td class=\"table-body\">RBR </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\">Semi-colon </td>\n\
                        <td class=\"table-body\">SEMI </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\">Return/Enter </td>\n\
                        <td class=\"table-body\">ENTR </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\">Space Bar </td>\n\
                        <td class=\"table-body\">SPC </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\">Pause </td>\n\
                        <td class=\"table-body\">PAUSE </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\">Insert </td>\n\
                        <td class=\"table-body\">INS </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\">Home </td>\n\
                        <td class=\"table-body\">HOME </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\">Page Up </td>\n\
                        <td class=\"table-body\">PGUP </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\">Page Down </td>\n\
                        <td class=\"table-body\">PGDN </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\">Delete </td>\n\
                        <td class=\"table-body\">DEL </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\">End </td>\n\
                        <td class=\"table-body\">END </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\">Up Arrow </td>\n\
                        <td class=\"table-body\">UP </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\">Left Arrow </td>\n\
                        <td class=\"table-body\">LEFT </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-even-row\">\n\
                        <td class=\"table-body\">Down Arrow </td>\n\
                        <td class=\"table-body\">DOWN </td>\n\
                     </tr>\n\
                     <tr class=\"ruled-odd-row\">\n\
                        <td class=\"table-body\">Right Arrow </td>\n\
                        <td class=\"table-body\">RGHT </td>\n\
                     </tr>\n\
                  </table>\n\
               </div> \n\
            </div> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";