var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-391A97C9-35B9-4C98-A8CE-5CD718A7D70A\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Running Python Scripts</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-391A97C9-35B9-4C98-A8CE-5CD718A7D70A\"></a><div class=\"head\">\n\
            <h1>Running Python Scripts</h1>\n\
         </div>\n\
         <p><a name=\"GUID-D33C9ACD-95DA-439D-BD1B-DA5996FDFCA4\"></a>You can run Python scripts when MotionBuilder starts up and while MotionBuilder is\n\
            running. \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_B6236C12F7014E20B3F56480FFFAD8BD\"></a> \n\
            <h2><a name=\"GUID-38CC24D9-8D8B-4A91-8DFB-CB6E02DA29E5\"></a>Running Python Scripts at Start Up\n\
            </h2> \n\
            <p><a name=\"GUID-AEAD13C2-7EE7-4BD0-9118-FAF50E121F89\"></a>At start up, MotionBuilder runs Python scripts in the following order: <a name=\"OL_94AF153530954E9B92A250C8E4C22E5C\"></a><ol type=\"1\" start=\"1\">\n\
                  <li><span class=\"filePath\" translate=\"no\">ToolManager.py</span> in <span class=\"filePath\" translate=\"no\">&lt;yourinstallationfolder&gt;\\bin\\config\\Python\\ToolManager.py</span>. The Python Tool Manager stores a list of all custom tools that you create using\n\
                     Python. For more information, see <span class=\"char_link\"><a href=\"#!/url=./files/GUID-34FB0BD6-6FE8-479F-86C8-929E0FC09244.htm#SECTION_DBDCE008F66042C8AF61F354AE71B8C1\">Managing Python Tools</a></span>. \n\
                  </li>\n\
                  <li>Python scripts in the user folder. For example, <span class=\"filePath\" translate=\"no\">C:\\Users\\&lt;username&gt;\\Documents\\MB\\&lt;year&gt;-x64\\config\\PythonStartup</span>) \n\
                  </li>\n\
                  <li>Python scripts in <span class=\"filePath\" translate=\"no\">&lt;yourinstallationfolder&gt;\\bin\\config\\PythonStartup</span> \n\
                  </li>\n\
                  <li>Python scripts in a user defined Python startup folder. To set the user defined Python\n\
                     startup folder, select <span class=\"MenuCascade\" id=\"GUID-211FB740-24BB-4A15-A7C6-9266C1CDBED8\">Settings <img src=\"images/ac.menuaro.gif\"> Preferences <img src=\"images/ac.menuaro.gif\"> Python</span>, and specify a folder in the <span class=\"MenuCascade\" id=\"GUID-635C707E-A0F3-4156-8699-6DA16915012A\">Python startup folder</span> field. \n\
                  </li>\n\
               </ol>\n\
               <div><a name=\"GUID-E9AFBAF7-31AC-4D2D-BB82-F01B06A5C1B5\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Do not specify a system folder like <span class=\"filePath\" translate=\"no\">&lt;yourinstallationfolder&gt;\\bin\\config\\Scripts\\UI</span> as the Python startup folder. Some scripts in these folders might not work during\n\
                     start up and can crash MotionBuilder. It is a best practice to create your own folder\n\
                     to save scripts and specify it as the Python startup folder. \n\
                  </div>\n\
               </div> \n\
            </p> \n\
            <p><a name=\"GUID-8CA4DDA2-4774-4821-A590-90474AD8C619\"></a>The startup folder is added to the Python import path variable (<span class=\"code\" translate=\"no\">sys.path</span>). You can import functionality from scripts saved here to other scripts. Alternatively,\n\
               you can also use the <span class=\"char_link\"><a href=\"#!/url=./files/GUID-989682FC-305F-4925-8B37-66490BC45C4C.htm\">Command Line Options</a></span> to specify which script to run when MotionBuilder starts up. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_9A2F4B6A757B456B996C23C5D44A3A79\"></a> \n\
            <h2><a name=\"GUID-4E64EB03-042B-4DF2-AE62-5A626C665044\"></a>Executing Python Programs while MotionBuilder is Running\n\
            </h2> \n\
            <p><a name=\"GUID-D9E4249F-5577-41F7-A5D4-9E190B87E619\"></a>You can run Python scripts within MotionBuilder in the following ways: \n\
            </p> <a name=\"UL_E64E37FA0243415C9F4F4E07B128546F\"></a><ul>\n\
               <li> \n\
                  <p><a name=\"GUID-405850BE-8DB7-4B75-A3B3-880D0F70F17E\"></a>Run individual commands and Python scripts in the <span class=\"char_link\"><a href=\"#!/url=./files/GUID-6B00DBAE-EC34-4958-86F5-A5B644C2DB00.htm\">Python Editor</a></span>\'s interactive console, or using the <span class=\"char_link\"><a href=\"#!/url=./files/GUID-82CF06D0-BC20-4F4A-A7E0-A61CDF2670D2.htm\">Python Telnet Console</a></span>. \n\
                  </p> \n\
               </li>\n\
               <li>Bind Python scripts to a keyboard shortcut. For more information, see <span class=\"char_link\"><a href=\"#!/url=./files/GUID-34FB0BD6-6FE8-479F-86C8-929E0FC09244.htm#SECTION_DC58867995C7417998CD74C13C1E7BF4\">Managing Python Tools</a></span>. \n\
               </li>\n\
               <li>Run Python scripts from the Asset Browser using a custom path (right click in the\n\
                  navigation tree). When you drag and drop from the Asset Browser to the scene, you\n\
                  are prompted to execute, add to the scene, or both. Adding to the scene makes it accessible\n\
                  in the Navigator under Scripts. \n\
               </li>\n\
               <li>Run Python scripts through MotionBuilder\'s C++ API function <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBApplication::ExecuteScript()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_application.html#ad1cd7792dd9dd89f5d2690a0fba85871&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication::ExecuteScript()</a>.</span> \n\
               </li>\n\
            </ul> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";