var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-3C3563D5-F88E-4E1B-BA83-0B1EF4F1A2B7\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Sampling modes</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-3C3563D5-F88E-4E1B-BA83-0B1EF4F1A2B7\"></a><div class=\"head\">\n\
            <h1>Sampling modes</h1>\n\
         </div><a name=\"GUID-067D15FF-2E96-4E72-973A-A0D34421E439\"></a><dl>\n\
            <dt><a name=\"WS1A9193826455F5FF-6AB24494122F0F3D6B8-1420\"></a><span class=\"term\"><a name=\"WS1A9193826455F5FF-6AB24494122F0F3D6B8-141F\"></a>Hardware timestamp</span></dt>\n\
            <dd>\n\
               <div class=\"definition\"><a name=\"WS1A9193826455F5FF-6AB24494122F0F3D6B8-141E\"></a> \n\
                  <p><a name=\"WS1A9193826455F5FF-6AB24494122F0F3D6B8-141D\"></a>This is the best mode. The hardware has its own internal clock, and attaches a timestamp\n\
                     to each packet. The advantages are the uniqueness of each packet, and independence\n\
                     from communication spurts. \n\
                  </p> \n\
               </div>\n\
            </dd>\n\
            <dt><a name=\"WS1A9193826455F5FF-6AB24494122F0F3D6B8-141C\"></a><span class=\"term\"><a name=\"WS1A9193826455F5FF-6AB24494122F0F3D6B8-141B\"></a>Hardware frequency</span></dt>\n\
            <dd>\n\
               <div class=\"definition\"><a name=\"WS1A9193826455F5FF-6AB24494122F0F3D6B8-141A\"></a> \n\
                  <p><a name=\"WS1A9193826455F5FF-6AB24494122F0F3D6B8-1419\"></a>This is the second best time stamping mode. The sampling interval is known to be at\n\
                     a given fixed frequency. At the beginning of the communication, a time counter is\n\
                     started for the device. The hardware packet, upon arrival, is given the current timestamp\n\
                     for packets. This ‘current timestamp’ is then modified to reflect the receipt of a\n\
                     packet (augmented by one period of the device’s rate. To respect this, the data coming\n\
                     in from the hardware must be at a fixed rate. The hardware period used can be specified\n\
                     in the HardwarePeriod variable. An advantage is that Independent of communication\n\
                     spurts; a disadvantage is that the loss of one packet induces error for all of the\n\
                     following packets. \n\
                  </p> \n\
               </div>\n\
            </dd>\n\
            <dt><a name=\"WS1A9193826455F5FF-6AB24494122F0F3D6B8-1418\"></a><span class=\"term\"><a name=\"WS1A9193826455F5FF-6AB24494122F0F3D6B8-1417\"></a>Auto Frequency</span></dt>\n\
            <dd>\n\
               <div class=\"definition\"><a name=\"WS1A9193826455F5FF-6AB24494122F0F3D6B8-1416\"></a> \n\
                  <p><a name=\"WS1A9193826455F5FF-6AB24494122F0F3D6B8-1415\"></a>In the case of an unknown hardware frequency, the data coming in can be averaged and\n\
                     the period can be calculated. This is the same principle as in the case of ‘Hardware\n\
                     Frequency’, but with an unknown (and unspecified) frequency. Advantages: Semi-Independent\n\
                     of communication spurts; a disadvantage is that the loss of one packet induces error\n\
                     for all of the following packets, Requires evenly spaced data, Too many communication\n\
                     spurts may affect the quality of the reconstructed timestamps, Requires resampling\n\
                     of the data at a given rate. \n\
                  </p> \n\
               </div>\n\
            </dd>\n\
            <dt><a name=\"WS1A9193826455F5FF-6AB24494122F0F3D6B8-1414\"></a><span class=\"term\"><a name=\"WS1A9193826455F5FF-6AB24494122F0F3D6B8-1413\"></a>Software Timestamp</span></dt>\n\
            <dd>\n\
               <div class=\"definition\"><a name=\"WS1A9193826455F5FF-6AB24494122F0F3D6B8-1412\"></a> \n\
                  <p><a name=\"WS1A9193826455F5FF-6AB24494122F0F3D6B8-1411\"></a>This is a worst-case scenario, where no information can be obtained about the incoming\n\
                     data packets. When a hardware packet is received, the current time in MotionBuilder\n\
                     is assigned to it. The disadvantages is that data is subject to communication spurts.\n\
                     \n\
                  </p> \n\
               </div>\n\
            </dd>\n\
         </dl>\n\
         <p><a name=\"WS1A9193826455F5FF6DEA2AA512298434427-7C1A\"></a>Typical polled devices are pointing devices. It does not have its own sampling frequency,\n\
            but makes available a value to be read. The sampling frequency is the frequency at\n\
            which MotionBuilder polls the hardware. \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">if(mHardware.PollData())\n\
{\n\
    //Data is not timestamped, get time from MotionBuilder\n\
    evalTime = pDeviceNotifyInfo.GetLocalTime();\n\
    // Timestamp and punch new data in\n\
    DeviceRecordFrame(evalTime,pDeviceNotify Info);\n\
}</pre></div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";