var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-3E40210C-0BE5-4059-AB8C-87A8030286A3\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Referencing an FBX File</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-3E40210C-0BE5-4059-AB8C-87A8030286A3\"></a><div class=\"head\">\n\
            <h1>Referencing an FBX File</h1>\n\
         </div>\n\
         <p><a name=\"GUID-CD66E036-EA6C-4DF4-8722-F18C22C84E9A\"></a> Any FBX file from MotionBuilder 2011 or latest can be referenced. You must store\n\
            the entire referenced object within a namespace when referenced. \n\
         </p>\n\
         <p><a name=\"GUID-93B65C4B-0F77-4879-BB7E-24C0AB175408\"></a>The namespace is a proper object. Namespaces are used for separating the referenced\n\
            items from the scene items. When a file is referenced, it is represented as a reference\n\
            object, which is a type of namespace. The following figure illustrates how a file\n\
            is referenced. \n\
         </p><a name=\"FIG_E86407E0877540CD9451BAA0FD8A936F\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-A25D8127-1894-4EDE-B35B-07A8D1695099-low.png\"></div>\n\
         <div class=\"section\"><a name=\"SECTION_52ED67B37D9A4242A58E97C8B15FD184\"></a> \n\
            <h2><a name=\"GUID-DEFC27A8-A99B-44D2-A198-00CE1D2EF7D0\"></a>Features\n\
            </h2> \n\
            <p><a name=\"GUID-054A55F7-5D00-4D05-A5E4-D6AE6CE4E5A2\"></a> <a name=\"UL_3B89E10112A049D89258D09FA1621F54\"></a><ul>\n\
                  <li>You can see a referenced object listed in the Navigator under Namespaces. </li>\n\
                  <li>An item within a referenced hierarchy can be constrained to other objects in the scene.\n\
                     \n\
                  </li>\n\
                  <li>Any node in the referenced file that does not have a parent can be parented to other\n\
                     objects in the scene. \n\
                  </li>\n\
                  <li>Any leaf node in the referenced file can become the parent of other objects in the\n\
                     scene. \n\
                  </li>\n\
                  <li>Any referenced item can contain animatable and non-animatable custom properties. </li>\n\
                  <li>Any referenced object can contain non-animatable custom properties only. </li>\n\
               </ul> \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_0D6E85F43D2046468EB681AA5A850603\"></a> \n\
            <h2><a name=\"GUID-2DDA8611-4CBF-4D59-AE23-FB2A0DAEDC3D\"></a>Limitations\n\
            </h2> \n\
            <p><a name=\"GUID-59F24AA3-4EE4-427B-97B8-C31D6B53D504\"></a> <a name=\"UL_72B60FAD806E4FE18AB5A819C7893046\"></a><ul>\n\
                  <li>A referenced item cannot be renamed. </li>\n\
                  <li>A referenced item cannot be deleted. </li>\n\
                  <li>An item within a referenced hierarchy cannot be re-parented. </li>\n\
                  <li>Referenced objects cannot be nested. </li>\n\
                  <li>Keyframe animation is not possible on referenced items unless those items are animated\n\
                     using the Story tool. See <span class=\"char_link\"><a href=\"#!/url=./files/GUID-9729D523-8231-4D43-A3EE-E9A427C9B19E.htm\">Keyframe Animation on Referenced Items</a></span>. \n\
                  </li>\n\
                  <li>Connections between items within a referenced object are not allowed. See <span class=\"char_link\"><a href=\"#!/url=./files/GUID-E80B6143-0A1B-4AED-986B-F59B395DC2A3.htm\">Connections Between Referenced Items </a></span>. \n\
                  </li>\n\
               </ul> \n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";