var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-46F873C8-32C7-4834-8264-1735F20A10FE\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>FBCharacter - Characters</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-46F873C8-32C7-4834-8264-1735F20A10FE\"></a><div class=\"head\">\n\
            <h1>FBCharacter - Characters</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_97AE868B1A0D4310B1C815A424D3A56C\"></a> \n\
            <h2><a name=\"GUID-EB69C0E2-3F40-4B59-8B8A-C86930FD2970\"></a>What is an FBCharacter?\n\
            </h2> \n\
            <p><a name=\"GUID-973F1C19-1136-4FD3-A7C3-4F46483F7F0F\"></a>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCharacter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_character.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_character.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacter</a></span> class encapsulates the set of constraints on a hierarchy of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a></span>. This hierarchy is usually composed of instances of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelSkeleton\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_skeleton.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_skeleton.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelSkeleton</a></span>, though instances of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelRoot\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_root.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_root.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelRoot</a></span> are also used to define the character\'s <em class=\"mild\">reference point</em> and <em class=\"mild\">hips</em>, as seen in the <span class=\"char_link\"><a href=\"#!/url=./files/GUID-46F873C8-32C7-4834-8264-1735F20A10FE.htm#SECTION_7AC4D12B1A3A449CB84668318C45C139\">Example: Creating a Character</a></span> below. \n\
            </p> \n\
            <p><a name=\"GUID-38A3CD23-330B-46EB-A926-F05CB88CBD5C\"></a>When an instance of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCharacter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_character.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_character.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacter</a></span> is created, it does not contain any joints. You must explicitly assign instances\n\
               of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelSkeleton\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_skeleton.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_skeleton.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelSkeleton</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelRoot\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_root.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_root.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelRoot</a></span> to their appropriate <em class=\"strong\">slots</em> in the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCharacter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_character.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_character.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacter</a></span>. Slots are identified as instances of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBProperty\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_property.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_property.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBProperty</a></span> in <span class=\"code\" translate=\"no\">FBCharacter.PropertyList</span> whose names end with \"<span class=\"code\" translate=\"no\">Link</span>\". For example, the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBProperty\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_property.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_property.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBProperty</a></span> corresponding to the character\'s hip joint is named \"<span class=\"code\" translate=\"no\">HipsLink</span>\". \n\
            </p> \n\
            <p><a name=\"GUID-411F3062-7BCD-47D1-BDB5-77DC38586098\"></a>The script below creates an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCharacter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_character.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_character.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacter</a></span>, and prints all its slot names. It then illustrates how to assign a hierarchy of\n\
               <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelSkeleton\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_skeleton.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_skeleton.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelSkeleton</a></span> to the character\'s \"<span class=\"code\" translate=\"no\">HipsLink</span>\" and \"<span class=\"code\" translate=\"no\">SpineLink</span>\" slots, via <span class=\"code\" translate=\"no\">FBProperty.append()</span>. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">from pyfbsdk import *\n\
\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a>().FileNew()\n\
\n\
# Create a character.\n\
character = <a href=\"javascript:void(0)\" data-symbol=\"FBCharacter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_character.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacter</a>(\'myCharacter\')\n\
\n\
# <a href=\"javascript:void(0)\" data-symbol=\"Print\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a6e4d6b1145275e9c1d89c9aa5b778546&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Print</a> all the slot names.\n\
for <a href=\"javascript:void(0)\" data-symbol=\"item\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/dictobject_8h.html#a54447cc31a87ae88effdc512eb6d5496&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">item</a> in character.PropertyList:\n\
    if item.Name.endswith(\'Link\'):\n\
        print item.Name\n\
    \n\
# Create a T-Pose hierarchy...\n\
hips = <a href=\"javascript:void(0)\" data-symbol=\"FBModelSkeleton\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_skeleton.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelSkeleton</a>(\'myHips\')\n\
hips.Show = True\n\
hips.Translation = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(0, 60, 0)\n\
\n\
spine = <a href=\"javascript:void(0)\" data-symbol=\"FBModelSkeleton\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_skeleton.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelSkeleton</a>(\'mySpine\')\n\
spine.Show = True\n\
spine.Parent = hips\n\
spine.Translation = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(0, 20, 0)\n\
# ...\n\
\n\
# <a href=\"javascript:void(0)\" data-symbol=\"Assign\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a20ef6778f00445938f70621bb6bcc118&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Assign</a> the models to their appropriate slots in the character...\n\
hipslot = character.PropertyList.Find(\'HipsLink\')\n\
hipslot.append(hips)\n\
\n\
spineslot = character.PropertyList.Find(\'SpineLink\')\n\
spineslot.append(spine)\n\
# ...</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_6281B991658B4C78B9D9402E98472FB2\"></a> \n\
            <h2><a name=\"GUID-DAF07A0C-357B-449B-BAF8-FB54E43FF484\"></a>Creating a Skeleton\n\
            </h2> \n\
            <p><a name=\"GUID-281CFDA7-8615-4ADF-8BDB-88F5625626FC\"></a>A character\'s skeleton is defined by a hierarchy of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a></span>. The subclass(es) of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a></span> used to define a skeleton only affect how the skeleton is rendered in the viewport.\n\
               In the case of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelSkeleton\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_skeleton.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_skeleton.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelSkeleton</a></span>, the joints are linked with a bone, denoted by a triangular prism. If a joint is\n\
               an instance of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelRoot\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_root.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_root.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelRoot</a></span>, it is not linked with a triangular prism from its parent joint. \n\
            </p> \n\
            <p><a name=\"GUID-EDAB52E2-DF6D-4F41-B04D-C6ABBAB8D821\"></a>It is recommended that each skeleton begin with a \"reference\" joint (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelRoot\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_root.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_root.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelRoot</a></span>), to help position the character along the X-Z plane. The hips of the skeleton should\n\
               also be an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelRoot\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_root.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_root.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelRoot</a></span>, so that a bone is not drawn between the reference joint and the hips. \n\
            </p> \n\
            <p><a name=\"GUID-1917B15E-4923-4A8D-AAD9-6D478B2BBA83\"></a>If you are creating a biped, the skeleton you initially define must be in a <em class=\"strong\">T-Pose</em>. If you are creating a quadruped, its four legs must be below its body, and its toes\n\
               must be pointing downwards. \n\
            </p> \n\
            <p><a name=\"GUID-75743301-3544-48F7-9F6A-C0BA974ED2B7\"></a>The function <span class=\"code\" translate=\"no\">createSkeleton()</span> in the script below uses a custom \"<span class=\"code\" translate=\"no\">jointMap</span>\" data structure as a template to create a hierarchy of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelRoot\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_root.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_root.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelRoot</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelSkeleton\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_skeleton.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_skeleton.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelSkeleton</a></span>. Two skeletons are added to the scene, but we do not bind their joints to instances\n\
               of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCharacter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_character.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_character.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacter</a></span>. As such, the joints of these skeletons are <span class=\"charspan-emphasis\">not</span> constrained to move like a biped. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">from pyfbsdk import *\n\
\n\
# <a href=\"javascript:void(0)\" data-symbol=\"In\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#aeae2807c86997ffad2fa6d972a29ee1fad8ff8dfc9381018e97fce86d909f8975&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">In</a> the following skeleton template, the \"LeftUpLeg\" \n\
# has \"Hips\" as its parent, and its local (<a href=\"javascript:void(0)\" data-symbol=\"x\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#a280f2393c503127fff91ecbc558e288d&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">x</a>,y,z) translation is (15, -10, 0).\n\
jointMap = {\n\
    #jointName,     (parentName,       translation  )\n\
    \'Reference\':    (None,           (  0,   0,  0)),\n\
    \'Hips\':         (\'Reference\',    (  0,  75,  0)),    \n\
    \'LeftUpLeg\':    (\'Hips\',         ( 15, -10,  0)),\n\
    \'LeftLeg\':      (\'LeftUpLeg\',    (  0, -30,  0)),\n\
    \'LeftFoot\':     (\'LeftLeg\',      (  0, -30,  0)),     \n\
    \'RightUpLeg\':   (\'Hips\',         (-15, -10,  0)),\n\
    \'RightLeg\':     (\'RightUpLeg\',   (  0, -30,  0)),\n\
    \'RightFoot\':    (\'RightLeg\',     (  0, -30,  0)),     \n\
    \'Spine\':        (\'Hips\',         (  0,  40,  0)),\n\
    \'LeftArm\':      (\'Spine\',        ( 20,  10,  0)),\n\
    \'LeftForeArm\':  (\'LeftArm\',      ( 30,   0,  0)),\n\
    \'LeftHand\':     (\'LeftForeArm\',  ( 30,   0,  0)),    \n\
    \'RightArm\':     (\'Spine\',        (-20,  10,  0)),\n\
    \'RightForeArm\': (\'RightArm\',     (-30,   0,  0)),\n\
    \'RightHand\':    (\'RightForeArm\', (-30,   0,  0)),\n\
    \'Head\':         (\'Spine\',        (  0,  30,  0)),\n\
}\n\
\n\
###############################################################\n\
# Helper Function(<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a>).                                         #\n\
###############################################################\n\
\n\
# Create a skeleton in a T-pose facing along the positive Z axis\n\
def createSkeleton(pNamespace, pColor):\n\
    global jointMap\n\
    skeleton = {}\n\
    \n\
    # Populate the skeleton with joints.\n\
    for jointName, (parentName, translation) in jointMap.iteritems():\n\
        if jointName == \'Reference\' or jointName == \'Hips\':\n\
            # <a href=\"javascript:void(0)\" data-symbol=\"If\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a3caa32cf8ff8db15e5835f5e40e6c6f8&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">If</a> it is the reference <a href=\"javascript:void(0)\" data-symbol=\"node\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/node_8h.html#addb697c9bca6f8981a870daa4953af4f&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">node</a>, create an FBModelRoot.\n\
            joint = <a href=\"javascript:void(0)\" data-symbol=\"FBModelRoot\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_root.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelRoot</a>(jointName)\n\
            \n\
        else:\n\
            # Otherwise, create an FBModelSkeleton.\n\
            joint = <a href=\"javascript:void(0)\" data-symbol=\"FBModelSkeleton\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_skeleton.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelSkeleton</a>(jointName)\n\
        \n\
        joint.LongName = pNamespace + \':\' + joint.Name # Apply the specified namespace to each joint.\n\
        joint.Color = pColor\n\
        joint.Size = 250                               # Arbitrary size: big enough to see in viewport \n\
        joint.Show = True                              # Make the joint visible in the scene.\n\
        \n\
        # <a href=\"javascript:void(0)\" data-symbol=\"Add\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#ab9d92a0f505af42d2049e62ae49ef932a0d592a4b562059bc283e00b3704865c9&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Add</a> the joint to our skeleton.\n\
        skeleton[jointName] = joint\n\
    \n\
    # Once all the joints have been created, apply the parent/child \n\
    # relationships to each of the skeleton\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> joints.\n\
    for jointName, (parentName, translation) in jointMap.iteritems():\n\
        # Only assign a parent if it exists.\n\
        if parentName != None and parentName in jointMap.keys():\n\
            skeleton[jointName].Parent = skeleton[parentName] \n\
        \n\
        # The translation should be set after the parent has been assigned.\n\
        skeleton[jointName].Translation = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(translation)\n\
\n\
    return skeleton\n\
\n\
\n\
###############################################################\n\
# Main.                                                       #\n\
###############################################################\n\
\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a>().FileNew()\n\
\n\
red = <a href=\"javascript:void(0)\" data-symbol=\"FBColor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_color.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBColor</a>(1, 0, 0)\n\
skeleton1 = createSkeleton(\'mySkeleton1\', red)\n\
skeleton1[\'Reference\'].Translation = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(-100, 0, 0)\n\
\n\
green = <a href=\"javascript:void(0)\" data-symbol=\"FBColor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_color.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBColor</a>(0, 1, 0)\n\
skeleton2 = createSkeleton(\'mySkeleton2\', green)\n\
skeleton2[\'Reference\'].Translation = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(100, 0, 0)</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_D495F91CF44B470794FEE16047770457\"></a> \n\
            <h2><a name=\"GUID-8E43658E-2426-4EB6-9C04-F901886FE2B1\"></a>Characterizing a Skeleton\n\
            </h2> \n\
            <p><a name=\"GUID-ED56EFF5-73FC-4F70-ABE7-79212AA462EB\"></a>An <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCharacter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_character.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_character.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacter</a></span> is said to be \"characterized\" if a minimal hierarchy of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a></span> has been assigned to the \"Base\" (required) character slots. The following list presents\n\
               the names of these required character slots: <span class=\"code\" translate=\"no\">HipsLink</span>, <span class=\"code\" translate=\"no\">LeftUpLegLink</span>, <span class=\"code\" translate=\"no\">LeftLegLink</span>, <span class=\"code\" translate=\"no\">LeftFootLink</span>, <span class=\"code\" translate=\"no\">RightUpLegLink</span>, <span class=\"code\" translate=\"no\">RightLegLink</span>, <span class=\"code\" translate=\"no\">RightFootLink</span>, <span class=\"code\" translate=\"no\">SpineLink</span>, <span class=\"code\" translate=\"no\">LeftArmLink</span>, <span class=\"code\" translate=\"no\">LeftForeArmLink</span>, <span class=\"code\" translate=\"no\">LeftHandLink</span>, <span class=\"code\" translate=\"no\">RightArmLink</span>, <span class=\"code\" translate=\"no\">RightForeArmLink</span>, <span class=\"code\" translate=\"no\">RightHandLink</span>, <span class=\"code\" translate=\"no\">HeadLink</span>. The image below shows a valid characterization of the required character slots.\n\
               \n\
            </p> \n\
            <p><a name=\"GUID-CFEF80C2-CEB2-4474-B618-394E6C3EAEA1\"></a></p> \n\
            <p><a name=\"GUID-AC379054-A93C-4F96-89BA-CB88C1B42D5F\"></a> <img src=\"images/GUID-FCE68592-79BA-413A-820A-6689738383A8-low.png\"> \n\
            </p> \n\
            <p><a name=\"GUID-38941CE0-8353-463B-9C9F-BD617B82ABAF\"></a>When the required slots have been associated with a joint in a skeleton, the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCharacter.SetCharacterizeOn()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_character.html#abfff259d019b1fd93d9cfaef2a57c97e&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacter.SetCharacterizeOn()</a></span> function may be called with the <span class=\"code\" translate=\"no\">True</span> parameter. When a character is successfully characterized, an <em class=\"strong\">inverse</em> and/or <em class=\"strong\">forward kinematic control rig</em> may be created using <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCharacter.CreateControlRig()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_character.html#a3d62e7b6366579537754de9a910850de&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacter.CreateControlRig()</a></span>. To display and use this control rig, set the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCharacter.ActiveInput\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_character.html#a5dc126089b6a29bc975eed08dbf038c3&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacter.ActiveInput</a></span> property to <span class=\"code\" translate=\"no\">True</span>. \n\
            </p> \n\
            <p><a name=\"GUID-8B37BD79-227A-46EF-95D8-7F4E48F5E478\"></a>The code below is taken from <span class=\"char_link\"><a href=\"#!/url=./files/GUID-46F873C8-32C7-4834-8264-1735F20A10FE.htm#SECTION_7AC4D12B1A3A449CB84668318C45C139\">Example: Creating a Character</a></span>, and illustrates how to characterize a skeleton. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\"># Characterize the skeleton and create a control rig.\n\
def characterizeSkeleton(pCharacterName, pSkeleton):\n\
    # Create a new character.\n\
    character = <a href=\"javascript:void(0)\" data-symbol=\"FBCharacter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_character.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacter</a>(pCharacterName)\n\
    <a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a>().CurrentCharacter = character\n\
    \n\
    # <a href=\"javascript:void(0)\" data-symbol=\"Add\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#ab9d92a0f505af42d2049e62ae49ef932a0d592a4b562059bc283e00b3704865c9&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Add</a> each joint in our skeleton to the character.\n\
    for jointName, joint in pSkeleton.iteritems():\n\
        slot = character.PropertyList.Find(jointName + \'Link\')\n\
        slot.append(joint)\n\
\n\
    # Flag that the character has been characterized.\n\
    character.SetCharacterizeOn(True)\n\
    \n\
    # Create a control rig using Forward and Inverse Kinematics,\n\
    # as specified by the \"True\" parameter.\n\
    character.CreateControlRig(True)\n\
    \n\
    # <a href=\"javascript:void(0)\" data-symbol=\"Set\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a8b39bad9fda6bc73af75e4d6085bcf91&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Set</a> the control rig to active.\n\
    character.ActiveInput = True\n\
    \n\
    return character</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_7AC4D12B1A3A449CB84668318C45C139\"></a> \n\
            <h2><a name=\"GUID-A533B9CD-99F7-4B1F-86C5-283398FF7008\"></a>Example: Creating a Character.\n\
            </h2> \n\
            <p><a name=\"GUID-07DD7D47-18F5-4C28-B985-76581D8F16D9\"></a> <em class=\"strong\">Sample Viewport Output:</em> \n\
            </p> \n\
            <p><a name=\"GUID-003B0F90-B115-446C-AE41-C770166255C4\"></a></p> <img src=\"images/GUID-9E05FD93-CA83-4D7C-A6D4-C8D647258FBB-low.png\"> \n\
            <p><a name=\"GUID-C64E9F47-2590-4AC1-BAE2-A25BB0A1516B\"></a><em class=\"strong\">Program Summary:</em> The program below first defines a template which will be used to create a hierarchy\n\
               of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelSkeleton\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_skeleton.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_skeleton.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelSkeleton</a></span> joints. The joint names are important here because they correspond to MotionBuilder\'s\n\
               most basic biped characterization naming template. \n\
            </p> \n\
            <p><a name=\"GUID-B319C3DC-FB53-470E-A96C-143FAB88A871\"></a>Once the skeleton is created, we apply cartoon-shaded spheres to each joint to make\n\
               our character more visually appealing. In practice however, we would assign a mesh\n\
               to the skeleton\'s <span class=\"code\" translate=\"no\">\'Reference\'</span> model. The vertices of this mesh would be weighted according to the character\'s bones.\n\
               This lengthy process is omitted for clarity. \n\
            </p> \n\
            <p><a name=\"GUID-3E47526D-81A2-4BAF-81AC-FDB8ADA4CF88\"></a>The program concludes by characterizing the skeleton, and creating a forward- and\n\
               inverse-kinematic control rig. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">from pyfbsdk import *\n\
\n\
# <a href=\"javascript:void(0)\" data-symbol=\"In\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#aeae2807c86997ffad2fa6d972a29ee1fad8ff8dfc9381018e97fce86d909f8975&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">In</a> the following skeleton template, the \"LeftUpLeg\" \n\
# has \"Hips\" as its parent, and its local (<a href=\"javascript:void(0)\" data-symbol=\"x\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#a280f2393c503127fff91ecbc558e288d&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">x</a>,y,z) translation is (15, -10, 0).\n\
jointMap = {\n\
    #jointName,     (parentName,       translation  )\n\
    \'Reference\':    (None,           (  0,   0,  0)),\n\
    \'Hips\':         (\'Reference\',    (  0,  75,  0)),    \n\
    \'LeftUpLeg\':    (\'Hips\',         ( 15, -10,  0)),\n\
    \'LeftLeg\':      (\'LeftUpLeg\',    (  0, -30,  0)),\n\
    \'LeftFoot\':     (\'LeftLeg\',      (  0, -30,  0)),     \n\
    \'RightUpLeg\':   (\'Hips\',         (-15, -10,  0)),\n\
    \'RightLeg\':     (\'RightUpLeg\',   (  0, -30,  0)),\n\
    \'RightFoot\':    (\'RightLeg\',     (  0, -30,  0)),     \n\
    \'Spine\':        (\'Hips\',         (  0,  40,  0)),\n\
    \'LeftArm\':      (\'Spine\',        ( 20,  10,  0)),\n\
    \'LeftForeArm\':  (\'LeftArm\',      ( 30,   0,  0)),\n\
    \'LeftHand\':     (\'LeftForeArm\',  ( 30,   0,  0)),    \n\
    \'RightArm\':     (\'Spine\',        (-20,  10,  0)),\n\
    \'RightForeArm\': (\'RightArm\',     (-30,   0,  0)),\n\
    \'RightHand\':    (\'RightForeArm\', (-30,   0,  0)),\n\
    \'Head\':         (\'Spine\',        (  0,  30,  0)),\n\
}\n\
\n\
###############################################################\n\
# Helper Function(<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a>).                                         #\n\
###############################################################\n\
\n\
# Create a skeleton in a T-pose facing along the positive Z axis\n\
def createSkeleton(pNamespace):\n\
    global jointMap\n\
    skeleton = {}\n\
    \n\
    # Populate the skeleton with joints.\n\
    for jointName, (parentName, translation) in jointMap.iteritems():\n\
        if jointName == \'Reference\' or jointName == \'Hips\':\n\
            # <a href=\"javascript:void(0)\" data-symbol=\"If\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a3caa32cf8ff8db15e5835f5e40e6c6f8&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">If</a> it is the reference <a href=\"javascript:void(0)\" data-symbol=\"node\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/node_8h.html#addb697c9bca6f8981a870daa4953af4f&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">node</a>, create an FBModelRoot.\n\
            joint = <a href=\"javascript:void(0)\" data-symbol=\"FBModelRoot\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_root.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelRoot</a>(jointName)\n\
            \n\
        else:\n\
            # Otherwise, create an FBModelSkeleton.\n\
            joint = <a href=\"javascript:void(0)\" data-symbol=\"FBModelSkeleton\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_skeleton.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelSkeleton</a>(jointName)\n\
        \n\
        joint.LongName = pNamespace + \':\' + joint.Name # Apply the specified namespace to each joint.\n\
        joint.Color = <a href=\"javascript:void(0)\" data-symbol=\"FBColor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_color.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBColor</a>(0.3, 0.8, 1)             # Cyan\n\
        joint.Size = 250                               # Arbitrary size: big enough to see in viewport \n\
        joint.Show = True                              # Make the joint visible in the scene.\n\
        \n\
        # <a href=\"javascript:void(0)\" data-symbol=\"Add\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#ab9d92a0f505af42d2049e62ae49ef932a0d592a4b562059bc283e00b3704865c9&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Add</a> the joint to our skeleton.\n\
        skeleton[jointName] = joint\n\
    \n\
    # Once all the joints have been created, apply the parent/child \n\
    # relationships to each of the skeleton\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> joints.\n\
    for jointName, (parentName, translation) in jointMap.iteritems():\n\
        # Only assign a parent if it exists.\n\
        if parentName != None and parentName in jointMap.keys():\n\
            skeleton[jointName].Parent = skeleton[parentName] \n\
        \n\
        # The translation should be set after the parent has been assigned.\n\
        skeleton[jointName].Translation = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(translation)\n\
\n\
    \'\'\' The following is a much longer way to write the above function:\n\
    \n\
    reference = <a href=\"javascript:void(0)\" data-symbol=\"FBModelRoot\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_root.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelRoot</a>(\'Reference\')\n\
    \n\
    hips = <a href=\"javascript:void(0)\" data-symbol=\"FBModelRoot\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_root.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelRoot</a>(\'Hips\')\n\
    hips.Color = <a href=\"javascript:void(0)\" data-symbol=\"FBColor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_color.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBColor</a>(0.3, 0.8, 1)\n\
    hips.Size = 250\n\
    hips.Translation = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(0, 75, 0)\n\
    hips.Parent = reference\n\
    skeleton[\'Hips\'] = hips\n\
    \n\
    spine = createSkeletonNode(\'Spine\')\n\
    spine.Parent = hips\n\
    spine.Color = <a href=\"javascript:void(0)\" data-symbol=\"FBColor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_color.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBColor</a>(0.3, 0.8, 1)\n\
    spine.Size = 250\n\
    spine.Translation = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(0, 25, 0)\n\
    skeleton[\'Spine\'] = spine\n\
    \n\
    # ...\n\
    \'\'\'\n\
    return skeleton\n\
    \n\
# Create a model which will be applied to each joint in the skeleton.\n\
def createModel():\n\
    # Create a sphere.\n\
    model = <a href=\"javascript:void(0)\" data-symbol=\"FBCreateObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga6698333c163da7c3bc077537889b6c33&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCreateObject</a>(\'Browsing/Templates/Elements/Primitives\', \'Sphere\', \'Sphere\')\n\
    model.Scaling = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(0.9, 0.9, 0.9)\n\
    \n\
    # Define a slightly reflective dark material.\n\
    material = <a href=\"javascript:void(0)\" data-symbol=\"FBMaterial\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_material.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMaterial</a>(\'MyMaterial\')\n\
    material.Ambient = <a href=\"javascript:void(0)\" data-symbol=\"FBColor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_color.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBColor</a>(0, 0, 0)\n\
    material.Diffuse = <a href=\"javascript:void(0)\" data-symbol=\"FBColor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_color.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBColor</a>(0, 0.04, 0.08)\n\
    material.Specular = <a href=\"javascript:void(0)\" data-symbol=\"FBColor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_color.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBColor</a>(0, 0.7, 0.86)\n\
    material.Shininess = 100\n\
    model.Materials.append(material)\n\
\n\
    # Create a cartoon-like shader.\n\
    shader = <a href=\"javascript:void(0)\" data-symbol=\"FBCreateObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga6698333c163da7c3bc077537889b6c33&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCreateObject</a>(\'Browsing/Templates/Shading Elements/Shaders\', \'Edge Cartoon\', \'MyShader\')\n\
    \n\
    # <a href=\"javascript:void(0)\" data-symbol=\"For\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a8392a32b4f002d4b372598185b549a1d&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">For</a> a list of all the shader\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> properties do:\n\
    #for <a href=\"javascript:void(0)\" data-symbol=\"item\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/dictobject_8h.html#a54447cc31a87ae88effdc512eb6d5496&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">item</a> in shader.PropertyList:\n\
    #    print item.Name\n\
    aliasProp = shader.PropertyList.Find(\'Antialiasing\')\n\
    aliasProp.Data = True\n\
    colorProp = shader.PropertyList.Find(\'EdgeColor\')\n\
    colorProp.Data = <a href=\"javascript:void(0)\" data-symbol=\"FBColor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_color.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBColor</a>(0, 0.83, 1)\n\
    widthProp = shader.PropertyList.Find(\'EdgeWidth\')\n\
    widthProp.Data = 8\n\
    \n\
    # Append the cartoon shader to the model.\n\
    model.Shaders.append(shader)        \n\
    \n\
    # The default shader must also be applied to the model.\n\
    defaultShader = <a href=\"javascript:void(0)\" data-symbol=\"FBSystem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem</a>().Scene.Shaders[0]\n\
    model.Shaders.append(defaultShader) \n\
    \n\
    # Use the default shading mode.\n\
    model.ShadingMode = <a href=\"javascript:void(0)\" data-symbol=\"FBModelShadingMode.kFBModelShadingDefault\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_shading_mode.html#aca9ba938464abeaf4480fcd049f41d78&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelShadingMode.kFBModelShadingDefault</a>\n\
    \n\
    return model\n\
\n\
# Apply a copy of pModel to each joint in the skeleton. \n\
def applyModelToSkeleton(pSkeleton, pModel):   \n\
    # Create a copy of the model for each joint in the skeleton.\n\
    for jointName, joint in pSkeleton.iteritems():\n\
        if jointName == \'Reference\':\n\
            # Do not apply the model to the Reference node.\n\
            continue\n\
        \n\
        # Parent the copied model to the joint.\n\
        model = pModel.Clone()\n\
        model.Parent = joint        \n\
        model.Show = True\n\
        \n\
        # Use the joint <a href=\"javascript:void(0)\" data-symbol=\"name\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#afcd1706c9144e6d6eee6127661ae3be2&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">name</a> as a prefix.\n\
        model.Name = jointName + pModel.Name\n\
\n\
        # Reset the model\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> translation to place it at the same \n\
        # location as its parent joint.\n\
        model.Translation = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(0, 0, 0)\n\
\n\
# Characterize the skeleton and create a control rig.\n\
def characterizeSkeleton(pCharacterName, pSkeleton):\n\
    # Create a new character.\n\
    character = <a href=\"javascript:void(0)\" data-symbol=\"FBCharacter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_character.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacter</a>(pCharacterName)\n\
    <a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a>().CurrentCharacter = character\n\
    \n\
    # <a href=\"javascript:void(0)\" data-symbol=\"Add\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#ab9d92a0f505af42d2049e62ae49ef932a0d592a4b562059bc283e00b3704865c9&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Add</a> each joint in our skeleton to the character.\n\
    for jointName, joint in pSkeleton.iteritems():\n\
        slot = character.PropertyList.Find(jointName + \'Link\')\n\
        slot.append(joint)\n\
\n\
    # Flag that the character has been characterized.\n\
    character.SetCharacterizeOn(True)\n\
    \n\
    # Create a control rig using Forward and Inverse Kinematics,\n\
    # as specified by the \"True\" parameter.\n\
    character.CreateControlRig(True)\n\
    \n\
    # <a href=\"javascript:void(0)\" data-symbol=\"Set\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a8b39bad9fda6bc73af75e4d6085bcf91&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Set</a> the control rig to active.\n\
    character.ActiveInput = True\n\
    \n\
    return character\n\
\n\
\n\
###############################################################\n\
# Main.                                                       #\n\
###############################################################\n\
\n\
# Clear the scene.\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a>().FileNew()\n\
\n\
# Create a new skeleton.\n\
characterName = \'MyStickman\'\n\
skeleton = createSkeleton(characterName)\n\
\n\
# Apply a model to each limb of the skeleton.\n\
templateModel = createModel()\n\
applyModelToSkeleton(skeleton, templateModel)\n\
templateModel.FBDelete() # We do not need the template model anymore.\n\
\n\
# Characterize the skeleton and create a control rig.\n\
character = characterizeSkeleton(characterName, skeleton)\n\
</pre></div> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";