var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-5381A46B-FE19-4C2D-94A7-56B4CD3C4150\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Audio / video</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-5381A46B-FE19-4C2D-94A7-56B4CD3C4150\"></a><div class=\"head\">\n\
            <h1>Audio / video</h1>\n\
         </div>\n\
         <p><a name=\"WS1A9193826455F5FF3913A1A412260CA5929-799C\"></a>Use <span class=\"code\" translate=\"no\">pyfbsdk::FBAudioClip</span> to play audio, or access properties of an audio , for example: \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">myAudio = <a href=\"javascript:void(0)\" data-symbol=\"FBAudioClip\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_audio_clip.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBAudioClip</a>(\"c:\\\\example.wav\")<a href=\"javascript:void(0)\" data-symbol=\"FBAudioClip.Play\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_audio_clip.html#a6c8691cd9ac9a18151098f526f2fd3f3&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBAudioClip.Play</a>(myAudio)</pre></div>\n\
         <p><a name=\"WS1A9193826455F5FF-6AB24494122F0F3D6B8-231E\"></a>See also the code sample in AudioTrackSetupTool.py. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF3913A1A412260CA5929-799F\"></a> <span class=\"code\" translate=\"no\">pyfbsdk::FBVideo</span> is a general media class for images, video clips and video memory. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF3913A1A412260CA5929-799E\"></a>The following code snippet shows how to load with <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBAudioClip\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_audio_clip.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_audio_clip.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBAudioClip</a></span> and then validate with <span class=\"code\" translate=\"no\">FBVideoClip::IsValid</span>: \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\"># load a file\n\
myVideo = <a href=\"javascript:void(0)\" data-symbol=\"FBVideoClip\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_video_clip.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVideoClip</a>(\"c:\\\\example.avi\") \n\
# verify the path and file are valid \n\
if myVideo.IsValid(): \n\
    # do something</pre></div>\n\
         <p><a name=\"WS1A9193826455F5FF-6AB24494122F0F3D6B8-231D\"></a>See also the code sample in ShotTrackSetupTool.py and in the C++ sample <span class=\"code\" translate=\"no\">toolaudio</span>. \n\
         </p>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";