var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-747BA9FF-F7F4-4637-BB99-F130AD48BB00\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>MotionBuilder Python API</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-747BA9FF-F7F4-4637-BB99-F130AD48BB00\"></a><div class=\"head\">\n\
            <h1>MotionBuilder Python API</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_0F3F64F9DC674009BC268760382E30B9\"></a> \n\
            <h2><a name=\"GUID-5541D40A-598D-497F-98E4-881FD4BD538E\"></a>MotionBuilder Python API\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F48755F2FC9DF120970276F7-1FBF\"></a>The MotionBuilder Python API is contained in the <em class=\"strong\">pyfbsdk</em> module. This module was generated using the <a href=\"http://wiki.python.org/moin/boost.python?action=show&amp;redirect=BoostPython\" target=\"_blank\">Boost.Python</a> library, which binds C++ functions to Python functions. The functions contained in\n\
               this module therefore have analogous signatures to the MotionBuilder C++ API (ORSDK).\n\
               \n\
            </p> \n\
            <p><a name=\"GUID-1BB37319-F2D2-49B6-9433-D14D3B8AFC38\"></a>The MotionBuilder Python API also includes the <em class=\"strong\">pyfbsdk_additions</em> module, which contains Python specific enhancements and some additional functionality.\n\
               This module was not generated by the Boost.Python library, and was written separately.\n\
               \n\
            </p> \n\
            <p><a name=\"GUID-C12380D4-6161-4777-AFC4-292775770E7C\"></a>For more information on how to get started with Python and MotionBuilder, including\n\
               how to run your first Python program, see <span class=\"char_link\"><a href=\"#!/url=./files/GUID-6C0C0CC2-F247-45B7-9530-41FDEC58290C.htm\">Using Python with MotionBuilder</a></span>. \n\
            </p> \n\
            <div class=\"section\"><a name=\"SECTION_EB1208F670AB4EC4BAA775A02F2FC5AC\"></a> \n\
               <h3><a name=\"GUID-74189556-614B-4072-9E2B-E3CD5237A3EF\"></a>MotionBuilder\'s Python Interpreter\n\
               </h3> \n\
               <p><a name=\"GUID-9CD85B01-21AE-4062-A9AA-33D4A395E2B7\"></a>MotionBuilder comes packaged with its own Python interpreter. This means that the\n\
                  Python programs you write are excecuted <em class=\"mild\">within</em> the MotionBuilder application. For information on the current version of MotionBuilder\'s\n\
                  Python interpreter, see <span class=\"char_link\"><a href=\"#!/url=./files/GUID-0C6F6BA3-E9A2-40D0-87AE-F4F8CF20A66C.htm#SECTION_F2672FBACC734FA8A014414C6E208022\">Python Requirements</a></span>. \n\
               </p> \n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_66F0EF47FB254DF19A3071F15F9567B6\"></a> \n\
            <h2><a name=\"GUID-74456173-107B-4AB7-8E60-7B8E73C30175\"></a>Why would I want to use Python with MotionBuilder?\n\
            </h2> \n\
            <p><a name=\"GUID-34825585-0825-400C-BA07-AC28A72EAFD4\"></a>Compared to many other programming languages, Python is easy to use and learn. Its\n\
               design emphasizes programmer productivity and code readability. The interactive interpreter\n\
               allows you to type lines of code and have them execute immediately. Moreover, Python\n\
               development tools are generally free, and MotionBuilder comes with its own built-in\n\
               <span class=\"char_link\"><a href=\"#!/url=./files/GUID-6B00DBAE-EC34-4958-86F5-A5B644C2DB00.htm\">Python Editor</a></span> to facilitate development and program execution. \n\
            </p> \n\
            <p><a name=\"GUID-0146FE2B-4420-4B3E-9637-99AC5702B1A7\"></a>By contrast, C++ development on Windows usually requires an installation of Visual\n\
               Studio. C++ code must also be compiled into a <span class=\"filePath\" translate=\"no\">.dll</span> file, and placed in MotionBuilder\'s plugin directory. \n\
            </p> \n\
            <p><a name=\"GUID-E61DBB5F-0C4D-476D-B281-D91EDC69DF9B\"></a>Python is a multi-paradigm language, which means you can write simple procedural scripts,\n\
               or develop larger object-oriented programs. It is used as a scripting language for\n\
               many tools including Autodesk Maya, Autodesk Softimage, and it is widely used in pipelines\n\
               throughout the computer graphics industry. \n\
            </p> \n\
            <p><a name=\"GUID-D47EEF32-BDB0-4CC7-B873-B49B8F2F0DDA\"></a>The Python official website at <a href=\"http://www.python.org/\" target=\"_blank\">python.org</a> includes documentation, downloads and links to the community. \n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";