var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-7871AFE8-5209-4377-B4B4-2881840E7EDF\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>FBProperty - Object Properties</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-7871AFE8-5209-4377-B4B4-2881840E7EDF\"></a><div class=\"head\">\n\
            <h1>FBProperty - Object Properties</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_06576F7FBB7F4ED8BE5C8B7C84D298B9\"></a> \n\
            <h2><a name=\"GUID-0B0EBB3A-5005-4463-AE65-67CCB23005EF\"></a>Object Properties\n\
            </h2> \n\
            <p><a name=\"GUID-E9C8DDB9-E478-46AA-A9BC-F633563E0984\"></a>The state and behavior of an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_component.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent</a></span> is controlled by its list of properties (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBProperty\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_property.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_property.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBProperty</a></span>). To obtain an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_component.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent</a></span>\'s list of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBProperty\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_property.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_property.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBProperty</a></span> instances, you may (1): consult the SDK\'s class reference documentation, or (2):\n\
               iterate through the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent.PropertyList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_component.html#a8a4fc4a031d937704ae36899e10cb6d1&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent.PropertyList</a></span> to print the names of the component\'s properties: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">for property in lComponent.PropertyList:\n\
    # The following <a href=\"javascript:void(0)\" data-symbol=\"name\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#afcd1706c9144e6d6eee6127661ae3be2&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">name</a> can be used to obtain a property in FBComponent.PropertyList.Find(&lt;<a href=\"javascript:void(0)\" data-symbol=\"name\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#afcd1706c9144e6d6eee6127661ae3be2&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">name</a>&gt;)\n\
    print property.Name</pre></div> \n\
            <p><a name=\"GUID-A1518C8F-0796-496E-8C71-CF53C4D8E259\"></a>Observe that an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a></span> uses instances of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBProperty\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_property.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_property.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBProperty</a></span> to define the local translation, rotation and scaling vectors. Properties can be\n\
               accessed in two ways: \n\
            </p> <a name=\"UL_39AF51F7342F42DBB30042A3C2538205\"></a><ul>\n\
               <li> \n\
                  <p><a name=\"GUID-DC3D382C-4759-48C0-BE03-22D23973525D\"></a> <em class=\"strong\">Directly from the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_component.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent</a></span>.</em> \n\
                  </p> \n\
                  <p><a name=\"GUID-071B21DF-C0DD-457B-85A4-0774D853455A\"></a> In the following code sample, we obtain the local translation <em class=\"strong\">vector</em> of a newly created cube. \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">cube = <a href=\"javascript:void(0)\" data-symbol=\"FBModelCube\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_cube.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelCube</a>(\'myCube\')\n\
\n\
# Obtain the translation vector from the cube.\n\
translationVector = cube.Translation</pre></div> \n\
               </li>\n\
               <li> \n\
                  <p><a name=\"GUID-AC7CE68E-A1B7-4C4A-970D-F2A0DE079E87\"></a> <em class=\"strong\">From the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_component.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent</a></span>\'s property list (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent.PropertyList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_component.html#a8a4fc4a031d937704ae36899e10cb6d1&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent.PropertyList</a></span>).</em> \n\
                  </p> \n\
                  <p><a name=\"GUID-7772CF7B-3C2C-4BB8-A870-7EDE464E5E33\"></a>In the following code sample, we first obtain the translation <em class=\"strong\">property</em> of a newly created cube. The actual translation vector is contained within the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBProperty\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_property.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_property.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBProperty</a></span> object, accessible via <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBProperty.Data\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_property.html#af5baa506e65b4caa6be6d1c6661dfe63&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBProperty.Data</a></span>. \n\
                  </p> \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">cube = <a href=\"javascript:void(0)\" data-symbol=\"FBModelCube\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_cube.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelCube</a>(\'myCube\')\n\
\n\
# Obtain the translation property from the cube.\n\
translationProperty = cube.PropertyList.Find(\'Translation\')\n\
\n\
# Obtain the translation vector from the property object.\n\
translationVector = translationProperty.Data</pre></div> \n\
               </li>\n\
            </ul> \n\
            <p><a name=\"GUID-15353034-A9C2-48DF-89A6-B0A00B2F2457\"></a> \n\
               <div><a name=\"GUID-1D3FE199-FEDE-47DD-9D54-474CD2695DC4\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Classes which inherit from <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBProperty\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_property.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_property.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBProperty</a></span> are generally named to reflect the return type of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBProperty.Data\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_property.html#af5baa506e65b4caa6be6d1c6661dfe63&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBProperty.Data</a></span>. For example, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPropertyInt.Data\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_property_int.html#a248bfced8a2a84c147f9b20efe3e669a&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPropertyInt.Data</a></span> returns an integer (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"int\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/code_8h.html#aa4332194bf83cd22038ee4511e4decea&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">int</a></span>) type, whereas <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPropertyVector3d.Data\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_property_vector3d.html#a248bfced8a2a84c147f9b20efe3e669a&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPropertyVector3d.Data</a></span> returns an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a883a3ad9217243068a0f3cb38780b323&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a></span> object. \n\
                  </div>\n\
               </div> \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_2B17B14455B54E5FB39E12C8D7BCE8EE\"></a> \n\
            <h2><a name=\"GUID-2F3DCB3A-5D82-4D82-A131-83E09E06D9D4\"></a>Animatable Properties\n\
            </h2> \n\
            <p><a name=\"GUID-5ECC133F-74FA-465F-A5E2-4AA00B24D850\"></a>An <em class=\"strong\">animatable property</em> is an instance of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPropertyAnimatable\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_property_animatable.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_property_animatable.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPropertyAnimatable</a></span>. Many properties are animatable, such as <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel.Translation\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model.html#a5c91773e963963f719d3d4baf99cf3c8&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel.Translation</a></span>, and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBMaterial.Diffuse\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_material.html#a9f586523554931c76cb61fb6092614e4&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMaterial.Diffuse</a></span>. Before these properties can be animated however, they must have their animated status\n\
               set to <span class=\"code\" translate=\"no\">True</span> via <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPropertyAnimatable.SetAnimated()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_property_animatable.html#a49cec03d8c8b31dc234e525f2429b110&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPropertyAnimatable.SetAnimated()</a></span>. The following example enables the animation of a light\'s intensity property. For\n\
               an example on how to animate a camera using key frames and animation nodes (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBAnimationNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_animation_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_animation_node.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBAnimationNode</a></span>), see <span class=\"char_link\"><a href=\"#!/url=./files/GUID-3D242E6C-0A04-4BE3-84A7-C7FF923527EE.htm#SECTION_0247889C7FDB468FB6D34A0873672FAF\">FBCamera - Cameras</a></span>. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">from pyfbsdk import *\n\
\n\
\n\
###############################################################\n\
# Main.                                                       #\n\
###############################################################\n\
\n\
light = <a href=\"javascript:void(0)\" data-symbol=\"FBLight\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_light.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLight</a>(\'myLight\')\n\
\n\
print \'light.Intensity animation node: \' + <a href=\"javascript:void(0)\" data-symbol=\"str\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/node_8h.html#a62b34ca1362fe946082b7aa0cd9be844&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">str</a>(light.Intensity.GetAnimationNode())\n\
\n\
# Enable animation for the light\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> intensity.\n\
# (!) This initializes the animation <a href=\"javascript:void(0)\" data-symbol=\"node\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/node_8h.html#addb697c9bca6f8981a870daa4953af4f&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">node</a> for intensity.\n\
light.Intensity.SetAnimated(True)\n\
\n\
print \'light.Intensity animation node: \' + <a href=\"javascript:void(0)\" data-symbol=\"str\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/node_8h.html#a62b34ca1362fe946082b7aa0cd9be844&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">str</a>(light.Intensity.GetAnimationNode())\n\
\n\
\n\
###############################################################\n\
# Output.                                                     #\n\
###############################################################\n\
\'\'\'\n\
light.Intensity animation node: None\n\
light.Intensity animation node: &lt;pyfbsdk.FBAnimationNode <a href=\"javascript:void(0)\" data-symbol=\"object\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#a904fdf014f8cdbefe8320ca2bfd6daf6&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">object</a> at 0x000000002F588828&gt;\n\
\'\'\'</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_49C8979C65904E829F9951BF8704C15F\"></a> \n\
            <h2><a name=\"GUID-B61C9B1D-4A50-4887-A199-8EDC290F3431\"></a>Modifying a Component\'s List of Properties\n\
            </h2> \n\
            <p><a name=\"GUID-C3C66B51-027A-4C22-BFA5-F7F82735BDD5\"></a>By calling <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent.PropertyList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_component.html#a8a4fc4a031d937704ae36899e10cb6d1&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent.PropertyList</a></span>, we are actually accessing the component\'s <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPropertyManager\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_property_manager.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_property_manager.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPropertyManager</a></span>. Each instance of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_component.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent</a></span> has its own <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPropertyManager\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_property_manager.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_property_manager.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPropertyManager</a></span>, which contains a list of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBProperty\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_property.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_property.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBProperty</a></span>. \n\
            </p> \n\
            <p><a name=\"GUID-9BBD97C7-02E6-4C2D-B2AD-D7ABFE00FECD\"></a> An <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBProperty\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_property.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_property.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBProperty</a></span> may be added or removed from the component using <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent.PropertyAdd()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_component.html#a0940a3e192f25536b2fa70c77bdf64f8&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent.PropertyAdd()</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent.PropertyRemove()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_component.html#a97ab3f547b9ffc782a63ae971b88b1b9&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent.PropertyRemove()</a></span>. The index returned by <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent.PropertyAdd()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_component.html#a0940a3e192f25536b2fa70c77bdf64f8&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent.PropertyAdd()</a></span> refers to the property\'s position in the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPropertyManager\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_property_manager.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_property_manager.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPropertyManager</a></span>. Additional instances of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBProperty\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_property.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_property.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBProperty</a></span> can be created within the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_component.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent</a></span> using <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent.PropertyCreate()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_component.html#a942f5881c44c6fc910d717c13509faf8&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent.PropertyCreate()</a></span>. \n\
            </p> \n\
            <p><a name=\"GUID-ADB5E107-6A79-490F-9384-0BAA1573FACD\"></a> \n\
               <div><a name=\"GUID-97AC412E-C076-4AC4-88DC-C3F0DCA56CD4\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>The relationships between <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_component.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBProperty\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_property.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_property.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBProperty</a></span> can also be viewed through the use of <em class=\"mild\">connections</em>. For more information, see <span class=\"char_link\"><a href=\"#!/url=./files/GUID-A214721A-1E8F-4F00-ADDC-F5A420F9BF29.htm\">FBPlug - Object Connection Management</a></span>. \n\
                  </div>\n\
               </div> \n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";