var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-7CD5EC6A-A3F4-4AFE-8167-E197C0C9F0BF\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>FBApplication - File I/O and Application Utilities</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-7CD5EC6A-A3F4-4AFE-8167-E197C0C9F0BF\"></a><div class=\"head\">\n\
            <h1>FBApplication - File I/O and Application Utilities</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_1B964EA481804D5FBE1FBBE47A9DA25F\"></a> \n\
            <h2><a name=\"GUID-9C5C5533-AA5C-4712-8FA4-E21CD75F9C5E\"></a>Application Utilities\n\
            </h2> \n\
            <p><a name=\"GUID-7B4C6391-6F3A-44CE-B559-11701FDE000C\"></a> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_application.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a></span> provides similar functionality to the \"<span class=\"code\" translate=\"no\">File</span>\" menu in MotionBuilder. An instance of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_application.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a></span> is required to save and load data from a file (see <span class=\"char_link\"><a href=\"#!/url=./files/GUID-6A324BD7-C0EF-41EB-9CBE-D587B9AB21E2.htm\">File Input and Output</a></span> below). \n\
            </p> \n\
            <p><a name=\"GUID-A4820D1B-57FE-4B0B-9032-E849B3298188\"></a>It can also be used for minimizing (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBApplication.Minimize()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html#a6473d192a1ab85ab77dbc0107381f0c7&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication.Minimize()</a></span>), maximizing (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBApplication.Maximize()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html#aebd10ba9c08ae757e46cecc72baec1b5&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication.Maximize()</a></span>), or closing (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBApplication.FileExit()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html#a945a99e3b63f6b633e8877288afd7ca4&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication.FileExit()</a></span>) the MotionBuilder application. The following code sample uses <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBApplication.FileNew()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html#aefa0a63a4493ce116e7a85d7a248b1cc&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication.FileNew()</a></span> to clear the scene. This is analogous to selecting <span class=\"code\" translate=\"no\">File &gt; New</span> in the application menu, however the user will <em class=\"strong\">not</em> be prompted to save the previous scene. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">from pyfbsdk import *\n\
\n\
# Get the instance of FBApplication.\n\
app = <a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a>()\n\
\n\
# Clear the scene.\n\
app.FileNew()</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_9E6DF3E8F04E40B19921F4043113FDC9\"></a> \n\
            <h2><a name=\"GUID-19CB780A-0124-4F3C-A535-BF04ADBAC261\"></a>File I/O\n\
            </h2> \n\
            <p><a name=\"GUID-3395B24B-6BDB-4BCD-9CEC-AC3DCAED9B1C\"></a>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_application.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a></span> class is primarily used for file input and output operations such as importing, exporting,\n\
               merging, and batch file processing. Most functions related to file I/O are defined\n\
               in <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_application.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a></span>, except for <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBAudioClip\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_audio_clip.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_audio_clip.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBAudioClip</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBVideo\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_video.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_video.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVideo</a></span>, which respectively define audio and video file I/O functions. For more information,\n\
               see <span class=\"char_link\"><a href=\"#!/url=./files/GUID-6A324BD7-C0EF-41EB-9CBE-D587B9AB21E2.htm\">File Input and Output</a></span>. \n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";