var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-861C3367-FED1-4F27-A813-16CB6990F13A\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Animating Characters</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-861C3367-FED1-4F27-A813-16CB6990F13A\"></a><div class=\"head\">\n\
            <h1>Animating Characters</h1>\n\
         </div>\n\
         <p><a name=\"GUID-92BF70BC-E57B-48D4-96EA-E76BFD9B5BDC\"></a> You can consider a character (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCharacter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_character.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_character.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacter</a></span>) as a set of constraints on a hierarchy of models or skeletal joints. This hierarchy\n\
            is usually composed of instances of bones (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelSkeleton\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_skeleton.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_skeleton.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelSkeleton</a></span>), though instances of model root (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelRoot\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_root.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_root.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelRoot</a></span>) are also used to define a character\'s reference point and hips. \n\
         </p>\n\
         <p><a name=\"GUID-EAE9B7DB-357D-4413-9F90-F36DC24FD865\"></a>Generally, a skeleton and weighted mesh (skin) that can receive animation is referred\n\
            to as a character. The skeleton is used for driving the animation. The mesh (skin)\n\
            is constrained to the skeleton automatically through the deformer constraints (weighting).\n\
            You must set up the skeleton and mesh prior to loading the character into MotionBuilder.\n\
            This is typically done in Maya, 3ds Max, or Softimage. \n\
         </p>\n\
         <p><a name=\"GUID-35521004-66E7-4E30-B310-13A614C7D83E\"></a>A character can constrain the data received from an actor, and apply it to a character\n\
            model to create animation. There can be one or more characters between an actor and\n\
            a character model. The character can act as a receiver from another character or as\n\
            a sender. The character can possess a number of sources like an actor or another character,\n\
            but only one source is active at a time. \n\
         </p>\n\
         <p><a name=\"GUID-CAA2E3D0-1398-49F4-A8FE-669FD8CB128A\"></a>Download the <span class=\"filePath\" translate=\"no\">create_character_actor_face_etc.py</span> script from <a href=\"http://area.autodesk.com/downloads/scripts/motionbuilder-animation-scripts\" target=\"_blank\">http://area.autodesk.com/downloads/scripts/motionbuilder-animation-scripts</a>. Run the script to create an actor, actor face, character, character extension, and\n\
            character face. \n\
         </p><span class=\"noindex\">\n\
            <div class=\"topic-list\">\n\
               <h4 class=\"related\">Topics in this section</h4>\n\
               <ul class=\"jumplist\">\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-F4D37550-F4DB-4DFF-A64E-AE4540B11D49.htm\">Characterization</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-F95213E8-643A-4416-8DD4-23EF01D7586C.htm\">Modifying Character Animation using Effectors</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-70AF5762-CCEF-44CC-A64D-19A6D5172A1F.htm\">Animation using Poses</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-FD33DF70-9E1E-47E8-8F0D-D2680D75D736.htm\">Transferring Animation from Markers to a Character</a></li>\n\
               </ul>\n\
            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";