var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-891478E7-AF8B-4A11-970C-582542511DAA\">\n\
      <meta name=\"description\" content=\"This section provides information on how to use motion capture devices (mocap) and other input/output devices with the MotionBuilder SDK.\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Motion Capture Devices</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-891478E7-AF8B-4A11-970C-582542511DAA\"></a><div class=\"head\">\n\
            <h1>Motion Capture Devices</h1>\n\
         </div>\n\
         <p class=\"blurb\">This section provides information on how to use motion capture devices (mocap) and\n\
            other input/output devices with the MotionBuilder SDK. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF61D1E3E812435C7CB1B-3EC1\"></a>A device is a piece of hardware that communicates with MotionBuilder, typically motion\n\
            capture (mocap) hardware transmitting positional data from opical sensors which are\n\
            then used by MotionBuilder to animate a character. Hardware providing the data could\n\
            also be a joystick, a mouse, or any other input device. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF-75C1F7C3124F51CCBD1-53F\"></a>Devices are controlled by plugins written with this SDK. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF6DEA2AA512298434427-7C7F\"></a>Device plugins derive from <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBDevice\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_device.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_device.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBDevice</a></span> or a derived class of it (e.g. <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBDeviceOptical\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_device_optical.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_device_optical.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBDeviceOptical</a></span>, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBDeviceCamera\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_device_camera.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBDeviceCamera</a></span>). \n\
         </p>\n\
         <div><a name=\"GUID-38E91BCE-253F-4778-8FF5-960351B3F72B\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>FBDevice() cannot be instantiated from Python. \n\
            </div>\n\
         </div>\n\
         <p><a name=\"GUID-C54C6C86-9782-4E20-A6A3-5214BB6CAE61\"></a>An <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBDevice\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_device.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_device.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBDevice</a></span> is an abstraction layer representing flows of input or output. For example, when\n\
            the input/output thread communicates with the device, it fills the data structure\n\
            at a constant rate. The evaluation thread pulls the information from this data structure\n\
            when it needs to, isolating communication with the hardware to one high-priority thread.\n\
            \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF-75C1F7C3124F51CCBD1-B92\"></a> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBDevice\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_device.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_device.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBDevice</a></span> inherits from <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBBox\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_box.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_box.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBBox</a></span>, including the evaluation of input and output animation nodes. \n\
         </p><a name=\"WS1A9193826455F5FF61D1E3E812435C7CB1B-3EBF\"></a><p class=\"list-intro\"><a name=\"WS1A9193826455F5FF61D1E3E812435C7CB1B-3EBE\"></a>Main types of devices:\n\
         </p>\n\
         <ul>\n\
            <li>Input devices: these receive data from hardware and use it to animate models in the\n\
               scene. \n\
            </li>\n\
            <li> <span class=\"char_link\"><a href=\"#!/url=./files/GUID-190CFE2F-5F62-4777-98AC-3048CB225F17.htm\">Output devices</a></span>. \n\
            </li>\n\
         </ul><a name=\"WS1A9193826455F5FF-75C1F7C3124F51CCBD1-E7F\"></a><p class=\"list-intro\"><a name=\"WS1A9193826455F5FF-75C1F7C3124F51CCBD1-E7E\"></a>Relationship of mocap data to characters:\n\
         </p>\n\
         <ul>\n\
            <li>Mocap sensor data can be associated directly in the mocap hardware with a character\'s\n\
               skeleton nodes. This mechanism is demonstrated by the <span class=\"char_link\"><a href=\"#!/url=./files/\">\n\
                     NO LABEL\n\
                     </a></span> sample. \n\
            </li>\n\
            <li>Mocap data can be mapped onto markers (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelMarker\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_marker.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_marker.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelMarker</a></span>), which are contained on the actor <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBActor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_actor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_actor.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBActor</a></span> using model templates <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelTemplate\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_template.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_template.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelTemplate</a></span>. This can be gotten and set via the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBActor::OutputMarkerSet\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_actor.html#af646a798d1cd861f098ddb2cb079d78b&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBActor::OutputMarkerSet</a></span> property. The actor drives the animation of the character <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCharacter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_character.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_character.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacter</a></span>, and is gotten or set via the <span class=\"code\" translate=\"no\">FBCharacter:: InputActor</span> property. \n\
            </li>\n\
         </ul><a name=\"WS1A9193826455F5FF-75C1F7C3124F51CCBD1-B91\"></a><p class=\"list-intro\"><a name=\"WS1A9193826455F5FF-75C1F7C3124F51CCBD1-B90\"></a>MotionBuilder runs two different threads\n\
         </p>\n\
         <ul>\n\
            <li>Real-time engine thread: tells your plugin to query the hardware for data. It calls\n\
               <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBDevice::DeviceTransportNotify()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_device.html#a9196d71cc251d519ff3352110996ac21&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBDevice::DeviceTransportNotify()</a></span>, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBDevice::DeviceIONotify()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_device.html#a65922344760a5f44851818f211ca6526&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBDevice::DeviceIONotify()</a></span>, and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBDevice::DeviceEvaluationNotify()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_device.html#ad4a2df6f0d2278100c48f801ffac2269&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBDevice::DeviceEvaluationNotify()</a></span>. Note that any functions called by the real-time engine, must be optimized and cannot\n\
               block (i.e. wait on a resource or another thread). \n\
            </li>\n\
            <li>Animation thread: tells your plugin to deliver animation data. This calls <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBDevice::AnimationNodeNotify()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_device.html#a1761a25ebcc79ff01a370535fef51336&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBDevice::AnimationNodeNotify()</a></span>. \n\
            </li>\n\
         </ul><a name=\"WS1A9193826455F5FF-75C1F7C3124F51CCBD1-E99\"></a><p class=\"list-intro\"><a name=\"WS1A9193826455F5FF-75C1F7C3124F51CCBD1-E98\"></a>Plugins can be built by overriding the following functions:\n\
         </p>\n\
         <ul>\n\
            <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBDevice::AnimationNodeNotify()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_device.html#a1761a25ebcc79ff01a370535fef51336&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBDevice::AnimationNodeNotify()</a></span>: get data from the hardware abstraction. Write data to animation nodes. It is called\n\
               asynchronously, when needed. \n\
            </li>\n\
            <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBDevice::DeviceIONotify()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_device.html#a65922344760a5f44851818f211ca6526&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBDevice::DeviceIONotify()</a></span>: read and record each data packet. <span class=\"code\" translate=\"no\">DeviceIONotify</span> is called at the <span class=\"code\" translate=\"no\">SamplingPeriod</span>. The input data is read from the hardware into the abstraction layer. Be careful\n\
               that calls to functions like <span class=\"code\" translate=\"no\">AnimationNodeNotify</span>, <span class=\"code\" translate=\"no\">DeviceEvaluationNotify</span>, and <span class=\"code\" translate=\"no\">DeviceIONotify</span> consume as little CPU time as possible and return as soon as possible because they\n\
               have a high priority of execution. Blocking is generally an option in most protocols.\n\
               \n\
            </li>\n\
            <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBDevice::DeviceOperation()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_device.html#ab9cb807f1983e43d1978ca6ed0c9ce5e&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBDevice::DeviceOperation()</a></span>: operates the device. \n\
            </li>\n\
            <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBDevice::FBCreate()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_device.html#a8222192c59814d30314e0441d1eeb6be&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBDevice::FBCreate()</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBDevice::FBDestroy()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_device.html#a32c136301cd2f650260d23733d6c1089&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBDevice::FBDestroy()</a></span>: perform initialization such as creation of model templates and clean-up such as\n\
               removing binding. \n\
            </li>\n\
            <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBDevice::FbxStore()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_device.html#a85f7d3d313eba385662783def5429f63&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBDevice::FbxStore()</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBDevice::FbxRetrieve()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_device.html#ad125b308c701397c7f607a5b2ac977ba&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBDevice::FbxRetrieve()</a></span> are used to access device configuration in the FBX file. \n\
            </li>\n\
            <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBDevice::RecordingDoneAnimation()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_device.html#afd66cc0fe08de2267049fde92218ae96&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBDevice::RecordingDoneAnimation()</a></span>: called by motion builder when recording of an animation is completed. \n\
            </li>\n\
         </ul>\n\
         <p><a name=\"WS73099CC142F48755-575EAB4C124F5234AA8-38AC\"></a> <span class=\"code\" translate=\"no\">OnStatusChange</span> is an event associated with a change of status (live/online/record) of the device.\n\
            \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF-75C1F7C3124F51CCBD1-E8E\"></a>It is also possible to use the real-time synchronous calls to schedule functionality\n\
            in the application (as the devicereclist sample). \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF1F92379812730122E4B-78EC\"></a>Store data in the object, not in the layout, due to the volatile nature of a layout.\n\
            A layout in MotionBuilder may be destroyed and re-created many times during the execution\n\
            of the program, creating a problem for the persistence of the data required by the\n\
            tool/manipulator/constraint. Store data in the object itself (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBDevice\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_device.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_device.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBDevice</a></span>, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBManipulator\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_manipulator.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBManipulator</a></span>, and so on) instead of in the layout (<span class=\"code\" translate=\"no\">FBDeviceLayout</span>, and so on). \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF1F92379812730122E4B-78EB\"></a>Display current state: use the UI tools to display the current operation/status. There\n\
            are various user interface tools available in the Open Reality SDK that can help you\n\
            debug a plug-in, and they also provide useful information. Among these are the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBProgress\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_progress.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBProgress</a></span> classes and the text strings for the status of a device. These items can be useful\n\
            when interacting with you, and inform both you and the user of the current status\n\
            of the device and what is happening on the internal side of the software. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF1F92379812730122E4B-78EA\"></a>Acknowledge samples for statistics. Use the AckOneSample[Sent/Received]() functions\n\
            so they display beside the sampling rate in the user interface. Use <span class=\"code\" translate=\"no\">AckOneSampleReceived</span>, <span class=\"code\" translate=\"no\">AckOneSampleSent</span>, and so on, to mark the receipt/transmission of a data packet. MotionBuilder is able\n\
            to deal with the data that they generate. This can also be a good source of information\n\
            to help with debugging a plug-in. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF1F92379812730122E4B-78E9\"></a>In the case of the output functionality for a device, <span class=\"code\" translate=\"no\">DeviceEvaluationNotify</span> reads data from the output nodes and copies it into the hardware abstraction to be\n\
            transferred to the device in the IO thread. The difference between this thread and\n\
            the <span class=\"code\" translate=\"no\">AnimationNodeNotify</span> thread is that it provokes an evaluation if necessary and is called at a fixed rate\n\
            (the same rate as DeviceIONotify). To change the rate of DeviceIONotify: In the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBDevice\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_device.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_device.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBDevice</a></span> class, there is a variable called <span class=\"code\" translate=\"no\">SamplingPeriod</span>. This variable determines the rate at which <span class=\"code\" translate=\"no\">DeviceIONotify</span> and <span class=\"code\" translate=\"no\">DeviceEvaluationNotify</span> are called. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF1F92379812730122E4B-78E8\"></a> <span class=\"code\" translate=\"no\">DeviceIONotify</span> is called twice each evaluation loop, once for reading the device’s information,\n\
            and once for writing data back to the device. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF1F92379812730122E4B-78E7\"></a> <span class=\"code\" translate=\"no\">DeviceEvaluationNotify</span> is called at a given sampling rate (see Q1), between the two <span class=\"code\" translate=\"no\">DeviceIONotify</span> calls (see Q3). \n\
         </p><span class=\"noindex\">\n\
            <div class=\"topic-list\">\n\
               <h4 class=\"related\">Topics in this section</h4>\n\
               <ul class=\"jumplist\">\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-BD13B250-CEBF-4110-8BE2-3EA1A04A5B1A.htm\">Device operation</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-12F74C2F-2822-4F07-8441-25A1562C7D94.htm\">Model templates</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-52B6A4E5-643B-453C-B8DF-F796C4484206.htm\">Streaming devices</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-E6E1AA38-B59E-4A4A-B558-07D5BC5F4878.htm\">Optical devices</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-3C3563D5-F88E-4E1B-BA83-0B1EF4F1A2B7.htm\">Sampling modes</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-4F96A0F5-FDBF-4D79-B186-05D7D0292661.htm\">Device layouts</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-190CFE2F-5F62-4777-98AC-3048CB225F17.htm\">Output devices</a></li>\n\
               </ul>\n\
            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";