var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-8A7C3593-60E2-4915-8222-19118539E46B\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>MotionBuilder 2013</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-8A7C3593-60E2-4915-8222-19118539E46B\"></a><div class=\"head\">\n\
            <h1>MotionBuilder 2013</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_DBE45C80404040D2816D373C17925576\"></a> \n\
            <h2><a name=\"GUID-682D56C1-BE61-4557-BCF1-325523860A62\"></a>Programming Environment and Code Refactoring Changes\n\
            </h2> <a name=\"UL_B4BAC235812A413B9B8356948B0D1CCE\"></a><ul>\n\
               <li>MotionBuilder and its distributed plug-ins are now compiled using <em class=\"strong\">Visual Studio 2010 (Service Pack 1).</em> \n\
               </li>\n\
               <li> <em class=\"strong\">Environment Variables:</em> <a name=\"UL_D5DA524E481C488C9F616C56715A41BF\"></a><ul>\n\
                     <li><span class=\"code\" translate=\"no\">MOTIONBUILDER_PLUGIN_PATH</span> - The list of directories contained in this environment variable determines the location\n\
                        from which MotionBuilder will load compiled plugins. \n\
                     </li>\n\
                     <li><span class=\"code\" translate=\"no\">MOTIONBUILDER_PYTHON_STARTUP</span> - The directory contained in this environment variable determines the location from\n\
                        which MotionBuilder loads the Python startup scripts. Setting this environment variable\n\
                        overrides the default Python startup path in MotionBuilder. \n\
                     </li>\n\
                     <li><span class=\"code\" translate=\"no\">FILMBOX_CONSOLE</span> - Setting this environment variable to <span class=\"code\" translate=\"no\">1</span> allows the console to appear, otherwise the console will not appear. \n\
                     </li>\n\
                  </ul> \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\">FBContainer</span> has been renamed to <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBVisualContainer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_visual_container.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVisualContainer</a></span> to increase the uniformity of cross-product naming schemes. \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\">const</span> correctness improvements. \n\
               </li>\n\
               <li>Although not enforced in this release, we recommend that the \"<span class=\"code\" translate=\"no\">H</span>\" prefix in classes such as <span class=\"code\" translate=\"no\">HFBPlug</span> be removed and replaced by the pointer suffix \"<span class=\"code\" translate=\"no\">*</span>\", for example: <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_plug.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPlug</a>*</span>. This change is intended to facilitate the use of the documentation system in the\n\
                  near future. \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBShader\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_shader.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_shader.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBShader</a></span> has been heavily refactored for performance. \n\
               </li>\n\
               <li>The <span class=\"code\" translate=\"no\">FBModelTransformationMatrix</span> enumeration type has been renamed to <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelTransformationType\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a0b029cdd10f4e62bb60aa39467b102de&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_transformation_type.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelTransformationType</a></span>. \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\">FBFindObjectsByNamespace</span> has been deprecated. Use <span class=\"code\" translate=\"no\">FBFindObjectsByFullName</span> or <span class=\"code\" translate=\"no\">FBFindObjectsByName</span> instead. \n\
               </li>\n\
            </ul> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_A92013CD69F945FBA5E27BD26479FEDF\"></a> \n\
            <h2><a name=\"GUID-E3C69E17-0A05-4CF0-A034-ACAE8CD62583\"></a>New Classes\n\
            </h2> <a name=\"UL_37A5E88847C244EA8C6FAA611D2E44F1\"></a><ul>\n\
               <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBSyncReference\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_sync_reference.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSyncReference</a></span> - Allows the MotionBuilder application to sync its time with a device\'s time. For\n\
                  more information, consult the <span class=\"code\" translate=\"no\">ordevicesync_device</span> plugin. \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBTimeCode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_time_code.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_time_code.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTimeCode</a></span> - A timecode contains the time and frame information used to identify a specific\n\
                  moment in a timeline, often used in video and audio production. This class can namely\n\
                  help in the conversion of a point in time from one frame rate domain to another. \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBHUD\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_h_u_d.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_h_u_d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBHUD</a>, <a href=\"javascript:void(0)\" data-symbol=\"FBHUDElement\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_h_u_d_element.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_h_u_d_element.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBHUDElement</a></span> - These classes represent the new Heads-Up Display (HUD) feature in MotionBuilder.\n\
                  A HUD is connected to a camera, and appears as a 2D overlay. This overlay can be used\n\
                  to display information about the take, such as the current time, frame number, etc.\n\
                  \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBFileMonitoringManager\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_file_monitoring_manager.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_file_monitoring_manager.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFileMonitoringManager</a></span> - This class can be used to monitor operating system file events. By contrast, the\n\
                  event properties in <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_application.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a></span> only monitor events triggered within the MotionBuilder application. \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBNamespace\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_namespace.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_namespace.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBNamespace</a></span> - This class has been exposed to facilitate the use of namespaces among scene elements.\n\
                  Functions such as <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBFindModelByLabelName()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#aff5d93ad5cb7d8e581d94ab69555540a&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga7572e2672e95a9d964c46b67c70097a6&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFindModelByLabelName()</a></span>, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBFbxOptions::NamespaceList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_fbx_options.html#ab8851d7ba9a72bd6579b209c56a4eede&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFbxOptions::NamespaceList</a></span>, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBFbxOptions::SetNamespaceList()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_fbx_options.html#a50d5115f5318f16327cee980e84fe0ea&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFbxOptions::SetNamespaceList()</a></span>, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBFbxOptions::GetNamespaceList()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_fbx_options.html#a64f5a7763de1e74f288eec0a64bf0d78&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFbxOptions::GetNamespaceList()</a></span>, and the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBScene\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_scene.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_scene.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBScene</a></span>\'s namespace related functions (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBScene::NamespaceImport()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_scene.html#a23279b654fc349522a9a597e042a20d0&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBScene::NamespaceImport()</a></span>) can filter, select, import and export scene elements using namespaces. \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\">FBAudioRenderOptions()</span> - This class has been added to specify audio rendering options, which can be passed\n\
                  as a parameter to <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBApplication::AudioRender()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_application.html#aceb69691b08848eb160ae29144f59e76&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication::AudioRender()</a></span>. Consult the <span class=\"filePath\" translate=\"no\">Scripts/Samples/Audio/AudioRendering.py</span> sample for more details. \n\
               </li>\n\
            </ul> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_6D6CA2CCD0194B4BAF573F7A028F306D\"></a> \n\
            <h2><a name=\"GUID-D84B4410-EA7D-4631-9740-298F8AFC7D18\"></a>New Methods and Added Functionality\n\
            </h2> <a name=\"UL_5CAE6BC80B8F416F95354F6C6295F88C\"></a><ul>\n\
               <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBAnimationNode::KeyCandidate()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_animation_node.html#a0c8fbf5dcabca11ac181628a599db279&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBAnimationNode::KeyCandidate()</a></span>, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPropertyAnimatable::KeyAt()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_property_animatable.html#aacd74d7cbfb683402ffaafda5a2bb617&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPropertyAnimatable::KeyAt()</a></span> - These functions now provide the ability to key at a given time without moving time.\n\
                  \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBSystem.ConfigPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html#a17c8b49529d853784eda883797b9f8f7&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem.ConfigPath</a></span>, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBSystem.UserConfigPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html#a22639580d9c2162c938dc94b86c22f49&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem.UserConfigPath</a></span>, <span class=\"code\" translate=\"no\">FBSystem.TempPath</span> - These properties respectively define MotionBuilder\'s directory paths for config\n\
                  files, user config files, and temporary files. \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBAudioClip\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_audio_clip.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_audio_clip.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBAudioClip</a></span> - A substantial amount of functionality has been added to this class. Consult the\n\
                  header files and class documentation for more information. \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBMenuManager\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_menu_manager.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMenuManager</a></span> - Functionality has been added to this class to manipulate and remove MotionBuilder\'s\n\
                  UI top menu bar. \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent::GetFullName()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_component.html#ad9a19bcd2439eb736f5c331d621059c9&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent::GetFullName()</a></span> - Retrieves an object\'s unique name. \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBStory\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_story.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_story.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBStory</a></span>, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBStoryFolder\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_story_folder.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_story_folder.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBStoryFolder</a></span>, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBStoryTrack\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_story_track.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_story_track.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBStoryTrack</a></span> - Added the capability to record stories on disk with properties such as <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBStory::RecordToDisk\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_story.html#a562c0bd496b4b87a6a113ed67d580b51&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBStory::RecordToDisk</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBStoryFolder::RecordClipPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_story_folder.html#a2feb4d0662b9c8485e45da03f76c5ac9&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBStoryFolder::RecordClipPath</a></span>. \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\">FBDevice::ModelBindingCreate</span>, <span class=\"code\" translate=\"no\">FBDevice::ModelBindingRootsList</span> - These functions allow you to create a model binding from a device, or obtain a\n\
                  list of all possible root models which can be bound to the device. \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a></span> - Exposed additional properties to facilitate custom rendering. For example, viewport\n\
                  dimensions can be set in the model, which are only updated and valid during custom\n\
                  renderer callbacks (<span class=\"code\" translate=\"no\">FBModel::CameraViewportX</span>, <span class=\"code\" translate=\"no\">FBModel::CameraViewportY</span>, <span class=\"code\" translate=\"no\">FBModel::CameraViewportWidth</span>, <span class=\"code\" translate=\"no\">FBModel::CameraViewportHeight</span>). Motion blur properties have also been added: <span class=\"code\" translate=\"no\">FBModel::MotionBlurIntensity</span>, <span class=\"code\" translate=\"no\">FBModel::UseMotionBlur</span>, <span class=\"code\" translate=\"no\">FBModel::UseRealTimeMotionBlur</span>. \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelNull\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_null.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_null.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelNull</a></span>, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelMarker\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_marker.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_marker.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelMarker</a></span> - Overloaded several FBModel base class functions in these subclasses to increase\n\
                  user customization. These functions are: <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelMarker\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_marker.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_marker.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelMarker</a>/<a href=\"javascript:void(0)\" data-symbol=\"FBModelNull::FbxStore()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_null.html#a338af922f322871b1001d527851ec995&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelNull::FbxStore()</a></span>, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelMarker\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_marker.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_marker.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelMarker</a>/<a href=\"javascript:void(0)\" data-symbol=\"FBModelNull::FbxRetrieve()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_null.html#a8342c156c28a1991d8680312c470b9d5&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelNull::FbxRetrieve()</a></span>, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelMarker\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_marker.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_marker.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelMarker</a>/FBModelNull::FbxGetObject()</span>, and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelMarker\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_marker.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_marker.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelMarker</a>/<a href=\"javascript:void(0)\" data-symbol=\"FBModelNull::FbxGetObjectSubType()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_null.html#a7a9036db507c99abab739acf2afe2fc6&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelNull::FbxGetObjectSubType()</a></span>. \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBMaterial\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_material.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_material.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMaterial</a></span> - Custom material support, and added sample project (<span class=\"filePath\" translate=\"no\">OpenRealitySDK/Samples/miscellaneous/material_template</span>) \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBRenderer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_renderer.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBRenderer</a></span> - Added new functionality such as <span class=\"code\" translate=\"no\">FBRenderer::GetViewingCamera()</span> to obtain the current camera, <span class=\"code\" translate=\"no\">FBRenderer::InPicking()</span> to determine if the renderer is in the picking phase, and a variety of other functions\n\
                  and properties related to picking. \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBEvaluateManager\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_evaluate_manager.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_evaluate_manager.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBEvaluateManager</a></span> - Added functionality allows for computationally intensive tasks to be registered\n\
                  and run as callbacks in a background thread (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBEvaluateManager::RegisterEvaluationGlobalFunction()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_evaluate_manager.html#a8f200256c4dd41d9984bbf0575c7b60d&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBEvaluateManager::RegisterEvaluationGlobalFunction()</a></span>, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBEvaluateManager::UnregisterEvaluationGlobalFunction()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_evaluate_manager.html#a92a4b508c62cac91d606d984f49a70da&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBEvaluateManager::UnregisterEvaluationGlobalFunction()</a></span>) \n\
               </li>\n\
               <li>The local time can now be obtained by calling <span class=\"code\" translate=\"no\">FBSystem().LocalTime.GetFrame()</span>. An optional <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBTimeMode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a7a0358a02ed3b6f18045939192c38b99&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_time_mode.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTimeMode</a></span> parameter may be passed to <span class=\"code\" translate=\"no\">GetFrame()</span> to specify the time mode. The default time mode is <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"kFBTimeModeDefault\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a7a0358a02ed3b6f18045939192c38b99ab79ec0b606425e55159c9d697746930b&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">kFBTimeModeDefault</a></span>. \n\
               </li>\n\
            </ul> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_76946CC212B849AAB9ADE43733BDD106\"></a> \n\
            <h2><a name=\"GUID-BD5BC56C-D005-401E-8358-AACDDB96249C\"></a>Optimizations\n\
            </h2> <a name=\"UL_C13A2A0FF793470E8952042F05B90129\"></a><ul>\n\
               <li>Optimized functions <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBFindObjectByFullName()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a3367b7ebdbcd1c6a6fcc129eb8bbb4fa&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga980a7ebfc02171f683b0bfed6527faa2&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFindObjectByFullName()</a></span> and <span class=\"code\" translate=\"no\">FBDeleteObjectsByNames()</span>. \n\
               </li>\n\
               <li>Optimized the merging of multiple files transaction workflow: <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBMergeTransactionBegin()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/group___file.html#ga256b348d4b61b1d26e8023e722ac2a6b&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga7fbdb19c5baa54d138e53267d701471a&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMergeTransactionBegin()</a></span>, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBMergeTransactionEnd()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/group___file.html#ga7e3b51dc84ffcb8fc307f93a7eafd730&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga673100b5f331d24cf1285b3386d9b9b3&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMergeTransactionEnd()</a></span>. \n\
               </li>\n\
            </ul> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_2F089A818B7F4523942D19B651959269\"></a> \n\
            <h2><a name=\"GUID-4CD4A862-C589-4F00-BA91-B00730421F7B\"></a>SDK Bug Fixes and Improvements\n\
            </h2> \n\
            <p><a name=\"GUID-3F396F99-0664-4BA5-9BD9-A5533DAA8C18\"></a>For information on SDK Bug Fixes and Improvements, consult the <a href=\"http://www.autodesk.com/motionbuilder2013-documentation\" target=\"_blank\">MotionBuilder 2013 Release Notes</a>. \n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";