var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-8EC1E48A-B713-42A9-A174-24F7778A4833\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Managing Animation using Takes</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-8EC1E48A-B713-42A9-A174-24F7778A4833\"></a><div class=\"head\">\n\
            <h1>Managing Animation using Takes</h1>\n\
         </div>\n\
         <p><a name=\"GUID-F5CE820C-1E6A-4860-BFE9-F12CAE319FBC\"></a> The following sections explain how to use takes and animation layers. To follow the\n\
            instructions, download the files and scripts from <a href=\"http://area.autodesk.com/downloads/scripts/motionbuilder-animation-scripts\" target=\"_blank\">http://area.autodesk.com/downloads/scripts/motionbuilder-animation-scripts</a>. \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_2D804CAE3D244F2989740326B2ECBACA\"></a> \n\
            <h2><a name=\"GUID-F4FE3629-4CD3-4641-B5D8-CB54B07EFAA8\"></a>Navigating Through Takes\n\
            </h2> \n\
            <p><a name=\"GUID-F81742D1-606C-456D-AF85-8C820194366C\"></a>A take (FBTake) is a level of animation in your scene. \n\
            </p> \n\
            <p><a name=\"GUID-C70BE077-A41C-4EC0-A861-D78BCEF4115B\"></a>Run the <span class=\"filePath\" translate=\"no\">go_to_next_take.py</span> script to create two takes. You can navigate to the next take by running the <em class=\"mild\">Go to next take</em> code as shown in the following figure. <a name=\"FIG_5F918EDCD84A4D99B5686310D1DAFA81\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-8E68BDC4-629D-4F8A-8A83-3F24F3DE92F1-low.png\"></div> \n\
            </p> \n\
            <p><a name=\"GUID-D1F8AD9D-8EE5-473F-8E9D-242D9C12F3E2\"></a>Following are the points to keep in mind: <a name=\"UL_0AE4B6FE28754509AD6436EF2631BC9D\"></a><ul>\n\
                  <li><span class=\"code\" translate=\"no\"> lSystem.CurrentTake</span> – Always returns the current take. \n\
                  </li>\n\
                  <li><span class=\"code\" translate=\"no\"> lSystem.Scene.Takes</span> – The takes list in a scene. \n\
                  </li>\n\
                  <li><span class=\"code\" translate=\"no\"> <a href=\"javascript:void(0)\" data-symbol=\"FBTake\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_take.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_take.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTake</a>(\"Take 002\")</span> – Creates a new take. \n\
                  </li>\n\
                  <li> <span class=\"code\" translate=\"no\">lSystem.Scene.Takes.append(lNewTake)</span> – Adds a take to the scene. \n\
                  </li>\n\
               </ul> \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_3C633784B8E14926A355BBF593E5D83E\"></a> \n\
            <h2><a name=\"GUID-9FB856B8-D2CA-4B6D-8585-A685230210A9\"></a>Creating Animation on Animation Layers\n\
            </h2> \n\
            <p><a name=\"GUID-76044486-7899-448A-8A95-BBBAC5DECAF9\"></a> A take can contain multiple animation layers. You can make changes in one layer without\n\
               affecting the other layers. \n\
            </p> \n\
            <p><a name=\"GUID-AAADC436-6609-4D1C-A4B8-C5966F7021F1\"></a>Run the <span class=\"filePath\" translate=\"no\">create_animation_on_animation_layers.py</span> script to create animation in multiple layers. Select the two animation layers as\n\
               shown in the following figure. <a name=\"FIG_4B94667EC612443C89099EE31E685D25\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-011937E9-710C-48D2-B7B7-155E452ADBD5-low.png\"></div> \n\
            </p> \n\
            <p><a name=\"GUID-69ED8350-1996-4739-BF28-0C3E08B8E447\"></a>Following are the points to keep in mind: <a name=\"UL_704691398497495FAC3E9F8B2316FE67\"></a><ul>\n\
                  <li><span class=\"code\" translate=\"no\"> lSystem.CurrentTake.SetCurrentLayer(<a href=\"javascript:void(0)\" data-symbol=\"index\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#aed9361a6a6957b25e08992d6392020a4&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">index</a>)</span> – Sets an animation layer as the current animation layer. \n\
                  </li>\n\
                  <li><span class=\"code\" translate=\"no\">lSystem.CurrentTake.GetLayerCount()</span> – Gets the number of animation layers. \n\
                  </li>\n\
                  <li><span class=\"code\" translate=\"no\">lSystem.CurrentTake.GetLayerByName()</span>– Gets an animation layer by name. \n\
                  </li>\n\
                  <li><span class=\"code\" translate=\"no\">lSystem.CurrentTake.CreateNewLayer()</span> – Creates a new layer. \n\
                  </li>\n\
                  <li><span class=\"code\" translate=\"no\">ParentLayer.AddChildLayer(NewChildLayer)</span> – Builds the animation layer hierarchy. \n\
                  </li>\n\
               </ul> \n\
            </p> \n\
            <p><a name=\"GUID-580D6D99-0F6F-4F09-9BB5-A4D5AD14F067\"></a>Animation layers have properties such as, Weight, LayerMode, and others that you can\n\
               set in the script. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_FFF793AE1A8046FD819980B14235F730\"></a> \n\
            <h2><a name=\"GUID-7752B91B-AE83-4402-AAB0-E4513269F56D\"></a>Merging Animation Layers\n\
            </h2> \n\
            <p><a name=\"GUID-E5DD3AB3-0A30-4B6C-92DD-8BB94EC1CCB0\"></a>In the scene used in the <span class=\"char_link\"><a href=\"#!/url=./files/GUID-8EC1E48A-B713-42A9-A174-24F7778A4833.htm#SECTION_3C633784B8E14926A355BBF593E5D83E\">Creating Animation on Animation Layers</a></span> section, select two layers (PythonLayer1 and PythonLayer2). Run the <span class=\"filePath\" translate=\"no\">merge_animation_layers.py</span> script to merge the layers into one layer as shown in the following figure. <a name=\"FIG_516A906317F947DD8DA26DC5715B0AC7\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-B60DEF25-1353-44B0-A01C-F5C8A023EADF-low.png\"></div> \n\
            </p> \n\
            <p><a name=\"GUID-0633B47E-7C03-4F12-B248-0A8319FA19E0\"></a>Following are the points to keep in mind: <a name=\"UL_F2ACFC0119894FE8957B3876E3EAAEEF\"></a><ul>\n\
                  <li><span class=\"code\" translate=\"no\">lSystem.CurrentTake.GetLayerByName(\"PythonLayer1\").SelectLayer(True, False)</span> – Selects an animation layer. \n\
                  </li>\n\
                  <li><span class=\"code\" translate=\"no\"> <span class=\"charspan-msgph\" translate=\"no\">lSystem.CurrentTake.MergeLayers()</span> </span> – Merges the selected animation layers into one. Refer to the <span class=\"code\" translate=\"no\">MergeLayers()</span> function in the SDK help for information about the function parameters. \n\
                  </li>\n\
               </ul> \n\
            </p> \n\
         </div><span class=\"noindex\">\n\
            <div class=\"topic-list\">\n\
               <h4 class=\"related\">Topics in this section</h4>\n\
               <ul class=\"jumplist\">\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-899C83A3-1E30-40B2-8F39-5A9F0050D9CB.htm\">Plotting Animation for the Basic Models in a Take</a></li>\n\
               </ul>\n\
            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";