var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-9729D523-8231-4D43-A3EE-E9A427C9B19E\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Keyframe Animation on Referenced Items</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-9729D523-8231-4D43-A3EE-E9A427C9B19E\"></a><div class=\"head\">\n\
            <h1>Keyframe Animation on Referenced Items</h1>\n\
         </div>\n\
         <p><a name=\"GUID-463F8C43-BDC4-480C-A641-CB13A84B2C66\"></a> Keyframe animation is not possible on referenced items unless those items are animated\n\
            using the Story tool. You can animate the items within the source file prior to it\n\
            being referenced and the animation will play as expected. \n\
         </p>\n\
         <p><a name=\"GUID-814BE654-2681-4F92-93FB-5ED222445FA4\"></a>To animate the referenced items, you must create an animation track in the Story tool,\n\
            set its contents to the referenced items, and enable its keying ability. This is possible\n\
            because the animation is stored in an external FBX file according to the normal Story\n\
            tool behavior. \n\
         </p>\n\
         <p><a name=\"GUID-C4CD7F68-D3AE-4FC0-8E02-0CE6D9EBD8D5\"></a>For example, consider a scene that contains a file reference object as shown in the\n\
            following figure. \n\
         </p><a name=\"FIG_1DF9671094C04B69839541C5C3A0C0D0\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-3FB86FE2-786E-4BE7-9A3E-D03B6ACC3D98-low.png\"></div>\n\
         <p><a name=\"GUID-FE376319-7432-402E-B6F4-607AF2D27168\"></a>The following code sets NS:Cube, NS:Cube 1, and NS:Cube 2 to be the contents of an\n\
            animation track. \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">lNSCube = <a href=\"javascript:void(0)\" data-symbol=\"FBFindObjectByFullName\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga980a7ebfc02171f683b0bfed6527faa2&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFindObjectByFullName</a>( \"Model::NS:Cube\" )\n\
lNSCube1 = <a href=\"javascript:void(0)\" data-symbol=\"FBFindObjectByFullName\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga980a7ebfc02171f683b0bfed6527faa2&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFindObjectByFullName</a>( \"Model::NS:Cube 1\" )\n\
lNSCube2 = <a href=\"javascript:void(0)\" data-symbol=\"FBFindObjectByFullName\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga980a7ebfc02171f683b0bfed6527faa2&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFindObjectByFullName</a>( \"Model::NS:Cube 2\" )\n\
lFolder = <a href=\"javascript:void(0)\" data-symbol=\"FBStoryFolder\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_story_folder.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBStoryFolder</a>(None)\n\
lAnimTrack = <a href=\"javascript:void(0)\" data-symbol=\"FBStoryTrack\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_story_track.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBStoryTrack</a>(<a href=\"javascript:void(0)\" data-symbol=\"FBStoryTrackType.kFBStoryTrackAnimation\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_story_track_type.html#ab8d1c18db865f62a717b8a3f33c5ab54&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBStoryTrackType.kFBStoryTrackAnimation</a>, lFolder)\n\
lStoryClip = <a href=\"javascript:void(0)\" data-symbol=\"FBStoryClip\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_story_clip.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBStoryClip</a>( {PathToYourAnimClip}, lAnimTrack, <a href=\"javascript:void(0)\" data-symbol=\"FBTime\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_time.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTime</a>(0,0,0,0) )\n\
\n\
lPropDetail = lAnimTrack.PropertyList.Find(\"Details\")\n\
lPropTravellingNode = lAnimTrack.PropertyList.Find(\"TravellingNode\")\n\
\n\
lNSCube.ConnectDst(lPropDetail)\n\
lNSCube.ConnectDst(lPropTravellingNode)\n\
lNSCube1.ConnectDst(lPropDetail)\n\
lNSCube2.ConnectDst(lPropDetail)\n\
\n\
lOptions = <a href=\"javascript:void(0)\" data-symbol=\"FBFbxOptions\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_fbx_options.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFbxOptions</a>( False )\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a>().FileSave( {SceneFilePath}, lOptions )\n\
</pre></div>\n\
         <p><a name=\"GUID-6667BE6E-D38C-41EE-8F1D-F046142E5A3F\"></a>The animation is setup correctly after the scene is reloaded. \n\
         </p>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";