var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-9BBE655C-9540-4B1B-81EA-13B3DACC85BB\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Naming Conventions</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-9BBE655C-9540-4B1B-81EA-13B3DACC85BB\"></a><div class=\"head\">\n\
            <h1>Naming Conventions</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_738A50FB1BA84CFDAFB10ACFDD2A5FD7\"></a> \n\
            <h2><a name=\"GUID-C17DB196-3F5C-4947-B339-C32AA5E776BC\"></a>Variable Names\n\
            </h2> \n\
            <p><a name=\"GUID-52AAC1C5-5120-4A3D-BB50-87FAC892010E\"></a>Many code samples use variables whose names are prefixed with specific lower-case\n\
               letters. The following list describes the meaning of these prefixes. \n\
            </p> <a name=\"UL_8830268302954B3AACF12526860FC002\"></a><ul>\n\
               <li>\"<span class=\"code\" translate=\"no\">g</span>\" - <em class=\"strong\">global</em> variable. \n\
               </li>\n\
               <li>\"<span class=\"code\" translate=\"no\">l</span>\" - <em class=\"strong\">local</em> variable. \n\
               </li>\n\
               <li>\"<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"p\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/floatobject_8h.html#af18a92ce774f4c499544fbcc894db7e8&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">p</a></span>\" - function <em class=\"strong\">parameter</em>. \n\
               </li>\n\
               <li>\"<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"m\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a61c2f43341311f6f63e8f440c4fd3892&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">m</a></span>\" - class <em class=\"strong\">member</em>. \n\
               </li>\n\
            </ul> \n\
            <div><a name=\"GUID-A1480D62-FDAC-47CA-9F8D-1962110A165A\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Some code samples do not strictly follow this naming convention. \n\
               </div>\n\
            </div> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";