var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-9CAF4183-B1B1-4CCE-81F2-7D8D61E0CF87\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Understanding the Referenced Objects and Referenced Items</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-9CAF4183-B1B1-4CCE-81F2-7D8D61E0CF87\"></a><div class=\"head\">\n\
            <h1>Understanding the Referenced Objects and Referenced Items </h1>\n\
         </div>\n\
         <p><a name=\"GUID-2392FBBD-64DF-4E15-9C01-3029A3E96914\"></a>The following example shows how the referenced objects and referenced items can be\n\
            used in a scene. \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_A19216B615B3467480037F917D1E98D9\"></a> \n\
            <h2><a name=\"GUID-8D7BCD62-D147-43BD-8A5A-48DBC269D935\"></a>Example Scene Showing Referenced Objects and Referenced Items\n\
            </h2> \n\
            <p><a name=\"GUID-209B6EF7-C761-4FBD-9E71-AE86AE42F35B\"></a>Consider a scene named <span class=\"filePath\" translate=\"no\">abc.fbx</span> that contains a couple of cubes as shown in the following figure. \n\
            </p> \n\
            <p><a name=\"GUID-59CBC1FE-E81D-43A4-99C8-83F9AF147DD7\"></a> <a name=\"FIG_833BBC8F65F94821BC33B32AACCEE72A\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-9EE7DAFC-5882-42B8-A684-454D652DD8D1-low.png\"></div> \n\
            </p> \n\
            <p><a name=\"GUID-CD053D46-DD38-4C23-87AF-E2964C764A09\"></a>You can create a file reference object that references <span class=\"filePath\" translate=\"no\">abc.fbx</span> using the <span class=\"code\" translate=\"no\">NamespaceImport</span> function. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"FBSystem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem</a>().Scene.NamespaceImport( \"NS\", \"abc.fbx\", True )</pre></div> \n\
            <p><a name=\"GUID-8DF6DD0C-116D-4613-B809-EC9A60223732\"></a>This creates a scene structure as shown in the following figure. \n\
            </p> <a name=\"FIG_7AB2CD1B8B9A4F8797BA1EA3AA4A54A8\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-3FB86FE2-786E-4BE7-9A3E-D03B6ACC3D98-low.png\"></div> \n\
            <p><a name=\"GUID-2FA731CD-6B63-479E-A046-04FEB5B564B3\"></a>You can now create a new cube and a parent/child constraint. You can also connect\n\
               the newly created cube to one of the referenced items using the parent/child constraint.\n\
               \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\"># Create a parent/child constraint\n\
lConstraintManager = <a href=\"javascript:void(0)\" data-symbol=\"FBConstraintManager\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_constraint_manager.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConstraintManager</a>()\n\
for lIndex in range( lConstraintManager.TypeGetCount() ):\n\
    if lConstraintManager.TypeGetName( lIndex ) == \"Parent/Child\":\n\
        lParentChildConstraint = lConstraintManager.TypeCreateConstraint( lIndex )\n\
\n\
# Create a new cube\n\
lNewCube = <a href=\"javascript:void(0)\" data-symbol=\"FBModelCube\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_cube.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelCube</a>( \"NewCube\" )\n\
lNewCube.Show = True\n\
\n\
# Find the “Cube 2” under file reference <a href=\"javascript:void(0)\" data-symbol=\"object\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#a904fdf014f8cdbefe8320ca2bfd6daf6&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">object</a> “NS”\n\
1NSCube2 = <a href=\"javascript:void(0)\" data-symbol=\"FBFindObjectByFullName\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga980a7ebfc02171f683b0bfed6527faa2&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFindObjectByFullName</a>( \"Model::NS:Cube 2\" )\n\
\n\
# <a href=\"javascript:void(0)\" data-symbol=\"Set\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a8b39bad9fda6bc73af75e4d6085bcf91&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Set</a> “NS:Cube 2” to be the child of the constraint\n\
lProperty = lParentChildConstraint.PropertyList.Find( \"Constrained <a href=\"javascript:void(0)\" data-symbol=\"object\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#a904fdf014f8cdbefe8320ca2bfd6daf6&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">object</a> (Child)\" )\n\
lNSCube2.ConnectSrc( lProperty )\n\
\n\
# <a href=\"javascript:void(0)\" data-symbol=\"Set\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a8b39bad9fda6bc73af75e4d6085bcf91&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Set</a> NewCube to be the parent of the constraint\n\
lProperty = lParentChildConstraint.PropertyList.Find( \"Source (Parent)\" )\n\
lNewCube.ConnectDst(lProperty)\n\
</pre></div> \n\
            </p> \n\
            <p><a name=\"GUID-2A251F51-5EA5-429C-B174-E981339659B2\"></a>NS:Cube does not have a parent, so it can be parented to another scene object even\n\
               though it belongs to the reference object. This can be achieved through the following\n\
               script. \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">lParentCube = <a href=\"javascript:void(0)\" data-symbol=\"FBModelCube\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_cube.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelCube</a>( \"NewParent\" )\n\
lParentCube.Show = True\n\
lNSCube = <a href=\"javascript:void(0)\" data-symbol=\"FBFindObjectByFullName\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga980a7ebfc02171f683b0bfed6527faa2&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFindObjectByFullName</a>( \"Model::NS:Cube\" )\n\
lNSCube.Parent = lParentCube\n\
</pre></div>This creates a scene structure as shown in the following figure. \n\
            </p> <a name=\"FIG_B666BF7464554C969A60E3F5CD57130B\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-BBEC0698-7CFA-43DF-8515-6DFE7C156FF5-low.png\"></div> \n\
            <p><a name=\"GUID-34920D99-044A-47A6-B507-2D96A5E6A1F8\"></a>NS:Cube 1 is the leaf node in the reference object, so it can be the parent of a non-referenced\n\
               scene object. The following script parents a new scene object to NS:Cube 1. \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">lChildCube = <a href=\"javascript:void(0)\" data-symbol=\"FBModelCube\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_cube.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelCube</a>( \"NewChild\" )\n\
lChildCube.Show = True\n\
lNSCube1 = <a href=\"javascript:void(0)\" data-symbol=\"FBFindObjectByFullName\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga980a7ebfc02171f683b0bfed6527faa2&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFindObjectByFullName</a>( \"Model::NS:Cube 1\" )\n\
lChildCube.Parent = lNSCube1\n\
</pre></div>This creates a scene structure as shown in the following figure. \n\
            </p> <a name=\"FIG_EF2005A4F42F465F974D889732FA1148\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-8977FDE8-4926-442A-8B0C-3B03009F9F98-low.png\"></div> \n\
            <p><a name=\"GUID-BCA728F1-0061-452F-9967-29BF12C7A305\"></a>You can also add animatable and non-animatable custom properties to referenced items\n\
               using the <span class=\"code\" translate=\"no\">PropertyCreate()</span> function as follows: \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">lReferencedCube = <a href=\"javascript:void(0)\" data-symbol=\"FBFindObjectByFullName\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga980a7ebfc02171f683b0bfed6527faa2&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFindObjectByFullName</a>( \"Model::NS:Cube\" )\n\
lReferencedCube.PropertyCreate( \"CustomProp\", <a href=\"javascript:void(0)\" data-symbol=\"FBPropertyType.kFBPT_double\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_property_type.html#aa8a02daa579067984daf328c0af210ca&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPropertyType.kFBPT_double</a>, \"\", False, True, None )</pre></div> \n\
            </p> \n\
            <p><a name=\"GUID-27468AB4-FF00-4CD0-8FC3-8D3849EF4CA3\"></a>Running this script creates a non-animatable custom property named <span class=\"code\" translate=\"no\">CustomProp</span> on NS:Cube. The fourth parameter determines whether the newly created custom property\n\
               is animatable. Additionally, the file reference edit reflects the changes whenever\n\
               the new custom property is changed. \n\
            </p> \n\
            <p><a name=\"GUID-33EB2AEE-6AFF-464C-8942-5D208AEAAF45\"></a>The same action can also be done on the reference object as follows: \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">lFileReference = <a href=\"javascript:void(0)\" data-symbol=\"FBFindObjectByFullName\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga980a7ebfc02171f683b0bfed6527faa2&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFindObjectByFullName</a>( \"FileReference::NS\" )\n\
lFileReference.PropertyCreate( \"CustomProp\", <a href=\"javascript:void(0)\" data-symbol=\"FBPropertyType.kFBPT_double\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_property_type.html#aa8a02daa579067984daf328c0af210ca&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPropertyType.kFBPT_double</a>, \"\", False, True, None )\n\
</pre></div> \n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";