var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-9E8784B2-3C8A-4891-852C-CB3B34F3A745\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>FBGeometry - Meshes and Surfaces</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-9E8784B2-3C8A-4891-852C-CB3B34F3A745\"></a><div class=\"head\">\n\
            <h1>FBGeometry - Meshes and Surfaces</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_A8F09185708449DE9ACADA06DEBF37EB\"></a> \n\
            <h2><a name=\"GUID-7FED3168-6274-4413-94B6-BB39C3CC1324\"></a>What is FBGeometry?\n\
            </h2> \n\
            <p><a name=\"GUID-FA95748C-4C44-4FEF-A2C3-2A185B305CF2\"></a><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBGeometry\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_geometry.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_geometry.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBGeometry</a></span> regroups all geometry-related elements which can be bound to an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a></span>. Subclasses of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBGeometry\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_geometry.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_geometry.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBGeometry</a></span> include: <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_mesh.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_mesh.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMesh</a></span>, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBSurface\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_surface.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_surface.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSurface</a></span>, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBNurbs\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_nurbs.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_nurbs.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBNurbs</a></span>, and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPatch\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_patch.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_patch.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPatch</a></span>. Instances of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBGeometry\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_geometry.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_geometry.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBGeometry</a></span> contain a set of vertices. In the case of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_mesh.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_mesh.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMesh</a></span>, these vertices form polygons to which normals, materials and UV texture coordinates\n\
               can be mapped. \n\
            </p> \n\
            <p><a name=\"GUID-0F242981-7C37-4E87-907D-71D385DF5E27\"></a>Geometry is bound to an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a></span> via its <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel.Geometry\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model.html#ab64b6d6798a3333a5818126d5b3e6c8a&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel.Geometry</a></span> property. As such, the mesh of an instance of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelCube\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_cube.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_cube.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelCube</a></span> can be changed to any other user-defined geometry. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_511638DA90324530A7EC98E06AC58B63\"></a> \n\
            <h2><a name=\"GUID-E485E3E6-C6CF-4168-B907-463DF25032D1\"></a>Creating a Mesh\n\
            </h2> \n\
            <p><a name=\"GUID-4C5EF0EF-8FB4-4E5D-9CE4-4657CA500282\"></a>A mesh is created using the <span class=\"code\" translate=\"no\">FBMesh()</span> constructor. The functions <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBGeometry.GeometryBegin()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_geometry.html#afc091bcd1bdd94d94c509ef6df7fb4d3&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBGeometry.GeometryBegin()</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBGeometry.GeometryEnd()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_geometry.html#ab00a362dc4a2de10c6d9f9700f653d44&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBGeometry.GeometryEnd()</a></span> must surround the code used to define the geometry\'s vertices or control points.\n\
               \n\
            </p> \n\
            <p><a name=\"GUID-6F8689BD-8F09-41BE-9287-83CE71A7C4A4\"></a>In the case of a mesh, <span class=\"code\" translate=\"no\">FBMesh.VertexInit()</span> reserves memory for the mesh\'s vertex, normal and UV arrays. <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBMesh.PolygonBegin()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_mesh.html#aa7f039da715f5cb70f3136a4ccfac259&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMesh.PolygonBegin()</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBMesh.PolygonEnd()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_mesh.html#a9188726850b1863355b16652d7d7623f&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMesh.PolygonEnd()</a></span> are used to create the various polygons within the mesh. The argument to <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBMesh.PolygonVertexAdd()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_mesh.html#ac58b87caa1923249df5cca7b8812350a&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMesh.PolygonVertexAdd()</a></span> refers to the index of the vertex we want to use within the mesh\'s array of vertices.\n\
               The following code is adapted from the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"Samples/Geometry/VertexColor.py\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/_samples_2_geometry_2_vertex_color_8py-example.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Samples/Geometry/VertexColor.py</a></span> sample. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">from pyfbsdk import *\n\
\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a>().FileNew()\n\
\n\
# Create the custom mesh\n\
lMesh = <a href=\"javascript:void(0)\" data-symbol=\"FBMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_mesh.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMesh</a>(\"myMesh\")\n\
\n\
# Alway call GeometryBegin() / GeometryEnd() in pair when editting geometry.\n\
lMesh.GeometryBegin()\n\
\n\
# <a href=\"javascript:void(0)\" data-symbol=\"Call\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a67521ede95e4d7bdfd5aced80c17a3aa&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Call</a> VertexInit() to resize or reserve vertex/normal array. \n\
# pResize = <a href=\"javascript:void(0)\" data-symbol=\"true\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#af6a258d8f3ee5206d682d799316314b1a08f175a5505a10b9ed657defeb050e4b&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">true</a>, work with known vertex <a href=\"javascript:void(0)\" data-symbol=\"count\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a8f9bd2e8322b1ca9128fbfca71322230&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">count</a> and VertexSet() function.\n\
# pResize = <a href=\"javascript:void(0)\" data-symbol=\"false\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#af6a258d8f3ee5206d682d799316314b1ae9de385ef6fe9bf3360d1038396b884c&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">false</a>, work with dynamical vertex <a href=\"javascript:void(0)\" data-symbol=\"count\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a8f9bd2e8322b1ca9128fbfca71322230&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">count</a> and VertexAdd() function.\n\
lMesh.VertexInit(4, False, False, True)\n\
\n\
lMesh.VertexAdd(0, 100, 0)  # vertex 0\n\
lMesh.VertexAdd(100,100, 0) # vertex 1\n\
lMesh.VertexAdd(100, 0, 0)  # vertex 2\n\
lMesh.VertexAdd(0,  0, 0)   # vertex 3\n\
\n\
lMesh.VertexColorSet(1, 0, 0, 1, 0) # (r, g, b, alpha, vertex <a href=\"javascript:void(0)\" data-symbol=\"index\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#aed9361a6a6957b25e08992d6392020a4&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">index</a>)\n\
lMesh.VertexColorSet(0, 1, 0, 1, 1)\n\
lMesh.VertexColorSet(0, 0, 1, 1, 2)\n\
lMesh.VertexColorSet(1, 1, 0, 1, 3)\n\
\n\
# <a href=\"javascript:void(0)\" data-symbol=\"Add\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#ab9d92a0f505af42d2049e62ae49ef932a0d592a4b562059bc283e00b3704865c9&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Add</a> a Polygon\n\
lMesh.PolygonBegin()\n\
lMesh.PolygonVertexAdd(0)   # add polygon vertex 0\n\
lMesh.PolygonVertexAdd(1)   # add polygon vertex 1\n\
lMesh.PolygonVertexAdd(2)   # add polygon vertex 2\n\
lMesh.PolygonVertexAdd(3)   # add polygon vertex 3\n\
# Polygon add End\n\
lMesh.PolygonEnd()\n\
\n\
# Compute mesh vertex normal with Counter Clock-Wise order\n\
lMesh.ComputeVertexNormals(True)\n\
\n\
# Alway call GeometryBegin() / GeometryEnd() in pair when editting geometry.\n\
lMesh.GeometryEnd()\n\
\n\
# <a href=\"javascript:void(0)\" data-symbol=\"And\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a16067ed2b6546040536da29338709abfa60b042c2c7da21af2ed42f8cc27e7ff8&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">And</a> we use Geometry Instancing feature to share this simple plane among multiple models.\n\
for lIndex in range(1, 10):\n\
    #create a cube but we will replace its geometry\n\
    lModel = <a href=\"javascript:void(0)\" data-symbol=\"FBModelCube\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_cube.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelCube</a>(\"myModel\")\n\
    \n\
    # Replace the geometry instance\n\
    lModel.Geometry = lMesh\n\
    \n\
    lModel.SetVector( <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(120*lIndex - 600, 50, 50 ) )\n\
\n\
    # Let\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> use a different shading mode.\n\
    if (lIndex &gt; 5):\n\
        lModel.ShadingMode = <a href=\"javascript:void(0)\" data-symbol=\"FBModelShadingMode.kFBModelShadingWire\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_shading_mode.html#a1939188a4465fe2340383f85b8dedf96&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelShadingMode.kFBModelShadingWire</a>\n\
    else:\n\
        lModel.ShadingMode = <a href=\"javascript:void(0)\" data-symbol=\"FBModelShadingMode.kFBModelShadingFlat\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_shading_mode.html#a19d16a5c1f7d6ccff5a380a4f6c9d707&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelShadingMode.kFBModelShadingFlat</a>    \n\
        \n\
    # The <a href=\"javascript:void(0)\" data-symbol=\"object\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#a904fdf014f8cdbefe8320ca2bfd6daf6&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">object</a> must be set visible to be present in the system.\n\
    lModel.Visible = True\n\
    lModel.Show = True</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_74AC9E3ABA0B43E892C43FB2A6CEEB74\"></a> \n\
            <h2><a name=\"GUID-3D8052B7-3F28-4490-B5E9-46DE239979C3\"></a>Example: Spiral Mesh\n\
            </h2> \n\
            <p><a name=\"GUID-19D13465-BB32-4ED4-B41A-DB838AFD0A98\"></a> <em class=\"strong\">Sample Viewport Output:</em> \n\
            </p> \n\
            <p><a name=\"GUID-07070054-B988-44E4-90C5-04D0184F6175\"></a></p> <img src=\"images/GUID-174D3D49-ABD0-4DEF-A0C2-56E5B8E2474C-low.png\"> \n\
            <p><a name=\"GUID-0FC960DA-6C39-46DF-B533-86458F0251E4\"></a><em class=\"strong\">Program Summary:</em> The program begins by creating a spiral mesh object. The spiral mesh object is then\n\
               assigned to the geometry of an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelCube\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_cube.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_cube.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelCube</a></span> (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel.Geometry\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model.html#ab64b6d6798a3333a5818126d5b3e6c8a&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel.Geometry</a></span>), effectively replacing the cube\'s mesh with the spiral mesh. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">from pyfbsdk import *\n\
import math\n\
\n\
\n\
###############################################################\n\
# Helper Function(<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a>).                                         #\n\
###############################################################\n\
\n\
# Generate a list of vertices which will define a spiral.\n\
def createVertices(pWidth, pHeight):\n\
    vertices = []    \n\
\n\
    # Our first vertex will be centered at the origin.\n\
    vertices.append(<a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(0,0,0)) \n\
    \n\
    # The rest of the vertices will form the spiral.\n\
    for t in range(pHeight / (pWidth * 2), pHeight):\n\
        <a href=\"javascript:void(0)\" data-symbol=\"x\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#a280f2393c503127fff91ecbc558e288d&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">x</a> = pWidth * math.cos(0.25 * t) * 1/float(t) * pHeight\n\
        y = t\n\
        z = pWidth * math.sin(0.25 * t) * 1/float(t) * pHeight\n\
        vertices.append(<a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(<a href=\"javascript:void(0)\" data-symbol=\"x\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#a280f2393c503127fff91ecbc558e288d&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">x</a>,y,z))\n\
    \n\
    return vertices\n\
\n\
# Create a spiral mesh using the width and height parameters.\n\
def createSpiralMesh(pWidth, pHeight):\n\
    # Obtain a list of vertices defining a spiral.\n\
    spiralVertices = createVertices(pWidth, pHeight)\n\
    numVertices = <a href=\"javascript:void(0)\" data-symbol=\"len\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#abc8b352d6723c361fc39710e5b10b502&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">len</a>(spiralVertices)\n\
\n\
    # Create an empty mesh object.\n\
    mesh = <a href=\"javascript:void(0)\" data-symbol=\"FBMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_mesh.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMesh</a>(\'mySpiralMesh\')\n\
        \n\
    # Always call GeometryBegin() / GeometryEnd() in pair when editting geometry.\n\
    mesh.GeometryBegin()\n\
\n\
    # Initialize all the vertices inside the mesh <a href=\"javascript:void(0)\" data-symbol=\"object\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#a904fdf014f8cdbefe8320ca2bfd6daf6&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">object</a> and\n\
    # add the (<a href=\"javascript:void(0)\" data-symbol=\"x\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#a280f2393c503127fff91ecbc558e288d&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">x</a>, y, z) coordinate of each spiral vertex into the mesh.\n\
    mesh.VertexInit(numVertices, False, True, True)\n\
    for vertex in spiralVertices:\n\
        mesh.VertexAdd(vertex[0], vertex[1], vertex[2])\n\
    \n\
    # Define the polygons as a series of triangles to form the spiral.\n\
    for <a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a> in range(2, numVertices):\n\
        # Begin a new polygon.\n\
        mesh.PolygonBegin()\n\
        \n\
        # The <a href=\"javascript:void(0)\" data-symbol=\"argument\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/graminit_8h.html#abff5cb3be00ddd07fc5fd6ee8e170bf8&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">argument</a> of PolygonVertexAdd() is the corresponding vertex inside the mesh.\n\
        mesh.PolygonVertexAdd(0)\n\
        mesh.PolygonVertexAdd(<a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a>-1)\n\
        mesh.PolygonVertexAdd(<a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a>)\n\
        \n\
        # End the polygon.\n\
        mesh.PolygonEnd()\n\
\n\
    # Compute the clockwise normals, as indicated by the True argument.\n\
    mesh.ComputeVertexNormals(True)\n\
    \n\
    # Finish the geometry editting.\n\
    mesh.GeometryEnd()\n\
    \n\
    return mesh\n\
\n\
\n\
###############################################################\n\
# Main.                                                       #\n\
###############################################################\n\
\n\
# Clear the scene.\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a>().FileNew()\n\
scene = <a href=\"javascript:void(0)\" data-symbol=\"FBSystem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem</a>().Scene\n\
\n\
# Create a spiral mesh which we will assign to a model.\n\
spiralWidth = 5\n\
spiralHeight = 150\n\
spiralMesh = createSpiralMesh(spiralWidth, spiralHeight)\n\
\n\
# Create a model, whose mesh we will replace by the spiral.\n\
model = <a href=\"javascript:void(0)\" data-symbol=\"FBModelCube\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_cube.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelCube</a>(\'myModel\')\n\
model.Geometry = spiralMesh\n\
model.Show = True</pre></div> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";