var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-A1189AA0-3816-4350-B8F3-5383DEC25A33\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>FBPose - Poses</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-A1189AA0-3816-4350-B8F3-5383DEC25A33\"></a><div class=\"head\">\n\
            <h1>FBPose - Poses</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_A37B782F4551460798228A5C11CBBDFA\"></a> \n\
            <h2><a name=\"GUID-CD67F8E3-5087-4FAC-AAA2-713D163FC603\"></a>What is a Pose?\n\
            </h2> \n\
            <p><a name=\"GUID-4B57AAC0-9252-411E-B3E9-707EB42CC071\"></a>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPose\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_pose.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_pose.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPose</a></span> class encapsulates MotionBuilder\'s ability to take a snapshot of characters (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCharacterPose\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_character_pose.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_character_pose.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacterPose</a></span>), and objects (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBObjectPose\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_object_pose.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_object_pose.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBObjectPose</a></span>). \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_843D90C83E944FC38FD19B1CB09CB7AE\"></a> \n\
            <h2><a name=\"GUID-A4EE8CB9-3ED2-4C85-81E6-A2A1A1E67D43\"></a>Creating a Character Pose\n\
            </h2> \n\
            <p><a name=\"GUID-557CC845-F5A2-4702-9C03-3A0941DB88C3\"></a>A character pose is created by invoking the <span class=\"code\" translate=\"no\">FBCharacterPose()</span> constructor. This adds an empty pose item in the scene\'s list of poses, as well as\n\
               in MotionBuilder\'s <span class=\"code\" translate=\"no\">Pose Controls</span> UI element. \n\
            </p> \n\
            <p><a name=\"GUID-A8ABDE34-3465-4FFE-B6B6-208988C4DB89\"></a>Given a reference to an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCharacter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_character.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_character.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacter</a></span> in the scene (for example: <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBApplication.CurrentCharacter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html#a78660b9a208d512d1390d9cbd82a8ff4&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication.CurrentCharacter</a></span>), the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCharacterPose.CopyPose()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_character_pose.html#a163bbc82f819d5cb39813038543c022c&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacterPose.CopyPose()</a></span> function stores the given character\'s pose into that <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCharacterPose\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_character_pose.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_character_pose.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacterPose</a></span> object. Pose creation is illustrated in the code snippet below. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\"># Create poses of the character.\n\
def createPoses(pCharacter):   \n\
    poseList = []\n\
    \n\
    # Create our first pose.\n\
    pose1 = <a href=\"javascript:void(0)\" data-symbol=\"FBCharacterPose\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_character_pose.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacterPose</a>(\'myPose1\')\n\
    pose1.CopyPose(pCharacter)\n\
    poseList.append(pose1)\n\
    \n\
    # Obtain a reference to the character\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> effectors.\n\
    hipsEffector = pCharacter.GetEffectorModel(<a href=\"javascript:void(0)\" data-symbol=\"FBEffectorId.kFBHipsEffectorId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_effector_id.html#a5ac1d11358e661a5da7c02134589e36d&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBEffectorId.kFBHipsEffectorId</a>)\n\
    \n\
    # Create our second pose.\n\
    hipsEffector.Translation = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(0, 50, 0)\n\
    # (!!!) Note: It is very important to invoke <a href=\"javascript:void(0)\" data-symbol=\"FBSystem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem</a>().Scene.Evaluate() \n\
    #       at this <a href=\"javascript:void(0)\" data-symbol=\"step\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/sliceobject_8h.html#a22b0b4a11e692578c4afabff0985f230&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">step</a> to ensure the hipsEffector has effectively been translated. \n\
    #       Otherwise, it is not guaranteed that MotionBuilder\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> evaluation thread \n\
    #       will have translated the hips effector before pose2.CopyPose() is called.\n\
    <a href=\"javascript:void(0)\" data-symbol=\"FBSystem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem</a>().Scene.Evaluate()\n\
    pose2 = <a href=\"javascript:void(0)\" data-symbol=\"FBCharacterPose\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_character_pose.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacterPose</a>(\'myPose2\')\n\
    pose2.CopyPose(pCharacter)\n\
    poseList.append(pose2)\n\
    \n\
    # Repeat pose1 in our poseList to enable looping later.\n\
    poseList.append(pose1)\n\
    \n\
    return (poseList)</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_310AB8C8F76044E0B2F224AA0ED6E3EE\"></a> \n\
            <h2><a name=\"GUID-54DEE868-E681-4730-BBDA-C82087D92713\"></a>Applying a Pose to a Character\n\
            </h2> \n\
            <p><a name=\"GUID-3EC609A9-30AA-4B2F-B545-CDA8781F2C19\"></a>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCharacterPose.PastePose()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_character_pose.html#a963a137abb35546b2bb08f63a5d63175&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacterPose.PastePose()</a></span> function applies the data contained in <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCharacterPose\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_character_pose.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_character_pose.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacterPose</a></span> to the specified character. An instance of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCharacterPoseOptions\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_character_pose_options.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_character_pose_options.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacterPoseOptions</a></span> can also be specified to ensure the pose is mirrored, or to enable full-body keying\n\
               mode. The code snippet below illustrates how to apply a list of poses to a character\n\
               in the scene, and how to use these poses as animation key frames. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\"># Create keys from the pose list.\n\
def createKeys(pCharacter, pPoseList):\n\
    # Ensure we take a pose of the entire character\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> body.\n\
    poseOptions = <a href=\"javascript:void(0)\" data-symbol=\"FBCharacterPoseOptions\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_character_pose_options.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacterPoseOptions</a>()\n\
    poseOptions.mCharacterPoseKeyingMode = <a href=\"javascript:void(0)\" data-symbol=\"FBCharacterPoseKeyingMode.kFBCharacterPoseKeyingModeFullBody\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_character_pose_keying_mode.html#a4a844441ab237c3dc2913910f8a3a876&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacterPoseKeyingMode.kFBCharacterPoseKeyingModeFullBody</a>\n\
    poseOptions.SetFlag(<a href=\"javascript:void(0)\" data-symbol=\"FBCharacterPoseFlag.kFBCharacterPoseMirror\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_character_pose_flag.html#a936ba72e86aba89a587221bee61ace5d&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacterPoseFlag.kFBCharacterPoseMirror</a>, True)\n\
    \n\
    # Select the character\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> control rig (1st and 3rd parameter = True). This \n\
    # allows <a href=\"javascript:void(0)\" data-symbol=\"FBPlayerControl.Key\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_player_control.html#a52d3e230d73235d549481f955e9b75ce&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPlayerControl.Key</a>() to <a href=\"javascript:void(0)\" data-symbol=\"key\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#ada6705808cbd8c921df38387db9a6aee&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">key</a> the selected models.\n\
    pCharacter.SelectModels(True, False, True, False)\n\
    \n\
    # Create a pose every 15 frames using our pose list.\n\
    lPlayer = <a href=\"javascript:void(0)\" data-symbol=\"FBPlayerControl\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_player_control.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPlayerControl</a>()\n\
    poseCount = 0\n\
    frameInterval = 15\n\
    for pose in pPoseList:\n\
        # Go to the next frame.\n\
        lPlayer.Goto(<a href=\"javascript:void(0)\" data-symbol=\"FBTime\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_time.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTime</a>(0, 0, 0, frameInterval * poseCount))\n\
        <a href=\"javascript:void(0)\" data-symbol=\"FBSystem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem</a>().Scene.Evaluate()\n\
        # Apply the pose to the character using our pose options.\n\
        pose.PastePose(pCharacter, poseOptions)\n\
        <a href=\"javascript:void(0)\" data-symbol=\"FBSystem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem</a>().Scene.Evaluate()\n\
        # Create a <a href=\"javascript:void(0)\" data-symbol=\"key\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#ada6705808cbd8c921df38387db9a6aee&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">key</a> in the player.\n\
        lPlayer.Key()\n\
        <a href=\"javascript:void(0)\" data-symbol=\"FBSystem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem</a>().Scene.Evaluate()\n\
        # Increment our counter.\n\
        poseCount += 1\n\
    \n\
    # De-select the character\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> control rig (1st parameter = False, 3rd parameter = True).\n\
    pCharacter.SelectModels(False, False, True, False)\n\
    \n\
    # <a href=\"javascript:void(0)\" data-symbol=\"Return\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#abdae7f49d66ce8e500825bb53aa14901&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Return</a> the frame number of the last frame keyed.\n\
    return frameInterval * (poseCount - 1)</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_02D7B8AFCF2D48E893306054917D401A\"></a> \n\
            <h2><a name=\"GUID-3C2BB616-5A5C-4B76-A8E6-C053B3ED6CA7\"></a>Example: Animating a Character With Poses.\n\
            </h2> \n\
            <p><a name=\"GUID-3B4CE1DF-288C-4197-9FFE-047AC0E3A2E3\"></a> <em class=\"strong\">Sample Viewport Output:</em> \n\
            </p> \n\
            <p><a name=\"GUID-CA1789DF-4B19-471D-81BC-9DDB86CC6B3F\"></a></p> <img src=\"images/GUID-44AB0AE0-B637-4208-9EFA-24BD1F58EDB0-low.png\"> \n\
            <p><a name=\"GUID-1B82FFBF-299F-4D55-A087-9A30D2A269E1\"></a><em class=\"strong\">Program Summary:</em> The following program builds on the program presented in <span class=\"char_link\"><a href=\"#!/url=./files/GUID-46F873C8-32C7-4834-8264-1735F20A10FE.htm\">FBCharacter - Characters</a></span>. We define two new functions to make the character perform a looping \"crouching\"\n\
               animation: <a name=\"UL_2514C4D443D8434DA6821E7E70C40E0D\"></a><ul>\n\
                  <li><span class=\"code\" translate=\"no\">createPoses()</span>: This function creates two poses, the first of which is the T-Pose of the character.\n\
                     The second pose has the character\'s hips effector translated to <span class=\"code\" translate=\"no\">(0, 50, 0)</span>. Character poses are taken via <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCharacterPose.CopyPose()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_character_pose.html#a163bbc82f819d5cb39813038543c022c&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacterPose.CopyPose()</a></span>. \n\
                  </li>\n\
                  <li><span class=\"code\" translate=\"no\">createKeys()</span>: This function keys the character every 15 frames, according to the specified list\n\
                     of poses. Poses are applied to the character via <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCharacterPose.PastePose()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_character_pose.html#a963a137abb35546b2bb08f63a5d63175&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacterPose.PastePose()</a></span>. \n\
                  </li>\n\
               </ul> \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">from pyfbsdk import *\n\
\n\
# <a href=\"javascript:void(0)\" data-symbol=\"In\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#aeae2807c86997ffad2fa6d972a29ee1fad8ff8dfc9381018e97fce86d909f8975&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">In</a> the following skeleton template, the \"LeftUpLeg\" \n\
# has \"Hips\" as its parent, and its local (<a href=\"javascript:void(0)\" data-symbol=\"x\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#a280f2393c503127fff91ecbc558e288d&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">x</a>,y,z) translation is (15, -10, 0).\n\
jointMap = {\n\
    #jointName,     (parentName,       translation  )\n\
    \'Reference\':    (None,           (  0,   0,  0)),\n\
    \'Hips\':         (\'Reference\',    (  0,  75,  0)),    \n\
    \'LeftUpLeg\':    (\'Hips\',         ( 15, -10,  0)),\n\
    \'LeftLeg\':      (\'LeftUpLeg\',    (  0, -30,  0)),\n\
    \'LeftFoot\':     (\'LeftLeg\',      (  0, -30,  0)),     \n\
    \'RightUpLeg\':   (\'Hips\',         (-15, -10,  0)),\n\
    \'RightLeg\':     (\'RightUpLeg\',   (  0, -30,  0)),\n\
    \'RightFoot\':    (\'RightLeg\',     (  0, -30,  0)),     \n\
    \'Spine\':        (\'Hips\',         (  0,  40,  0)),\n\
    \'LeftArm\':      (\'Spine\',        ( 20,  10,  0)),\n\
    \'LeftForeArm\':  (\'LeftArm\',      ( 30,   0,  0)),\n\
    \'LeftHand\':     (\'LeftForeArm\',  ( 30,   0,  0)),    \n\
    \'RightArm\':     (\'Spine\',        (-20,  10,  0)),\n\
    \'RightForeArm\': (\'RightArm\',     (-30,   0,  0)),\n\
    \'RightHand\':    (\'RightForeArm\', (-30,   0,  0)),\n\
    \'Head\':         (\'Spine\',        (  0,  30,  0)),\n\
}\n\
\n\
###############################################################\n\
# Helper Function(<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a>).                                         #\n\
###############################################################\n\
\n\
# Create a skeleton in a T-pose facing along the positive Z axis\n\
def createSkeleton(pNamespace):\n\
    global jointMap\n\
    skeleton = {}\n\
    \n\
    # Populate the skeleton with joints.\n\
    for jointName, (parentName, translation) in jointMap.iteritems():\n\
        if jointName == \'Reference\' or jointName == \'Hips\':\n\
            # <a href=\"javascript:void(0)\" data-symbol=\"If\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a3caa32cf8ff8db15e5835f5e40e6c6f8&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">If</a> it is the reference <a href=\"javascript:void(0)\" data-symbol=\"node\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/node_8h.html#addb697c9bca6f8981a870daa4953af4f&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">node</a>, create an FBModelRoot.\n\
            joint = <a href=\"javascript:void(0)\" data-symbol=\"FBModelRoot\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_root.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelRoot</a>(jointName)\n\
            \n\
        else:\n\
            # Otherwise, create an FBModelSkeleton.\n\
            joint = <a href=\"javascript:void(0)\" data-symbol=\"FBModelSkeleton\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_skeleton.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelSkeleton</a>(jointName)\n\
        \n\
        joint.LongName = pNamespace + \':\' + joint.Name # Apply the specified namespace to each joint.\n\
        joint.Color = <a href=\"javascript:void(0)\" data-symbol=\"FBColor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_color.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBColor</a>(0.3, 0.8, 1)             # Cyan\n\
        joint.Size = 250                               # Arbitrary size: big enough to see in viewport \n\
        joint.Show = True                              # Make the joint visible in the scene.\n\
        \n\
        # <a href=\"javascript:void(0)\" data-symbol=\"Add\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#ab9d92a0f505af42d2049e62ae49ef932a0d592a4b562059bc283e00b3704865c9&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Add</a> the joint to our skeleton.\n\
        skeleton[jointName] = joint\n\
    \n\
    # Once all the joints have been created, apply the parent/child \n\
    # relationships to each of the skeleton\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> joints.\n\
    for jointName, (parentName, translation) in jointMap.iteritems():\n\
        # Only assign a parent if it exists.\n\
        if parentName != None and parentName in jointMap.keys():\n\
            skeleton[jointName].Parent = skeleton[parentName] \n\
        \n\
        # The translation should be set after the parent has been assigned.\n\
        skeleton[jointName].Translation = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(translation)\n\
\n\
    \'\'\' The following is a much longer way to write the above function:\n\
    \n\
    reference = <a href=\"javascript:void(0)\" data-symbol=\"FBModelRoot\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_root.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelRoot</a>(\'Reference\')\n\
    \n\
    hips = <a href=\"javascript:void(0)\" data-symbol=\"FBModelRoot\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_root.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelRoot</a>(\'Hips\')\n\
    hips.Color = <a href=\"javascript:void(0)\" data-symbol=\"FBColor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_color.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBColor</a>(0.3, 0.8, 1)\n\
    hips.Size = 250\n\
    hips.Translation = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(0, 75, 0)\n\
    hips.Parent = reference\n\
    skeleton[\'Hips\'] = hips\n\
    \n\
    spine = createSkeletonNode(\'Spine\')\n\
    spine.Parent = hips\n\
    spine.Color = <a href=\"javascript:void(0)\" data-symbol=\"FBColor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_color.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBColor</a>(0.3, 0.8, 1)\n\
    spine.Size = 250\n\
    spine.Translation = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(0, 25, 0)\n\
    skeleton[\'Spine\'] = spine\n\
    \n\
    # ...\n\
    \'\'\'\n\
    return skeleton\n\
    \n\
# Create a model which will be applied to each joint in the skeleton.\n\
def createModel():\n\
    # Create a sphere.\n\
    model = <a href=\"javascript:void(0)\" data-symbol=\"FBCreateObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga6698333c163da7c3bc077537889b6c33&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCreateObject</a>(\'Browsing/Templates/Elements/Primitives\', \'Sphere\', \'Sphere\')\n\
    model.Scaling = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(0.9, 0.9, 0.9)\n\
    \n\
    # Define a slightly reflective dark material.\n\
    material = <a href=\"javascript:void(0)\" data-symbol=\"FBMaterial\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_material.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMaterial</a>(\'MyMaterial\')\n\
    material.Ambient = <a href=\"javascript:void(0)\" data-symbol=\"FBColor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_color.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBColor</a>(0, 0, 0)\n\
    material.Diffuse = <a href=\"javascript:void(0)\" data-symbol=\"FBColor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_color.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBColor</a>(0, 0.04, 0.08)\n\
    material.Specular = <a href=\"javascript:void(0)\" data-symbol=\"FBColor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_color.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBColor</a>(0, 0.7, 0.86)\n\
    material.Shininess = 100\n\
    model.Materials.append(material)\n\
\n\
    # Create a cartoon-like shader.\n\
    shader = <a href=\"javascript:void(0)\" data-symbol=\"FBCreateObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga6698333c163da7c3bc077537889b6c33&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCreateObject</a>(\'Browsing/Templates/Shading Elements/Shaders\', \'Edge Cartoon\', \'MyShader\')\n\
    \n\
    # <a href=\"javascript:void(0)\" data-symbol=\"For\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a8392a32b4f002d4b372598185b549a1d&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">For</a> a list of all the shader\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> properties do:\n\
    #for <a href=\"javascript:void(0)\" data-symbol=\"item\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/dictobject_8h.html#a54447cc31a87ae88effdc512eb6d5496&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">item</a> in shader.PropertyList:\n\
    #    print item.Name\n\
    aliasProp = shader.PropertyList.Find(\'Antialiasing\')\n\
    aliasProp.Data = True\n\
    colorProp = shader.PropertyList.Find(\'EdgeColor\')\n\
    colorProp.Data = <a href=\"javascript:void(0)\" data-symbol=\"FBColor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_color.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBColor</a>(0, 0.83, 1)\n\
    widthProp = shader.PropertyList.Find(\'EdgeWidth\')\n\
    widthProp.Data = 8\n\
    \n\
    # Append the cartoon shader to the model.\n\
    model.Shaders.append(shader)        \n\
    \n\
    # The default shader must also be applied to the model.\n\
    defaultShader = <a href=\"javascript:void(0)\" data-symbol=\"FBSystem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem</a>().Scene.Shaders[0]\n\
    model.Shaders.append(defaultShader) \n\
    \n\
    # Use the default shading mode.\n\
    model.ShadingMode = <a href=\"javascript:void(0)\" data-symbol=\"FBModelShadingMode.kFBModelShadingDefault\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_shading_mode.html#aca9ba938464abeaf4480fcd049f41d78&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelShadingMode.kFBModelShadingDefault</a>\n\
    \n\
    return model\n\
\n\
# Apply a copy of pModel to each joint in the skeleton. \n\
def applyModelToSkeleton(pSkeleton, pModel):   \n\
    # Create a copy of the model for each joint in the skeleton.\n\
    for jointName, joint in pSkeleton.iteritems():\n\
        if jointName == \'Reference\':\n\
            # Do not apply the model to the Reference node.\n\
            continue\n\
        \n\
        # Parent the copied model to the joint.\n\
        model = pModel.Clone()\n\
        model.Parent = joint        \n\
        model.Show = True\n\
        \n\
        # Use the joint <a href=\"javascript:void(0)\" data-symbol=\"name\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#afcd1706c9144e6d6eee6127661ae3be2&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">name</a> as a prefix.\n\
        model.Name = jointName + pModel.Name\n\
\n\
        # Reset the model\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> translation to place it at the same \n\
        # location as its parent joint.\n\
        model.Translation = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(0, 0, 0)\n\
\n\
# Characterize the skeleton and create a control rig.\n\
def characterizeSkeleton(pCharacterName, pSkeleton):\n\
    # Create a new character.\n\
    character = <a href=\"javascript:void(0)\" data-symbol=\"FBCharacter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_character.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacter</a>(pCharacterName)\n\
    <a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a>().CurrentCharacter = character\n\
    \n\
    # <a href=\"javascript:void(0)\" data-symbol=\"Add\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#ab9d92a0f505af42d2049e62ae49ef932a0d592a4b562059bc283e00b3704865c9&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Add</a> each joint in our skeleton to the character.\n\
    for jointName, joint in pSkeleton.iteritems():\n\
        slot = character.PropertyList.Find(jointName + \'Link\')\n\
        slot.append(joint)\n\
\n\
    # Flag that the character has been characterized.\n\
    character.SetCharacterizeOn(True)\n\
    \n\
    # Create a control rig using Forward and Inverse Kinematics,\n\
    # as specified by the \"True\" parameter.\n\
    character.CreateControlRig(True)\n\
    \n\
    # <a href=\"javascript:void(0)\" data-symbol=\"Set\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a8b39bad9fda6bc73af75e4d6085bcf91&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Set</a> the control rig to active.\n\
    character.ActiveInput = True\n\
    \n\
    return character\n\
\n\
# Create poses of the character.\n\
def createPoses(pCharacter):   \n\
    poseList = []\n\
    \n\
    # Create our first pose.\n\
    pose1 = <a href=\"javascript:void(0)\" data-symbol=\"FBCharacterPose\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_character_pose.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacterPose</a>(\'myPose1\')\n\
    pose1.CopyPose(pCharacter)\n\
    poseList.append(pose1)\n\
    \n\
    # Obtain a reference to the character\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> effectors.\n\
    hipsEffector = pCharacter.GetEffectorModel(<a href=\"javascript:void(0)\" data-symbol=\"FBEffectorId.kFBHipsEffectorId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_effector_id.html#a5ac1d11358e661a5da7c02134589e36d&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBEffectorId.kFBHipsEffectorId</a>)\n\
    \n\
    # Create our second pose.\n\
    hipsEffector.Translation = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(0, 50, 0)\n\
    # (!!!) Note: It is very important to invoke <a href=\"javascript:void(0)\" data-symbol=\"FBSystem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem</a>().Scene.Evaluate() \n\
    #       at this <a href=\"javascript:void(0)\" data-symbol=\"step\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/sliceobject_8h.html#a22b0b4a11e692578c4afabff0985f230&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">step</a> to ensure the hipsEffector has effectively been translated. \n\
    #       Otherwise, it is not guaranteed that MotionBuilder\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> evaluation thread \n\
    #       will have translated the hips effector before pose2.CopyPose() is called.\n\
    <a href=\"javascript:void(0)\" data-symbol=\"FBSystem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem</a>().Scene.Evaluate()\n\
    pose2 = <a href=\"javascript:void(0)\" data-symbol=\"FBCharacterPose\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_character_pose.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacterPose</a>(\'myPose2\')\n\
    pose2.CopyPose(pCharacter)\n\
    poseList.append(pose2)\n\
    \n\
    # Repeat pose1 in our poseList to enable looping later.\n\
    poseList.append(pose1)\n\
    \n\
    return (poseList)\n\
\n\
# Create keys from the pose list.\n\
def createKeys(pCharacter, pPoseList):\n\
    # Ensure we take a pose of the entire character\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> body.\n\
    poseOptions = <a href=\"javascript:void(0)\" data-symbol=\"FBCharacterPoseOptions\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_character_pose_options.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacterPoseOptions</a>()\n\
    poseOptions.mCharacterPoseKeyingMode = <a href=\"javascript:void(0)\" data-symbol=\"FBCharacterPoseKeyingMode.kFBCharacterPoseKeyingModeFullBody\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_character_pose_keying_mode.html#a4a844441ab237c3dc2913910f8a3a876&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacterPoseKeyingMode.kFBCharacterPoseKeyingModeFullBody</a>\n\
    poseOptions.SetFlag(<a href=\"javascript:void(0)\" data-symbol=\"FBCharacterPoseFlag.kFBCharacterPoseMirror\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_character_pose_flag.html#a936ba72e86aba89a587221bee61ace5d&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacterPoseFlag.kFBCharacterPoseMirror</a>, True)\n\
    \n\
    # Select the character\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> control rig (3rd parameter = True). This \n\
    # allows <a href=\"javascript:void(0)\" data-symbol=\"FBPlayerControl.Key\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_player_control.html#a52d3e230d73235d549481f955e9b75ce&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPlayerControl.Key</a>() to <a href=\"javascript:void(0)\" data-symbol=\"key\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#ada6705808cbd8c921df38387db9a6aee&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">key</a> the selected models.\n\
    pCharacter.SelectModels(True, False, True, False)\n\
    \n\
    # Create a pose every 15 frames using our pose list.\n\
    lPlayer = <a href=\"javascript:void(0)\" data-symbol=\"FBPlayerControl\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_player_control.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPlayerControl</a>()\n\
    poseCount = 0\n\
    frameInterval = 15\n\
    for pose in pPoseList:\n\
        # Go to the next frame.\n\
        lPlayer.Goto(<a href=\"javascript:void(0)\" data-symbol=\"FBTime\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_time.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTime</a>(0, 0, 0, frameInterval * poseCount))\n\
        <a href=\"javascript:void(0)\" data-symbol=\"FBSystem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem</a>().Scene.Evaluate()\n\
        # Apply the pose to the character using our pose options.\n\
        pose.PastePose(pCharacter, poseOptions)\n\
        <a href=\"javascript:void(0)\" data-symbol=\"FBSystem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem</a>().Scene.Evaluate()\n\
        # Create a <a href=\"javascript:void(0)\" data-symbol=\"key\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#ada6705808cbd8c921df38387db9a6aee&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">key</a> in the player.\n\
        lPlayer.Key()\n\
        <a href=\"javascript:void(0)\" data-symbol=\"FBSystem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem</a>().Scene.Evaluate()\n\
        # Increment our counter.\n\
        poseCount += 1\n\
    \n\
    # De-select the character\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> control rig (1st parameter = False).\n\
    pCharacter.SelectModels(False, False, True, False)\n\
    \n\
    # <a href=\"javascript:void(0)\" data-symbol=\"Return\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#abdae7f49d66ce8e500825bb53aa14901&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Return</a> the frame number of the last frame keyed.\n\
    return frameInterval * (poseCount - 1)\n\
    \n\
    \n\
###############################################################\n\
# Main.                                                       #\n\
###############################################################\n\
\n\
# Clear the scene.\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a>().FileNew()\n\
\n\
# Create a new skeleton.\n\
characterName = \'MyStickman\'\n\
skeleton = createSkeleton(characterName)\n\
\n\
# Apply a model to each limb of the skeleton.\n\
templateModel = createModel()\n\
applyModelToSkeleton(skeleton, templateModel)\n\
templateModel.FBDelete() # We do not need the template model anymore.\n\
\n\
# Characterize the skeleton and create a control rig.\n\
character = characterizeSkeleton(characterName, skeleton)\n\
\n\
# Create the poses\n\
poseList = createPoses(character)\n\
\n\
# Create keys in the player control.\n\
lastFrame = createKeys(character, poseList)\n\
\n\
# Play the animation.\n\
lPlayer = <a href=\"javascript:void(0)\" data-symbol=\"FBPlayerControl\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_player_control.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPlayerControl</a>()\n\
lPlayer.LoopStart = <a href=\"javascript:void(0)\" data-symbol=\"FBTime\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_time.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTime</a>(0, 0, 0, 0)         # <a href=\"javascript:void(0)\" data-symbol=\"Set\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a8b39bad9fda6bc73af75e4d6085bcf91&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Set</a> the <a href=\"javascript:void(0)\" data-symbol=\"start\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/sliceobject_8h.html#ab80172fa2f374f0198e6186560ed619e&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">start</a> time in the player control.\n\
lPlayer.LoopStop = <a href=\"javascript:void(0)\" data-symbol=\"FBTime\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_time.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTime</a>(0, 0, 0, lastFrame)  # <a href=\"javascript:void(0)\" data-symbol=\"Set\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a8b39bad9fda6bc73af75e4d6085bcf91&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Set</a> the end time in the player control.\n\
lPlayer.LoopActive = True                      # Enable playback looping.\n\
lPlayer.GotoStart()                            # Play the animation from the beginning.\n\
lPlayer.Play()</pre></div> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";