var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-AB029633-946C-4CCB-879C-C533FDE236AB\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Your First Python Program</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-AB029633-946C-4CCB-879C-C533FDE236AB\"></a><div class=\"head\">\n\
            <h1>Your First Python Program</h1>\n\
         </div>\n\
         <p><a name=\"GUID-B17E22DC-E4C2-44DC-9DD3-DE668D0E2E40\"></a>You can refer to this topic to gain a basic understanding of how to use Python in\n\
            MotionBuilder. Additionally, some important classes and concepts are explained in\n\
            this topic for understanding how to use Python. \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_12CFA81154E945B48276994F1A8F4EEA\"></a> \n\
            <h2><a name=\"GUID-706D73A9-0039-404E-A76A-A88A719B763B\"></a>About the Python Program\n\
            </h2> \n\
            <p><a name=\"GUID-8B1A5128-1FFA-44B6-8C78-8E6F6F424DE3\"></a><span class=\"char_link\"><a href=\"#!/url=./files/GUID-AB029633-946C-4CCB-879C-C533FDE236AB.htm#SECTION_3570B32D78E5450C80327305959CEABA\">The Dancing Man</a></span> program described in this topic <em class=\"mild\">constrains</em> a character\'s hip effector to the screen coordinates (x,y) of the mouse. At the end\n\
               of this step-by-step tutorial, a character appears to <em class=\"mild\">dance</em> in the scene when you move the mouse. The image below shows the result of <span class=\"char_link\"><a href=\"#!/url=./files/GUID-AB029633-946C-4CCB-879C-C533FDE236AB.htm#SECTION_3570B32D78E5450C80327305959CEABA\">The Dancing Man</a></span> program. \n\
            </p> \n\
            <p><a name=\"GUID-279ABCA6-8E28-4CEB-A302-B71E1C5A607A\"></a></p> <img src=\"images/GUID-6273B676-5CE2-4A2F-AB38-3B807D3A3F11-low.png\"> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_5985B7D4F2BA4DD48787207C7F31ADD2\"></a> \n\
            <h2><a name=\"GUID-66895864-72EF-4084-B47E-67C41682D676\"></a>Opening the Python Editor\n\
            </h2> \n\
            <p><a name=\"GUID-5B85BC9A-A362-4FA2-8167-D0ACC68AF320\"></a>From the application menu, select <span class=\"MenuCascade\" id=\"GUID-410D3F66-5494-48B5-8FC0-8A081499BC23\">Window <img src=\"images/ac.menuaro.gif\"> Python Editor</span>. The <span class=\"char_link\"><a href=\"#!/url=./files/GUID-6B00DBAE-EC34-4958-86F5-A5B644C2DB00.htm\">Python Editor</a></span> appears. You can create and run Python programs in this editor. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_FFA5CDF9E6C24D059872E353D364D36D\"></a> \n\
            <h2><a name=\"GUID-1E7A488D-749F-4496-831B-65CA395A922E\"></a>Importing the MotionBuilder Python Module\n\
            </h2> \n\
            <p><a name=\"GUID-A5E02549-649A-4CE7-90EB-088848DAE2AA\"></a>The MotionBuilder Python API is contained in the <span class=\"code\" translate=\"no\">pyfbsdk</span> module. This module is generated from the MotionBuilder C++ API using Boost Python.\n\
               The <span class=\"code\" translate=\"no\">pyfbsdk</span> module contains most of the Python classes included in the MotionBuilder SDK and\n\
               many functions including the matrix and vector manipulation functions (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBMatrixInverse()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a5b120ce070624389cc1d744a568cb31e&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#gab42ef24eb4d80a1fd011f1ca609f3e20&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMatrixInverse()</a></span>, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBDot()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a226016a40cf1f7946281fb032ede0918&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga4fac6d26ad0101dddac33770bc6b5787&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBDot()</a></span>, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBLength()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a62ae4dbc9da04b3c7523365452fd4a04&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#gaa9ef7e1aa8b2b5bb860081c038e60b68&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLength()</a></span>, and others). For more information about <span class=\"code\" translate=\"no\">pyfbsdk</span>, refer to the Python API Reference section. \n\
            </p> \n\
            <p><a name=\"GUID-D5E94B14-5A9F-43F9-B7B2-8A0E6327A15A\"></a>The first line of your MotionBuilder Python program must import the <span class=\"code\" translate=\"no\">pyfbsdk</span> module. You must also import the <span class=\"code\" translate=\"no\">os</span> module to interface with the operating system. The following code sample shows how\n\
               to import the modules. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">from pyfbsdk import *\n\
import os</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_EC8A09208E32459FA0EA3732EF08AAE3\"></a> \n\
            <h2><a name=\"GUID-492A4CE6-70CB-4C05-8040-CE420AC06407\"></a>Clearing the Scene\n\
            </h2> \n\
            <p><a name=\"GUID-3490BBBC-FEAE-4222-AC15-AD3AAD7DA506\"></a>First obtain a reference to MotionBuilder\'s instance of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_application.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a></span>. The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_application.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a></span> class provides most of the functionality available in the <span class=\"MenuCascade\" id=\"GUID-1D30F02E-C355-4444-A60D-0930B2A49C0E\">File</span> application menu. As shown in following code sample, invoke <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBApplication.FileNew()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html#aefa0a63a4493ce116e7a85d7a248b1cc&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication.FileNew()</a></span>, which is equivalent to <span class=\"MenuCascade\" id=\"GUID-F08AE689-6433-427F-8017-9575E2A7BE2A\">File <img src=\"images/ac.menuaro.gif\"> New</span>, but does not prompt to save before clearing the scene. For more information, see\n\
               <span class=\"char_link\"><a href=\"#!/url=./files/GUID-7CD5EC6A-A3F4-4AFE-8167-E197C0C9F0BF.htm\">FBApplication - File I/O and Application Utilities</a></span>. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\"># Get an instance of <a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a> and clear the scene with FileNew().\n\
app = <a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a>()\n\
app.FileNew()</pre></div> \n\
            <p><a name=\"GUID-29B4A8C5-8FC0-4CE8-B728-400D8EDDEBD3\"></a>Now, obtain a reference to MotionBuilder\'s scene, which is used to add a mouse device\n\
               later. The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBSystem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_system.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_system.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem</a></span> class is used to access the scene (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBScene\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_scene.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_scene.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBScene</a></span>), as well as track system properties such as the memory usage, application path,\n\
               and MotionBuilder\'s version information. For more information, see <span class=\"char_link\"><a href=\"#!/url=./files/GUID-2A900B42-AC78-44A0-BA39-74F7D6D39133.htm\">FBSystem - The System Class</a></span>. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\"># Get a reference to the underlying system properties of MotionBuilder.\n\
system = <a href=\"javascript:void(0)\" data-symbol=\"FBSystem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem</a>()\n\
\n\
# Get a reference to the current MotionBuilder scene.\n\
scene = system.Scene</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_9CA98BAD61814ED8AB8A9F6BC5AF1247\"></a> \n\
            <h2><a name=\"GUID-52CB999B-668A-4EF7-B2BF-0D0B191C0890\"></a>Opening a File\n\
            </h2> \n\
            <p><a name=\"GUID-AB92F013-A18A-4DB2-932F-82A47B9C6574\"></a>The character file to open is in the MotionBuilder installation directory under <span class=\"filePath\" translate=\"no\">OpenRealitySDK\\scenes\\PlasticMan.fbx</span>. You need to define the <span class=\"code\" translate=\"no\">GetMotionBuilderInstallationDirectory()</span> helper function, which makes use of the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBSystem.ApplicationPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html#a6d467e5583f980ef0806f9d0d4bd3fa4&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem.ApplicationPath</a></span> property to obtain the installation directory. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\"># Get the MotionBuilder installation directory.\n\
#\n\
# Note: <a href=\"javascript:void(0)\" data-symbol=\"FBSystem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem</a>().ApplicationPath returns a <a href=\"javascript:void(0)\" data-symbol=\"string\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#aafa21ae74f7a3e4ac0c645f0f30ee853&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">string</a> similar to:\n\
#       \'C:\\Program Files\\Autodesk\\MotionBuilder &lt;year&gt;\\bin\\x64\'.\n\
#       We only want to return the substring:\n\
#       \'C:\\Program Files\\Autodesk\\MotionBuilder &lt;year&gt;\\\n\
#\n\
def GetMotionBuilderInstallationDirectory() :\n\
    applicationPath = <a href=\"javascript:void(0)\" data-symbol=\"FBSystem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem</a>().ApplicationPath\n\
    return applicationPath[0:applicationPath.index(\'bin\')]</pre></div> \n\
            <p><a name=\"GUID-7DA92815-1A49-4921-AB78-749AF0FED621\"></a>Invoking <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBApplication.FileOpen()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html#a038c732a4956190b7cebfec5d6f14ab3&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication.FileOpen()</a></span> with the second argument set to <span class=\"code\" translate=\"no\">False</span> opens the <span class=\"filePath\" translate=\"no\">PlasticMan.fbx</span> file without prompting through a dialog. For more information on opening, merging,\n\
               and appending the contents of a file to the scene, see <span class=\"char_link\"><a href=\"#!/url=./files/GUID-1956163C-F19B-453F-A0DB-5F29FDE38C25.htm\">Loading from a File</a></span>. Upon completion of <span class=\"code\" translate=\"no\">FBapplication.FileOpen()</span>, the <em class=\"mild\">PlasticMan</em> character appears. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\"># Use the sample PlasticMan.fbx file in the default installation directory.\n\
filename = GetMotionBuilderInstallationDirectory() + \'OpenRealitySDK\\scenes\\PlasticMan.fbx\'\n\
app.FileOpen(filename, False)</pre></div> \n\
            <div><a name=\"GUID-EA891D88-727A-4361-971C-606B53B90736\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>You can save or load specific scene elements from a file after discarding other elements.\n\
                  For more information, see <span class=\"char_link\"><a href=\"#!/url=./files/GUID-9CA39221-DEDB-4355-ADFA-C86D3D3DDE83.htm\">File Options</a></span>. \n\
               </div>\n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_B2BBE483188042BD87743FB057A8272D\"></a> \n\
            <h2><a name=\"GUID-B95B9698-2815-4665-9D10-ABBBDE82734A\"></a>Getting the Character\'s Hips Effector\n\
            </h2> \n\
            <p><a name=\"GUID-024353C6-F93A-48FC-B71E-32E9A22232C3\"></a>You must manipulate the hips effector to make the <em class=\"mild\">PlasticMan</em> character dance. Most objects in the scene are uniquely identified using their own\n\
               namespace and name (see <span class=\"char_link\"><a href=\"#!/url=./files/GUID-E47A0026-9D57-4C18-845F-CF5712EDF798.htm#SECTION_A9F919F34F594BBCBD41DC6088511742\">Names and Namespaces</a></span>). You can also refer to <span class=\"char_link\"><a href=\"#!/url=./files/GUID-D04CD336-5D6A-4FB3-A75E-E50EC79819FA.htm\">Scene Elements</a></span> for information about how to set up scenes, manipulate objects, and work with characters.\n\
               \n\
            </p> \n\
            <p><a name=\"GUID-75D58080-9777-47A8-9D48-C37F6764A8D0\"></a>To obtain the hips effector, you can search for<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a></span> whose name corresponds to <span class=\"code\" translate=\"no\">Plasticman_Ctrl:HipsEffector</span> using <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBFindModelByLabelName()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#aff5d93ad5cb7d8e581d94ab69555540a&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga7572e2672e95a9d964c46b67c70097a6&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFindModelByLabelName()</a></span>. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\"># Get a reference to the Plastic Man\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> hips effector.\n\
hipEffector = <a href=\"javascript:void(0)\" data-symbol=\"FBFindModelByLabelName\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga7572e2672e95a9d964c46b67c70097a6&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFindModelByLabelName</a>(\"Plasticman_Ctrl:HipsEffector\")</pre></div> \n\
            <p><a name=\"GUID-2C769B3A-E697-422B-ADC8-F2BA4036F870\"></a>The <span class=\"code\" translate=\"no\">hipEffector</span> variable now points to the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelMarker\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_marker.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_marker.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelMarker</a></span> corresponding to the <em class=\"mild\">PlasticMan\'s</em> hips effector. The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a></span> base class is used to define the <em class=\"mild\">Translation</em>, <em class=\"mild\">Rotation</em>, and <em class=\"mild\">Scaling</em> (TRS) of scene elements. The goal here is to constrain the translation and rotation\n\
               of the <em class=\"mild\">PlasticMan\'s</em> hips effector to the mouse input. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_2CF7B99BAD914C37B07D9A1F6C3AE273\"></a> \n\
            <h2><a name=\"GUID-364666A0-517C-4B7C-8C81-8E325C04BC2E\"></a>Adding a Mouse Device to the Scene\n\
            </h2> \n\
            <p><a name=\"GUID-FC1B84B3-084D-4970-A8C4-3E0A609C9968\"></a>To use the mouse as an input device, you need to add a mouse (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBDevice\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_device.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_device.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBDevice</a></span>) to the scene. You can use the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCreateObject()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a5111370ada05db17e04b97b447ddbd7c&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga6698333c163da7c3bc077537889b6c33&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCreateObject()</a></span> function to obtain a mouse device. After the mouse object is created, you must activate\n\
               it (<span class=\"code\" translate=\"no\">FBDevice.OnLine</span>), allow the application to read its data (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBBox.Live\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_box.html#af6bd45b256bd6de29ecbd8e3b2b7f550&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBBox.Live</a></span>) , and append it to the scene\'s list of devices (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBScene.Devices\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_scene.html#a7d39909068f8748ff9e96c6e7e72ea57&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBScene.Devices</a></span>). \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\"># Create a mouse device and append it to the scene.\n\
mouseDevice = <a href=\"javascript:void(0)\" data-symbol=\"FBCreateObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga6698333c163da7c3bc077537889b6c33&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCreateObject</a>(\"Browsing/Templates/Devices\", \"Mouse\", \"MyMouse\")\n\
mouseDevice.OnLine = True\n\
mouseDevice.Live = True\n\
scene.Devices.append(mouseDevice)</pre></div> \n\
            <p><a name=\"GUID-30A29E49-368A-49E3-AEAB-EC3311227D78\"></a>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCreateObject()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a5111370ada05db17e04b97b447ddbd7c&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga6698333c163da7c3bc077537889b6c33&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCreateObject()</a></span> function is used to create objects from within the Asset Browser window. Following\n\
               are the arguments of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCreateObject()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a5111370ada05db17e04b97b447ddbd7c&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga6698333c163da7c3bc077537889b6c33&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCreateObject()</a></span>: <a name=\"UL_3EA9A962B6B14E85B449DC563A5D7BC1\"></a><ul>\n\
                  <li><em class=\"strong\">Argument 1:</em> <span class=\"code\" translate=\"no\">\"Browsing/Templates/Devices\"</span> - The Asset Browser <em class=\"mild\">path</em>. This path is illustrated by the node hierarchy in the navigation tree. This path\n\
                     must always begin with <span class=\"code\" translate=\"no\">Browsing/</span>. \n\
                  </li>\n\
                  <li><em class=\"strong\">Argument 2:</em> <span class=\"code\" translate=\"no\">\"Mouse\"</span> - The <em class=\"mild\">entry name</em>. It corresponds to the red circle in the following figure. \n\
                  </li>\n\
                  <li><em class=\"strong\">Argument 3:</em> <span class=\"code\" translate=\"no\">\"MyMouse\"</span> - The <em class=\"mild\">custom name</em> of the object. \n\
                     <p><a name=\"GUID-538B7A88-9BD4-4B17-B7BA-99F493D09F6D\"></a> <a name=\"FIG_5C3F2CFDF67F4619A3FC88220F9655D1\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-1FBCFC32-BE5B-497E-8D44-5A121F58EAB7-low.png\"></div> \n\
                     </p> \n\
                     <div><a name=\"GUID-7F4ABE14-7089-40F2-8E71-F97686AACA7E\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>If you are attempting to create primitives in <span class=\"code\" translate=\"no\">\"Browsing/Templates/Elements/Primitives\"</span>, the custom name must be the same as the entry name. For more information, refer\n\
                           to the <span class=\"filePath\" translate=\"no\">BasicOperations/ObjectCreation.py</span> example in the Python API Reference section. \n\
                        </div>\n\
                     </div> \n\
                  </li>\n\
               </ul> \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_21F9471B3EDC4BD799DE463EECA637FB\"></a> \n\
            <h2><a name=\"GUID-CECC411B-1FEE-40B8-9E08-51DD68A9374F\"></a>Constraining the Character\'s Hips Effector to the Mouse\n\
            </h2> \n\
            <p><a name=\"GUID-1DD4FE28-A1A9-40A6-8C9C-01D2F5CD374D\"></a>You can now <em class=\"mild\">constrain</em> the character\'s hips effector to the mouse input. To do this, create a new <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBConstraintRelation\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_constraint_relation.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_constraint_relation.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConstraintRelation</a></span>, and name it <span class=\"code\" translate=\"no\">\"DanceConstraint\"</span>. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\"># Create a constraint relation.\n\
constraintRelation = <a href=\"javascript:void(0)\" data-symbol=\"FBConstraintRelation\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_constraint_relation.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConstraintRelation</a>(\"DanceConstraint\")\n\
constraintRelation.Active = True</pre></div> \n\
            <p><a name=\"GUID-11690B6F-B3B5-4167-BDB7-81E3F83B8DB2\"></a>The following figure illustrates how the hips effector is constrained by the mouse.\n\
               Instances of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBBox\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_box.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_box.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBBox</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBAnimationNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_animation_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_animation_node.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBAnimationNode</a></span> are used in an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBConstraintRelation\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_constraint_relation.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_constraint_relation.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConstraintRelation</a></span> to define the behavior of the constraint. \n\
            </p> \n\
            <p><a name=\"GUID-F0B76043-5864-44CD-8FBC-3C37E6D99064\"></a> <a name=\"FIG_31E5D2E190094D5EB02A63D864A482F8\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-6D2FD07C-7E54-44C0-BB68-6444940FC51E-low.png\"></div> \n\
            </p> \n\
            <div class=\"section\"><a name=\"SECTION_011460AA0FCF4C48B9B3438D71C4908F\"></a> \n\
               <h3><a name=\"GUID-A0A99F01-68E2-4B4E-8962-D0982F6B31C0\"></a>Animatable Elements - The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBBox\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_box.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_box.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBBox</a></span> Base Class\n\
               </h3> \n\
               <p><a name=\"GUID-43412655-07EC-412F-BD8D-0F9024F18992\"></a><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBBox\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_box.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_box.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBBox</a></span> is the base class of any animatable element in the scene including models (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a></span>), lights (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBLight\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_light.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_light.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLight</a></span>), materials (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBMaterial\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_material.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_material.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMaterial</a></span>), textures (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBTexture\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_texture.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_texture.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTexture</a></span>), shaders (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBShader\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_shader.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_shader.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBShader</a></span>), constraints (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBConstraint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_constraint.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_constraint.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConstraint</a></span>), and so on. Our <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBConstraintRelation\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_constraint_relation.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_constraint_relation.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConstraintRelation</a></span> contains a set of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBBox\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_box.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_box.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBBox</a></span> objects. In the figure, the boxes <span class=\"code\" translate=\"no\">MyMouse</span>, <span class=\"code\" translate=\"no\">Number to Vector</span>, <span class=\"code\" translate=\"no\">Number to Vector 1</span>, and <span class=\"code\" translate=\"no\">Plasticman_Ctrl:HipsEffector</span> are all instances of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBBox\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_box.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_box.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBBox</a></span>. Each instance of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBBox\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_box.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_box.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBBox</a></span> performs a specific role in the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBConstraintRelation\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_constraint_relation.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_constraint_relation.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConstraintRelation</a></span>. <a name=\"UL_286C69BE61C445F8BE9FC6C1FA295A54\"></a><ul>\n\
                     <li>The <span class=\"code\" translate=\"no\">MyMouse</span> box acts as a data <em class=\"mild\">source</em>. \n\
                     </li>\n\
                     <li> The <span class=\"code\" translate=\"no\">Plasticman_Ctrl:HipsEffector</span> box is being constrained. \n\
                     </li>\n\
                     <li>The <span class=\"code\" translate=\"no\">Number to Vector</span> and <span class=\"code\" translate=\"no\">Number to Vector 1</span> boxes <em class=\"mild\">convert</em> the X and Y data from the mouse into 3D vectors. \n\
                     </li>\n\
                  </ul> \n\
               </p> \n\
               <p><a name=\"GUID-5B19797F-E990-4251-AFE1-59E3C945E8D3\"></a>The following code sample shows how to create these boxes and set their position in\n\
                  the Constraint Settings window. \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\"># 1. Create a box for the mouse\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> output.\n\
mouseBox = constraintRelation.SetAsSource(mouseDevice)\n\
constraintRelation.SetBoxPosition(mouseBox, 30, 30)\n\
\n\
# 2. Create a box for the hip effector\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> input.\n\
hipEffectorBox = constraintRelation.ConstrainObject(hipEffector)\n\
constraintRelation.SetBoxPosition(hipEffectorBox, 700, 30)\n\
\n\
# 3. Create a number to vector box to map the \'Y\' output of the mouse\n\
# to the \'Y\' translation of the PlasticMan\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> hip effector.\n\
translationConversionBox = constraintRelation.CreateFunctionBox(\'Converters\', \'Number to Vector\')\n\
constraintRelation.SetBoxPosition(translationConversionBox, 300, 100)\n\
\n\
# 4. Create a number to vector box to map the \'X\' output of the mouse\n\
# to the \'X\' and \'Z\' rotation of the PlasticMan\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> hip effector.\n\
rotationConversionBox = constraintRelation.CreateFunctionBox(\'Converters\', \'Number to Vector\')\n\
constraintRelation.SetBoxPosition(rotationConversionBox, 300, 0)</pre></div> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_A163B788DA6244918EAB85BE67DD76ED\"></a> \n\
               <h3><a name=\"GUID-C8FFA5EC-442D-4BF6-A317-BD6822A5D9B7\"></a>Animatable Properties - The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBAnimationNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_animation_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_animation_node.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBAnimationNode</a></span> Class\n\
               </h3> \n\
               <p><a name=\"GUID-D7BF2EA1-5F72-41F3-BB9B-4BFEF8A647F9\"></a>Instances of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBAnimationNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_animation_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_animation_node.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBAnimationNode</a></span> are contained within an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBBox\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_box.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_box.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBBox</a></span>. In the figure, the animation nodes are denoted by arrows. An <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBAnimationNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_animation_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_animation_node.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBAnimationNode</a></span> exists for any animatable property of an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBBox\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_box.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_box.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBBox</a></span>. For example, the <span class=\"code\" translate=\"no\">Plasticman_Ctrl:HipsEffector</span> box provides one <em class=\"mild\">input</em> animation node for each of its animatable properties: translation, rotation, and\n\
                  scaling. \n\
               </p> <a name=\"UL_47FEDF1FD47A4051AD07223F89C48445\"></a><ul>\n\
                  <li>Arrows on the <em class=\"mild\">left</em> side of a box correspond to <em class=\"mild\">input</em> animation nodes. \n\
                  </li>\n\
                  <li>Arrows on the <em class=\"mild\">right</em> side of a box correspond to <em class=\"mild\">output</em> animation nodes. \n\
                  </li>\n\
               </ul> \n\
               <p><a name=\"GUID-C7D23A4C-86EB-463A-BF48-91622EE86EBD\"></a> The utility function <span class=\"code\" translate=\"no\">FindAnimationNode()</span> defined at the beginning of the program returns the child animation node whose name\n\
                  corresponds to the one specified by <span class=\"code\" translate=\"no\">pName</span>. \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\"># Define a utility function to look up a named\n\
# animation <a href=\"javascript:void(0)\" data-symbol=\"node\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/node_8h.html#addb697c9bca6f8981a870daa4953af4f&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">node</a> under a given parent node.\n\
def FindAnimationNode( pParent, pName ):\n\
    lResult = None\n\
    for lNode in pParent.Nodes:\n\
        if lNode.Name == pName:\n\
            lResult = lNode\n\
            break\n\
    return lResult</pre></div> \n\
               <p><a name=\"GUID-806FF4F2-8183-4F4A-8193-6F3B2B72C02C\"></a>You can extract the animation nodes of interest and connect them together using <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBConnect()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#ae714fd0a71698e4948530ed309901c60&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga332a173e2c25db9dcf3a55118981a303&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConnect()</a></span> as shown in the following code sample. \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\"># Get a reference to all the animation nodes we need to connect.\n\
# Mouse output:\n\
xMouseOut = FindAnimationNode(mouseBox.AnimationNodeOutGet(), \'X\')\n\
yMouseOut = FindAnimationNode(mouseBox.AnimationNodeOutGet(), \'Y\')\n\
\n\
# Translation conversion:\n\
yTranslationConversionIn = FindAnimationNode(translationConversionBox.AnimationNodeInGet(), \'Y\')\n\
translationConversionOut = FindAnimationNode(translationConversionBox.AnimationNodeOutGet(), \'Result\')\n\
\n\
# Rotation conversion:\n\
xRotationConversionIn = FindAnimationNode(rotationConversionBox.AnimationNodeInGet(), \'X\')\n\
zRotationConversionIn = FindAnimationNode(rotationConversionBox.AnimationNodeInGet(), \'Z\')\n\
rotationConversionOut = FindAnimationNode(rotationConversionBox.AnimationNodeOutGet(), \'Result\')\n\
\n\
# Hip effector input:\n\
hipTranslationIn = FindAnimationNode(hipEffectorBox.AnimationNodeInGet(), \'Translation\')\n\
hipRotationIn = FindAnimationNode(hipEffectorBox.AnimationNodeInGet(), \'Rotation\')\n\
\n\
# Connect the animation nodes in the constraint.\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBConnect\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga332a173e2c25db9dcf3a55118981a303&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConnect</a>(yMouseOut, yTranslationConversionIn)\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBConnect\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga332a173e2c25db9dcf3a55118981a303&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConnect</a>(xMouseOut, xRotationConversionIn)\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBConnect\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga332a173e2c25db9dcf3a55118981a303&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConnect</a>(xMouseOut, zRotationConversionIn)\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBConnect\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga332a173e2c25db9dcf3a55118981a303&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConnect</a>(translationConversionOut, hipTranslationIn)\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBConnect\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga332a173e2c25db9dcf3a55118981a303&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConnect</a>(rotationConversionOut, hipRotationIn)</pre></div> \n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_9B2AE23F42024D279CA7AC4FCE9F4A5D\"></a> \n\
            <h2><a name=\"GUID-3F8AB759-EAAD-44C2-8287-6F49C86AF6BC\"></a>Saving to a File with a Dialog\n\
            </h2> \n\
            <p><a name=\"GUID-B5DABC92-238B-4206-9EC3-A3E84DF784FF\"></a>Create a dialog box using <span class=\"code\" translate=\"no\">FBFilePopup()</span>, and configure it for saving. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\"># Save the file using a dialog box.\n\
saveDialog = <a href=\"javascript:void(0)\" data-symbol=\"FBFilePopup\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_file_popup.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFilePopup</a>()\n\
saveDialog.Style = <a href=\"javascript:void(0)\" data-symbol=\"FBFilePopupStyle.kFBFilePopupSave\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_file_popup_style.html#a44a2974841ec91d6bb0c83bbe2bf77d0&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFilePopupStyle.kFBFilePopupSave</a>\n\
saveDialog.Filter = \'*\'\n\
\n\
saveDialog.Caption = \'My Save Dialog Box\'\n\
# <a href=\"javascript:void(0)\" data-symbol=\"Set\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a8b39bad9fda6bc73af75e4d6085bcf91&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Set</a> the path to the current user\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> My Documents\\MB folder.\n\
saveDialog.Path = os.path.expanduser(\'~\') + \'\\Documents\\MB\'\n\
saveDialog.FileName = \'DancingMan.fbx\'\n\
\n\
if saveDialog.Execute():\n\
    app.FileSave(saveDialog.FullFilename)</pre></div> \n\
            <p><a name=\"GUID-DDEA0BF2-2AC0-44A5-AEFA-A3F638F846B5\"></a> \n\
               <div><a name=\"GUID-DF6E023C-C497-4EDC-B9A8-0CA895C2BE16\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>A current issue in the MotionBuilder SDK requires that the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBFilePopup.Filter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_file_popup.html#ad8fed2cad0d38b7b250061a6323301d1&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFilePopup.Filter</a></span> property be set to <span class=\"code\" translate=\"no\">\"*\"</span>. Failure to do so might result in a crash. \n\
                  </div>\n\
               </div> \n\
            </p> \n\
            <p><a name=\"GUID-E37DA689-D701-4C71-98D2-205B1AC4D337\"></a>You can also refer to <span class=\"char_link\"><a href=\"#!/url=./files/GUID-FE8DB4BD-ED47-47CD-9439-A31A7ADE565A.htm\">Saving to a File</a></span> and <span class=\"char_link\"><a href=\"#!/url=./files/GUID-2E76D18A-BF4A-4C13-B5C7-2CB6225E5893.htm\">User Interface</a></span> for more information. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_3570B32D78E5450C80327305959CEABA\"></a> \n\
            <h2><a name=\"GUID-D34B913F-1A8A-4CDA-85B1-403C551AB9DC\"></a>The Dancing Man Program\n\
            </h2> \n\
            <p><a name=\"GUID-159EB071-5BA5-4CDC-85E9-AC868CF6502B\"></a>The following code sample is the complete Dancing Man program that you can copy into\n\
               the <span class=\"char_link\"><a href=\"#!/url=./files/GUID-6B00DBAE-EC34-4958-86F5-A5B644C2DB00.htm\">Python Editor</a></span> and run. Change the <span class=\"code\" translate=\"no\">filename</span> value to a suitable path if you are not using the default 64-bit installation of\n\
               MotionBuilder. You also need to change the <span class=\"code\" translate=\"no\">Plasticman_Ctrl:HipsEffector</span> string if your file contains a different character. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">from pyfbsdk import *\n\
import os\n\
\n\
# Define a utility function to look up a named\n\
# animation <a href=\"javascript:void(0)\" data-symbol=\"node\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/node_8h.html#addb697c9bca6f8981a870daa4953af4f&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">node</a> under a given parent node.\n\
def FindAnimationNode( pParent, pName ):\n\
    lResult = None\n\
    for lNode in pParent.Nodes:\n\
        if lNode.Name == pName:\n\
            lResult = lNode\n\
            break\n\
    return lResult\n\
\n\
# Get the MotionBuilder installation directory.\n\
#\n\
# Note: <a href=\"javascript:void(0)\" data-symbol=\"FBSystem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem</a>().ApplicationPath returns a <a href=\"javascript:void(0)\" data-symbol=\"string\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#aafa21ae74f7a3e4ac0c645f0f30ee853&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">string</a> similar to:\n\
#       \'C:\\Program Files\\Autodesk\\MotionBuilder &lt;year&gt;\\bin\\x64\'.\n\
#       We only want to return the path:\n\
#       \'C:\\Program Files\\Autodesk\\MotionBuilder &lt;year&gt;\\\n\
def GetMotionBuilderInstallationDirectory() :\n\
    applicationPath = <a href=\"javascript:void(0)\" data-symbol=\"FBSystem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem</a>().ApplicationPath\n\
    return applicationPath[0:applicationPath.index(\'bin\')]\n\
\n\
\n\
\n\
# Get the instance of <a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a>, and clear the scene with FileNew().\n\
app = <a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a>()\n\
app.FileNew()\n\
\n\
\n\
\n\
# Get a reference to the underlying system properties of MotionBuilder.\n\
system = <a href=\"javascript:void(0)\" data-symbol=\"FBSystem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem</a>()\n\
\n\
\n\
\n\
# Get a reference to the current MotionBuilder scene.\n\
scene = system.Scene\n\
\n\
\n\
\n\
# Use the sample PlasticMan.fbx file in the default installation directory.\n\
filename = GetMotionBuilderInstallationDirectory() + \'OpenRealitySDK\\scenes\\PlasticMan.fbx\'\n\
app.FileOpen(filename, False)\n\
\n\
\n\
\n\
# Get a reference to the Plastic Man\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> hips effector.\n\
hipEffector = <a href=\"javascript:void(0)\" data-symbol=\"FBFindModelByLabelName\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga7572e2672e95a9d964c46b67c70097a6&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFindModelByLabelName</a>(\'Plasticman_Ctrl:HipsEffector\')\n\
\n\
\n\
\n\
# Create a mouse device and append it to the scene.\n\
mouseDevice = <a href=\"javascript:void(0)\" data-symbol=\"FBCreateObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga6698333c163da7c3bc077537889b6c33&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCreateObject</a>(\'Browsing/Templates/Devices\', \'Mouse\', \'MyMouse\')\n\
mouseDevice.Online = True\n\
mouseDevice.Live = True\n\
scene.Devices.append(mouseDevice)\n\
\n\
\n\
\n\
# Create a constraint relation.\n\
constraintRelation = <a href=\"javascript:void(0)\" data-symbol=\"FBConstraintRelation\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_constraint_relation.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConstraintRelation</a>(\'DanceConstraint\')\n\
constraintRelation.Active = True\n\
\n\
\n\
\n\
# 1. Create a box for the mouse\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> output.\n\
mouseBox = constraintRelation.SetAsSource(mouseDevice)\n\
constraintRelation.SetBoxPosition(mouseBox, 30, 30)\n\
\n\
# 2. Create a box for the hip effector\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> input.\n\
hipEffectorBox = constraintRelation.ConstrainObject(hipEffector)\n\
constraintRelation.SetBoxPosition(hipEffectorBox, 700, 30)\n\
\n\
# 3. Create a number to vector box to map the \'Y\' output of the mouse\n\
# to the \'Y\' translation of the PlasticMan\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> hip effector.\n\
translationConversionBox = constraintRelation.CreateFunctionBox(\'Converters\', \'Number to Vector\')\n\
constraintRelation.SetBoxPosition(translationConversionBox, 300, 100)\n\
\n\
# 4. Create a number to vector box to map the \'X\' output of the mouse\n\
# to the \'X\' and \'Z\' rotation of the PlasticMan\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> hip effector.\n\
rotationConversionBox = constraintRelation.CreateFunctionBox(\'Converters\', \'Number to Vector\')\n\
constraintRelation.SetBoxPosition(rotationConversionBox, 300, 0)\n\
\n\
\n\
\n\
# Get a reference to all the animation nodes we need to connect.\n\
# Mouse output:\n\
xMouseOut = FindAnimationNode(mouseBox.AnimationNodeOutGet(), \'X\')\n\
yMouseOut = FindAnimationNode(mouseBox.AnimationNodeOutGet(), \'Y\')\n\
\n\
# Translation conversion:\n\
yTranslationConversionIn = FindAnimationNode(translationConversionBox.AnimationNodeInGet(), \'Y\')\n\
translationConversionOut = FindAnimationNode(translationConversionBox.AnimationNodeOutGet(), \'Result\')\n\
\n\
# Rotation conversion:\n\
xRotationConversionIn = FindAnimationNode(rotationConversionBox.AnimationNodeInGet(), \'X\')\n\
zRotationConversionIn = FindAnimationNode(rotationConversionBox.AnimationNodeInGet(), \'Z\')\n\
rotationConversionOut = FindAnimationNode(rotationConversionBox.AnimationNodeOutGet(), \'Result\')\n\
\n\
# Hip effector input:\n\
hipTranslationIn = FindAnimationNode(hipEffectorBox.AnimationNodeInGet(), \'Translation\')\n\
hipRotationIn = FindAnimationNode(hipEffectorBox.AnimationNodeInGet(), \'Rotation\')\n\
\n\
\n\
# Connect the animation nodes in the constraint.\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBConnect\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga332a173e2c25db9dcf3a55118981a303&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConnect</a>(yMouseOut, yTranslationConversionIn)\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBConnect\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga332a173e2c25db9dcf3a55118981a303&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConnect</a>(xMouseOut, xRotationConversionIn)\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBConnect\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga332a173e2c25db9dcf3a55118981a303&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConnect</a>(xMouseOut, zRotationConversionIn)\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBConnect\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga332a173e2c25db9dcf3a55118981a303&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConnect</a>(translationConversionOut, hipTranslationIn)\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBConnect\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga332a173e2c25db9dcf3a55118981a303&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConnect</a>(rotationConversionOut, hipRotationIn)\n\
\n\
\n\
\n\
# Save the file using a dialog box.\n\
saveDialog = <a href=\"javascript:void(0)\" data-symbol=\"FBFilePopup\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_file_popup.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFilePopup</a>()\n\
saveDialog.Style = <a href=\"javascript:void(0)\" data-symbol=\"FBFilePopupStyle.kFBFilePopupSave\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_file_popup_style.html#a44a2974841ec91d6bb0c83bbe2bf77d0&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFilePopupStyle.kFBFilePopupSave</a>\n\
saveDialog.Filter = \'*\'\n\
\n\
saveDialog.Caption = \'My Save Dialog Box\'\n\
# <a href=\"javascript:void(0)\" data-symbol=\"Set\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a8b39bad9fda6bc73af75e4d6085bcf91&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Set</a> the path to the current user\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> My Documents\\MB folder.\n\
saveDialog.Path = os.path.expanduser(\'~\') + \'\\Documents\\MB\'\n\
saveDialog.FileName = \'DancingMan.fbx\'\n\
\n\
if saveDialog.Execute():\n\
    app.FileSave(saveDialog.FullFilename)</pre></div> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";