var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-AD4A884E-8A9B-463D-B883-6E947D76125D\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Solving from the Goal to the Skeleton</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-AD4A884E-8A9B-463D-B883-6E947D76125D\"></a><div class=\"head\">\n\
            <h1>Solving from the Goal to the Skeleton </h1>\n\
         </div>\n\
         <p><a name=\"GUID-20B263EC-24A0-4F6A-AC3E-E9970451DB3F\"></a>You can implement your own solver for a customized IK solve instead of using the internal\n\
            solver or HIK 2014 solver. You can read from the markers again to guide the solver.\n\
            The following sample shows how to retarget the goal FK state into the skeleton. \n\
         </p>\n\
         <div class=\"codeBlock\"><a name=\"LANG-CPP\"></a><pre class=\"prettyprint lang-cpp\">void ORCharacterSolver_Custom::SetupAllAnimationNodes()\n\
{\n\
  <a href=\"javascript:void(0)\" data-symbol=\"FBCharacter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_character.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacter</a>* lCharacter = TargetCharacter;\n\
  if(lCharacter != <a href=\"javascript:void(0)\" data-symbol=\"NULL\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/kaydara_8h.html#a070d2ce7b6bb7e5c05602aa8c308d0c4&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">NULL</a> &amp;&amp; lCharacter-&gt;GetCharacterize() &amp;&amp; AnimationNodeInGet())\n\
  {\n\
    if(TargetCharacter-&gt;InputType == kFBCharacterInputMoCap)\n\
    {\n\
      <a href=\"javascript:void(0)\" data-symbol=\"FBCharacterMarkerSet\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_character_marker_set.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacterMarkerSet</a>* lMarkerSet = TargetCharacter-&gt;GetCharacterMarkerSet();\n\
\n\
      if(lMarkerSet)\n\
      {\n\
        for(<a href=\"javascript:void(0)\" data-symbol=\"int\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/code_8h.html#aa4332194bf83cd22038ee4511e4decea&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">int</a> lBodyNodeId = kFBHipsNodeId; lBodyNodeId &lt; kFBLastNodeId; lBodyNodeId++)\n\
        {\n\
          if(lBodyNodeId != kFBReferenceNodeId)\n\
          {\n\
            mNodes[lBodyNodeId].Setup(lCharacter-&gt;GetModel((<a href=\"javascript:void(0)\" data-symbol=\"FBBodyNodeId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_body_node_id.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBBodyNodeId</a>)lBodyNodeId), this, lBodyNodeId);\n\
          }\n\
        }\n\
      }\n\
    }\n\
  }\n\
}\n\
\n\
void ORCharacterSolver_Custom::RemoveAllAnimationNodes()\n\
{\n\
  // All animation nodes are cleared by the system.\n\
  ClearNodes();\n\
}\n\
\n\
<a href=\"javascript:void(0)\" data-symbol=\"bool\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#af6a258d8f3ee5206d682d799316314b1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">bool</a> ORCharacterSolver_Custom::AnimationNodeNotify(<a href=\"javascript:void(0)\" data-symbol=\"FBAnimationNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_animation_node.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBAnimationNode</a>* pConnector,\n\
     <a href=\"javascript:void(0)\" data-symbol=\"FBEvaluateInfo\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_evaluate_info.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBEvaluateInfo</a>* pEvaluateInfo,<a href=\"javascript:void(0)\" data-symbol=\"FBConstraintInfo\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_constraint_info.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConstraintInfo</a>* pConstraintInfo)\n\
{\n\
  //Get the <a href=\"javascript:void(0)\" data-symbol=\"state\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/structstate.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">state</a> for this evaluation.\n\
  if(mEvaluateId != pEvaluateInfo-&gt;GetEvaluationID())\n\
  {\n\
    mEvaluateId = pEvaluateInfo-&gt;GetEvaluationID();\n\
  \n\
    //The character marker set.\n\
    if(TargetCharacter-&gt;InputType == kFBCharacterInputMoCap)\n\
    {\n\
      // Simple logic that retargets the goal <a href=\"javascript:void(0)\" data-symbol=\"state\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/structstate.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">state</a> into the skeleton.\n\
      <a href=\"javascript:void(0)\" data-symbol=\"FBCharacterMarkerSet\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_character_marker_set.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacterMarkerSet</a>* lMarkerSet = TargetCharacter-&gt;GetCharacterMarkerSet();\n\
      if(lMarkerSet)\n\
      {\n\
        FBControlSetState*  lFKState = TargetCharacter-&gt;GetControlSetEvaluationCache(pEvaluateInfo);\n\
        FBEffectorSetState*  lIKState = TargetCharacter-&gt;GetEffectorEvaluationCache(pEvaluateInfo);\n\
        lMarkerSet-&gt;ReadCtrlSetAndEffectorState(lFKState,lIKState,pEvaluateInfo);\n\
  \n\
        // Plotting directly to the control rig is not implemented (check the HIK sample for implementation details)\n\
        //const <a href=\"javascript:void(0)\" data-symbol=\"bool\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#af6a258d8f3ee5206d682d799316314b1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">bool</a> lPlotToRig = (TargetCharacter-&gt;InputType == kFBCharacterOutputMarkerSet || \n\
        //TargetCharacter-&gt;IsPlottingActorToCtrlRig());\n\
\n\
        <a href=\"javascript:void(0)\" data-symbol=\"FBMatrix\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_matrix.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMatrix</a>  lGX;\n\
        <a href=\"javascript:void(0)\" data-symbol=\"FBMatrix\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_matrix.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMatrix</a>  lCtr2Skeleton;\n\
        FBRVector  lROffset;\n\
\n\
        for(<a href=\"javascript:void(0)\" data-symbol=\"int\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/code_8h.html#aa4332194bf83cd22038ee4511e4decea&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">int</a> lBodyNodeId = kFBHipsNodeId; lBodyNodeId &lt; kFBLastNodeId; lBodyNodeId++)\n\
        {\n\
          // Get the global matrix for the body <a href=\"javascript:void(0)\" data-symbol=\"node\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/node_8h.html#addb697c9bca6f8981a870daa4953af4f&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">node</a> in the control rig space.\n\
          lFKState-&gt;GetNodeMatrix((<a href=\"javascript:void(0)\" data-symbol=\"FBBodyNodeId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_body_node_id.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBBodyNodeId</a>)lBodyNodeId, lGX);\n\
\n\
          // Conversion from the control rig to the skeleton space.\n\
          TargetCharacter-&gt;GetROffset((<a href=\"javascript:void(0)\" data-symbol=\"FBBodyNodeId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_body_node_id.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBBodyNodeId</a>)lBodyNodeId, &amp;lROffset);\n\
          <a href=\"javascript:void(0)\" data-symbol=\"FBRotationToMatrix\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga782488097fa4c031793413a9368bcf8e&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBRotationToMatrix</a>(lCtr2Skeleton, lROffset);\n\
          <a href=\"javascript:void(0)\" data-symbol=\"FBMatrixMult\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga1edce7b465175483dff856a6135be8e3&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMatrixMult</a>(lGX, lGX, lCtr2Skeleton);\n\
\n\
          // <a href=\"javascript:void(0)\" data-symbol=\"Write\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_h_i_k2014_2humanik_2hikdump_8h.html#a1d1ad5167f4ec48974c454e18a0a4ca9&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Write</a> the \"solve\" to the skeleton\n\
          mNodes[lBodyNodeId].<a href=\"javascript:void(0)\" data-symbol=\"Write\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_h_i_k2014_2humanik_2hikdump_8h.html#a1d1ad5167f4ec48974c454e18a0a4ca9&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Write</a>(lGX, pEvaluateInfo, (lBodyNodeId == kFBHipsNodeId));\n\
        }\n\
      }\n\
    }\n\
  AnimationNodesOutDisableIfNotWritten(pEvaluateInfo);\n\
  }\n\
  return <a href=\"javascript:void(0)\" data-symbol=\"true\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#af6a258d8f3ee5206d682d799316314b1a08f175a5505a10b9ed657defeb050e4b&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">true</a>;\n\
}\n\
\n\
struct AnimationNodeMapping\n\
{\n\
  <a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a>*  mModel;\n\
  \n\
  <a href=\"javascript:void(0)\" data-symbol=\"FBAnimationNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_animation_node.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBAnimationNode</a>*  mT;\n\
  <a href=\"javascript:void(0)\" data-symbol=\"FBAnimationNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_animation_node.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBAnimationNode</a>*  mR;\n\
  <a href=\"javascript:void(0)\" data-symbol=\"FBAnimationNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_animation_node.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBAnimationNode</a>*  mS;\n\
\n\
  AnimationNodeMapping()\n\
  {\n\
  Clear();\n\
  }\n\
\n\
  ~AnimationNodeMapping()\n\
  {\n\
  Clear();\n\
  }\n\
\n\
  void Clear()\n\
  {\n\
    mModel = <a href=\"javascript:void(0)\" data-symbol=\"NULL\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/kaydara_8h.html#a070d2ce7b6bb7e5c05602aa8c308d0c4&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">NULL</a>;\n\
    mT = mR = mS = <a href=\"javascript:void(0)\" data-symbol=\"NULL\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/kaydara_8h.html#a070d2ce7b6bb7e5c05602aa8c308d0c4&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">NULL</a>;\n\
  }\n\
\n\
  <a href=\"javascript:void(0)\" data-symbol=\"bool\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#af6a258d8f3ee5206d682d799316314b1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">bool</a> Valid() {return mModel != <a href=\"javascript:void(0)\" data-symbol=\"NULL\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/kaydara_8h.html#a070d2ce7b6bb7e5c05602aa8c308d0c4&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">NULL</a>;}\n\
  \n\
  void Setup(<a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a>* pModel, <a href=\"javascript:void(0)\" data-symbol=\"FBConstraint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_constraint.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConstraint</a>* pConstraint, <a href=\"javascript:void(0)\" data-symbol=\"int\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/code_8h.html#aa4332194bf83cd22038ee4511e4decea&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">int</a> pIndex=0);\n\
\n\
  void <a href=\"javascript:void(0)\" data-symbol=\"Write\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_h_i_k2014_2humanik_2hikdump_8h.html#a1d1ad5167f4ec48974c454e18a0a4ca9&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Write</a>(<a href=\"javascript:void(0)\" data-symbol=\"FBMatrix\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_matrix.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMatrix</a>&amp; pMatrix, <a href=\"javascript:void(0)\" data-symbol=\"FBEvaluateInfo\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_evaluate_info.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBEvaluateInfo</a>* pEvaluateInfo, <a href=\"javascript:void(0)\" data-symbol=\"bool\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#af6a258d8f3ee5206d682d799316314b1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">bool</a> pWriteT=<a href=\"javascript:void(0)\" data-symbol=\"false\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#af6a258d8f3ee5206d682d799316314b1ae9de385ef6fe9bf3360d1038396b884c&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">false</a>, <a href=\"javascript:void(0)\" data-symbol=\"bool\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#af6a258d8f3ee5206d682d799316314b1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">bool</a> pWriteR=<a href=\"javascript:void(0)\" data-symbol=\"true\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#af6a258d8f3ee5206d682d799316314b1a08f175a5505a10b9ed657defeb050e4b&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">true</a>, <a href=\"javascript:void(0)\" data-symbol=\"bool\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#af6a258d8f3ee5206d682d799316314b1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">bool</a> pWriteS=<a href=\"javascript:void(0)\" data-symbol=\"false\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#af6a258d8f3ee5206d682d799316314b1ae9de385ef6fe9bf3360d1038396b884c&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">false</a>);\n\
};\n\
 \n\
void ORCharacterSolver_Custom::AnimationNodeMapping::Setup(<a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a>* pModel, <a href=\"javascript:void(0)\" data-symbol=\"FBConstraint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_constraint.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConstraint</a>* pConstraint, <a href=\"javascript:void(0)\" data-symbol=\"int\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/code_8h.html#aa4332194bf83cd22038ee4511e4decea&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">int</a> pIndex)\n\
{\n\
  mModel = pModel;\n\
  if(mModel)\n\
  {\n\
    mT = pConstraint-&gt;AnimationNodeInCreate(pIndex, mModel, <a href=\"javascript:void(0)\" data-symbol=\"ANIMATIONNODE_TYPE_TRANSLATION\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/fbdata_8h.html#ad028286cbd5236e6861369feb0458a0b&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">ANIMATIONNODE_TYPE_TRANSLATION</a>);\n\
    mR = pConstraint-&gt;AnimationNodeInCreate(pIndex, mModel, <a href=\"javascript:void(0)\" data-symbol=\"ANIMATIONNODE_TYPE_ROTATION\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/fbdata_8h.html#acfa83cb52082517f2265fe1ce60ba002&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">ANIMATIONNODE_TYPE_ROTATION</a>);\n\
    mS = pConstraint-&gt;AnimationNodeInCreate(pIndex, mModel, <a href=\"javascript:void(0)\" data-symbol=\"ANIMATIONNODE_TYPE_SCALING\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/fbdata_8h.html#ab84746adbe5ef689aa58e90da4bf6598&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">ANIMATIONNODE_TYPE_SCALING</a>);\n\
  }\n\
}\n\
\n\
void ORCharacterSolver_Custom::AnimationNodeMapping::Write( <a href=\"javascript:void(0)\" data-symbol=\"FBMatrix\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_matrix.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMatrix</a>&amp; pMatrix, <a href=\"javascript:void(0)\" data-symbol=\"FBEvaluateInfo\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_evaluate_info.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBEvaluateInfo</a>* pEvaluateInfo,\n\
     <a href=\"javascript:void(0)\" data-symbol=\"bool\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#af6a258d8f3ee5206d682d799316314b1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">bool</a> pWriteT, <a href=\"javascript:void(0)\" data-symbol=\"bool\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#af6a258d8f3ee5206d682d799316314b1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">bool</a> pWriteR, <a href=\"javascript:void(0)\" data-symbol=\"bool\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#af6a258d8f3ee5206d682d799316314b1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">bool</a> pWriteS )\n\
{\n\
  if(Valid())\n\
  {\n\
    FBTVector lT;\n\
    FBRVector lR;\n\
    <a href=\"javascript:void(0)\" data-symbol=\"FBSVector\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_s_vector.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSVector</a> lS;\n\
    <a href=\"javascript:void(0)\" data-symbol=\"FBMatrixToTRS\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#gaf899f613397165e818a3750087e6e2ff&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMatrixToTRS</a>(lT, lR, lS, pMatrix);\n\
\n\
    if(pWriteT &amp;&amp; mT) mT-&gt;WriteData(lT.mValue,pEvaluateInfo);\n\
    if(pWriteR &amp;&amp; mR) mR-&gt;WriteData(lR.mValue,pEvaluateInfo);\n\
    if(pWriteS &amp;&amp; mS) mS-&gt;WriteData(lS.mValue,pEvaluateInfo);\n\
  }\n\
}\n\
\n\
struct Node\n\
{\n\
  <a href=\"javascript:void(0)\" data-symbol=\"FBBodyNodeId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_body_node_id.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBBodyNodeId</a>    mStartNode;\n\
  <a href=\"javascript:void(0)\" data-symbol=\"FBBodyNodeId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_body_node_id.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBBodyNodeId</a>    mEndNode;\n\
  \n\
  <a href=\"javascript:void(0)\" data-symbol=\"FBAnimationNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_animation_node.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBAnimationNode</a>*  mReadT;\n\
  <a href=\"javascript:void(0)\" data-symbol=\"FBAnimationNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_animation_node.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBAnimationNode</a>*  mWriteT;\n\
  double    mLength;\n\
  \n\
  Node(<a href=\"javascript:void(0)\" data-symbol=\"FBBodyNodeId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_body_node_id.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBBodyNodeId</a> pNodeA, <a href=\"javascript:void(0)\" data-symbol=\"FBBodyNodeId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_body_node_id.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBBodyNodeId</a> pNodeB)\n\
  {\n\
    mStartNode = pNodeA;\n\
    mEndNode = pNodeB;\n\
    Clear();\n\
  }\n\
  ~Node()\n\
  {\n\
    Clear();\n\
  }\n\
\n\
  void ReferenceAdd(<a href=\"javascript:void(0)\" data-symbol=\"FBCharacter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_character.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacter</a>* pCharacter, <a href=\"javascript:void(0)\" data-symbol=\"FBConstraint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_constraint.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConstraint</a>* pConstraint, <a href=\"javascript:void(0)\" data-symbol=\"int\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/code_8h.html#aa4332194bf83cd22038ee4511e4decea&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">int</a> pGroup);\n\
\n\
  void Setup(<a href=\"javascript:void(0)\" data-symbol=\"FBCharacter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_character.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacter</a>* pCharacter, <a href=\"javascript:void(0)\" data-symbol=\"FBConstraint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_constraint.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConstraint</a>* pConstraint, <a href=\"javascript:void(0)\" data-symbol=\"int\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/code_8h.html#aa4332194bf83cd22038ee4511e4decea&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">int</a> pIndex);\n\
\n\
  void Clear()\n\
  {\n\
    mReadT = <a href=\"javascript:void(0)\" data-symbol=\"NULL\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/kaydara_8h.html#a070d2ce7b6bb7e5c05602aa8c308d0c4&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">NULL</a>;\n\
    mWriteT = <a href=\"javascript:void(0)\" data-symbol=\"NULL\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/kaydara_8h.html#a070d2ce7b6bb7e5c05602aa8c308d0c4&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">NULL</a>;\n\
    mLength = 1e10;\n\
  }\n\
\n\
  void Solve(<a href=\"javascript:void(0)\" data-symbol=\"FBCharacter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_character.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacter</a>* pCharacter, <a href=\"javascript:void(0)\" data-symbol=\"FBConstraint\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_constraint.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConstraint</a>* pConstraint, <a href=\"javascript:void(0)\" data-symbol=\"FBEvaluateInfo\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_evaluate_info.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBEvaluateInfo</a>* pEvaluateInfo);\n\
};</pre></div>\n\
         <p><a name=\"GUID-549AB2E3-6A1D-4263-AE52-0407E555D038\"></a>You can refer to the full <span class=\"filePath\" translate=\"no\">CustomMarkerSolver</span> sample at <a href=\"http://area.autodesk.com/downloads/plugins/sample_plug_ins_for_the_flexible_mocap_workflow\" target=\"_blank\">http://area.autodesk.com/downloads/plugins/sample_plug_ins_for_the_flexible_mocap_workflow</a>. \n\
         </p>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";