var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-B6AE7E61-8D2C-4A21-95A4-5721CCE02431\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Smoothing Keys using Filters</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-B6AE7E61-8D2C-4A21-95A4-5721CCE02431\"></a><div class=\"head\">\n\
            <h1>Smoothing Keys using Filters</h1>\n\
         </div>\n\
         <p><a name=\"GUID-6EABFDDA-1011-4740-AA90-BF6D1E00FCFD\"></a> This topic shows how to smooth keys using filters. To follow the instructions, download\n\
            the file and script from <a href=\"http://area.autodesk.com/downloads/scripts/motionbuilder-animation-scripts\" target=\"_blank\">http://area.autodesk.com/downloads/scripts/motionbuilder-animation-scripts</a>. <a name=\"OL_D3638E8B0E2E4B1D85B307E664ECD658\"></a><ol type=\"1\" start=\"1\">\n\
               <li> Open the <span class=\"filePath\" translate=\"no\">filters_butterworth.fbx</span> file in MotionBuilder. <a name=\"FIG_4E09ED7F4C1C49BA8D31FCA5422B15A4\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-A5E7E87E-7E07-4230-B8ED-23941F385315-low.png\"></div> \n\
               </li>\n\
               <li>Run the <span class=\"filePath\" translate=\"no\">filters_butterworth.py</span> script to remove the noise in the FCurve. The FCurves appear smooth as shown in the\n\
                  following figure. <a name=\"FIG_100928BB14084DA2B035B910A6577C7A\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-4FE2D038-1844-4549-A4D6-84DB5C7DE10D-low.png\"></div> \n\
               </li>\n\
            </ol> \n\
         </p>\n\
         <p><a name=\"GUID-51D940C9-D8E5-4373-B1C8-CF9E1F7240E0\"></a>You can use the other filters in a similar way as explained in this topic. You need\n\
            to do the following: <a name=\"OL_6C2F96412887425F8C7256057A60DBEB\"></a><ol type=\"1\" start=\"1\">\n\
               <li>Create a filter using <span class=\"code\" translate=\"no\">FBFilterManager().CreateFilter (\'&lt;Filter’<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> <a href=\"javascript:void(0)\" data-symbol=\"Name\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a3e9f22c154a65956ebd413d2d8dafc0f&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Name</a>&gt;\')</span>. \n\
               </li>\n\
               <li>Set the properties using <span class=\"code\" translate=\"no\">lFilter.PropertyList.Find (‘&lt;Property <a href=\"javascript:void(0)\" data-symbol=\"Name\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a3e9f22c154a65956ebd413d2d8dafc0f&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Name</a>&gt;\').Data = &lt;Property Value&gt;</span>. \n\
               </li>\n\
               <li>Set the start and stop time using <span class=\"code\" translate=\"no\">lFilter.Start = <a href=\"javascript:void(0)\" data-symbol=\"FBTime\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_time.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_time.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTime</a>(0, 0, 0, 15)</span>. \n\
               </li>\n\
               <li>Execute the filter using <span class=\"code\" translate=\"no\">lFilter.Apply (&lt;FCurve_Node_Object&gt;, True)</span>. \n\
               </li>\n\
            </ol> \n\
         </p>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";