var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-BD11FE18-5969-44D2-906C-4DEFAEE61D97\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Utility Classes</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-BD11FE18-5969-44D2-906C-4DEFAEE61D97\"></a><div class=\"head\">\n\
            <h1>Utility Classes</h1>\n\
         </div>\n\
         <p><a name=\"WS1A9193826455F5FF6DEA2AA512298434427-7AEE\"></a>Utility classes provide multi-purpose tools to create plugins for MotionBuilder. They\n\
            are math functions, I/O classes, and array management classes providing ready-to-go\n\
            usable classes for any plugin based on the MotionBuilder architecture. \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_7BAEEDF7E6CD4F1ABE4FA9B84E0D87D7\"></a> \n\
            <h2><a name=\"GUID-01805D62-365F-483B-A677-83D1BA4216C6\"></a>Playback\n\
            </h2> \n\
            <p><a name=\"GUID-4848A05D-7D19-4E55-B6A1-C03AB0D3F460\"></a>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPlayerControl\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_player_control.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_player_control.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPlayerControl</a></span> class lets you manipulate the transport controls (play, stop, step, loop) of animations.\n\
               \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_8D8DEF90DF674DF5BA816FD5D9173C04\"></a> \n\
            <h2><a name=\"GUID-CD0F3799-806C-4C3A-A60F-F44A50A108B6\"></a>Dynamic Arrays\n\
            </h2> \n\
            <p><a name=\"GUID-1D2FCB32-F9EF-4A99-876B-E3CD3CE56269\"></a>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBArrayTemplate\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_array_template.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBArrayTemplate</a></span> class alleviates the C++ memory management problems of dynamic arrays. It is optimized\n\
               to work with MotionBuilder. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_C831B7FDAC474035A4C8000EF47384B6\"></a> \n\
            <h2><a name=\"GUID-AA5E7896-5CBF-472A-B8DF-AD02CDA2DD9E\"></a>Communication\n\
            </h2> \n\
            <p><a name=\"GUID-2A094443-964B-499B-BEB3-16AD5CC37BDA\"></a>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"fbio.h\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/fbio_8h.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">fbio.h</a></span> header file defines the communication classes: <a name=\"UL_66FB28760ABB4223A25F344E82705AD0\"></a><ul>\n\
                  <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBTCPIP\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_t_c_p_i_p.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTCPIP</a></span> - Socket-based networking communication. Allows for blocking, non-blocking and datagram\n\
                     packet communication. \n\
                  </li>\n\
                  <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCommPort\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_comm_port.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCommPort</a></span> - Fully configurable serial port communication. \n\
                  </li>\n\
               </ul> \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_035634470D90473BA389D5D7F3E670E0\"></a> \n\
            <h2><a name=\"GUID-3ED24FFF-F9EC-4685-AEB8-C4EF09AA8D0A\"></a>Mathematics\n\
            </h2> \n\
            <p><a name=\"GUID-4EF073A4-D1BF-4A13-AA2B-4F7D07A4AC0C\"></a>Vector and matrix manipulation functions such as <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBAdd()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a0933605b1557ebdc3c30942d97032ed2&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga3d89e7ebf98292cb4e4a9092d15dc236&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBAdd()</a></span>, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBDot()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a226016a40cf1f7946281fb032ede0918&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga4fac6d26ad0101dddac33770bc6b5787&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBDot()</a></span>, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBMult()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a787620a4a4288e716adcb7841bd45450&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga5681901b5a13f9a59efbb3b6317a730e&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMult()</a></span>, and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBMatrixInverse()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a5b120ce070624389cc1d744a568cb31e&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#gab42ef24eb4d80a1fd011f1ca609f3e20&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMatrixInverse()</a></span> are contained in the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"fbmath.h\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/fbmath_8h.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">fbmath.h</a></span> header file. They are also accessible from the <span class=\"code\" translate=\"no\">pyfbsdk</span> module. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_4E91D171552143E2843297246DF1870E\"></a> \n\
            <h2><a name=\"GUID-E370E21C-3C11-4BBF-BB09-FB5BA465584F\"></a>Media\n\
            </h2> \n\
            <p><a name=\"GUID-C36EF278-4677-4340-B923-F5588EDBDD2B\"></a>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBVideo\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_video.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_video.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVideo</a></span> class serves as the base class for media in MotionBuilder. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_152CA108D2694231BC4164A7A2C52693\"></a> \n\
            <h2><a name=\"GUID-20471E5F-A13A-4794-A63D-41FBAB540846\"></a>Images\n\
            </h2> \n\
            <p><a name=\"GUID-47897671-F9E4-41CA-A123-E4D019614E4C\"></a>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBImage\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_image.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_image.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBImage</a></span> class can be used to load and manipulate image data from disk or from memory. \n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";