var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-BE331C90-3722-44F3-AA52-6781D82778D4\">\n\
      <meta name=\"contextid\" content=\"API_TECHNICAL_SUPPORT\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Information and Technical Support</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-BE331C90-3722-44F3-AA52-6781D82778D4\"></a><div class=\"head\">\n\
            <h1> Information and Technical Support</h1>\n\
         </div>\n\
         <p><a name=\"GUID-B710DCDF-EB6F-4E60-AFE9-C54973611418\"></a>Several sources of information are available for MotionBuilder SDK users, including\n\
            the \n\
            		<a href=\"http://www.autodesk.com/motionbuilder\" target=\"_blank\">Autodesk MotionBuilder website</a>, the MotionBuilder SDK Programmer\'s Guide, the C++ Reference, the Python Reference,\n\
            the Autodesk Developer Network, and the AREA discussion forums. \n\
            	 \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_9104596F36484B1491F3B50AA4A2EB87\"></a> \n\
            <h2><a name=\"GUID-7D7AED68-4909-417A-A740-B6DBFA6625CC\"></a>MotionBuilder SDK Programmer\'s Guide\n\
            </h2> \n\
            <p><a name=\"GUID-378C7E63-783E-42BF-8954-85658BBDC4B9\"></a>The document you are currently reading is the MotionBuilder SDK Programmer\'s Guide.\n\
               Its purpose is to get you familiar with key concepts in the MotionBuilder SDK. Its\n\
               topics point you towards insightful \n\
               		  <span class=\"char_link\"><a href=\"#!/url=./files/GUID-E3631806-1B7C-419E-A7BA-0B1FBA8CED8C.htm\">Sample Programs</a></span> and relevant documentation within the MotionBuilder SDK C++ and Python Reference\n\
               Guides. \n\
               		\n\
            </p> \n\
            <div><a name=\"GUID-990D4F5B-C632-46C6-87EA-F9E35A08025D\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span> <em class=\"strong\">The majority of the code samples in this Programmer\'s Guide are written in Python\n\
                     to facilitate their readability and ease of execution. The MotionBuilder Python API\n\
                     is largely generated from the MotionBuilder C++ API, and therefore supports analogous\n\
                     method signatures.</em> \n\
               </div>\n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_3BD64B1C830046C7AD5A71C2FD332CA7\"></a> \n\
               <h3><a name=\"GUID-4474DC11-449C-4332-98D0-F2836A3570A8\"></a>C++\n\
               </h3> \n\
               <p><a name=\"GUID-3EAC80E9-0A0C-4DD4-A6C8-33B6C1FC0F3B\"></a>The C++ Reference contains the API documentation for the \n\
                  			 <em class=\"strong\">Open Reality SDK</em>. It includes descriptions and parameters for the API\'s classes, member functions,\n\
                  enums, etc. \n\
                  		  \n\
               </p> \n\
               <p><a name=\"GUID-F7B4B12B-7778-4B16-AF2F-0C77DF3B3D03\"></a>OR SDK sample code is located in the following directory: \n\
                  			 \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">&lt;MotionBuilder Installation Directory&gt;/OpenRealitySDK/samples</pre></div> \n\
               </p> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_BE62D72C92E0431995C8707943CE5BA2\"></a> \n\
               <h3><a name=\"GUID-8F557287-E450-45E1-86D7-11545ADACC5D\"></a>Python\n\
               </h3> \n\
               <p><a name=\"GUID-9378D76F-3BB7-4EF0-8CB9-ABFC3EF6823F\"></a>The Python Reference contains the API documentation for the \n\
                  			 <em class=\"strong\">pyfbsdk</em> Python module. It includes descriptions and parameters for the API\'s classes, methods,\n\
                  etc. \n\
                  		  \n\
               </p> \n\
               <p><a name=\"GUID-E5CA66C6-C666-45BD-91DB-FB13A3736689\"></a>MotionBuilder Python sample code is located in the following directory: \n\
                  			 \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">&lt;MotionBuilder Installation Directory&gt;/bin/config/Scripts\n\
</pre></div> \n\
               </p> \n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_6F02595A09124C11B6819083EA413792\"></a> \n\
            <h2><a name=\"GUID-794DD457-6F3D-4850-820B-BBAC83881081\"></a>External Resources and Tutorials\n\
            </h2> \n\
            <p><a name=\"GUID-9A12B357-4420-4BC6-932D-B23BFF5E3575\"></a>Python.org provides a wealth of information about the Python programming language:\n\
               \n\
               		  <a href=\"http://www.python.org\" target=\"_blank\">www.python.org</a>. \n\
               		\n\
            </p> \n\
            <p><a name=\"GUID-4FB37501-08DD-4176-A74C-D1C3F4B3BC99\"></a>Several Python books are also available: \n\
               		\n\
            </p> <a name=\"UL_01640910340B40A4B99073915D9CB135\"></a><ul>\n\
               <li>Learning Python by Mark Lutz and David Ascher \n\
                  		  \n\
               </li>\n\
               <li>Programming Python by Mark Lutz \n\
                  		  \n\
               </li>\n\
               <li>Dive into Python by Mark Pilgrim \n\
                  		  \n\
               </li>\n\
            </ul> \n\
            <p><a name=\"GUID-8DF670B6-D5FC-4A3C-B440-9353386DC3E6\"></a>Consult the following user-created MotionBuilder Python tutorials for additional insight\n\
               into the functionality of the MotionBuilder SDK. \n\
               		\n\
            </p> <a name=\"UL_FA242D91F0A34C0698A5BF65679DC5C3\"></a><ul>\n\
               <li>Creating Interactive MotionBuilder User Interface Tools by Christopher Evans: \n\
                  			 <a href=\"http://chrisevans3d.com/tutorials/mbui.htm\" target=\"_blank\">http://chrisevans3d.com/tutorials/mbui.htm</a>. \n\
                  		  \n\
               </li>\n\
               <li>MotionBuilder Driven Key Importer by Jason Parks: \n\
                  			 <a href=\"http://www.jason-parks.com/Pipeline_Tools/MotionBuilder_Scripts.html\" target=\"_blank\">http://www.jason-parks.com/Pipeline_Tools/MotionBuilder_Scripts.html</a>. \n\
                  		  \n\
               </li>\n\
            </ul> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_D3E20F5552844C38BD3074F3D3FB8F8C\"></a> \n\
            <h2><a name=\"GUID-FD0CD16A-DCA3-490A-8E0A-271FF1C8BE6D\"></a>Autodesk Developer Network\n\
            </h2> \n\
            <p><a name=\"GUID-63B34D4C-0A82-4B3F-8B28-16B523CD30CD\"></a>Technical support for the MotionBuilder SDK is provided through the Autodesk Developer\n\
               Network (ADN). The ADN program is based on an annual membership fee. Program details,\n\
               benefits, and pricing are found on the \n\
               		  <a href=\"http://www.autodesk.com/adn\" target=\"_blank\">Autodesk Developer Center</a> web page. \n\
               		\n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_F24A375D5D534D5E982657261592E6CC\"></a> \n\
            <h2><a name=\"GUID-D10FC063-4E73-41A8-BEBA-59AB078A3D7C\"></a>Discussion Forums\n\
            </h2> \n\
            <p><a name=\"GUID-07969005-9533-4119-AB4B-C67219D5ACF6\"></a>The \n\
               		  <a href=\"http://area.autodesk.com/forum/autodesk-motionbuilder\" target=\"_blank\">Autodesk MotionBuilder AREA</a> forums provide a convenient hub for Autodesk users to discuss their ideas and solutions.\n\
               \n\
               		\n\
            </p> \n\
            <p><a name=\"GUID-DC447F23-274A-44FB-801D-0FD184A9C124\"></a>The C++ discussion forum can be found here: \n\
               		  <a href=\"http://area.autodesk.com/forum/autodesk-motionbuilder/open-reality/\" target=\"_blank\">area.autodesk.com/forum/autodesk-motionbuilder/open-reality/</a>. \n\
               		\n\
            </p> \n\
            <p><a name=\"GUID-6E66B32B-50B2-4165-8F11-8792C0C9BF9A\"></a>The Python discussion forum can be found here: \n\
               		  <a href=\"http://area.autodesk.com/forum/autodesk-motionbuilder/python/\" target=\"_blank\">area.autodesk.com/forum/autodesk-motionbuilder/python/</a>. \n\
               		\n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_9725010F2D7148788F52873D660213AE\"></a> \n\
            <h2><a name=\"GUID-4A18890C-1A91-463C-BD7A-4BF99D059579\"></a>The MotionBuilder Development Team\n\
            </h2> \n\
            <p><a name=\"GUID-70B7D44D-85BF-4A3C-819A-2B0A8020EC47\"></a>If you encounter an issue with MotionBuilder or a problem causes the application to\n\
               crash, you can submit a defect report at \n\
               		  <a href=\"http://www.autodesk.com/motionbuilder-bugreport\" target=\"_blank\">www.autodesk.com/motionbuilder-bugreport</a>. \n\
               		\n\
            </p> \n\
         </div>\n\
         <p><a name=\"GUID-17022286-DA77-42C2-9FF4-8938CF3534F6\"></a>The MotionBuilder Development team also welcomes your suggestions at \n\
            		<a href=\"http://www.autodesk.com/motionbuilder-sug\" target=\"_blank\">www.autodesk.com/motionbuilder-sug</a>. \n\
            	 \n\
         </p>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";