var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-BF84A2FE-D625-4A2D-9E1E-485B58711290\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Extraction Types</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-BF84A2FE-D625-4A2D-9E1E-485B58711290\"></a><div class=\"head\">\n\
            <h1>Extraction Types</h1>\n\
         </div>\n\
         <p><a name=\"GUID-43DFF489-433B-4D9D-85CA-7118D4B53B09\"></a> You can use these extraction types on a set of markers to get the rotation and translation\n\
            of a goal: position and rotate joint in markers, rotate joint in markers, and aim\n\
            joint at markers. The following figure shows the extraction types. \n\
         </p><a name=\"FIG_2EABA374F31641CC9E5DA77977873E8A\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-9E4205C1-218A-4BA2-9105-B039381182B7-low.png\"></div>\n\
         <div class=\"section\"><a name=\"SECTION_E59063C3EB1D48F1BFAA66D1C24C6467\"></a> \n\
            <h2><a name=\"GUID-0BEFF584-833A-4DC4-8BC3-4991B30B6F9C\"></a>Position and Rotate Joint in Markers\n\
            </h2> \n\
            <p><a name=\"GUID-262AA957-BF1A-4C03-9A7B-36EFD039813F\"></a>This extraction type requires at least three markers to be assigned to a joint. The\n\
               <em class=\"mild\">aim joint at markers</em> extraction type is used if less than three markers are assigned to the joint. \n\
            </p> \n\
            <p><a name=\"GUID-D278059F-C63D-44DE-8788-30B2C22FA4A2\"></a>You can extract a translation vector from a set of three markers by computing their\n\
               average. Rotation is extracted by creating a rotated referential from the three markers.\n\
               A vector is defined from the first marker to the second marker, and another vector\n\
               is defined from the first marker to the third marker. The cross product of these vectors\n\
               is the Z axis of the rotated referential. The sum of these two vectors is perpendicular\n\
               to the Z axis (by property of the cross product) and is used as the X axis of the\n\
               rotated referential. You can compute the Y axis as the cross product of the Z axis\n\
               and X axis. \n\
            </p> \n\
            <p><a name=\"GUID-4C7541D3-17C5-47B5-83B0-E5EC1207D66E\"></a>The rotation is not used directly as the goal rotation. When markers are assigned\n\
               to a joint, a snap offset is computed as the difference between the joint’s rotation\n\
               and translation and the extracted rotation and translation at snap time. These snap\n\
               offsets are used for computing the goal position and rotation at any time by simply\n\
               removing them from the extracted rotation and translation. \n\
            </p> \n\
            <p><a name=\"GUID-44AF51F4-7BAB-41CF-88CD-DAF37FD31743\"></a>If more than three markers are available for this extraction type, the extracted position\n\
               and rotation are averaged between all possible combinations of the three markers to\n\
               get the final extracted values. \n\
            </p> \n\
            <div><a name=\"GUID-D84696BB-83FB-4440-882D-92B5FF702FFB\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Rotations are averaged using the quaternion linear addition followed by normalization\n\
                  of the result. \n\
               </div>\n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_ED9A4C24885A4BA591736661211AECB8\"></a> \n\
            <h2><a name=\"GUID-E1976263-1393-4880-A84B-0C63A4B1FD20\"></a>Rotate Joint in Markers\n\
            </h2> \n\
            <p><a name=\"GUID-B17BC853-D5B4-433B-8264-2D2892FE7598\"></a>This extraction type computes the goal rotation in the same way as the <em class=\"mild\">position and rotate joint in markers</em> extraction type. \n\
            </p> \n\
            <p><a name=\"GUID-2B82C7DD-2FB4-4CB6-8B77-A42554B87255\"></a>However, instead of using markers to compute the goal position, this extraction type\n\
               uses hierarchical information from the character to position the goal at the same\n\
               place as its associated joint. Therefore, markers are only used to extract rotation\n\
               in this extraction type. \n\
            </p> \n\
            <p><a name=\"GUID-27F10B92-9873-4EC8-B1BC-64D9DA4E9A4F\"></a>The snap offsets are used in the same way as in the <em class=\"mild\">position and rotate joint in markers</em> extraction type for computing the actual goal rotation. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_17F09696EB414A0E8CAB51E5334718C9\"></a> \n\
            <h2><a name=\"GUID-732EAAC5-40A8-4BB6-A699-E82F1CEF9F5C\"></a>Aim Joint at Markers\n\
            </h2> \n\
            <p><a name=\"GUID-F4EA1483-C09B-4609-8739-B35C88F1D115\"></a>This extraction type can take only two markers to extract the rotation. The joint\n\
               position from the hierarchy (as in the <em class=\"mild\">rotate joint in markers</em> extraction type) is used as a third point to extract the rotation as in other extraction\n\
               types. Like other extraction types, snap offsets are used for computing the actual\n\
               goal rotation. \n\
            </p> \n\
            <p><a name=\"GUID-D8C38135-E885-474D-BCE4-B118F5649D9D\"></a>If this extraction type is used because less than three markers are assigned in the\n\
               <em class=\"mild\">position and rotate joint in markers</em> extraction type, the position extracted from the set of points composed by the two\n\
               markers and the joint position from the hierarchy is used as the extracted position.\n\
               This might be different than the joint position from the hierarchy if the three points\n\
               do not perfectly respect a rigid body constraint. \n\
            </p> \n\
            <p><a name=\"GUID-E66EFFC3-4017-4B5B-9A49-3158DAD2AEE9\"></a>The extraction is performed from the root of the hierarchy (the hips joint) and it\n\
               propagates down the hierarchy. For this reason, the hips joint must always use the\n\
               <em class=\"mild\">position and rotate joint in markers</em> extraction type so that it is properly positioned. After the hips are positioned,\n\
               anything down the hierarchy can either use the position information from the extraction\n\
               (use the <em class=\"mild\">Position and rotation joint in marker</em> extraction type) or use the position from the hierarchy (use the <em class=\"mild\">rotate joint in marker</em> or <em class=\"mild\">aim joint at marker</em> extraction type). \n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";