var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-C2628485-D0B8-4985-9EF5-745D1BB4253B\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Shaders</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-C2628485-D0B8-4985-9EF5-745D1BB4253B\"></a><div class=\"head\">\n\
            <h1>Shaders</h1>\n\
         </div>\n\
         <p><a name=\"WS1A9193826455F5FF-3D980B8612487088DED-7C71\"></a>Like materials and textures, shaders control the surface appearance of models. Unlike\n\
            a texture, which is simply an image file stretched or tiled across an object, a shader\n\
            gives your objects descriptive properties like shadowing or reflectivity. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF-3D980B8612487088DED-7C70\"></a>Shaders are real-time shading plugins, altering the appearance of models in the scene.\n\
            With Open Reality you can add new shaders to MotionBuilder. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF-3D980B8612487088DED-7C6F\"></a>To build the samples cgshader and cgshaderfractal you need the Cg header files and\n\
            libraries provided by the Cg Toolkit 3.0. The DLLs are provided in the MotionBuilder\n\
            bin folder, or they can be downloaded from NVIDIA. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF-3D980B8612487088DED-7C6E\"></a>The project files will need to be modified to reflect the location of the headers\n\
            and library files. For the linker step you will also need to add cg.lib and cgGL.lib\n\
            as additional dependencies under the input tab. \n\
         </p><a name=\"WS1A9193826455F5FF-3D980B8612487088DED-7C6C\"></a><p class=\"list-intro\"><a name=\"WS1A9193826455F5FF-3D980B8612487088DED-7C6B\"></a>To see a shader:\n\
         </p>\n\
         <ol type=\"1\" start=\"1\">\n\
            <li>Add a model to the scene, e.g. Asset Browser &gt; Elements &gt; Primitives &gt; Cube. </li>\n\
            <li>From Asset Browser &gt; Shaders, drag a shader onto the model. </li>\n\
         </ol><a name=\"GUID-8A80F7E3-6232-4099-8EDC-12A20581F885\"></a><h2><a name=\"GUID-E698DA97-C616-410E-9B24-B3954BDA1453\"></a>Sample shaders:\n\
         </h2>\n\
         <dl>\n\
            <dt><a name=\"WS1A9193826455F5FF-3D980B8612487088DED-7C68\"></a><span class=\"term\"><a name=\"WS1A9193826455F5FF-3D980B8612487088DED-7C67\"></a>cgshader</span></dt>\n\
            <dd>\n\
               <div class=\"definition\"><a name=\"WS1A9193826455F5FF-3D980B8612487088DED-7C66\"></a> \n\
                  <p><a name=\"WS1A9193826455F5FF-3D980B8612487088DED-7C65\"></a>Simple Cg vertex shader. Requires Cg Toolkit 3.0. \n\
                  </p> \n\
               </div>\n\
            </dd>\n\
            <dt><a name=\"WS1A9193826455F5FF-3D980B8612487088DED-7C64\"></a><span class=\"term\"><a name=\"WS1A9193826455F5FF-3D980B8612487088DED-7C63\"></a>cgshaderfractal</span></dt>\n\
            <dd>\n\
               <div class=\"definition\"><a name=\"WS1A9193826455F5FF-3D980B8612487088DED-7C62\"></a> \n\
                  <p><a name=\"WS1A9193826455F5FF-3D980B8612487088DED-7C61\"></a>More complex Cg shader.A pixel shader that uses the Mandelbrot set fractals. Requires\n\
                     Cg Toolkit 3.0. \n\
                  </p> \n\
               </div>\n\
            </dd>\n\
            <dt><a name=\"WS1A9193826455F5FF-3D980B8612487088DED-7C60\"></a><span class=\"term\"><a name=\"WS1A9193826455F5FF-3D980B8612487088DED-7C5F\"></a>shader_template</span></dt>\n\
            <dd>\n\
               <div class=\"definition\"><a name=\"WS1A9193826455F5FF-3D980B8612487088DED-7C5E\"></a> \n\
                  <p><a name=\"WS1A9193826455F5FF-3D980B8612487088DED-7C5D\"></a>Simple template for creating new shaders. It is a simple lit shader, the same as the\n\
                     default shader used in the software. \n\
                  </p> \n\
               </div>\n\
            </dd>\n\
            <dt><a name=\"WS1A9193826455F5FF-3D980B8612487088DED-7C5C\"></a><span class=\"term\"><a name=\"WS1A9193826455F5FF-3D980B8612487088DED-7C5B\"></a>shaderscreen</span></dt>\n\
            <dd>\n\
               <div class=\"definition\"><a name=\"WS1A9193826455F5FF-3D980B8612487088DED-7C5A\"></a> \n\
                  <p><a name=\"WS1A9193826455F5FF-3D980B8612487088DED-7C59\"></a>Draws triangles at model vertices. Draws triangles in screen coordinates at model\n\
                     vertices. \n\
                  </p> \n\
               </div>\n\
            </dd>\n\
            <dt><a name=\"WS1A9193826455F5FF-3D980B8612487088DED-7C58\"></a><span class=\"term\"><a name=\"WS1A9193826455F5FF-3D980B8612487088DED-7C57\"></a>shadertexmat</span></dt>\n\
            <dd>\n\
               <div class=\"definition\"><a name=\"WS1A9193826455F5FF-3D980B8612487088DED-7C56\"></a> \n\
                  <p><a name=\"WS1A9193826455F5FF-3D980B8612487088DED-7C55\"></a>Simple texture material shader that applies textures and materials with OpenGL. \n\
                  </p> \n\
               </div>\n\
            </dd>\n\
         </dl>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";