var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-DF39D862-D6CC-4706-BDA4-7125C46CAC28\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Spreadsheets</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-DF39D862-D6CC-4706-BDA4-7125C46CAC28\"></a><div class=\"head\">\n\
            <h1>Spreadsheets</h1>\n\
         </div>\n\
         <p><a name=\"WS1A9193826455F5FF-29C43AA61173633F416-5F59\"></a>Spreadsheets are data structures that function as traditional spreadsheets, but with\n\
            certain areas of the spreadsheets pre-defined and configured to contain extra data.\n\
            \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-751DE9951262947C01C-67E8\"></a>Set values with <span class=\"code\" translate=\"no\">FBSpread::SetCellValue()</span>. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF-E569A012180CE58914629\"></a>See the sample script Spread.py which shows how to create a tool with a spreadsheet.\n\
            \n\
         </p><a name=\"GUID-E9917E5B-7921-466D-BF93-CB118F2329EB\"></a><dl>\n\
            <dt><a name=\"WS1A9193826455F5FF-E569A012180CE5891462A\"></a><span class=\"term\"><a name=\"WS1A9193826455F5FF-E569A012180CE5891462B\"></a>Spread Parts</span></dt>\n\
            <dd>\n\
               <div class=\"definition\"><a name=\"WS1A9193826455F5FF-E569A012180CE5891462C\"></a> \n\
                  <p><a name=\"WS1A9193826455F5FF-E569A012180CE5891462D\"></a>The class <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBSpreadPart\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_spread_part.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSpreadPart</a></span> can be used to represent any element of a spreadsheet. All of the objects in a spreadsheet\n\
                     inherit from this class, giving any element in the spreadsheet common characteristics.\n\
                     \n\
                  </p> \n\
               </div>\n\
            </dd>\n\
            <dt><a name=\"WS1A9193826455F5FF-E569A012180CE5891462E\"></a><span class=\"term\"><a name=\"WS1A9193826455F5FF-E569A012180CE5891462F\"></a>Header Row</span></dt>\n\
            <dd>\n\
               <div class=\"definition\"><a name=\"WS1A9193826455F5FF-E569A012180CE58914630\"></a> \n\
                  <p><a name=\"WS1A9193826455F5FF-E569A012180CE58914631\"></a>The header row is the top row of the spreadsheet. It can be clicked or selected, and\n\
                     it can contain titles. The header row does not have all of the spread cell properties\n\
                     that data cells have. \n\
                  </p> \n\
               </div>\n\
            </dd>\n\
            <dt><a name=\"WS1A9193826455F5FF-E569A012180CE58914632\"></a><span class=\"term\"><a name=\"WS1A9193826455F5FF-E569A012180CE58914633\"></a>Column-1</span></dt>\n\
            <dd>\n\
               <div class=\"definition\"><a name=\"WS1A9193826455F5FF-E569A012180CE58914634\"></a> \n\
                  <p><a name=\"WS1A9193826455F5FF-E569A012180CE58914635\"></a>Column-1 is the first column of row titles in the spreadsheet. It has special aspects\n\
                     that are slightly different in functionality from the other columns in the spreadsheet.\n\
                     \n\
                  </p> \n\
               </div>\n\
            </dd>\n\
            <dt><a name=\"WS1A9193826455F5FF-E569A012180CE58914636\"></a><span class=\"term\"><a name=\"WS1A9193826455F5FF-E569A012180CE58914637\"></a>Data cells</span></dt>\n\
            <dd>\n\
               <div class=\"definition\"><a name=\"WS1A9193826455F5FF-E569A012180CE58914638\"></a> \n\
                  <p><a name=\"WS1A9193826455F5FF-29C43AA61173633F416-5F51\"></a>The data cells, depending on the settings for that particular cell, can contain and\n\
                     display various elements. The <span class=\"code\" translate=\"no\">CellType</span> property determines which variable is to be displayed. \n\
                  </p> \n\
                  <p><a name=\"WS1A9193826455F5FF-29C43AA61173633F416-5F50\"></a>In the following example, setting the style causes the spread cell to display the\n\
                     contents of its double variable: <span class=\"code\" translate=\"no\">mSpread.GetCell(0,1).Style = <a href=\"javascript:void(0)\" data-symbol=\"kFBCellStyleDouble\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a0ed82888060d50879df365ef3089620aa903a34d48efcd70dbe770e79a535b2e9&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">kFBCellStyleDouble</a>;</span> \n\
                  </p> \n\
                  <p><a name=\"WS1A9193826455F5FF-29C43AA61173633F416-5F4F\"></a>However, the various values in a cell do not use a common memory space, so cells can\n\
                     contain values of different types (integer, double, etc.). \n\
                  </p> \n\
               </div>\n\
            </dd>\n\
         </dl>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";