var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-E6E1AA38-B59E-4A4A-B558-07D5BC5F4878\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Optical devices</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-E6E1AA38-B59E-4A4A-B558-07D5BC5F4878\"></a><div class=\"head\">\n\
            <h1>Optical devices</h1>\n\
         </div>\n\
         <p><a name=\"WS1A9193826455F5FF6DEA2AA512298434427-7C7B\"></a>Optical devices are input devices that include optical data (such as occlusion), with\n\
            specific tools to deal with this type of data. Tracking data from a device is mapped\n\
            onto a MotionBuilder character. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF6DEA2AA512298434427-7BFD\"></a>The first step is to derive the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBDeviceOptical\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_device_optical.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_device_optical.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBDeviceOptical</a></span> class, and then build the marker set, based on the configuration of the device. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF6DEA2AA512298434427-7BFB\"></a> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBDeviceOptical\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_device_optical.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_device_optical.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBDeviceOptical</a></span> manages an optical marker set represented as a list of optical markers stored in\n\
            <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBDeviceOptical::Markers\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_device_optical.html#a8a61f3e31d1040c39b59d8fb9b353573&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBDeviceOptical::Markers</a></span>. These markers have position (X,Y,Z) and occlusion (0) data associated with them.\n\
            They represent the physical sensors of your optical device. \n\
         </p><a name=\"WS1A9193826455F5FF6DEA2AA512298434427-7BFA\"></a><p class=\"list-intro\"><a name=\"WS1A9193826455F5FF6DEA2AA512298434427-7BF9\"></a>You should set up your marker set in the functions that get called the initialization\n\
            commands:\n\
         </p>\n\
         <ul>\n\
            <li> <span class=\"code\" translate=\"no\">kOpStart</span> \n\
            </li>\n\
            <li> <span class=\"code\" translate=\"no\">kOpReset</span> \n\
            </li>\n\
         </ul>\n\
         <p><a name=\"WS1A9193826455F5FF6DEA2AA512298434427-7BF6\"></a>The marker set construction calls must happen between calls to <span class=\"code\" translate=\"no\">DeviceOpticalBeginSetup()</span> and<span class=\"code\" translate=\"no\"> DeviceOpticalEndSetup()</span>. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF6DEA2AA512298434427-7BF5\"></a>Markers must have a unique name. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF6DEA2AA512298434427-7BF4\"></a>Each marker has a dirty flag called <span class=\"code\" translate=\"no\">IsUsed</span>. When set to true, it confirms that the marker is active. When false, MotionBuilder\n\
            ignores this marker when setting up the device (on a <span class=\"code\" translate=\"no\">DeviceOpticalEndSetup() </span>call). This flag is useful in the optical device and user interface support dynamic\n\
            during the addition or removal of markers to/from an existing marker set. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF6DEA2AA512298434427-7BF3\"></a> <span class=\"code\" translate=\"no\">DeviceOpticalBeginSetup()</span> sets all <span class=\"code\" translate=\"no\">IsUsed</span> flags to false. When <span class=\"code\" translate=\"no\">DeviceOpticalEndSetup() </span>is called, the base class deletes the connectors and unbinds the markers that have\n\
            an <span class=\"code\" translate=\"no\">IsUsed</span> flag set to false. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF6DEA2AA512298434427-7BF2\"></a>If you execute <span class=\"code\" translate=\"no\">Markers.Add(“<a href=\"javascript:void(0)\" data-symbol=\"name\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#afcd1706c9144e6d6eee6127661ae3be2&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">name</a>”)</span> with the name of a marker already in the list, the marker will not be added twice.\n\
            If the dirty flag <span class=\"code\" translate=\"no\">IsUsed</span> is set to false, <span class=\"code\" translate=\"no\">Markers.Add()</span> is reset to true. You can therefore use the <span class=\"code\" translate=\"no\">Markers.Add()</span> function to reconfirm the activeness of a marker. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF6DEA2AA512298434427-7BF0\"></a>To add Rigid bodies to the input from an optical device, it is possible to use the\n\
            class <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelOptical\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_optical.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_optical.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelOptical</a></span>, which contains a list of rigid bodies to add to the optical model when the sets\n\
            are configured. \n\
         </p><a name=\"WS1A9193826455F5FF6DEA2AA512298434427-7BEF\"></a><p class=\"list-intro\"><a name=\"WS1A9193826455F5FF6DEA2AA512298434427-7BEE\"></a>To create a rigid body:\n\
         </p>\n\
         <ol type=\"1\" start=\"1\">\n\
            <li>Get a handle on the optical model for the device. </li>\n\
            <li>Declare an object of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a9d6981bf7ab5733ef19f626563ef3fde&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_list.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelList</a></span>. \n\
            </li>\n\
            <li>Add markers to this list, using their name. </li>\n\
            <li>Make sure to set the marker position before adding them. </li>\n\
            <li>Add the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a9d6981bf7ab5733ef19f626563ef3fde&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_list.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelList</a></span> object to the optical model rigid bodies list. \n\
            </li>\n\
         </ol>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelOptical\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_optical.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelOptical</a>* lOptical = (HFBModelOptical) (HFBModel) ModelOptical;\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBModelList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_list.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelList</a> lList;\n\
for( <a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a> = 0; <a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a> &lt; lMarkerCount; <a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a>++ )\n\
{\n\
HFBModel lModel =  \n\
FBFindModelByName( lName[<a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a>] );\n\
lModel-&gt;SetVector( lSnapPos[<a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a>],  \n\
kModelTranslation, <a href=\"javascript:void(0)\" data-symbol=\"true\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#af6a258d8f3ee5206d682d799316314b1a08f175a5505a10b9ed657defeb050e4b&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">true</a> );\n\
lList.Add( lModel );\n\
}\n\
lOptical-&gt;RigidBodies.Add( lList, “MyRigidBody” );</pre></div>\n\
         <p><a name=\"WS1A9193826455F5FF6DEA2AA512298434427-7BE6\"></a>All data streaming and recording functionality is contained in a single function in\n\
            the case of an optical device, removing the need to manage <span class=\"code\" translate=\"no\">DeviceIONotify</span> and <span class=\"code\" translate=\"no\">AnimationNodeNotify</span>. \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">FBDeviceOptical::DeviceOpticalEvalAll\n\
Markers()</pre></div>\n\
         <p><a name=\"WS1A9193826455F5FF6DEA2AA512298434427-7BE5\"></a>Support for the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBDevice::DeviceIONotify()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_device.html#a65922344760a5f44851818f211ca6526&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBDevice::DeviceIONotify()</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBDevice::AnimationNodeNotify()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_device.html#a1761a25ebcc79ff01a370535fef51336&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBDevice::AnimationNodeNotify()</a></span> calls are implemented by the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBDeviceOptical\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_device_optical.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_device_optical.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBDeviceOptical</a></span> base class using the data supplied by <span class=\"code\" translate=\"no\">DeviceOpticalEvalAllMarkers()</span>. The base class calls this function at 30 Hz for NTSC or at 25 Hz for PAL. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF6DEA2AA512298434427-7BE3\"></a> <span class=\"code\" translate=\"no\">DeviceOpticalRecordFrame</span> sets a given maker’s position to [x,y,z] and its occlusion to 0. Once all markers\n\
            have been updated with their current position and occlusion values, a single call\n\
            to DeviceOpticalRecordFrame() enters the data in MotionBuilder for a given local time.\n\
            \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">Markers[<a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a>]-&gt;SetData( <a href=\"javascript:void(0)\" data-symbol=\"x\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#a280f2393c503127fff91ecbc558e288d&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">x</a>,y,z,<a href=\"javascript:void(0)\" data-symbol=\"o\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a70a0763575096c5545f2232a32ec302a&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">o</a> );</pre></div>\n\
         <p><a name=\"WS1A9193826455F5FF6DEA2AA512298434427-7B8B\"></a> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelOptical\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_optical.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_optical.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelOptical</a></span> provides the interface for configuring an optical device. This model is created when\n\
            a model binding is instanced from the device driver of an optical device. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF6DEA2AA512298434427-7B89\"></a>You can use <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBRigidBody\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_rigid_body.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_rigid_body.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBRigidBody</a></span> to access rigid body functionality. Attributes of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBRigidBody\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_rigid_body.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_rigid_body.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBRigidBody</a></span> list associated marker names and initial positions. The initial positions are used\n\
            to calculate the relative positions that the markers in the rigid body should have\n\
            in respect to each other. For an example of how to use rigid bodies with optical models,\n\
            see [MotionBuilder program directory]\\OpenRealitySDK\\Samples\\devices\\deviceoptical.\n\
            \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF6DEA2AA512298434427-7B83\"></a>The following code shows how to set a key inside a gap on an optical marker model\n\
            and then position the value (once InsertControlKey keys a default value). \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">\n\
\n\
void ORTool_Template::EventExecute_C_ButtonClick( HISender pSender, HKEvent pEvent )\n\
// Callback for Button \"Execute C\"\n\
{ __FUNCOUT\n\
ExportModel( <a href=\"javascript:void(0)\" data-symbol=\"FBSystem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem</a>().SceneRootModel );\n\
}\n\
\n\
void ORTool_Template::ExportModel( HFBModel pModel)\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"FBTrace\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/group___f_b_trace.html#ga532c4b1e58f5799cf4561346b7200549&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#gabff3bea6577707a2053a1bea331b04b3&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTrace</a> (\"in the function exportModel\\<a href=\"javascript:void(0)\" data-symbol=\"n\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/longobject_8h.html#a0a1cb627ccae562872efc91e5b752be1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">n</a>\");\n\
    <a href=\"javascript:void(0)\" data-symbol=\"FBTime\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_time.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTime</a> lTime = <a href=\"javascript:void(0)\" data-symbol=\"FBTime\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_time.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTime</a>(0,0,0,11);\n\
\n\
	   // Grabs the Scene Component\n\
    <a href=\"javascript:void(0)\" data-symbol=\"FBTrace\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/group___f_b_trace.html#ga532c4b1e58f5799cf4561346b7200549&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#gabff3bea6577707a2053a1bea331b04b3&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTrace</a>(pModel-&gt;<a href=\"javascript:void(0)\" data-symbol=\"Name\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a3e9f22c154a65956ebd413d2d8dafc0f&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Name</a>);     \n\
\n\
	   // Getting the children of the Scene\n\
   	for(<a href=\"javascript:void(0)\" data-symbol=\"int\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/code_8h.html#aa4332194bf83cd22038ee4511e4decea&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">int</a> <a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a>=0;<a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a>&lt; pModel-&gt;Children.GetCount();<a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a>++) \n\
    {\n\
		      // Grabs the optical component\n\
        <a href=\"javascript:void(0)\" data-symbol=\"FBTrace\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/group___f_b_trace.html#ga532c4b1e58f5799cf4561346b7200549&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#gabff3bea6577707a2053a1bea331b04b3&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTrace</a>(pModel-&gt;Children[<a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a>]-&gt;<a href=\"javascript:void(0)\" data-symbol=\"Name\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a3e9f22c154a65956ebd413d2d8dafc0f&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Name</a>); \n\
\n\
      		// Do special processing if optical component is of <a href=\"javascript:void(0)\" data-symbol=\"type\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/node_8h.html#ac765329451135abec74c45e1897abf26&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">type</a> <a href=\"javascript:void(0)\" data-symbol=\"FBModelOptical\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_optical.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelOptical</a>\n\
        if (pModel-&gt;Children[<a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a>]-&gt;<a href=\"javascript:void(0)\" data-symbol=\"Is\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#aeae2807c86997ffad2fa6d972a29ee1fa4e8f1adb83ee0775de17ed3aba6d45c0&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Is</a>(FBModelOptical::TypeInfo)) \n\
        {\n\
            <a href=\"javascript:void(0)\" data-symbol=\"FBTrace\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/group___f_b_trace.html#ga532c4b1e58f5799cf4561346b7200549&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#gabff3bea6577707a2053a1bea331b04b3&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTrace</a>(\"1.--&gt;Model is an <a href=\"javascript:void(0)\" data-symbol=\"FBModelOptical\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_optical.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelOptical</a> \\<a href=\"javascript:void(0)\" data-symbol=\"n\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/longobject_8h.html#a0a1cb627ccae562872efc91e5b752be1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">n</a>\");\n\
\n\
            // Cast the <a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a> as an FBModelOptical. \n\
	         		// The reason I need this is later I need to SetModelOptical, so \n\
         			// I need the parent of lHMarkerOptical which is this lHOptical.\n\
            HFBModelOptical lHOptical = (HFBModelOptical)pModel-&gt;Children[<a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a>];\n\
            \n\
	         		// Gets the selected marker, in this case it\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> M_RightShin (??!)\n\
            <a href=\"javascript:void(0)\" data-symbol=\"FBModelList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_list.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelList</a> lModelList;\n\
            <a href=\"javascript:void(0)\" data-symbol=\"FBGetSelectedModels\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#gafd7afc537327ebfd99dc4b41d08ed90b&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBGetSelectedModels</a>( lModelList );\n\
            <a href=\"javascript:void(0)\" data-symbol=\"int\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/code_8h.html#aa4332194bf83cd22038ee4511e4decea&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">int</a> <a href=\"javascript:void(0)\" data-symbol=\"count\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a8f9bd2e8322b1ca9128fbfca71322230&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">count</a> = lModelList.GetCount();\n\
            for( <a href=\"javascript:void(0)\" data-symbol=\"int\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/code_8h.html#aa4332194bf83cd22038ee4511e4decea&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">int</a> j = 0; j &lt; <a href=\"javascript:void(0)\" data-symbol=\"count\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a8f9bd2e8322b1ca9128fbfca71322230&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">count</a>; j++ )\n\
            {\n\
                HFBModel lModel = lModelList[j];\n\
                char* <a href=\"javascript:void(0)\" data-symbol=\"name\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#afcd1706c9144e6d6eee6127661ae3be2&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">name</a> = lModel-&gt;<a href=\"javascript:void(0)\" data-symbol=\"Name\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a3e9f22c154a65956ebd413d2d8dafc0f&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Name</a>;\n\
                <a href=\"javascript:void(0)\" data-symbol=\"FBTrace\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/group___f_b_trace.html#ga532c4b1e58f5799cf4561346b7200549&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#gabff3bea6577707a2053a1bea331b04b3&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTrace</a>( \"Model is : %<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a>\\<a href=\"javascript:void(0)\" data-symbol=\"n\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/longobject_8h.html#a0a1cb627ccae562872efc91e5b752be1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">n</a>\", <a href=\"javascript:void(0)\" data-symbol=\"name\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#afcd1706c9144e6d6eee6127661ae3be2&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">name</a> );\n\
\n\
            				// The M_RightShin component is of <a href=\"javascript:void(0)\" data-symbol=\"type\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/node_8h.html#ac765329451135abec74c45e1897abf26&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">type</a> <a href=\"javascript:void(0)\" data-symbol=\"FBModelMarkerOptical\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_marker_optical.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelMarkerOptical</a>\n\
                if( lModel-&gt;<a href=\"javascript:void(0)\" data-symbol=\"Is\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#aeae2807c86997ffad2fa6d972a29ee1fa4e8f1adb83ee0775de17ed3aba6d45c0&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Is</a>(FBModelMarkerOptical::TypeInfo) )\n\
                {\n\
	               				// Cast the model to <a href=\"javascript:void(0)\" data-symbol=\"type\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/node_8h.html#ac765329451135abec74c45e1897abf26&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">type</a> <a href=\"javascript:void(0)\" data-symbol=\"FBModelMarkerOptical\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_marker_optical.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelMarkerOptical</a>\n\
                    HFBModelMarkerOptical lHMarkerOptical = (HFBModelMarkerOptical)lModel; \n\
\n\
                    // Getting the Segments, because you have to get the segments to get the gaps <a href=\"javascript:void(0)\" data-symbol=\"count\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a8f9bd2e8322b1ca9128fbfca71322230&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">count</a> to renew\n\
                    lHMarkerOptical-&gt;SetModelOptical(lHOptical);\n\
                    <a href=\"javascript:void(0)\" data-symbol=\"FBTrace\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/group___f_b_trace.html#ga532c4b1e58f5799cf4561346b7200549&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#gabff3bea6577707a2053a1bea331b04b3&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTrace</a>(\"Marker Segment Count is %<a href=\"javascript:void(0)\" data-symbol=\"d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/pystrtod_8h.html#aebc55cdba1447f899efca30032620f9e&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">d</a>\\<a href=\"javascript:void(0)\" data-symbol=\"n\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/longobject_8h.html#a0a1cb627ccae562872efc91e5b752be1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">n</a>\", lHMarkerOptical-&gt;Segments.GetCount());\n\
\n\
               					// Now the gap <a href=\"javascript:void(0)\" data-symbol=\"count\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a8f9bd2e8322b1ca9128fbfca71322230&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">count</a> doesn\'t return 0 but the actual value...\n\
                    <a href=\"javascript:void(0)\" data-symbol=\"FBTrace\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/group___f_b_trace.html#ga532c4b1e58f5799cf4561346b7200549&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#gabff3bea6577707a2053a1bea331b04b3&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTrace</a>(\"Marker Gap Count is %<a href=\"javascript:void(0)\" data-symbol=\"d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/pystrtod_8h.html#aebc55cdba1447f899efca30032620f9e&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">d</a>\\<a href=\"javascript:void(0)\" data-symbol=\"n\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/longobject_8h.html#a0a1cb627ccae562872efc91e5b752be1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">n</a>\", lHMarkerOptical-&gt;Gaps.GetCount()); \n\
\n\
                    <a href=\"javascript:void(0)\" data-symbol=\"FBPlayerControl\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_player_control.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPlayerControl</a>().Goto(<a href=\"javascript:void(0)\" data-symbol=\"FBTime\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_time.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTime</a>(0, 0, 0, 11));\n\
\n\
	               				// Evaluate the scene \n\
                    <a href=\"javascript:void(0)\" data-symbol=\"FBSystem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem</a>().Scene-&gt;Evaluate();\n\
                    \n\
	               				// Inserts gap <a href=\"javascript:void(0)\" data-symbol=\"key\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#ada6705808cbd8c921df38387db9a6aee&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">key</a> at a default location....\n\
                    lHMarkerOptical-&gt;Gaps[1].InsertControlKey(lTime);\n\
                    <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a> <a href=\"javascript:void(0)\" data-symbol=\"pos\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/dictobject_8h.html#acae77df04bfdd60d1017f4132729ddc6&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">pos</a>(-100.0, 0.0, 0.0);\n\
                    lHMarkerOptical-&gt;Translation = <a href=\"javascript:void(0)\" data-symbol=\"pos\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/dictobject_8h.html#acae77df04bfdd60d1017f4132729ddc6&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">pos</a>;\n\
\n\
                    // Evaluate the scene again (why?!!)\n\
                    <a href=\"javascript:void(0)\" data-symbol=\"FBSystem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem</a>().Scene-&gt;Evaluate();\n\
	                <a href=\"javascript:void(0)\" data-symbol=\"FBPlayerControl\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_player_control.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPlayerControl</a>().Key();\n\
                }\n\
            }\n\
        }\n\
    }\n\
}\n\
</pre></div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";