var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-F2831E07-6692-49BC-887F-6E744DFBD4E4\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>FBMaterial and FBTexture - Materials and Textures</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-F2831E07-6692-49BC-887F-6E744DFBD4E4\"></a><div class=\"head\">\n\
            <h1>FBMaterial and FBTexture - Materials and Textures</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_994B1ACBD5F04D7696F9BD701850FF74\"></a> \n\
            <h2><a name=\"GUID-2A85B211-F552-400B-8599-E96B9B362159\"></a>FBMaterial\n\
            </h2> \n\
            <p><a name=\"GUID-5FBC11E4-7E5C-4707-976B-D50D43100F35\"></a>Materials are encapsulated by the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBMaterial\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_material.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_material.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMaterial</a></span> class. Instances of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBMaterial\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_material.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_material.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMaterial</a></span> are added to an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a></span>\'s list of materials (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel.Materials\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model.html#a7d893a637288b857f860d26bf9dd3991&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel.Materials</a></span>) to define its emissive, ambient, diffuse, and specular color channels. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">cube = <a href=\"javascript:void(0)\" data-symbol=\"FBModelCube\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_cube.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelCube</a>(\'myCube\')\n\
cube.Show = True\n\
\n\
material = <a href=\"javascript:void(0)\" data-symbol=\"FBMaterial\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_material.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMaterial</a>(\'myMaterial\')\n\
material.Diffuse = <a href=\"javascript:void(0)\" data-symbol=\"FBColor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_color.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBColor</a>(0.17, 0.47, 0.8)\n\
cube.Materials.append(material)</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_50B851A270834D5FBCEDDBAB4D75A012\"></a> \n\
            <h2><a name=\"GUID-289E493D-F07F-4829-A8AD-1C07A95F5D49\"></a>FBTexture\n\
            </h2> \n\
            <p><a name=\"GUID-A26D4A2C-72AA-431B-A9C8-46E990FBFEFF\"></a>Textures are defined by the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBTexture\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_texture.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_texture.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTexture</a></span> class. The argument of the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBTexture\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_texture.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_texture.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTexture</a></span> constructor should consist of a valid path to an image or video file. MotionBuilder\n\
               supports the following media formats:<span class=\"code\" translate=\"no\">.avi, .bmp, .dds, .iff, .jpeg, .jpg, .memory, .mov, .mp2, .mp4, .mpeg, .mpg, .mpg2,\n\
                  .mpg4, .pic, .png, .rgb, .rgba, .sgi, .switcher, .tga, .tif, .tiff, and .yuv</span>. Instances of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBTexture\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_texture.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_texture.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTexture</a></span> can be blended together in an instance of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBLayeredTexture\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_layered_texture.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_layered_texture.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLayeredTexture</a></span>, and can thus be used as a new texture. \n\
            </p> \n\
            <p><a name=\"GUID-E2FEBC25-E988-4D54-83C0-5EA384D78E5E\"></a>Instances of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBTexture\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_texture.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_texture.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTexture</a></span> are typically associated to an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBMaterial\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_material.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_material.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMaterial</a></span> via <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBMaterial.SetTexture()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_material.html#a2e3ef0c6bd07507e95d1f75c369ba04e&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMaterial.SetTexture()</a></span>. The first argument of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBMaterial.SetTexture()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_material.html#a2e3ef0c6bd07507e95d1f75c369ba04e&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMaterial.SetTexture()</a></span> is an instance of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBTexture\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_texture.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_texture.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTexture</a></span>. The second argument determines the material channel on which the texture will be\n\
               used, for example: the emissive (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBMaterialTextureType.kFBMaterialTextureEmissive\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_material_texture_type.html#a4847ebc8c2a21c7cffb473dce7f832b4&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMaterialTextureType.kFBMaterialTextureEmissive</a></span>), ambient (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBMaterialTextureType.kFBMaterialTextureAmbient\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_material_texture_type.html#a3e94fbba6681ba601189bf71f37b2750&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMaterialTextureType.kFBMaterialTextureAmbient</a></span>), diffuse (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBMaterialTextureType.kFBMaterialTextureDiffuse\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_material_texture_type.html#ae5b5b32193f9aa7e1f5e21612d0534d5&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMaterialTextureType.kFBMaterialTextureDiffuse</a></span>), specular (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBMaterialTextureType.kFBMaterialTextureSpecular\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_material_texture_type.html#a3e07e239b7225c33c7af4717a9583378&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMaterialTextureType.kFBMaterialTextureSpecular</a></span>), bump map (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBMaterialTextureType.kFBMaterialTextureBump\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_material_texture_type.html#a9f351fd238ba29d87c4cb0049c5676f6&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMaterialTextureType.kFBMaterialTextureBump</a></span>), normal map (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBMaterialTextureType.kFBMaterialTextureNormalMap\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_material_texture_type.html#a337c40e2d699f313fdb778dc96ff0dde&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMaterialTextureType.kFBMaterialTextureNormalMap</a></span>), or transparency (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBMaterialTextureType.kFBMaterialTextureTransparent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_material_texture_type.html#a0bde841aad4a3232691dbe80b4623be7&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMaterialTextureType.kFBMaterialTextureTransparent</a></span>) channel. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\"># Create a layered texture, assign it to the diffuse channel\n\
# of a material, and apply the material to the model.\n\
def applyTextureToModel(pTextureFullPath, pModel):\n\
    # Create a texture and set its mapping type.\n\
    texture = <a href=\"javascript:void(0)\" data-symbol=\"FBTexture\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_texture.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTexture</a>(pTextureFullPath)\n\
    texture.Mapping = <a href=\"javascript:void(0)\" data-symbol=\"FBTextureMapping.kFBTextureMappingXY\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_texture_mapping.html#a71020acf6a68e1132f180147293def0b&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTextureMapping.kFBTextureMappingXY</a>\n\
    \n\
    # Associate the new texture to the diffuse channel of a new material.\n\
    material = <a href=\"javascript:void(0)\" data-symbol=\"FBMaterial\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_material.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMaterial</a>(\'myMaterial\')\n\
    material.SetTexture(texture, <a href=\"javascript:void(0)\" data-symbol=\"FBMaterialTextureType.kFBMaterialTextureDiffuse\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_material_texture_type.html#ae5b5b32193f9aa7e1f5e21612d0534d5&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMaterialTextureType.kFBMaterialTextureDiffuse</a>)\n\
    \n\
    # Append the material to the model\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> list of materials.\n\
    pModel.Materials.append(material)</pre></div> \n\
            <p><a name=\"GUID-0CE5E469-5406-4C03-AF30-96965CFCC986\"></a>A texture can be mapped in multiple ways onto an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a></span>, and can adopt different blending modes if used in an instance of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBLayeredTexture\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_layered_texture.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_layered_texture.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLayeredTexture</a></span>. The following table lists the possible values for these <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBTexture\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_texture.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_texture.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTexture</a></span> properties. These values are reflected in MotionBuilder\'s <span class=\"code\" translate=\"no\">Texture Settings</span> user interface element, and are described in greater detail in MotionBuilder\'s User\n\
               Guide. \n\
            </p> <a name=\"TABLE_D79DC66D880541449CFC95F1B7FAABB9\"></a><div class=\"table-ruled\">\n\
               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
                  <colgroup>\n\
                     <col width=\"28.729066597429576%\">\n\
                     <col width=\"71.27093340257042%\">\n\
                  </colgroup>\n\
                  <tr class=\"ruled-heading\">\n\
                     <th class=\"table-heading\">Property </th>\n\
                     <th class=\"table-heading\">Description </th>\n\
                  </tr>\n\
                  <tr class=\"ruled-odd-row\">\n\
                     <td class=\"table-body\"> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBTexture.Mapping\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_texture.html#aa978aeaebef3048bea62853b98a6221a&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTexture.Mapping</a></span> \n\
                     </td>\n\
                     <td class=\"table-body\">An <em class=\"strong\">enumeration value</em> (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBTextureMapping\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#afd607c0fc03ea4fad86daeed328a6fb2&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_texture_mapping.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTextureMapping</a></span>) used to control how the texture is mapped onto the surface of the model. The possible\n\
                        texture mapping values are: <a name=\"UL_B8F5CEF09F7047E2B85CE6FDC02C39C5\"></a><ul>\n\
                           <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBTextureMapping.kFBTextureMappingUV\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_texture_mapping.html#a39e5c5238f1f87f80b4152277a4dba59&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTextureMapping.kFBTextureMappingUV</a></span> \n\
                           </li>\n\
                           <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBTextureMapping.kFBTextureMappingXY\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_texture_mapping.html#a71020acf6a68e1132f180147293def0b&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTextureMapping.kFBTextureMappingXY</a></span> \n\
                           </li>\n\
                           <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBTextureMapping.kFBTextureMappingYZ\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_texture_mapping.html#a3a8c62c3718c3c7faf8fc758db37098e&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTextureMapping.kFBTextureMappingYZ</a></span> \n\
                           </li>\n\
                           <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBTextureMapping.kFBTextureMappingXZ\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_texture_mapping.html#af9315d56f257181269fb7bbc275ef6f7&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTextureMapping.kFBTextureMappingXZ</a></span> \n\
                           </li>\n\
                           <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBTextureMapping.kFBTextureMappingSpherical\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_texture_mapping.html#a2f4c902356c4f619e8391633b0346371&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTextureMapping.kFBTextureMappingSpherical</a></span> \n\
                           </li>\n\
                           <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBTextureMapping.kFBTextureMappingCylindrical\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_texture_mapping.html#a840322496fb4dd06e3a8e41335c084a7&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTextureMapping.kFBTextureMappingCylindrical</a></span> \n\
                           </li>\n\
                           <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBTextureMapping.kFBTextureMappingEnvironment\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_texture_mapping.html#a0e732ce84c383d472964321c61bcece0&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTextureMapping.kFBTextureMappingEnvironment</a></span> \n\
                           </li>\n\
                           <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBTextureMapping.kFBTextureMappingProjection\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_texture_mapping.html#af3d324336e3d8657b424c410ed5a9b96&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTextureMapping.kFBTextureMappingProjection</a></span> \n\
                           </li>\n\
                        </ul> \n\
                     </td>\n\
                  </tr>\n\
                  <tr class=\"ruled-even-row\">\n\
                     <td class=\"table-body\"> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBTexture.BlendMode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_texture.html#a8eba58dfff8d6958426a9dd0ae9503c9&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTexture.BlendMode</a></span> \n\
                     </td>\n\
                     <td class=\"table-body\">An <em class=\"strong\">enumeration value</em> (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBTextureBlendMode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#aacb09e7f08b9857ed251675fbe41caf3&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_texture_blend_mode.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTextureBlendMode</a></span>) used to control how the textures are blended if used in an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBLayeredTexture\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_layered_texture.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_layered_texture.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLayeredTexture</a></span>. The possible blending mode values are: <a name=\"UL_9987E471933D4490928EC4E7DF5D6C01\"></a><ul>\n\
                           <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBTextureBlendMode.kFBTextureBlendTranslucent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_texture_blend_mode.html#a2e67e155251a1ce418f8efcdf0bb744c&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTextureBlendMode.kFBTextureBlendTranslucent</a></span> \n\
                           </li>\n\
                           <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBTextureBlendMode.kFBTextureBlendAdditive\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_texture_blend_mode.html#a6f959620b9917bc0670588e36440f900&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTextureBlendMode.kFBTextureBlendAdditive</a></span> \n\
                           </li>\n\
                           <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBTextureBlendMode.kFBTextureBlendModulate\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_texture_blend_mode.html#afbcbac6915354d5fd2318f46c8400723&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTextureBlendMode.kFBTextureBlendModulate</a></span> \n\
                           </li>\n\
                           <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBTextureBlendMode.kFBTextureBlendModulate2\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_texture_blend_mode.html#a9dba4a0a8c677871796914ff4bb6cbd7&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTextureBlendMode.kFBTextureBlendModulate2</a></span> \n\
                           </li>\n\
                        </ul> \n\
                     </td>\n\
                  </tr>\n\
               </table>\n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_6CB014DE61C44811A047F07B63F94562\"></a> \n\
            <h2><a name=\"GUID-0A5D0023-A401-48B7-97EE-B535A6BF2DBF\"></a>Example: Applying a Texture to a Model\n\
            </h2> \n\
            <p><a name=\"GUID-7F876049-8306-4CFC-88F3-5C25F80B6149\"></a> <em class=\"strong\">Sample Viewport Output:</em> \n\
            </p> \n\
            <p><a name=\"GUID-297DB637-F3E7-40BD-8CB9-46287BF6BC21\"></a></p> <img src=\"images/GUID-AF3180A4-AD9E-4EAE-91C7-60B1AEBFA406-low.png\"> \n\
            <p><a name=\"GUID-98A1AD33-C749-4CFA-9A0B-384E7CF0565E\"></a> <em class=\"strong\">Texture File and Location:</em> <span class=\"code\" translate=\"no\">C:\\&lt;user&gt;\\Documents\\MB\\Face.png</span> \n\
            </p> <img src=\"images/GUID-D5002057-1625-4461-B053-5278526AFCE1-low.png\"> \n\
            <p><a name=\"GUID-72BA9EF4-CBB4-40FA-AA09-1025746D0994\"></a><em class=\"strong\">Program Summary:</em> The program below creates a cube model, and creates a texture from the \'<span class=\"code\" translate=\"no\">Face.png</span>\' file contained in the current user\'s <span class=\"code\" translate=\"no\">My Documents</span> folder. It then associates the texture to a new material\'s diffuse channel, and appends\n\
               the material to the model. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">from pyfbsdk import *\n\
import os\n\
\n\
# Get the texture file residing in the current user\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> My Documents\\MB folder.\n\
myDocuments = os.path.expanduser(\'~\') + \'\\Documents\\MB\' \n\
textureFilename = \'Face.png\'\n\
textureFullPath = os.path.join(myDocuments, textureFilename)\n\
\n\
###############################################################\n\
# Helper Function(<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a>).                                         #\n\
###############################################################\n\
\n\
# Create a sphere primitive from the asset browser.\n\
def createModel():    \n\
    model = <a href=\"javascript:void(0)\" data-symbol=\"FBCreateObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga6698333c163da7c3bc077537889b6c33&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCreateObject</a>( \'Browsing/Templates/Elements/Primitives\', \'Cube\', \'Cube\' )\n\
    model.Name = \'myModel\'\n\
    model.Translation = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(0, 75, 0)\n\
    model.Scaling = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(2, 2, 2)\n\
    model.Show = True\n\
    return model\n\
\n\
# Create a layered texture, assign it to the diffuse channel\n\
# of a material, and apply the material to the model.\n\
def applyTextureToModel(pTextureFullPath, pModel):\n\
    # Create a texture and set its mapping type.\n\
    texture = <a href=\"javascript:void(0)\" data-symbol=\"FBTexture\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_texture.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTexture</a>(pTextureFullPath)\n\
    texture.Mapping = <a href=\"javascript:void(0)\" data-symbol=\"FBTextureMapping.kFBTextureMappingXY\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_texture_mapping.html#a71020acf6a68e1132f180147293def0b&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTextureMapping.kFBTextureMappingXY</a>\n\
    \n\
    # Associate the new texture to the diffuse channel of a new material.\n\
    material = <a href=\"javascript:void(0)\" data-symbol=\"FBMaterial\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_material.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMaterial</a>(\'myMaterial\')\n\
    material.SetTexture(texture, <a href=\"javascript:void(0)\" data-symbol=\"FBMaterialTextureType.kFBMaterialTextureDiffuse\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_material_texture_type.html#ae5b5b32193f9aa7e1f5e21612d0534d5&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMaterialTextureType.kFBMaterialTextureDiffuse</a>)\n\
    \n\
    # Append the material to the model\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> list of materials.\n\
    pModel.Materials.append(material)\n\
    \n\
\n\
###############################################################\n\
# Main.                                                       #\n\
###############################################################\n\
# Clear the scene.\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a>().FileNew()\n\
\n\
# Create a model to which we will apply a texture.\n\
model = createModel()\n\
\n\
# Create a texture <a href=\"javascript:void(0)\" data-symbol=\"object\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#a904fdf014f8cdbefe8320ca2bfd6daf6&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">object</a> using the texture path declared at the top of this file,\n\
# and apply it to the model.\n\
material = applyTextureToModel(textureFullPath, model)</pre></div> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";