var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-F4D37550-F4DB-4DFF-A64E-AE4540B11D49\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Characterization</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-F4D37550-F4DB-4DFF-A64E-AE4540B11D49\"></a><div class=\"head\">\n\
            <h1>Characterization</h1>\n\
         </div>\n\
         <p><a name=\"GUID-42D741E5-4C23-47BC-A4C7-C2BAFBDDC26F\"></a> A character is considered to be characterized when the bone (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelSkeleton\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_skeleton.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_skeleton.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelSkeleton</a></span>) and model root (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelRoot\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_root.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_root.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelRoot</a></span>) instances are assigned to their slots. Following are the required slots: <span class=\"code\" translate=\"no\">HipsLink</span>, <span class=\"code\" translate=\"no\">LeftUpLegLink</span>, <span class=\"code\" translate=\"no\">LeftLegLink</span>, <span class=\"code\" translate=\"no\">LeftFootLink</span>, <span class=\"code\" translate=\"no\">RightUpLegLink</span>, <span class=\"code\" translate=\"no\">RightLegLink</span>, <span class=\"code\" translate=\"no\">RightFootLink</span>, <span class=\"code\" translate=\"no\">SpineLink</span>, <span class=\"code\" translate=\"no\">LeftArmLink</span>, <span class=\"code\" translate=\"no\">LeftForeArmLink</span>, <span class=\"code\" translate=\"no\">LeftHandLink</span>, <span class=\"code\" translate=\"no\">RightArmLink</span>, <span class=\"code\" translate=\"no\">RightForeArmLink</span>, <span class=\"code\" translate=\"no\">RightHandLink</span>, and <span class=\"code\" translate=\"no\">HeadLink</span>. \n\
         </p>\n\
         <p><a name=\"GUID-3244E501-A512-456B-ABFA-038EB706B27D\"></a>Before you characterize a model, it must be in a T-stance or rest pose facing the\n\
            positive Z-axis. For biped models, the rest pose is a stance with all the fingers\n\
            and thumbs in a straight position. For quadrupeds, it is a stance where the four limbs\n\
            and all the toes point towards the floor. Stance is important because when you characterize\n\
            a model, the current stance of the model is used as the starting pose. All future\n\
            movements are based on the starting pose. \n\
         </p>\n\
         <p><a name=\"GUID-362C4AF7-D688-46AC-BEBF-2CACAD820752\"></a>To follow the instructions in this section, download the files and scripts from <a href=\"http://area.autodesk.com/downloads/scripts/motionbuilder-animation-scripts\" target=\"_blank\">http://area.autodesk.com/downloads/scripts/motionbuilder-animation-scripts</a>. \n\
         </p>\n\
         <p><a name=\"GUID-AD632125-D837-46FF-A3BF-15030EC201BA\"></a>Open the <span class=\"filePath\" translate=\"no\">GremlinGreen_NoCharacterization.fbx</span> file in MotionBuilder and run the <span class=\"filePath\" translate=\"no\">character_characterization.py</span> script to see a full workflow for characterization. <a name=\"FIG_3FDE2F9C1ECE47F7B4C26BBBFE5AD5E1\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-018C0AC2-559E-46BB-9C49-7DFD26120313-low.png\"></div> \n\
         </p>\n\
         <p><a name=\"GUID-F6E9D32A-6C94-4C49-96FF-FA176B55FE20\"></a>Following are the points to keep in mind: <a name=\"UL_14D9A943607A4DEA88AD5C2F43D3929A\"></a><ul>\n\
               <li>The model instances must be assigned to their slots before characterization. The following\n\
                  code is used for linking the models to their slots. \n\
                  <div class=\"codeBlock\"><pre class=\"prettyprint\">property = characterObject.PropertyList.Find(slot + \"Link\")     \n\
property.append (myJoint)</pre></div> \n\
               </li>\n\
               <li>After the models link to their slots, you can turn on characterization using <span class=\"code\" translate=\"no\">lCharacter.SetCharacterizeOn(True)</span>. \n\
               </li>\n\
               <li> Base slots are mandatory for characterization. </li>\n\
            </ul> \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_65F440677056463CA372EAB0C312A06C\"></a> \n\
            <h2><a name=\"GUID-73547569-9AD7-4E68-B281-A5015049024E\"></a>Retargeting the Character Animation\n\
            </h2> \n\
            <p><a name=\"GUID-4B1303FD-C7AC-40D3-BDE8-5D948857CA23\"></a> Open the <span class=\"filePath\" translate=\"no\">GremlinGreen_AfterCharacterization_MergeMia.fbx</span> file and run the <span class=\"filePath\" translate=\"no\">character_create_input.py</span> script to set the character input of <em class=\"mild\">grem</em> to <em class=\"mild\">mia</em>. Setting the character input drives the <em class=\"mild\">grem</em> character using the animation in <em class=\"mild\">mia</em> as shown in the following figure. <a name=\"FIG_B46D1F1F7D0D4D0E94E6BC5BB9451536\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-5926EBB4-8D3A-44F5-9EF5-30E270EC870A-low.png\"></div> \n\
            </p> \n\
            <p><a name=\"GUID-5823C690-3F58-4089-B1B9-9353325A46F3\"></a>Following are the points to keep in mind: <a name=\"UL_CDA085E8A1104CFF9B2D8C029E4E2598\"></a><ul>\n\
                  <li><span class=\"code\" translate=\"no\">Character.ActiveInput</span> must be <em class=\"mild\">True</em> to drive a character using the control rig or marker set. \n\
                  </li>\n\
                  <li><span class=\"code\" translate=\"no\">FBSystem().Scene.Characters</span> returns a list of characters in a scene. \n\
                  </li>\n\
                  <li> <span class=\"code\" translate=\"no\">lCharacter.InputCharacter = lScene.Characters[0]</span> sets the input to another character in a scene. If the input character has animation,\n\
                     it is used for driving the animation. \n\
                  </li>\n\
               </ul> \n\
            </p> \n\
            <p><a name=\"GUID-0D2EECFE-8301-4105-9BEF-C7FDB3AE9759\"></a>Additionally, you can run the commented code in the <span class=\"code\" translate=\"no\">character_create_input.py</span> script to introduce other inputs like the control rig and marker set. <span class=\"code\" translate=\"no\">lCharacter.CreateControlRig(True)</span> creates the control rig for the character (<span class=\"code\" translate=\"no\">True</span> or <span class=\"code\" translate=\"no\">False</span> specifies whether to create a IK/FK or IK only control rig). The control rig is shown\n\
               in the following figure. <a name=\"FIG_84DC17EA496C4336AFDD1CBD4BACFD47\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-AD773BED-F193-44E5-A5D3-7E3EEAD7F194-low.png\"></div> \n\
            </p> \n\
            <p><a name=\"GUID-4D958F3C-9A85-4770-8E16-AE90AD3082F4\"></a>You can refer to the MotionBuilder online help for more information about the character\n\
               input types. \n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";