var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-F95213E8-643A-4416-8DD4-23EF01D7586C\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Modifying Character Animation using Effectors</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-F95213E8-643A-4416-8DD4-23EF01D7586C\"></a><div class=\"head\">\n\
            <h1>Modifying Character Animation using Effectors</h1>\n\
         </div>\n\
         <p><a name=\"GUID-C4FA78F3-3F8A-4A1E-A853-BBAE8E2209CE\"></a>Effectors are also called Inverse Kinematics (IK). Effectors are used in MotionBuilder\n\
            to easily manipulate a character skeleton and achieve realistic animation. Effectors\n\
            jointly influence the corresponding bones in a skeleton. The influence of an effector\n\
            on the bones is adjusted using the <span class=\"MenuCascade\" id=\"GUID-FA827FBB-D234-4843-8007-0B2286CE2E9C\">IK Blend</span> and <span class=\"MenuCascade\" id=\"GUID-35FC251F-68B6-4C0A-B9CA-D5DE3BBADF9E\">IK Pull</span>. <a name=\"FIG_388D9B23E1EC4C579EA771C13EDF44A4\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-27028D69-D8DB-41DA-A6E8-C4BC7D5F0079-low.png\"></div> \n\
         </p>\n\
         <p><a name=\"GUID-AF2B09C7-5674-4BC5-A12C-7F5164F5752E\"></a>Blend is used for measuring how much the corresponding bone reaches the effector without\n\
            pulling the whole body. Pull works when the bone cannot reach the effector. It measures\n\
            how much the corresponding bone pulls the body to the effector. Refer to the MotionBuilder\n\
            online help for more information about the <span class=\"MenuCascade\" id=\"GUID-742DECD6-EB64-4DCB-BD42-553B51D36F36\">IK Blend</span> and <span class=\"MenuCascade\" id=\"GUID-CA776A77-E440-448D-B625-4984055D8392\">IK Pull</span>. \n\
         </p>\n\
         <p><a name=\"GUID-C426FCC3-1487-43FF-8B9A-1D17C52A5363\"></a>To follow the instructions in this topic, download the files and script from <a href=\"http://area.autodesk.com/downloads/scripts/motionbuilder-animation-scripts\" target=\"_blank\">http://area.autodesk.com/downloads/scripts/motionbuilder-animation-scripts</a>. \n\
         </p>\n\
         <p><a name=\"GUID-447A726B-7EBD-4F4F-8AEF-51071ED56EB6\"></a>The <span class=\"code\" translate=\"no\">manipulate_ik.py</span> script shows how to modify the animation using effectors. Run the <span class=\"filePath\" translate=\"no\">manipulate_ik.py</span> script step by step as explained in the following section: \n\
         </p>\n\
         <p><a name=\"GUID-F9DF0D8D-491D-466B-AA87-1823DE727A7A\"></a> <a name=\"OL_3480246D5A8441179CDCB463CDF19B7E\"></a><ol type=\"1\" start=\"1\">\n\
               <li>Open the <span class=\"filePath\" translate=\"no\">mia_fkik_runstopturn.fbx</span> file in MotionBuilder. \n\
               </li>\n\
               <li>Run the following steps in the <span class=\"filePath\" translate=\"no\">manipulate_ik.py</span> script one by one. <a name=\"OL_96112E7747614EDBB60BFE38DAEFD0B0\"></a><ol type=\"1\" start=\"1\">\n\
                     <li>Create a new layer. </li>\n\
                     <li> Go to frame 25 (in play control). The wrist position looks as shown in the following\n\
                        figure. <a name=\"FIG_52A23EA30A7A4EEB97D29C180D0AB2F9\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-6A5DBC3D-10A0-4F1B-94E3-2F316ABA4035-low.png\"></div> \n\
                     </li>\n\
                     <li>Select the left wrist effector. </li>\n\
                     <li>Change the left wrist effector\'s IK Blend T to 100. </li>\n\
                     <li>Modify the left wrist effector\'s T value. </li>\n\
                     <li>Key character. The character\'s animation on the left wrist is changed around frame\n\
                        25 by creating a new key in the new layer as shown in the following figure. <a name=\"FIG_ED70BECA3E72473A847364CA1A946821\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-9A0FE098-E6CF-44DF-83A0-682370BEBC9C-low.png\"></div> \n\
                     </li>\n\
                  </ol> \n\
               </li>\n\
            </ol> \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_98502196CFA846BFA1AFC2BC15ACEB09\"></a> \n\
            <h2><a name=\"GUID-CB65C5E2-6DAD-4E70-A41A-65E9C32E84EB\"></a>Plotting Animation from the Control Rig to the Skeleton\n\
            </h2> \n\
            <p><a name=\"GUID-9EDEC6A0-1D8A-4A2C-A620-1C40332835A6\"></a>Characters can store animation in the skeleton and control rig. The skeleton and control\n\
               rig have many bones (joints) that contain animation in the T, R, and S channels (also\n\
               called FCurve node). The FCurve node contains the x, y, and z FCurves, which contain\n\
               the keys with the value, time, and key type information. In character plotting, the\n\
               keys are copied and pasted frame by frame from one FCurve to the other. \n\
            </p> \n\
            <p><a name=\"GUID-367903BC-06AC-4BF9-84E8-842AA076ECF7\"></a>The UI option for plotting is shown in the following figure. <a name=\"FIG_D04D663ACF154C86BA5F3D3F20D08FD7\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-AB78D766-8117-40EB-92E0-2B32C094E4A4-low.png\"></div> \n\
            </p> \n\
            <p><a name=\"GUID-5590C34D-FC0B-428B-A164-0685B62AF083\"></a>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCharacter::PlotAnimation()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_character.html#aa7381f797daad86e9a551279a15859e4&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacter::PlotAnimation()</a></span> function is used for plotting in the SDK. \n\
            </p> \n\
            <p><a name=\"GUID-87A2495E-73B1-408C-85BA-096DEA2B291E\"></a>Continue the scene in the <span class=\"char_link\"><a href=\"#!/url=./files/GUID-F95213E8-643A-4416-8DD4-23EF01D7586C.htm#GUID-2A278E6A-D43B-484E-9EFA-BB9DD66111EB\">Modifying Character Animation using Effectors</a></span> section. Follow these steps to merge and plot the character animation to the control\n\
               rig and skeleton. <a name=\"OL_07EEACDCA735452B9ED58548C34CD635\"></a><ol type=\"1\" start=\"1\">\n\
                  <li>Run the <span class=\"code\" translate=\"no\">merge_character_animation_in_layers.py</span> script to merge the animation in two layers into one layer, but this is still on\n\
                     the control rig. <a name=\"FIG_72A65F21DE07456DBE0B5A05D800C361\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-F28EC63A-07C4-463E-8155-CDDAF61D44D8-low.png\"></div> \n\
                     <p><a name=\"GUID-C8BF4A44-8216-437F-B8D2-89D78C810942\"></a>Select a bone in the skeleton. You will not find any animation. <a name=\"FIG_9DF5A4D2EB4D4449A9B9D9E07D021103\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-A18774D6-4B0D-4416-AE67-14F7A788FF99-low.png\"></div> \n\
                     </p> \n\
                  </li>\n\
                  <li>Run the <span class=\"code\" translate=\"no\">plot_character_animation_to_skeleton.py</span> script to plot the character’s animation from the control rig to the skeleton in\n\
                     the current take. <a name=\"FIG_F98B191B174D473F91BEE4D898222D03\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-EF0F326C-83BB-4C54-B6A4-73B4B4E07ADB-low.png\"></div> \n\
                     <p><a name=\"GUID-DF7E104F-F6AD-4680-96E7-D88BD24C81EA\"></a>Now, you can see that the bone for the character (<span class=\"code\" translate=\"no\">LeftForeArmRoll</span>) contains animation as shown in the following figure. If you select the character\'s\n\
                        input to <em class=\"mild\">None</em> (usually, the input is automatically changed to None), the character still moves\n\
                        when played. It indicates that the animation is plotted to the skeleton, and the character\n\
                        does not require any input to move. <a name=\"FIG_C045D1D9C94B4C0E96F488C5C7E8A99F\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-F259E0E7-EA44-4DE1-BCD8-29866203DD25-low.png\"></div> \n\
                     </p> \n\
                  </li>\n\
               </ol> \n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";