var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-FFBAE6DD-7929-4421-B7F3-4AEE50A2F0EB\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Rigid Body Physics</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-FFBAE6DD-7929-4421-B7F3-4AEE50A2F0EB\"></a><div class=\"head\">\n\
            <h1>Rigid Body Physics</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_465AD494D0004C98A3520435B0AA6B73\"></a> \n\
            <h2><a name=\"GUID-E4B9923E-6E93-477C-917F-ABD203712A00\"></a>Assigning Rigid Body Behavior\n\
            </h2> \n\
            <p><a name=\"GUID-47D1DE0A-6ECC-4140-A51D-6B86E551AFB3\"></a>Instances of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a></span> can be assigned to a Rigid Body Physical Property, allowing them to react to forces\n\
               such as gravity. Models connected to a Rigid Body Physical Property can also collide\n\
               among each other, as well as with the scene\'s ground plane. \n\
            </p> \n\
            <p><a name=\"GUID-BCBBF084-5E5E-4D38-BBEC-E7D2BE19CD3E\"></a>A Rigid Body Physical Property object is instantiated via <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCreateObject()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a5111370ada05db17e04b97b447ddbd7c&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga6698333c163da7c3bc077537889b6c33&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCreateObject()</a></span>, using the <span class=\"code\" translate=\"no\">\'Browsing/Templates/Physical Properties\'</span> Asset Browser path, and the <span class=\"code\" translate=\"no\">\'Rigid Body\'</span> entry name. Models are connected to a Rigid Body Physical Property using <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBConnect()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#ae714fd0a71698e4948530ed309901c60&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga332a173e2c25db9dcf3a55118981a303&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConnect()</a></span>. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\"># Apply a Rigid Body physical property to the models.\n\
# The pActivation parameter defines the Activation value.\n\
# 0: Active | 1: Active at Collision | 2: Passive\n\
def applyRigidBody(pModelList, pActivation):\n\
    # Create the rigid body <a href=\"javascript:void(0)\" data-symbol=\"object\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#a904fdf014f8cdbefe8320ca2bfd6daf6&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">object</a> from the Asset Browser.\n\
    rigidBody = <a href=\"javascript:void(0)\" data-symbol=\"FBCreateObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga6698333c163da7c3bc077537889b6c33&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCreateObject</a>( \'Browsing/Templates/Physical Properties\', \'Rigid Body\', \'Rigid Body\' )\n\
    \n\
    # <a href=\"javascript:void(0)\" data-symbol=\"Set\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a8b39bad9fda6bc73af75e4d6085bcf91&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Set</a> the Activation property.\n\
    activationProp = rigidBody.PropertyList.Find(\'Activation\')\n\
    activationProp.Data = pActivation\n\
    \n\
    # <a href=\"javascript:void(0)\" data-symbol=\"If\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a3caa32cf8ff8db15e5835f5e40e6c6f8&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">If</a> we are using Active activation, set the Correct Mass Center to false.\n\
    if(pActivation == 0) :    \n\
        correctMassCenter = rigidBody.PropertyList.Find(\'Correct Mass Center\')\n\
        correctMassCenter.Data = False\n\
    \n\
    # Connect the rigid body to the models.\n\
    for model in pModelList:\n\
        <a href=\"javascript:void(0)\" data-symbol=\"FBConnect\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga332a173e2c25db9dcf3a55118981a303&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConnect</a>(rigidBody, model)</pre></div> \n\
            <p><a name=\"GUID-43D1367E-DB82-458C-8D02-26D2CD883158\"></a>The <span class=\"code\" translate=\"no\">\'Activation\'</span> property of a Rigid Body Physical Property denotes when the rigid body behavior of\n\
               the connected models activates. The accepted values for the <span class=\"code\" translate=\"no\">\'Activation\'</span> property are described below. \n\
            </p> <a name=\"TABLE_D79DC66D880541449CFC95F1B7FAABB9\"></a><div class=\"table-ruled\">\n\
               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
                  <colgroup>\n\
                     <col width=\"28.729066597429576%\">\n\
                     <col width=\"71.27093340257042%\">\n\
                  </colgroup>\n\
                  <tr class=\"ruled-heading\">\n\
                     <th class=\"table-heading\">Activation Value </th>\n\
                     <th class=\"table-heading\">Description </th>\n\
                  </tr>\n\
                  <tr class=\"ruled-odd-row\">\n\
                     <td class=\"table-body\"> <span class=\"code\" translate=\"no\">0</span> \n\
                     </td>\n\
                     <td class=\"table-body\"><em class=\"strong\">Active.</em> The connected models react to physical forces when the session is set to Live or\n\
                        when recording begins. \n\
                     </td>\n\
                  </tr>\n\
                  <tr class=\"ruled-even-row\">\n\
                     <td class=\"table-body\"> <span class=\"code\" translate=\"no\">1</span> \n\
                     </td>\n\
                     <td class=\"table-body\"><em class=\"strong\">Active at Collision.</em> A connected model only begins to react to physical forces when another model collides\n\
                        with it or if it is manipulated. \n\
                     </td>\n\
                  </tr>\n\
                  <tr class=\"ruled-odd-row\">\n\
                     <td class=\"table-body\"> <span class=\"code\" translate=\"no\">2</span> \n\
                     </td>\n\
                     <td class=\"table-body\"><em class=\"strong\">Passive.</em> The connected models are not affected by physical forces (ex: gravity), but can collide\n\
                        with other objects. \n\
                     </td>\n\
                  </tr>\n\
               </table>\n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_1372CE783B8942BDB0B9EDBBDBF90DEB\"></a> \n\
            <h2><a name=\"GUID-B704B4B6-864C-4405-99E9-9EB75EA29A37\"></a>Creating a Physics Solver\n\
            </h2> \n\
            <p><a name=\"GUID-25E65F80-B8D5-48FF-B4C4-482CD121F7D7\"></a>The rigid body calculations are solved by a Physics Solver, which must be added to\n\
               the scene via <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCreateObject()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a5111370ada05db17e04b97b447ddbd7c&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga6698333c163da7c3bc077537889b6c33&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCreateObject()</a></span> using the Asset Browser path <span class=\"code\" translate=\"no\">\'Browsing/Templates/Solvers\'</span> and the <span class=\"code\" translate=\"no\">\'Physics Solver\'</span> entry name. The <span class=\"code\" translate=\"no\">\'Gravity\'</span> property of the Physics Solver object defines the direction of gravity. The default\n\
               value for the <span class=\"code\" translate=\"no\">\'Gravity\'</span> property is <span class=\"code\" translate=\"no\">(0, -9.81, 0)</span>. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\"># Create a physics solver.\n\
def createPhysicsSolver():\n\
    solver = <a href=\"javascript:void(0)\" data-symbol=\"FBCreateObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga6698333c163da7c3bc077537889b6c33&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCreateObject</a>( \'Browsing/Templates/Solvers\', \'Physics Solver\', \'Physics Solver\' )\n\
    \n\
    # <a href=\"javascript:void(0)\" data-symbol=\"Set\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a8b39bad9fda6bc73af75e4d6085bcf91&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Set</a> the gravity to accelerate upwards.\n\
    solver.PropertyList.Find(\'Gravity\').Data = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(0, 9.81, 0)\n\
    \n\
    # Activate the Physics solver.\n\
    solver.Active = True\n\
    solver.Live = True</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_78D60433058A4F0EA65F49DD22A63BD5\"></a> \n\
            <h2><a name=\"GUID-16357E24-A076-4899-95EA-52E3AE814979\"></a>Example: Grid Collision\n\
            </h2> \n\
            <p><a name=\"GUID-CC7C1D66-D03C-4686-BF5D-5BF6E78607EB\"></a> <em class=\"strong\">Sample Viewport Output:</em> \n\
            </p> \n\
            <p><a name=\"GUID-E894887B-D2F3-46C7-8D61-5106CBDAB49C\"></a></p> <img src=\"images/GUID-276639C6-BDBD-43DA-A310-7BA626E8E249-low.png\"> \n\
            <p><a name=\"GUID-D47DBBBB-D6CE-4CDD-BFE6-03C57B8EE9D5\"></a><em class=\"strong\">Program Summary:</em> In the following program, a large cube collides with a grid of smaller cubes below\n\
               it. The large cube\'s Rigid Body Physical Property has its Activation set to 0 (active),\n\
               allowing it to fall when the program is run. The Rigid Body Physical Property bound\n\
               to the smaller cubes has its Activation set to 1 (active on collision), making the\n\
               smaller cubes fall to the ground plane if they experience a collision. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">from pyfbsdk import *\n\
\n\
###############################################################\n\
# Helper Function(<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a>).                                         #\n\
###############################################################\n\
\n\
# Create a primitive from the asset browser.\n\
def createModel(pTranslation, pScalingCoefficient):    \n\
    #model = <a href=\"javascript:void(0)\" data-symbol=\"FBCreateObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga6698333c163da7c3bc077537889b6c33&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCreateObject</a>( \'Browsing/Templates/Elements/Primitives\', \'polySphere\', \'polySphere\' )\n\
    model = <a href=\"javascript:void(0)\" data-symbol=\"FBCreateObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga6698333c163da7c3bc077537889b6c33&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCreateObject</a>( \'Browsing/Templates/Elements/Primitives\', \'Cube\', \'Cube\' )\n\
    model.Name = \'myModel\'\n\
    model.Translation = pTranslation\n\
    model.Scaling = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(pScalingCoefficient, pScalingCoefficient, pScalingCoefficient)\n\
    model.Show = True\n\
    \n\
    return model\n\
\n\
\n\
# Create a planar grid of models.\n\
def createGrid(pCenter, pModelsPerSide):\n\
    gridModels = []\n\
    spacing = 20\n\
    for <a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a> in range(-<a href=\"javascript:void(0)\" data-symbol=\"int\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/code_8h.html#aa4332194bf83cd22038ee4511e4decea&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">int</a>(pModelsPerSide/2), <a href=\"javascript:void(0)\" data-symbol=\"int\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/code_8h.html#aa4332194bf83cd22038ee4511e4decea&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">int</a>(pModelsPerSide/2) + 1):\n\
        for j in range(-<a href=\"javascript:void(0)\" data-symbol=\"int\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/code_8h.html#aa4332194bf83cd22038ee4511e4decea&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">int</a>(pModelsPerSide/2), <a href=\"javascript:void(0)\" data-symbol=\"int\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/code_8h.html#aa4332194bf83cd22038ee4511e4decea&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">int</a>(pModelsPerSide/2) + 1):\n\
            xOffset = pCenter[0] + <a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a> * spacing\n\
            yOffset = pCenter[1]\n\
            zOffset = pCenter[2] + j * spacing\n\
            # Create the model at the specific offset.\n\
            model = createModel(<a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(xOffset, yOffset, zOffset), 0.65)\n\
            gridModels.append(model)\n\
    \n\
    return gridModels\n\
\n\
\n\
# Apply a Rigid Body physical property to the models.\n\
# The pActivation parameter defines the Activation value.\n\
# 0: Active | 1: Active at Collision | 2: Passive\n\
def applyRigidBody(pModelList, pActivation):\n\
    # Create the rigid body <a href=\"javascript:void(0)\" data-symbol=\"object\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#a904fdf014f8cdbefe8320ca2bfd6daf6&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">object</a> from the Asset Browser.\n\
    rigidBody = <a href=\"javascript:void(0)\" data-symbol=\"FBCreateObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga6698333c163da7c3bc077537889b6c33&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCreateObject</a>( \'Browsing/Templates/Physical Properties\', \'Rigid Body\', \'Rigid Body\' )\n\
    \n\
    # <a href=\"javascript:void(0)\" data-symbol=\"Set\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a8b39bad9fda6bc73af75e4d6085bcf91&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Set</a> the Activation property.\n\
    activationProp = rigidBody.PropertyList.Find(\'Activation\')\n\
    activationProp.Data = pActivation\n\
    \n\
    # <a href=\"javascript:void(0)\" data-symbol=\"If\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a3caa32cf8ff8db15e5835f5e40e6c6f8&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">If</a> we are using Active activation, set the Correct Mass Center to false.\n\
    if(pActivation == 0) :    \n\
        correctMassCenter = rigidBody.PropertyList.Find(\'Correct Mass Center\')\n\
        correctMassCenter.Data = False\n\
    \n\
    # Connect the rigid body to the models.\n\
    for model in pModelList:\n\
        <a href=\"javascript:void(0)\" data-symbol=\"FBConnect\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga332a173e2c25db9dcf3a55118981a303&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConnect</a>(rigidBody, model)\n\
\n\
\n\
# Create a physics solver.\n\
def createPhysicsSolver():\n\
    solver = <a href=\"javascript:void(0)\" data-symbol=\"FBCreateObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga6698333c163da7c3bc077537889b6c33&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCreateObject</a>( \'Browsing/Templates/Solvers\', \'Physics Solver\', \'Physics Solver\' )\n\
\n\
    # <a href=\"javascript:void(0)\" data-symbol=\"Set\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a8b39bad9fda6bc73af75e4d6085bcf91&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Set</a> the gravity to accelerate slowly downwards.\n\
    solver.PropertyList.Find(\'Gravity\').Data = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(0, -2, 0)\n\
    \n\
    # Activate the Physics solver.\n\
    solver.Active = True\n\
    solver.Live = True\n\
\n\
\n\
\n\
###############################################################\n\
# Main.                                                       #\n\
###############################################################\n\
\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a>().FileNew()\n\
\n\
model = createModel(<a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(0, 200, 20), 1.5)\n\
applyRigidBody([model], 0) # Active\n\
\n\
gridModels = createGrid(<a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(0, 75, 0), 7)\n\
applyRigidBody(gridModels, 1) # Active at Collision\n\
\n\
createPhysicsSolver()\n\
</pre></div> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";