var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head><script src=\"../scripts/yepnope.1.5.4-min.js\" type=\"text/javascript\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><meta name=\"product\" content=\"MOBPRO\"><meta name=\"release\" content=\"2019\"><meta name=\"book\" content=\"Developer\"><meta name=\"created\" content=\"2019-01-07\"><meta name=\"topicid\" content=\"GUID-00E7F4B8-99DF-4F3F-AFE2-7A95D3046EE3\"><meta name=\"topic-type\" content=\"concept\">\n\
      <title>BasicOperations/CustomProperty.py</title>\n\
   \n\
\n\
<meta name=\"topic-subtype\" content=\"Python\"></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><link rel=\"stylesheet\" type=\"text/css\" href=\"py_ref/navtree.css\"><link rel=\"stylesheet\" type=\"text/css\" href=\"py_ref/doxygen.css\"><link rel=\"stylesheet\" type=\"text/css\" href=\"py_ref/tabs.css\"><link rel=\"stylesheet\" type=\"text/css\" href=\"style/adsk.cpm.css\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script type=\"text/javascript\">\n\
var tocSystemNeedsToBeLoaded = typeof(py_ref_adsk_ref_toc) == \'undefined\';\n\
var weAreIn21 = $(\'div#main.view-active\').length;\n\
var tocPrefix = \'\';\n\
if (weAreIn21)\n\
{ tocPrefix = \'py_ref/\'; }\n\
function py_ref_initializeToc(forceTrigger) {\n\
    py_ref_adsk_ref_toc.initResizable();\n\
    py_ref_adsk_ref_toc.initNavTree(\'_basic_operations_2_custom_property_8py-example.html\', tocPrefix);\n\
    dQuery(document).trigger(\'toc_initialized\');\n\
}\n\
if (tocSystemNeedsToBeLoaded)\n\
{\n\
	yepnope([{\n\
	load:[tocPrefix + \'json3.min.js\', tocPrefix + \'jquery.js\', tocPrefix + \'ref-toc-controller.js\', tocPrefix + \'dynsections.js\'],\n\
	complete: function() {\n\
	  if (typeof(dQuery) == \'undefined\')\n\
	  {\n\
	    dQuery = jQuery.noConflict(true);\n\
	  }\n\
	  else { jQuery.noConflict(true); }\n\
	  $(document).ready(py_ref_initializeToc);\n\
	}\n\
 	}])\n\
}\n\
if (!weAreIn21) { // if in AKN...\n\
$(window).load( function() {\n\
    setTimeout( function() {\n\
        var content = $(\'body > div\').not(\'#body-content\');     // take any divs under body that are not id=body-content\n\
        content.each( function() { \n\
            $(this).css( { \'padding-left\': $(this).css(\'margin-left\') } );       // and if they have any padding-left already, move it to margin-left.\n\
        } );\n\
        var width = py_ref_adsk_ref_toc.readFromStorage(\'width\');\n\
        content.css({marginLeft:parseInt(width)+6+\"px\"});\n\
    }, 100);\n\
} ); \n\
}\n\
</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script>\n\
 if (!tocSystemNeedsToBeLoaded) { py_ref_initializeToc(); }\n\
 </script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>BasicOperations/CustomProperty.py</h1>\n\
         </div>\n\
\n\
    <div id=\"top\"><!-- Generated by Doxygen 1.8.10 -->\n\
  <div id=\"navrow1\" class=\"tabs\">\n\
    <ul class=\"tablist\">\n\
      <li><a href=\"#!/url=./py_ref/index.html\"><span>Main&#160;Page</span></a></li>\n\
      <li><a href=\"#!/url=./py_ref/modules.html\"><span>Groups</span></a></li>\n\
      <li><a href=\"#!/url=./py_ref/annotated.html\"><span>Classes</span></a></li>\n\
      <li><a href=\"#!/url=./py_ref/examples.html\"><span>Examples</span></a></li>\n\
    </ul>\n\
  </div>\n\
</div><!-- top -->\n\
<div id=\"side-nav\" class=\"ui-resizable side-nav-resizable\">\n\
  <div id=\"nav-tree\">\n\
    <div id=\"nav-tree-contents\">\n\
      <div id=\"nav-sync\" class=\"sync\"></div>\n\
    </div>\n\
  </div>\n\
  <div id=\"splitbar\" style=\"-moz-user-select:none;\" class=\"ui-resizable-handle\">\n\
  </div>\n\
</div>\n\
\n\
<div id=\"doc-content\">\n\
<div class=\"header\">\n\
  <div class=\"headertitle\">\n\
<div class=\"title\">BasicOperations/CustomProperty.py</div>  </div>\n\
</div><!--header-->\n\
<div class=\"contents\">\n\
<div class=\"fragment\"><div class=\"line\"><a name=\"l00001\"></a><span class=\"lineno\">    1</span>&#160;<span class=\"comment\"># Copyright 2009 Autodesk, Inc.  All rights reserved.</span></div>\n\
<div class=\"line\"><a name=\"l00002\"></a><span class=\"lineno\">    2</span>&#160;<span class=\"comment\"># Use of this software is subject to the terms of the Autodesk license agreement </span></div>\n\
<div class=\"line\"><a name=\"l00003\"></a><span class=\"lineno\">    3</span>&#160;<span class=\"comment\"># provided at the time of installation or download, or which otherwise accompanies</span></div>\n\
<div class=\"line\"><a name=\"l00004\"></a><span class=\"lineno\">    4</span>&#160;<span class=\"comment\"># this software in either electronic or hard copy form.</span></div>\n\
<div class=\"line\"><a name=\"l00005\"></a><span class=\"lineno\">    5</span>&#160;<span class=\"comment\">#</span></div>\n\
<div class=\"line\"><a name=\"l00006\"></a><span class=\"lineno\">    6</span>&#160;<span class=\"comment\"># Script description:</span></div>\n\
<div class=\"line\"><a name=\"l00007\"></a><span class=\"lineno\">    7</span>&#160;<span class=\"comment\"># Create custom properties and attached them to all selected models.</span></div>\n\
<div class=\"line\"><a name=\"l00008\"></a><span class=\"lineno\">    8</span>&#160;<span class=\"comment\"># </span></div>\n\
<div class=\"line\"><a name=\"l00009\"></a><span class=\"lineno\">    9</span>&#160;<span class=\"comment\"># Topic: FBPropertyType, FBProperty</span></div>\n\
<div class=\"line\"><a name=\"l00010\"></a><span class=\"lineno\">   10</span>&#160;<span class=\"comment\">#</span></div>\n\
<div class=\"line\"><a name=\"l00011\"></a><span class=\"lineno\">   11</span>&#160;</div>\n\
<div class=\"line\"><a name=\"l00012\"></a><span class=\"lineno\">   12</span>&#160;<span class=\"keyword\">from</span> pyfbsdk <span class=\"keyword\">import</span> *</div>\n\
<div class=\"line\"><a name=\"l00013\"></a><span class=\"lineno\">   13</span>&#160;</div>\n\
<div class=\"line\"><a name=\"l00014\"></a><span class=\"lineno\">   14</span>&#160;<span class=\"comment\"># Create an empty FBModelList object.</span></div>\n\
<div class=\"line\"><a name=\"l00015\"></a><span class=\"lineno\">   15</span>&#160;lModels = <a class=\"code\" href=\"#!/url=./py_ref/class_f_b_model_list.html\">FBModelList</a>()</div>\n\
<div class=\"line\"><a name=\"l00016\"></a><span class=\"lineno\">   16</span>&#160;</div>\n\
<div class=\"line\"><a name=\"l00017\"></a><span class=\"lineno\">   17</span>&#160;<span class=\"comment\"># Obtain the list of selected models.</span></div>\n\
<div class=\"line\"><a name=\"l00018\"></a><span class=\"lineno\">   18</span>&#160;<a class=\"code\" href=\"#!/url=./py_ref/group__pyfbsdk.html#gafd7afc537327ebfd99dc4b41d08ed90b\">FBGetSelectedModels</a>(lModels)</div>\n\
<div class=\"line\"><a name=\"l00019\"></a><span class=\"lineno\">   19</span>&#160;</div>\n\
<div class=\"line\"><a name=\"l00020\"></a><span class=\"lineno\">   20</span>&#160;<span class=\"comment\"># List of Properties to create</span></div>\n\
<div class=\"line\"><a name=\"l00021\"></a><span class=\"lineno\">   21</span>&#160;</div>\n\
<div class=\"line\"><a name=\"l00022\"></a><span class=\"lineno\">   22</span>&#160;lProperty = ((<span class=\"stringliteral\">&#39;My Integer&#39;</span>, FBPropertyType.kFBPT_int, <span class=\"stringliteral\">&#39;Integer&#39;</span>, <span class=\"keyword\">True</span>, <span class=\"keyword\">True</span>, <span class=\"keywordtype\">None</span>),</div>\n\
<div class=\"line\"><a name=\"l00023\"></a><span class=\"lineno\">   23</span>&#160;             (<span class=\"stringliteral\">&#39;My Bool&#39;</span>, FBPropertyType.kFBPT_bool, <span class=\"stringliteral\">&#39;Bool&#39;</span>, <span class=\"keyword\">True</span>, <span class=\"keyword\">True</span>, <span class=\"keywordtype\">None</span>),</div>\n\
<div class=\"line\"><a name=\"l00024\"></a><span class=\"lineno\">   24</span>&#160;             (<span class=\"stringliteral\">&#39;My Float&#39;</span>, FBPropertyType.kFBPT_float, <span class=\"stringliteral\">&#39;Float&#39;</span>, <span class=\"keyword\">False</span>, <span class=\"keyword\">True</span>, <span class=\"keywordtype\">None</span>), <span class=\"comment\"># Not animatable</span></div>\n\
<div class=\"line\"><a name=\"l00025\"></a><span class=\"lineno\">   25</span>&#160;             (<span class=\"stringliteral\">&#39;My Double&#39;</span>, FBPropertyType.kFBPT_double, <span class=\"stringliteral\">&#39;Number&#39;</span>,<span class=\"keyword\">True</span>, <span class=\"keyword\">True</span>, <span class=\"keywordtype\">None</span>), </div>\n\
<div class=\"line\"><a name=\"l00026\"></a><span class=\"lineno\">   26</span>&#160;             (<span class=\"stringliteral\">&#39;My Chrptr&#39;</span>, FBPropertyType.kFBPT_charptr, <span class=\"stringliteral\">&#39;String&#39;</span>, <span class=\"keyword\">False</span>, <span class=\"keyword\">True</span>, <span class=\"keywordtype\">None</span>), <span class=\"comment\"># Not animatable</span></div>\n\
<div class=\"line\"><a name=\"l00027\"></a><span class=\"lineno\">   27</span>&#160;             (<span class=\"stringliteral\">&#39;My Enum&#39;</span>, FBPropertyType.kFBPT_enum, <span class=\"stringliteral\">&#39;Enum&#39;</span>, <span class=\"keyword\">True</span>, <span class=\"keyword\">True</span>, <span class=\"keywordtype\">None</span>),</div>\n\
<div class=\"line\"><a name=\"l00028\"></a><span class=\"lineno\">   28</span>&#160;             (<span class=\"stringliteral\">&#39;My Time&#39;</span>, FBPropertyType.kFBPT_Time, <span class=\"stringliteral\">&#39;Time&#39;</span>, <span class=\"keyword\">True</span>, <span class=\"keyword\">True</span>, <span class=\"keywordtype\">None</span>),</div>\n\
<div class=\"line\"><a name=\"l00029\"></a><span class=\"lineno\">   29</span>&#160;             (<span class=\"stringliteral\">&#39;My Obj&#39;</span>,  FBPropertyType.kFBPT_object, <span class=\"stringliteral\">&#39;Object&#39;</span>, <span class=\"keyword\">False</span>, <span class=\"keyword\">True</span>, <span class=\"keywordtype\">None</span> ), <span class=\"comment\"># Not animatable</span></div>\n\
<div class=\"line\"><a name=\"l00030\"></a><span class=\"lineno\">   30</span>&#160;             (<span class=\"stringliteral\">&#39;My Stringlist&#39;</span>, FBPropertyType.kFBPT_stringlist, <span class=\"stringliteral\">&#39;StringList&#39;</span>, <span class=\"keyword\">False</span>, <span class=\"keyword\">True</span>, <span class=\"keywordtype\">None</span>), <span class=\"comment\"># Not animatable</span></div>\n\
<div class=\"line\"><a name=\"l00031\"></a><span class=\"lineno\">   31</span>&#160;             (<span class=\"stringliteral\">&#39;My Vector4D&#39;</span>, FBPropertyType.kFBPT_Vector4D, <span class=\"stringliteral\">&#39;Vector4&#39;</span>, <span class=\"keyword\">True</span>, <span class=\"keyword\">True</span>, <span class=\"keywordtype\">None</span>),      </div>\n\
<div class=\"line\"><a name=\"l00032\"></a><span class=\"lineno\">   32</span>&#160;             (<span class=\"stringliteral\">&#39;My Vector3D&#39;</span>, FBPropertyType.kFBPT_Vector3D, <span class=\"stringliteral\">&#39;Vector&#39;</span>, <span class=\"keyword\">True</span>, <span class=\"keyword\">True</span>, <span class=\"keywordtype\">None</span>),</div>\n\
<div class=\"line\"><a name=\"l00033\"></a><span class=\"lineno\">   33</span>&#160;             (<span class=\"stringliteral\">&#39;My Vector2D&#39;</span>, FBPropertyType.kFBPT_Vector2D, <span class=\"stringliteral\">&#39;Vector2&#39;</span>, <span class=\"keyword\">True</span>, <span class=\"keyword\">True</span>, <span class=\"keywordtype\">None</span>),</div>\n\
<div class=\"line\"><a name=\"l00034\"></a><span class=\"lineno\">   34</span>&#160;             (<span class=\"stringliteral\">&#39;My Colour&#39;</span>, FBPropertyType.kFBPT_ColorRGB, <span class=\"stringliteral\">&#39;Color&#39;</span>, <span class=\"keyword\">True</span>, <span class=\"keyword\">True</span>, <span class=\"keywordtype\">None</span>),</div>\n\
<div class=\"line\"><a name=\"l00035\"></a><span class=\"lineno\">   35</span>&#160;             (<span class=\"stringliteral\">&#39;My ColourAndAlpha&#39;</span>, FBPropertyType.kFBPT_ColorRGBA, <span class=\"stringliteral\">&#39;ColorAndAlpha&#39;</span>, <span class=\"keyword\">True</span>, <span class=\"keyword\">True</span>, <span class=\"keywordtype\">None</span>),</div>\n\
<div class=\"line\"><a name=\"l00036\"></a><span class=\"lineno\">   36</span>&#160;             (<span class=\"stringliteral\">&#39;My Action&#39;</span>, FBPropertyType.kFBPT_Action, <span class=\"stringliteral\">&#39;Action&#39;</span>, <span class=\"keyword\">True</span>, <span class=\"keyword\">True</span>, <span class=\"keywordtype\">None</span>),</div>\n\
<div class=\"line\"><a name=\"l00037\"></a><span class=\"lineno\">   37</span>&#160;             (<span class=\"stringliteral\">&#39;My TimeSpan&#39;</span>, FBPropertyType.kFBPT_TimeSpan, <span class=\"stringliteral\">&#39;Time&#39;</span>, <span class=\"keyword\">False</span>, <span class=\"keyword\">True</span>, <span class=\"keywordtype\">None</span>), <span class=\"comment\"># Not animatable</span></div>\n\
<div class=\"line\"><a name=\"l00038\"></a><span class=\"lineno\">   38</span>&#160;             )</div>\n\
<div class=\"line\"><a name=\"l00039\"></a><span class=\"lineno\">   39</span>&#160;             </div>\n\
<div class=\"line\"><a name=\"l00040\"></a><span class=\"lineno\">   40</span>&#160;<span class=\"comment\"># Explanation of property syntax</span></div>\n\
<div class=\"line\"><a name=\"l00041\"></a><span class=\"lineno\">   41</span>&#160;</div>\n\
<div class=\"line\"><a name=\"l00042\"></a><span class=\"lineno\">   42</span>&#160;<span class=\"comment\"># Parameters: </span></div>\n\
<div class=\"line\"><a name=\"l00043\"></a><span class=\"lineno\">   43</span>&#160;<span class=\"comment\">#   pName -  The name of the property. </span></div>\n\
<div class=\"line\"><a name=\"l00044\"></a><span class=\"lineno\">   44</span>&#160;<span class=\"comment\">#   pType -  Type of the property see enum FBPropertyType. </span></div>\n\
<div class=\"line\"><a name=\"l00045\"></a><span class=\"lineno\">   45</span>&#160;<span class=\"comment\">#   pDataType -  DataType of the property is a text define in ANIMATIONNODE_TYPE_??? in fbdata.h. </span></div>\n\
<div class=\"line\"><a name=\"l00046\"></a><span class=\"lineno\">   46</span>&#160;<span class=\"comment\">#   pAnimatable -  To specify if the property can be animated. </span></div>\n\
<div class=\"line\"><a name=\"l00047\"></a><span class=\"lineno\">   47</span>&#160;<span class=\"comment\">#   pIsUser -  To specify if the property is available as a custom property or dynamic and attached to the object. </span></div>\n\
<div class=\"line\"><a name=\"l00048\"></a><span class=\"lineno\">   48</span>&#160;<span class=\"comment\">#   pReferenceSource - Use that param to specify the property that a reference refer to. </span></div>\n\
<div class=\"line\"><a name=\"l00049\"></a><span class=\"lineno\">   49</span>&#160;</div>\n\
<div class=\"line\"><a name=\"l00050\"></a><span class=\"lineno\">   50</span>&#160;<span class=\"comment\"># check if there is a selection</span></div>\n\
<div class=\"line\"><a name=\"l00051\"></a><span class=\"lineno\">   51</span>&#160;<span class=\"keywordflow\">if</span> len( lModels ) == 0:</div>\n\
<div class=\"line\"><a name=\"l00052\"></a><span class=\"lineno\">   52</span>&#160;  <a class=\"code\" href=\"#!/url=./py_ref/group__pyfbsdk.html#ga911b954221bb1fcc892a47156186caf1\">FBMessageBox</a>( <span class=\"stringliteral\">&quot;Message&quot;</span>, <span class=\"stringliteral\">&quot;Nothing selected&quot;</span>, <span class=\"stringliteral\">&quot;OK&quot;</span>, <span class=\"keywordtype\">None</span>, <span class=\"keywordtype\">None</span> )</div>\n\
<div class=\"line\"><a name=\"l00053\"></a><span class=\"lineno\">   53</span>&#160;  </div>\n\
<div class=\"line\"><a name=\"l00054\"></a><span class=\"lineno\">   54</span>&#160;<span class=\"keywordflow\">else</span>:</div>\n\
<div class=\"line\"><a name=\"l00055\"></a><span class=\"lineno\">   55</span>&#160;</div>\n\
<div class=\"line\"><a name=\"l00056\"></a><span class=\"lineno\">   56</span>&#160;    <span class=\"comment\"># Create a FBProgress object and set default values for the caption and text.</span></div>\n\
<div class=\"line\"><a name=\"l00057\"></a><span class=\"lineno\">   57</span>&#160;    lFbp = <a class=\"code\" href=\"#!/url=./py_ref/class_f_b_progress.html\">FBProgress</a>()</div>\n\
<div class=\"line\"><a name=\"l00058\"></a><span class=\"lineno\">   58</span>&#160;    lFbp.Caption = <span class=\"stringliteral\">&quot;CREATING CUSTOM PROPERTIES&quot;</span></div>\n\
<div class=\"line\"><a name=\"l00059\"></a><span class=\"lineno\">   59</span>&#160;    lFbp.Text = <span class=\"stringliteral\">&quot;yay !&quot;</span></div>\n\
<div class=\"line\"><a name=\"l00060\"></a><span class=\"lineno\">   60</span>&#160;    lCount = 0.0</div>\n\
<div class=\"line\"><a name=\"l00061\"></a><span class=\"lineno\">   61</span>&#160;</div>\n\
<div class=\"line\"><a name=\"l00062\"></a><span class=\"lineno\">   62</span>&#160;    <span class=\"comment\"># Create custom properties    </span></div>\n\
<div class=\"line\"><a name=\"l00063\"></a><span class=\"lineno\">   63</span>&#160;    <span class=\"keywordflow\">for</span> x <span class=\"keywordflow\">in</span> lModels:</div>\n\
<div class=\"line\"><a name=\"l00064\"></a><span class=\"lineno\">   64</span>&#160;        </div>\n\
<div class=\"line\"><a name=\"l00065\"></a><span class=\"lineno\">   65</span>&#160;        <span class=\"keywordflow\">for</span> ( pName, pType, pDataType,pAnimatable, pIsUser, pReferenceSource ) <span class=\"keywordflow\">in</span> lProperty:</div>\n\
<div class=\"line\"><a name=\"l00066\"></a><span class=\"lineno\">   66</span>&#160;            prop = x.PropertyCreate( pName, pType, pDataType, pAnimatable, pIsUser, pReferenceSource )                      </div>\n\
<div class=\"line\"><a name=\"l00067\"></a><span class=\"lineno\">   67</span>&#160;            <span class=\"keywordflow\">if</span> prop == <span class=\"keywordtype\">None</span>:</div>\n\
<div class=\"line\"><a name=\"l00068\"></a><span class=\"lineno\">   68</span>&#160;                <span class=\"keywordflow\">print</span> <span class=\"stringliteral\">&quot;NoneObj:&quot;</span>+pName+<span class=\"stringliteral\">&quot;,&quot;</span>+str(pType)</div>\n\
<div class=\"line\"><a name=\"l00069\"></a><span class=\"lineno\">   69</span>&#160;            <span class=\"keywordflow\">else</span>:</div>\n\
<div class=\"line\"><a name=\"l00070\"></a><span class=\"lineno\">   70</span>&#160;                <span class=\"keywordflow\">print</span> prop.GetName()+prop.GetPropertyTypeName()</div>\n\
<div class=\"line\"><a name=\"l00071\"></a><span class=\"lineno\">   71</span>&#160;        <span class=\"comment\"># set values for &#39;My Integer&#39;            </span></div>\n\
<div class=\"line\"><a name=\"l00072\"></a><span class=\"lineno\">   72</span>&#160;        lProp = x.PropertyList.Find(<span class=\"stringliteral\">&#39;My Integer&#39;</span>)<span class=\"comment\">### marche po</span></div>\n\
<div class=\"line\"><a name=\"l00073\"></a><span class=\"lineno\">   73</span>&#160;        lProp.SetMin(-100)</div>\n\
<div class=\"line\"><a name=\"l00074\"></a><span class=\"lineno\">   74</span>&#160;        lProp.SetMax(100)</div>\n\
<div class=\"line\"><a name=\"l00075\"></a><span class=\"lineno\">   75</span>&#160;        lProp.Data = 10</div>\n\
<div class=\"line\"><a name=\"l00076\"></a><span class=\"lineno\">   76</span>&#160;        lProp.SetAnimated(<span class=\"keyword\">True</span>)</div>\n\
<div class=\"line\"><a name=\"l00077\"></a><span class=\"lineno\">   77</span>&#160;        </div>\n\
<div class=\"line\"><a name=\"l00078\"></a><span class=\"lineno\">   78</span>&#160;        <span class=\"comment\"># set values for &#39;My Bool&#39;            </span></div>\n\
<div class=\"line\"><a name=\"l00079\"></a><span class=\"lineno\">   79</span>&#160;        lProp = x.PropertyList.Find(<span class=\"stringliteral\">&#39;My Bool&#39;</span>)</div>\n\
<div class=\"line\"><a name=\"l00080\"></a><span class=\"lineno\">   80</span>&#160;        lProp.Data = <span class=\"keyword\">False</span></div>\n\
<div class=\"line\"><a name=\"l00081\"></a><span class=\"lineno\">   81</span>&#160;        lProp.SetAnimated(<span class=\"keyword\">True</span>)</div>\n\
<div class=\"line\"><a name=\"l00082\"></a><span class=\"lineno\">   82</span>&#160;</div>\n\
<div class=\"line\"><a name=\"l00083\"></a><span class=\"lineno\">   83</span>&#160;        <span class=\"comment\"># set values for &#39;My Double&#39;            </span></div>\n\
<div class=\"line\"><a name=\"l00084\"></a><span class=\"lineno\">   84</span>&#160;        lProp = x.PropertyList.Find(<span class=\"stringliteral\">&#39;My Double&#39;</span>)</div>\n\
<div class=\"line\"><a name=\"l00085\"></a><span class=\"lineno\">   85</span>&#160;        lProp.SetMin(-100)</div>\n\
<div class=\"line\"><a name=\"l00086\"></a><span class=\"lineno\">   86</span>&#160;        lProp.SetMax(100)</div>\n\
<div class=\"line\"><a name=\"l00087\"></a><span class=\"lineno\">   87</span>&#160;        lProp.Data = 2.2</div>\n\
<div class=\"line\"><a name=\"l00088\"></a><span class=\"lineno\">   88</span>&#160;        <span class=\"comment\"># SetAnimated exposes the property to the relations constraint</span></div>\n\
<div class=\"line\"><a name=\"l00089\"></a><span class=\"lineno\">   89</span>&#160;        lProp.SetAnimated(<span class=\"keyword\">True</span>)</div>\n\
<div class=\"line\"><a name=\"l00090\"></a><span class=\"lineno\">   90</span>&#160;</div>\n\
<div class=\"line\"><a name=\"l00091\"></a><span class=\"lineno\">   91</span>&#160;        <span class=\"comment\"># set value for &#39;My Chrptr&#39;</span></div>\n\
<div class=\"line\"><a name=\"l00092\"></a><span class=\"lineno\">   92</span>&#160;        lProp= x.PropertyList.Find(<span class=\"stringliteral\">&#39;My ChrPtr&#39;</span>)</div>\n\
<div class=\"line\"><a name=\"l00093\"></a><span class=\"lineno\">   93</span>&#160;        lProp.Data = <span class=\"stringliteral\">&quot;TestThis!&quot;</span></div>\n\
<div class=\"line\"><a name=\"l00094\"></a><span class=\"lineno\">   94</span>&#160;</div>\n\
<div class=\"line\"><a name=\"l00095\"></a><span class=\"lineno\">   95</span>&#160;        <span class=\"comment\"># set value for &#39;My Enum&#39;</span></div>\n\
<div class=\"line\"><a name=\"l00096\"></a><span class=\"lineno\">   96</span>&#160;        lProp= x.PropertyList.Find(<span class=\"stringliteral\">&#39;My Enum&#39;</span>)</div>\n\
<div class=\"line\"><a name=\"l00097\"></a><span class=\"lineno\">   97</span>&#160;        lEnumList = lProp.GetEnumStringList(<span class=\"keyword\">True</span>) <span class=\"comment\">#Get Enum StringList and add new item.</span></div>\n\
<div class=\"line\"><a name=\"l00098\"></a><span class=\"lineno\">   98</span>&#160;        lEnumList.Add(<span class=\"stringliteral\">&quot;Test1&quot;</span>)</div>\n\
<div class=\"line\"><a name=\"l00099\"></a><span class=\"lineno\">   99</span>&#160;        lEnumList.Add(<span class=\"stringliteral\">&quot;Test2&quot;</span>)</div>\n\
<div class=\"line\"><a name=\"l00100\"></a><span class=\"lineno\">  100</span>&#160;        lEnumList.Add(<span class=\"stringliteral\">&quot;Test3&quot;</span>)</div>\n\
<div class=\"line\"><a name=\"l00101\"></a><span class=\"lineno\">  101</span>&#160;        lProp.NotifyEnumStringListChanged() <span class=\"comment\">#Notify change, to let it take effect.</span></div>\n\
<div class=\"line\"><a name=\"l00102\"></a><span class=\"lineno\">  102</span>&#160;        </div>\n\
<div class=\"line\"><a name=\"l00103\"></a><span class=\"lineno\">  103</span>&#160;        <span class=\"comment\"># set value for &#39;My Time &#39;</span></div>\n\
<div class=\"line\"><a name=\"l00104\"></a><span class=\"lineno\">  104</span>&#160;        lProp= x.PropertyList.Find(<span class=\"stringliteral\">&#39;My Time&#39;</span>)</div>\n\
<div class=\"line\"><a name=\"l00105\"></a><span class=\"lineno\">  105</span>&#160;        lProp.Data = <a class=\"code\" href=\"#!/url=./py_ref/class_f_b_time.html\">FBTime</a>(0,0,1,1)</div>\n\
<div class=\"line\"><a name=\"l00106\"></a><span class=\"lineno\">  106</span>&#160;        lProp.SetAnimated =<span class=\"keyword\">True</span></div>\n\
<div class=\"line\"><a name=\"l00107\"></a><span class=\"lineno\">  107</span>&#160;</div>\n\
<div class=\"line\"><a name=\"l00108\"></a><span class=\"lineno\">  108</span>&#160;        <span class=\"comment\"># set values for &#39;My Vector3D&#39;            </span></div>\n\
<div class=\"line\"><a name=\"l00109\"></a><span class=\"lineno\">  109</span>&#160;        lProp = x.PropertyList.Find(<span class=\"stringliteral\">&#39;My Vector3D&#39;</span>)</div>\n\
<div class=\"line\"><a name=\"l00110\"></a><span class=\"lineno\">  110</span>&#160;        lVector = <a class=\"code\" href=\"#!/url=./py_ref/class_f_b_vector3d.html\">FBVector3d</a>(90,20,-70)</div>\n\
<div class=\"line\"><a name=\"l00111\"></a><span class=\"lineno\">  111</span>&#160;        lProp.Data = lVector</div>\n\
<div class=\"line\"><a name=\"l00112\"></a><span class=\"lineno\">  112</span>&#160;        lProp.SetAnimated(<span class=\"keyword\">True</span>)      </div>\n\
<div class=\"line\"><a name=\"l00113\"></a><span class=\"lineno\">  113</span>&#160;        </div>\n\
<div class=\"line\"><a name=\"l00114\"></a><span class=\"lineno\">  114</span>&#160;        <span class=\"comment\"># set values for &#39;My Vector4D&#39;            </span></div>\n\
<div class=\"line\"><a name=\"l00115\"></a><span class=\"lineno\">  115</span>&#160;        lProp = x.PropertyList.Find(<span class=\"stringliteral\">&#39;My Vector4D&#39;</span>)</div>\n\
<div class=\"line\"><a name=\"l00116\"></a><span class=\"lineno\">  116</span>&#160;        lVector = <a class=\"code\" href=\"#!/url=./py_ref/class_f_b_vector4d.html\">FBVector4d</a>(90,20,-70,60)</div>\n\
<div class=\"line\"><a name=\"l00117\"></a><span class=\"lineno\">  117</span>&#160;        lProp.Data = lVector</div>\n\
<div class=\"line\"><a name=\"l00118\"></a><span class=\"lineno\">  118</span>&#160;        lProp.SetAnimated(<span class=\"keyword\">True</span>)</div>\n\
<div class=\"line\"><a name=\"l00119\"></a><span class=\"lineno\">  119</span>&#160;</div>\n\
<div class=\"line\"><a name=\"l00120\"></a><span class=\"lineno\">  120</span>&#160;        <span class=\"comment\"># set values for &#39;My Colour &#39;            </span></div>\n\
<div class=\"line\"><a name=\"l00121\"></a><span class=\"lineno\">  121</span>&#160;        lProp = x.PropertyList.Find(<span class=\"stringliteral\">&#39;My Colour&#39;</span>)</div>\n\
<div class=\"line\"><a name=\"l00122\"></a><span class=\"lineno\">  122</span>&#160;        lColour = <a class=\"code\" href=\"#!/url=./py_ref/class_f_b_color.html\">FBColor</a>(0,0,1)</div>\n\
<div class=\"line\"><a name=\"l00123\"></a><span class=\"lineno\">  123</span>&#160;        lProp.Data = lColour</div>\n\
<div class=\"line\"><a name=\"l00124\"></a><span class=\"lineno\">  124</span>&#160;        lProp.SetAnimated(<span class=\"keyword\">True</span>)</div>\n\
<div class=\"line\"><a name=\"l00125\"></a><span class=\"lineno\">  125</span>&#160;        </div>\n\
<div class=\"line\"><a name=\"l00126\"></a><span class=\"lineno\">  126</span>&#160;        <span class=\"comment\"># set values for &#39;My ColourAndAlpha &#39;            </span></div>\n\
<div class=\"line\"><a name=\"l00127\"></a><span class=\"lineno\">  127</span>&#160;        lProp = x.PropertyList.Find(<span class=\"stringliteral\">&#39;My ColourAndAlpha&#39;</span>)</div>\n\
<div class=\"line\"><a name=\"l00128\"></a><span class=\"lineno\">  128</span>&#160;        lColour = <a class=\"code\" href=\"#!/url=./py_ref/class_f_b_color_and_alpha.html\">FBColorAndAlpha</a>(0,1,0,0.5)</div>\n\
<div class=\"line\"><a name=\"l00129\"></a><span class=\"lineno\">  129</span>&#160;        <span class=\"comment\">##lProp.Data = lColour</span></div>\n\
<div class=\"line\"><a name=\"l00130\"></a><span class=\"lineno\">  130</span>&#160;        lProp.SetAnimated(<span class=\"keyword\">True</span>)</div>\n\
<div class=\"line\"><a name=\"l00131\"></a><span class=\"lineno\">  131</span>&#160;</div>\n\
<div class=\"line\"><a name=\"l00132\"></a><span class=\"lineno\">  132</span>&#160;        <span class=\"comment\"># set values for &#39;My Action &#39;            </span></div>\n\
<div class=\"line\"><a name=\"l00133\"></a><span class=\"lineno\">  133</span>&#160;        lProp = x.PropertyList.Find(<span class=\"stringliteral\">&#39;My Action&#39;</span>)</div>\n\
<div class=\"line\"><a name=\"l00134\"></a><span class=\"lineno\">  134</span>&#160;        lProp.SetAnimated(<span class=\"keyword\">True</span>)</div>\n\
<div class=\"line\"><a name=\"l00135\"></a><span class=\"lineno\">  135</span>&#160;</div>\n\
<div class=\"line\"><a name=\"l00136\"></a><span class=\"lineno\">  136</span>&#160;        <span class=\"comment\"># set values for &#39;My Bool &#39;            </span></div>\n\
<div class=\"line\"><a name=\"l00137\"></a><span class=\"lineno\">  137</span>&#160;        lProp = x.PropertyList.Find(<span class=\"stringliteral\">&#39;My Bool&#39;</span>)</div>\n\
<div class=\"line\"><a name=\"l00138\"></a><span class=\"lineno\">  138</span>&#160;        lProp.Data = <span class=\"keyword\">True</span></div>\n\
<div class=\"line\"><a name=\"l00139\"></a><span class=\"lineno\">  139</span>&#160;        lProp.SetAnimated(<span class=\"keyword\">True</span>)</div>\n\
<div class=\"line\"><a name=\"l00140\"></a><span class=\"lineno\">  140</span>&#160;</div>\n\
<div class=\"line\"><a name=\"l00141\"></a><span class=\"lineno\">  141</span>&#160;        <span class=\"comment\"># set values for &#39;My Integer &#39;            </span></div>\n\
<div class=\"line\"><a name=\"l00142\"></a><span class=\"lineno\">  142</span>&#160;        lProp = x.PropertyList.Find(<span class=\"stringliteral\">&#39;My Integer&#39;</span>)</div>\n\
<div class=\"line\"><a name=\"l00143\"></a><span class=\"lineno\">  143</span>&#160;        lProp.SetMin(0)</div>\n\
<div class=\"line\"><a name=\"l00144\"></a><span class=\"lineno\">  144</span>&#160;        lProp.SetMax(100)</div>\n\
<div class=\"line\"><a name=\"l00145\"></a><span class=\"lineno\">  145</span>&#160;        lProp.Data = 0</div>\n\
<div class=\"line\"><a name=\"l00146\"></a><span class=\"lineno\">  146</span>&#160;        lProp.SetAnimated(<span class=\"keyword\">True</span>)</div>\n\
<div class=\"line\"><a name=\"l00147\"></a><span class=\"lineno\">  147</span>&#160;        </div>\n\
<div class=\"line\"><a name=\"l00148\"></a><span class=\"lineno\">  148</span>&#160;    lCount += 1</div>\n\
<div class=\"line\"><a name=\"l00149\"></a><span class=\"lineno\">  149</span>&#160;    lVal = lCount / len(lModels) * 100            </div>\n\
<div class=\"line\"><a name=\"l00150\"></a><span class=\"lineno\">  150</span>&#160;    lFbp.Percent = int(lVal)</div>\n\
<div class=\"line\"><a name=\"l00151\"></a><span class=\"lineno\">  151</span>&#160;    </div>\n\
<div class=\"line\"><a name=\"l00152\"></a><span class=\"lineno\">  152</span>&#160;    <span class=\"comment\"># We must call FBDelete when the FBProgress object is no longer needed.</span></div>\n\
<div class=\"line\"><a name=\"l00153\"></a><span class=\"lineno\">  153</span>&#160;    lFbp.FBDelete()</div>\n\
<div class=\"line\"><a name=\"l00154\"></a><span class=\"lineno\">  154</span>&#160;</div>\n\
<div class=\"line\"><a name=\"l00155\"></a><span class=\"lineno\">  155</span>&#160;</div>\n\
<div class=\"line\"><a name=\"l00156\"></a><span class=\"lineno\">  156</span>&#160;</div>\n\
<div class=\"line\"><a name=\"l00157\"></a><span class=\"lineno\">  157</span>&#160;</div>\n\
<div class=\"line\"><a name=\"l00158\"></a><span class=\"lineno\">  158</span>&#160;</div>\n\
<div class=\"line\"><a name=\"l00159\"></a><span class=\"lineno\">  159</span>&#160;</div>\n\
<div class=\"line\"><a name=\"l00160\"></a><span class=\"lineno\">  160</span>&#160;</div>\n\
<div class=\"line\"><a name=\"l00161\"></a><span class=\"lineno\">  161</span>&#160;</div>\n\
<div class=\"line\"><a name=\"l00162\"></a><span class=\"lineno\">  162</span>&#160;</div>\n\
</div><!-- fragment --> </div><!-- contents -->\n\
</div><!-- doc-content -->\n\
          <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";