var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head><script src=\"../scripts/yepnope.1.5.4-min.js\" type=\"text/javascript\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><meta name=\"product\" content=\"MOBPRO\"><meta name=\"release\" content=\"2019\"><meta name=\"book\" content=\"Developer\"><meta name=\"created\" content=\"2019-01-07\"><meta name=\"topicid\" content=\"GUID-00E7F4B8-99DF-4F3F-AFE2-7A95D3046EE3\"><meta name=\"topic-type\" content=\"concept\">\n\
      <title>Python Scripting Reference Guide (pyfbsdk)</title>\n\
   \n\
\n\
<meta name=\"topic-subtype\" content=\"Python\"></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><link rel=\"stylesheet\" type=\"text/css\" href=\"py_ref/navtree.css\"><link rel=\"stylesheet\" type=\"text/css\" href=\"py_ref/doxygen.css\"><link rel=\"stylesheet\" type=\"text/css\" href=\"py_ref/tabs.css\"><link rel=\"stylesheet\" type=\"text/css\" href=\"style/adsk.cpm.css\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script type=\"text/javascript\">\n\
var tocSystemNeedsToBeLoaded = typeof(py_ref_adsk_ref_toc) == \'undefined\';\n\
var weAreIn21 = $(\'div#main.view-active\').length;\n\
var tocPrefix = \'\';\n\
if (weAreIn21)\n\
{ tocPrefix = \'py_ref/\'; }\n\
function py_ref_initializeToc(forceTrigger) {\n\
    py_ref_adsk_ref_toc.initResizable();\n\
    py_ref_adsk_ref_toc.initNavTree(\'index.html\', tocPrefix);\n\
    dQuery(document).trigger(\'toc_initialized\');\n\
}\n\
if (tocSystemNeedsToBeLoaded)\n\
{\n\
	yepnope([{\n\
	load:[tocPrefix + \'json3.min.js\', tocPrefix + \'jquery.js\', tocPrefix + \'ref-toc-controller.js\', tocPrefix + \'dynsections.js\'],\n\
	complete: function() {\n\
	  if (typeof(dQuery) == \'undefined\')\n\
	  {\n\
	    dQuery = jQuery.noConflict(true);\n\
	  }\n\
	  else { jQuery.noConflict(true); }\n\
	  $(document).ready(py_ref_initializeToc);\n\
	}\n\
 	}])\n\
}\n\
if (!weAreIn21) { // if in AKN...\n\
$(window).load( function() {\n\
    setTimeout( function() {\n\
        var content = $(\'body > div\').not(\'#body-content\');     // take any divs under body that are not id=body-content\n\
        content.each( function() { \n\
            $(this).css( { \'padding-left\': $(this).css(\'margin-left\') } );       // and if they have any padding-left already, move it to margin-left.\n\
        } );\n\
        var width = py_ref_adsk_ref_toc.readFromStorage(\'width\');\n\
        content.css({marginLeft:parseInt(width)+6+\"px\"});\n\
    }, 100);\n\
} ); \n\
}\n\
</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script>\n\
 if (!tocSystemNeedsToBeLoaded) { py_ref_initializeToc(); }\n\
 </script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Python Scripting Reference Guide (pyfbsdk)</h1>\n\
         </div>\n\
\n\
    <div id=\"top\"><!-- Generated by Doxygen 1.8.10 -->\n\
  <div id=\"navrow1\" class=\"tabs\">\n\
    <ul class=\"tablist\">\n\
      <li class=\"current\"><a href=\"#!/url=./py_ref/index.html\"><span>Main&#160;Page</span></a></li>\n\
      <li><a href=\"#!/url=./py_ref/modules.html\"><span>Groups</span></a></li>\n\
      <li><a href=\"#!/url=./py_ref/annotated.html\"><span>Classes</span></a></li>\n\
      <li><a href=\"#!/url=./py_ref/examples.html\"><span>Examples</span></a></li>\n\
    </ul>\n\
  </div>\n\
</div><!-- top -->\n\
<div id=\"side-nav\" class=\"ui-resizable side-nav-resizable\">\n\
  <div id=\"nav-tree\">\n\
    <div id=\"nav-tree-contents\">\n\
      <div id=\"nav-sync\" class=\"sync\"></div>\n\
    </div>\n\
  </div>\n\
  <div id=\"splitbar\" style=\"-moz-user-select:none;\" class=\"ui-resizable-handle\">\n\
  </div>\n\
</div>\n\
\n\
<div id=\"doc-content\">\n\
<div class=\"header\">\n\
  <div class=\"headertitle\">\n\
<div class=\"title\">Python Scripting Reference Guide (pyfbsdk) </div>  </div>\n\
</div><!--header-->\n\
<div class=\"contents\">\n\
<div class=\"textblock\"><h1><a class=\"anchor\" id=\"intro\"></a>\n\
Introduction to Python Scripting</h1>\n\
<p>This section lists the classes and methods in Python that you can use for scripting in MotionBuilder. </p>\n\
<h2><a class=\"anchor\" id=\"welcome\"></a>\n\
Python Scripting in MotionBuilder</h2>\n\
<p>MotionBuilder has a Python Editor and Python interpreter. You can write and run Python scripts from within MotionBuilder. You can use Python to customize MotionBuilder and for automating repetitive tasks. </p>\n\
<p>Only a subset of the existing C++ Open Reality SDK is exposed to Python using an almost identical class hierarchy. Some Python specific enhancements and additions are made in the exposed subset of the Open Reality SDK. See the pyfbsdk_additions.py file located in &lt;yourinstallationfolder&gt;. You might not be able to perform certain tasks because the necessary classes might not be available in the exposed subset. </p>\n\
<p>You can refer to the What�s New section for information about the new features and changes related to Python. </p>\n\
<h2><a class=\"anchor\" id=\"required\"></a>\n\
Requirements</h2>\n\
<p>You do not have to install any additional software for scripting in Python. MotionBuilder includes a minimal Python environment. If you have installed Python version 2.7.3, it is automatically used for running scripts in MotionBuilder. </p>\n\
<h2><a class=\"anchor\" id=\"limitations\"></a>\n\
Limitations and Restrictions</h2>\n\
<p>Python has the same limitations as the C++ Open Reality SDK because it is an exposed subset of the C++ Open Reality SDK. Additionally, the Python module has the following restrictions: </p>\n\
<ul>\n\
<li>\n\
The only way to run Python from C++ is by using the <a class=\"el\" translate=\"no\" href=\"#!/url=./py_ref/class_f_b_application.html#af17eab9efb66f7d7f82575ac1aa89613\">FBApplication::ExecuteScript</a> function to call the Python modules. For more information, see the <a class=\"el\" translate=\"no\" href=\"#!/url=./py_ref/class_f_b_application.html\">FBApplication</a> class reference in the SDK help. </li>\n\
<li>\n\
Python classes cannot serve as a parent to a client class because the inherited virtual methods cannot be overloaded. </li>\n\
<li>\n\
You cannot set certain enum flags that are exposed in Python. These are reserved flags and cannot be triggered. For example in the <a class=\"el\" translate=\"no\" href=\"#!/url=./py_ref/class_f_b_plug_modification_flag.html\">FBPlugModificationFlag</a> enum, the kFBSelfDataModified, kFBSelfKeyingModified, and kFBContentKeyingModified flags cannot be triggered when they are passed as a pModificationFlags parameter in the NamespaceGetContentList function of the <a class=\"el\" translate=\"no\" href=\"#!/url=./py_ref/class_f_b_scene.html\">FBScene</a> class. </li>\n\
</ul>\n\
<h2><a class=\"anchor\" id=\"custom\"></a>\n\
Custom Modules</h2>\n\
<p>To use a custom Python module, copy your modules to &lt;yourinstallationfolder&gt;/bin/&lt;platform&gt;/python/lib. You can copy the binary modules, such as .pyd for Windows to &lt;yourinstallationfolder&gt;/bin/&lt;platform&gt;/python/lib/plat-win. </p>\n\
<p>If you prefer a different set up, you can modify the PYTHONPATH and PATH environment variables. Please refer to the Python documentation for more information. </p>\n\
<h2><a class=\"anchor\" id=\"typeinfo\"></a>\n\
Class Type</h2>\n\
<p>You can determine if an object is of a certain class type by using the function Is(int pTypeId) in the <a class=\"el\" translate=\"no\" href=\"#!/url=./py_ref/class_f_b_plug.html\">FBPlug</a> class. The parameter pTypeId is a FBClassName_TypeInfo() function that is defined in each class exposed to Python. You can replace ClassName with a class name to determine the class type of the object. </p>\n\
<p>For example: </p>\n\
<p>cube.Is(FBComponent_TypeInfo()) returns True </p>\n\
<p><a class=\"el\" translate=\"no\" href=\"#!/url=./py_ref/class_f_b_system.html\">FBSystem()</a>.Is(FBModel_TypeInfo()) returns False </p>\n\
<h2><a class=\"anchor\" id=\"defaultparam\"></a>\n\
Default Parameter</h2>\n\
<p>If a class constructor has one or more default parameters, you must specify them when calling the constructor. </p>\n\
<h2><a class=\"anchor\" id=\"future\"></a>\n\
Documentation and Feedback</h2>\n\
<dl class=\"section warning\"><dt>Warning</dt><dd>The Python documentation is automatically generated from the Open Reality C++ SDK documentation. If there are any errors, omissions, or inconsistencies, you can report them to ensure that it is corrected. For contact and feedback information, refer to the Information and Technical Support topic in the SDK help.<br>\n\
 </dd></dl>\n\
<h1><a class=\"anchor\" id=\"dist\"></a>\n\
Distribution</h1>\n\
<h2><a class=\"anchor\" id=\"res\"></a>\n\
Resources</h2>\n\
<p>The Open Reality distribution consists of the following: </p><ul>\n\
<li>\n\
<b>Python Scripting Reference Guide (pyfbsdk)</b> </li>\n\
<li>\n\
<b>Python Scripting Sample Scripts</b> </li>\n\
</ul>\n\
</div></div><!-- contents -->\n\
</div><!-- doc-content -->\n\
          <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";