var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-082136AD-10C9-43BB-B911-2FE305305932\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Box layout</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-082136AD-10C9-43BB-B911-2FE305305932\"></a><div class=\"head\">\n\
            <h1>Box layout</h1>\n\
         </div>\n\
         <p><a name=\"WS73099CC142F48755-57AF30D311C79E97FC3E13\"></a>There are two box layouts: <span class=\"code\" translate=\"no\">VBoxLayout</span> (vertical) and <span class=\"code\" translate=\"no\">HBoxLayout</span> (horizontal). When you add a control (or even another layout) to these layouts, the\n\
            controls are aligned either vertically or horizontally. \n\
         </p><a name=\"WS73099CC142F48755-57AF30D311C79E97FC3E15\"></a><p class=\"list-intro\"><a name=\"WS1A9193826455F5FF-E569A012180CE58914D7F\"></a>To add the controls, do one of the following:\n\
         </p>\n\
         <ul>\n\
            <li>Specify a fixed size with <span class=\"code\" translate=\"no\">BoxLayout::Add</span>: width for horizontal layout, and height for vertical layout. When you resize a layout,\n\
               the fixed-size controls stay the same. \n\
            </li>\n\
            <li>Specify a ratio with <span class=\"code\" translate=\"no\">BoxLayout::AddRelative</span>. With ratio, once all controls are in the layout, space is allocated to all controls\n\
               having a fixed size. Then the remaining space is shared with all other controls according\n\
               to their ratio. When you resize a layout, the size of the ratio controls is updated.\n\
               \n\
            </li>\n\
         </ul>\n\
         <p><a name=\"WS73099CC142F48755-57AF30D311C79E97FC3E18\"></a>The sample TutorialBox.py shows how to create a vertical layout containing: a label,\n\
            a container occupying two thirds of the space, and a memo (text control) occupying\n\
            the remaining space. See the BoxLayout.py sample for more examples. \n\
         </p>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";