var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-12F74C2F-2822-4F07-8441-25A1562C7D94\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Model templates</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-12F74C2F-2822-4F07-8441-25A1562C7D94\"></a><div class=\"head\">\n\
            <h1>Model templates</h1>\n\
         </div>\n\
         <p><a name=\"WS1A9193826455F5FF-75C1F7C3124F51CCBD1-E70\"></a>Model templates (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelTemplate\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_template.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_template.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelTemplate</a></span>) are bound to the animation nodes (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBAnimationNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_animation_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_animation_node.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBAnimationNode</a></span>) of models (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a></span>).\n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF-75C1F7C3124F51CCBD1-E6F\"></a>A model template can be bound to markers or to skeleton nodes depending on the arguments\n\
            passed to the <span class=\"code\" translate=\"no\">FBModelTemplate:: FBModelTemplate()</span> constructor. The animation nodes which are bound to the model template are created\n\
            by the plugin device using a call to <span class=\"code\" translate=\"no\">AnimationNodeOutCreate()</span>. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF-75C1F7C3124F51CCBD1-E6E\"></a>The model templates have to be arranged in a hierarchy that corresponds to the skeleton\n\
            node hierachy of the physical device. The hierarchy of model template is created by\n\
            calling <span class=\"code\" translate=\"no\">FBProperlyListModelTemplate::Add()</span> on the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelTemplate::Children\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_template.html#a1027083e725c564785f8d714dd488e57&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelTemplate::Children</a></span> property. A root model template is created by passing <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"kFBModelTemplateRoot\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a50a7864c9f55f471aef32b7db64d4355aa9e390716f846856dc4ed7e7f2091c5e&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">kFBModelTemplateRoot</a></span> to the constructor. The root must then added to the device model template, for example:\n\
            <span class=\"code\" translate=\"no\">ModelTemplate.Children.Add(mRootTemplate);</span>.\n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF-75C1F7C3124F51CCBD1-E6D\"></a>Once the hierarchy is created, the model templates are bound to specific animation\n\
            nodes by calling <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPropertyListModelTemplateBinding::Add()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_property_list_model_template_binding.html#a807c1329ef19e73acf46090102d0c74e&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPropertyListModelTemplateBinding::Add()</a></span> on the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelTemplate::Bindings\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_template.html#a2d229231c14f4eb6f41abc4599ac2fa2&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelTemplate::Bindings</a></span> property. A model template would typically have bindings to two animation node, one\n\
            for translation and one for rotation. When model templates are no longer used the\n\
            bindings should be removed using <span class=\"code\" translate=\"no\">FBPropertyListModelTemplateBinding::Remove()</span>.\n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF6DEA2AA512298434427-7C53\"></a>A model template is an empty placeholder for input/output information to animate a\n\
            model. When the placeholder is set, the data is then applied to its child model (if\n\
            the child exists). This creates a link between the for example a mocap device and\n\
            the bones or markers of a 3D model in a MotionBuilder scene.\n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF6DEA2AA512298434427-7C4F\"></a>Model binding means binding templates to models and is used to get the same device\n\
            to animate different sets of models in a single scene.\n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF6DEA2AA512298434427-7C4E\"></a>This is similar to the analogy of the input for characters in the Character tool.\n\
            When creating a device, instead of creating specific models within the creation routines,\n\
            you should create objects of the class <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelTemplate\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_template.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_template.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelTemplate</a></span>. If it has no children, it is impossible to create a model binding for the device.\n\
            For an example project, see ordevice_template.\n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF6DEA2AA512298434427-7C4D\"></a>When model templates exist for a device, you are able to select the model binding\n\
            (the set of models to be driven by the device input) from the Model Binding list under\n\
            the Device controls (Online, Live &amp; Recording).\n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF6DEA2AA512298434427-7C4B\"></a>Best practice is to add a prefix to the root of your model template hierarchy (as\n\
            in the examples) to differentiate models that belong to your root model from other\n\
            models already in the scene.\n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF-75C1F7C3124F51CCBD1-E6C\"></a>A device plug-in could create model templates in its override of FBDevice:: FBCreate()\n\
            or in response to the FBDevice::DeviceOperation() call with the kOpStart flag.\n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-575EAB4C124F5234AA8-38AD\"></a> <span class=\"code\" translate=\"no\">ModelTemplateBindNotify</span> and <span class=\"code\" translate=\"no\">ModelTemplateUnBindNotify</span> are callbacks that send notification of a change in the binding status of a model.\n\
         </p>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";