var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-14801481-6BFB-4959-84A0-3148A79C3D7B\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Creating and Characterizing a Skeleton</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-14801481-6BFB-4959-84A0-3148A79C3D7B\"></a><div class=\"head\">\n\
            <h1>Creating and Characterizing a Skeleton</h1>\n\
         </div>\n\
         <p><a name=\"GUID-13683598-31A3-4E63-8B02-9A43D7FE57B9\"></a> This sample is a part of the <span class=\"filePath\" translate=\"no\">CharacterMarkerSetFromActor.py</span> script. The full script is located in <span class=\"filePath\" translate=\"no\">&lt;yourinstallationfolder&gt;\\bin\\config\\Scripts\\Samples\\Character</span>. \n\
         </p>\n\
         <div class=\"codeBlock\"><a name=\"LANG-PY\"></a><pre class=\"prettyprint lang-py\">def GetOrCreateSkeletonNode(pIndex,pPrefix,pCreateIfNotExisting=True):\n\
    if IsValidSkeletonNodeId(pIndex) == False:\n\
        return None\n\
    lName = GetFBSkeletonNodeIdName(pIndex,pPrefix)\n\
    lSkeletonNode = <a href=\"javascript:void(0)\" data-symbol=\"FBFindObjectByFullName\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga980a7ebfc02171f683b0bfed6527faa2&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFindObjectByFullName</a>(\'Model::\'+lName)\n\
    if lSkeletonNode == None and pCreateIfNotExisting:\n\
        if FBSkeletonNodeId.values[pIndex] != FBSkeletonNodeId.kFBSkeletonReferenceIndex:\n\
            lSkeletonNode = <a href=\"javascript:void(0)\" data-symbol=\"FBModelSkeleton\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_skeleton.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelSkeleton</a>(lName)\n\
        else:\n\
            lSkeletonNode = <a href=\"javascript:void(0)\" data-symbol=\"FBModelNull\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_null.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelNull</a>(lName)\n\
        lSkeletonNode.Show = True\n\
    return lSkeletonNode\n\
def CreateSkeletonForActor(pActor,pPrefix):\n\
    lState = pActor.GetCurrentSkeletonState(True)\n\
    lGX = <a href=\"javascript:void(0)\" data-symbol=\"FBMatrix\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_matrix.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMatrix</a>()\n\
    for enum in FBSkeletonNodeId.values:\n\
        if IsValidSkeletonNodeId(enum):\n\
            lState.GetNodeMatrix(FBSkeletonNodeId.values[enum],lGX)\n\
            lSkeletonNode = GetOrCreateSkeletonNode(enum,pPrefix)\n\
            lParentId = GetFBSkeletonNodeIdParentId(enum)\n\
            lParentSkeletonNode = GetOrCreateSkeletonNode(lParentId,pPrefix)\n\
            lSkeletonNode.SetMatrix(lGX)\n\
            if lParentSkeletonNode != None:\n\
                lSkeletonNode.Parent = lParentSkeletonNode\n\
def MapSkeletonBone(pCharacter, pIndex, pPrefix):\n\
    lModel = GetOrCreateSkeletonNode(pIndex,pPrefix)\n\
    if lModel != None and pCharacter != None:\n\
        lMappingPropName = lSkeletonNodeCharacterizationMapping[FBSkeletonNodeId.values[pIndex]]\n\
        lMappingProp = pCharacter.PropertyList.Find(lMappingPropName,False)\n\
        if lMappingProp != None:\n\
            lMappingProp.ConnectSrc(lModel)\n\
        else:\n\
            print \'Could not characterize: \' + lModel.Name + \'; MappingName: \' + lMappingPropName\n\
def CharacterizeActorSkeleton(pPrefix):\n\
    lCharacter = <a href=\"javascript:void(0)\" data-symbol=\"FBCharacter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_character.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacter</a>(pPrefix+\'Character\')\n\
    for enum in FBSkeletonNodeId.values:\n\
        if IsValidSkeletonNodeId(enum):\n\
            MapSkeletonBone(lCharacter, enum, pPrefix)\n\
    lCharacter.SetCharacterizeOn(True)\n\
    <a href=\"javascript:void(0)\" data-symbol=\"FBSystem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem</a>().Scene.Evaluate()\n\
    return lCharacter   \n\
def ConvertActorToCharacter(pActor, pPrefix):\n\
    # create the skeleton from the actor\n\
    CreateSkeletonForActor(pActor,pPrefix)\n\
    # <a href=\"javascript:void(0)\" data-symbol=\"Set\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a8b39bad9fda6bc73af75e4d6085bcf91&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Set</a> up characterization and lock the character\n\
    lChar = CharacterizeActorSkeleton(pPrefix)</pre></div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";