var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-2BEF3EE1-FC61-48EC-831D-7025D0961691\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Joint Chains</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-2BEF3EE1-FC61-48EC-831D-7025D0961691\"></a><div class=\"head\">\n\
            <h1>Joint Chains</h1>\n\
         </div>\n\
         <p><a name=\"GUID-AE377A48-3F56-47C8-916B-E52AD330AD86\"></a>This topic builds on the concepts presented in <span class=\"char_link\"><a href=\"#!/url=./files/GUID-FFBAE6DD-7929-4421-B7F3-4AEE50A2F0EB.htm\">Rigid Body Physics</a></span> and uses a Rigid Body Physical Property in conjunction with an instance of Joint\n\
            Physical Property. \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_25192ED7EBFC4566891982E9B52ACEF4\"></a> \n\
            <h2><a name=\"GUID-1B166C1C-84A7-491C-BB13-A2E3BC196400\"></a>Creating Joints\n\
            </h2> \n\
            <p><a name=\"GUID-6DDD178E-F6CA-445E-A8D5-2ABC3BB50CD3\"></a>To create a joint in the scene, we first require at least three models, as depicted\n\
               in the image below. The parent and child models are used to identify the extremities\n\
               of a joint. The null model in the middle represents the point around which the models\n\
               will rotate. The parent and child models are typically connected to a Rigid Body Physical\n\
               Property to allow them to react to physical forces and collisions (see <span class=\"char_link\"><a href=\"#!/url=./files/GUID-FFBAE6DD-7929-4421-B7F3-4AEE50A2F0EB.htm\">Rigid Body Physics</a></span>). \n\
            </p> \n\
            <p><a name=\"GUID-EED691F8-9C49-4B6D-AA3C-DA98E26FC07B\"></a></p> <img src=\"images/GUID-F1D2CC1C-F000-4349-8754-229987D8738C-low.png\"> \n\
            <p><a name=\"GUID-492BB3FF-221F-4F49-8C9B-EABAC0B4F1F5\"></a>The Joint Physical Property object is used to constrain these models to act as a physical\n\
               joint. An instance of Joint Physical Property is created via <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCreateObject()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a5111370ada05db17e04b97b447ddbd7c&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga6698333c163da7c3bc077537889b6c33&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCreateObject()</a></span> using the Asset Browser path <span class=\"code\" translate=\"no\">\'Browsing/Templates/Physical Properties\'</span> and the <span class=\"code\" translate=\"no\">\'Joint\'</span> entry name. A null model is first connected to the Joint Physical Property via <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBConnect()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#ae714fd0a71698e4948530ed309901c60&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga332a173e2c25db9dcf3a55118981a303&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConnect()</a></span> to define a new point of rotation. This generates an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_component.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent</a></span> within the Joint Physical Property whose name corresponds to <span class=\"code\" translate=\"no\">\'&lt;null_model_name&gt; Joint\'</span>. The parent and child models are thereafter connected to this new <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_component.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent</a></span>\'s <span class=\"code\" translate=\"no\">\'Connections\'</span> property via <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBConnect()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#ae714fd0a71698e4948530ed309901c60&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga332a173e2c25db9dcf3a55118981a303&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConnect()</a></span>. This process is outlined in the following code sample, taken from the <span class=\"char_link\"><a href=\"#!/url=./files/GUID-2BEF3EE1-FC61-48EC-831D-7025D0961691.htm#SECTION_F38B73E9B89B43E0AE594F2D02E65D7A\">example</a></span> below. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\"># Create the necessary relationships within a Joint Physical Property object.\n\
def createJoints(pNullDict):\n\
    # The \'joint\' <a href=\"javascript:void(0)\" data-symbol=\"object\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#a904fdf014f8cdbefe8320ca2bfd6daf6&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">object</a> maintains the physical property relations between model pairs and\n\
    # their respective points of rotation.\n\
    joint = <a href=\"javascript:void(0)\" data-symbol=\"FBCreateObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga6698333c163da7c3bc077537889b6c33&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCreateObject</a>( \'Browsing/Templates/Physical Properties\', \'Joint\', \'Joint\' )\n\
    \n\
    # Bind each \'(parent, child)\' <a href=\"javascript:void(0)\" data-symbol=\"key\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#ada6705808cbd8c921df38387db9a6aee&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">key</a> and its associated \'nullModel\' to the joint object.\n\
    for (parent, child), nullModel in pNullDict.iteritems():\n\
        \n\
        # Connect the joint to the nullModel to define the point of rotation for this (parent, child) pair\n\
        <a href=\"javascript:void(0)\" data-symbol=\"FBConnect\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga332a173e2c25db9dcf3a55118981a303&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConnect</a>(joint, nullModel)        \n\
        \n\
        # Connect the parent and child models to the joint to have them use the nullModel\n\
        # as a point of rotation.\n\
        for component in joint.Components:\n\
            connectionProp = None\n\
            if component.Name == nullModel.Name + \' Joint\':\n\
                connectionProp = component.PropertyList.Find(\'Connections\')\n\
                if connectionProp != None:\n\
                    # (!!!) Note: The order of the <a href=\"javascript:void(0)\" data-symbol=\"parameters\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/graminit_8h.html#aa270e645a3c2003a3bc549f72b7193ae&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">parameters</a> in <a href=\"javascript:void(0)\" data-symbol=\"FBConnect\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga332a173e2c25db9dcf3a55118981a303&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConnect</a>() is \n\
                    #       important!\n\
                    <a href=\"javascript:void(0)\" data-symbol=\"FBConnect\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga332a173e2c25db9dcf3a55118981a303&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConnect</a>(parent, connectionProp)\n\
                    <a href=\"javascript:void(0)\" data-symbol=\"FBConnect\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga332a173e2c25db9dcf3a55118981a303&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConnect</a>(child, connectionProp)</pre></div> \n\
            <div><a name=\"GUID-4F0C35C4-001E-41DA-AB46-DB97CE4C53BC\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>A single Joint Physical Property object can be used to create a chain of joints. \n\
               </div>\n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_F38B73E9B89B43E0AE594F2D02E65D7A\"></a> \n\
            <h2><a name=\"GUID-DAE3A771-86E2-494F-BD9C-1C009BC23F0B\"></a>Example: Rooted Joint Chain with Inverted Gravity\n\
            </h2> \n\
            <p><a name=\"GUID-5DAC2142-5AFB-4CCF-8692-A755663FCE9C\"></a> <em class=\"strong\">Sample Viewport Output:</em> \n\
            </p> \n\
            <p><a name=\"GUID-AC866537-468C-4B59-8553-5FA1A63E211F\"></a></p> <img src=\"images/GUID-8E565C39-AF36-41FE-BA92-9650BA1ADE5E-low.png\"> \n\
            <p><a name=\"GUID-7538F25A-64CE-4EB5-8CB3-8F2B0456E90E\"></a><em class=\"strong\">Program Summary:</em> The program below begins by creating a chain of cube primitives, arranged in a sequential\n\
               parent-child hierarchy. The base cube of this chain is passively rooted on the ground\n\
               plane and every other cube is assigned an active Rigid Body Physical Property. \n\
            </p> \n\
            <p><a name=\"GUID-2A9A07E1-1BE4-499B-B003-9308C220EAD3\"></a>An instance of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelNull\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_null.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_null.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelNull</a></span> is inserted between each parent-child pair in the cube chain to identify each joint\'s\n\
               point of rotation. A single Joint Physical Property object is then used to constrain\n\
               the chain\'s movement. Lastly, the Physics Solver\'s <span class=\"code\" translate=\"no\">\'Gravity\'</span> property is set to <span class=\"code\" translate=\"no\">(0, 9.81, 0)</span> to invert the force of gravity in the scene. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">from pyfbsdk import *\n\
\n\
# This tutorial loosely follows the steps outlined in the MotionBuilder User Guide topic:\n\
# \"User Guide &gt; Animating with Physical Properties &gt; Joint Physical property &gt; Creating a Joint chain reaction\"\n\
\n\
# <a href=\"javascript:void(0)\" data-symbol=\"Global\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a84df3f9175f02c4e11e66859646892f7&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Global</a> variables used to create the scene.\n\
numModels = 7\n\
modelSpacing = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(0, 21, 0)\n\
chainStart = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(-50, 0, 0)\n\
gravity = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(0, 9.81, 0)\n\
\n\
\n\
###############################################################\n\
# Helper Function(<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a>).                                         #\n\
###############################################################\n\
\n\
# Create a primitive from the asset browser.\n\
def createModel(pIndex, pTranslation):    \n\
    #model = <a href=\"javascript:void(0)\" data-symbol=\"FBCreateObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga6698333c163da7c3bc077537889b6c33&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCreateObject</a>( \'Browsing/Templates/Elements/Primitives\', \'polySphere\', \'polySphere\' )\n\
    model = <a href=\"javascript:void(0)\" data-symbol=\"FBCreateObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga6698333c163da7c3bc077537889b6c33&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCreateObject</a>( \'Browsing/Templates/Elements/Primitives\', \'Cube\', \'Cube\' )\n\
    model.Name = \'myModel\' + <a href=\"javascript:void(0)\" data-symbol=\"str\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/node_8h.html#a62b34ca1362fe946082b7aa0cd9be844&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">str</a>(pIndex)\n\
    model.Translation = pTranslation\n\
    model.Scaling = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(1, 1, 1)\n\
    model.Show = True\n\
    \n\
    return model\n\
\n\
\n\
# Create a null model at the specific position. A null model is used \n\
# to identify the rotation point between two models to form a joint.\n\
def createNull(pIndex, pTranslation):\n\
    nullModel = <a href=\"javascript:void(0)\" data-symbol=\"FBModelNull\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_null.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelNull</a>(\'myNull\' + <a href=\"javascript:void(0)\" data-symbol=\"str\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/node_8h.html#a62b34ca1362fe946082b7aa0cd9be844&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">str</a>(pIndex))\n\
    nullModel.Translation = pTranslation\n\
    nullModel.Show = True\n\
    \n\
    return nullModel\n\
\n\
\n\
# Create a chain of models distanced \'pModelSpacing\' apart starting at \n\
# the position \'pChainStart\'.\n\
def createModelChain(pChainStart, pNumModels, pModelSpacing):\n\
    models = []\n\
    for <a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a> in range(0, pNumModels):\n\
        modelOffset = pModelSpacing * <a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a>\n\
        modelPosition = pChainStart + modelOffset        \n\
        newModel = createModel(<a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a>, modelPosition)\n\
        models.append(newModel)\n\
        \n\
    return models\n\
\n\
\n\
# Create a null between each model in the chain.\n\
def createNullsFromModels(pModels):\n\
    # The \'nulls\' dictionary maps a pair of models (parent, child) to a\n\
    # null model. This null model denotes the point of rotation between the parent/child models.\n\
    # The resulting dictionary will look like this for 7 models:\n\
    #\n\
    # nulls = {\n\
    #     (myModel0, myModel1) : myNull1,\n\
    #     (myModel1, myModel2) : myNull2,\n\
    #          ...\n\
    #     (myModel5, myModel6) : myNull6\n\
    # }\n\
    #\n\
    nulls = {}\n\
    \n\
    for <a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a> in range(1, <a href=\"javascript:void(0)\" data-symbol=\"len\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#abc8b352d6723c361fc39710e5b10b502&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">len</a>(pModels)):\n\
        parent = pModels[<a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a>-1]\n\
        child = pModels[<a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a>]\n\
        \n\
        # Create the null at the halfway point between two models.\n\
        position0 = parent.Translation.Data\n\
        position1 = child.Translation.Data\n\
        nullPosition = position0 + (position1 - position0) / 2\n\
        \n\
        # Create the null and associate it to the (parent, child) pair\n\
        # in the \'nulls\' dictionary.\n\
        nullModel = createNull(<a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a>, nullPosition)\n\
        nulls[(parent, child)] = nullModel\n\
        \n\
    return nulls\n\
\n\
\n\
# Apply a Rigid Body physical property to the models in the list.\n\
# The pActivation parameter defines the Activation value.\n\
# 0: Active | 1: Active at Collision | 2: Passive\n\
def applyRigidBody(pModelList, pActivation):\n\
    # Create the rigid body <a href=\"javascript:void(0)\" data-symbol=\"object\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#a904fdf014f8cdbefe8320ca2bfd6daf6&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">object</a> from the Asset Browser.\n\
    rigidBody = <a href=\"javascript:void(0)\" data-symbol=\"FBCreateObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga6698333c163da7c3bc077537889b6c33&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCreateObject</a>( \'Browsing/Templates/Physical Properties\', \'Rigid Body\', \'Rigid Body\' )\n\
    \n\
    # <a href=\"javascript:void(0)\" data-symbol=\"Set\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a8b39bad9fda6bc73af75e4d6085bcf91&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Set</a> the Activation property.\n\
    activationProp = rigidBody.PropertyList.Find(\'Activation\')\n\
    activationProp.Data = pActivation\n\
    \n\
    # <a href=\"javascript:void(0)\" data-symbol=\"If\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a3caa32cf8ff8db15e5835f5e40e6c6f8&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">If</a> we are using Active activation, set the Correct Mass Center to false.\n\
    if(pActivation == 0) :    \n\
        correctMassCenter = rigidBody.PropertyList.Find(\'Correct Mass Center\')\n\
        correctMassCenter.Data = False\n\
    \n\
    # Connect the rigid body to the model.\n\
    for model in pModelList:\n\
        <a href=\"javascript:void(0)\" data-symbol=\"FBConnect\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga332a173e2c25db9dcf3a55118981a303&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConnect</a>(rigidBody, model)\n\
\n\
\n\
# Create the necessary relationships within a Joint Physical Property object.\n\
def createJoints(pNullDict):\n\
    # The \'joint\' <a href=\"javascript:void(0)\" data-symbol=\"object\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#a904fdf014f8cdbefe8320ca2bfd6daf6&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">object</a> maintains the physical property relations between model pairs and\n\
    # their respective points of rotation.\n\
    joint = <a href=\"javascript:void(0)\" data-symbol=\"FBCreateObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga6698333c163da7c3bc077537889b6c33&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCreateObject</a>( \'Browsing/Templates/Physical Properties\', \'Joint\', \'Joint\' )\n\
    \n\
    # Bind each \'(parent, child)\' <a href=\"javascript:void(0)\" data-symbol=\"key\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#ada6705808cbd8c921df38387db9a6aee&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">key</a> and its associated \'nullModel\' to the joint object.\n\
    for (parent, child), nullModel in pNullDict.iteritems():\n\
        \n\
        # Connect the joint to the nullModel to define the point of rotation for this (parent, child) pair\n\
        <a href=\"javascript:void(0)\" data-symbol=\"FBConnect\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga332a173e2c25db9dcf3a55118981a303&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConnect</a>(joint, nullModel)        \n\
        \n\
        # Connect the parent and child models to the joint to have them use the nullModel\n\
        # as a point of rotation.\n\
        for component in joint.Components:\n\
            connectionProp = None\n\
            if component.Name == nullModel.Name + \' Joint\':\n\
                connectionProp = component.PropertyList.Find(\'Connections\')\n\
                if connectionProp != None:\n\
                    # (!!!) Note: The order of the <a href=\"javascript:void(0)\" data-symbol=\"parameters\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/graminit_8h.html#aa270e645a3c2003a3bc549f72b7193ae&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">parameters</a> in <a href=\"javascript:void(0)\" data-symbol=\"FBConnect\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga332a173e2c25db9dcf3a55118981a303&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConnect</a>() is \n\
                    #       important!\n\
                    <a href=\"javascript:void(0)\" data-symbol=\"FBConnect\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga332a173e2c25db9dcf3a55118981a303&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConnect</a>(parent, connectionProp)\n\
                    <a href=\"javascript:void(0)\" data-symbol=\"FBConnect\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga332a173e2c25db9dcf3a55118981a303&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConnect</a>(child, connectionProp)\n\
\n\
\n\
# Create a physics solver.\n\
def createPhysicsSolver(pGravity):\n\
    solver = <a href=\"javascript:void(0)\" data-symbol=\"FBCreateObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga6698333c163da7c3bc077537889b6c33&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCreateObject</a>( \'Browsing/Templates/Solvers\', \'Physics Solver\', \'Physics Solver\' )\n\
    \n\
    # <a href=\"javascript:void(0)\" data-symbol=\"Set\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a8b39bad9fda6bc73af75e4d6085bcf91&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Set</a> the gravity property.\n\
    solver.PropertyList.Find(\'Gravity\').Data = pGravity\n\
    \n\
    # Activate the Physics solver.\n\
    solver.Active = True\n\
    solver.Live = True\n\
\n\
\n\
###############################################################\n\
# Main.                                                       #\n\
###############################################################\n\
# Clear the scene.\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a>().FileNew()\n\
\n\
# Create a chain of models.\n\
models = createModelChain(chainStart, numModels, modelSpacing)\n\
applyRigidBody([models[0]], 2) # Rigid Body - Passive Activation (2).\n\
applyRigidBody(models[1:], 0)  # Rigid Body - Active Activation (0).\n\
\n\
# Create nulls between each model.\n\
nullDict = createNullsFromModels(models)\n\
\n\
# Create the joints between the models and the nulls.\n\
createJoints(nullDict)\n\
\n\
# Create and activate a physics solver in the scene.\n\
createPhysicsSolver(gravity)\n\
\n\
# Move the <a href=\"javascript:void(0)\" data-symbol=\"base\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#af89ed82bba25b3f21c2294d4f56636f9&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">base</a> to make the chain wiggle.\n\
models[0].Translation.Data += <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(50, 0, 0)</pre></div> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";