var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-2E76D18A-BF4A-4C13-B5C7-2CB6225E5893\">\n\
      <meta name=\"description\" content=\"This section describes the available user interface components to interact with plugins developed for MotionBuilder. It also addresses layouts, spreadsheets, events, and widgets.\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>User Interface</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-2E76D18A-BF4A-4C13-B5C7-2CB6225E5893\"></a><div class=\"head\">\n\
            <h1>User Interface</h1>\n\
         </div>\n\
         <p class=\"blurb\">This section describes the available user interface components to interact with plugins\n\
            developed for MotionBuilder. It also addresses layouts, spreadsheets, events, and\n\
            widgets. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF6DEA2AA512298434427-7B75\"></a>These classes are derived from <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBVisualComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_visual_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVisualComponent</a></span>. They expose all of the widgets that are available in the MotionBuilder interface\n\
            to be used in custom layouts. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF-6AB24494123382A9C4B-56BE\"></a>The C++ code sample in <span class=\"code\" translate=\"no\">tooluidemo</span> shows some of the available functionality. \n\
         </p>\n\
         <p><a name=\"WS1A9193826455F5FF6DEA2AA512298434427-7B73\"></a>The user interface components in the ORSDK are all derived from the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBVisualComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_visual_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVisualComponent</a></span> class. This provides you with the tools necessary to interact with plug-ins developed\n\
            for MotionBuilder. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-57AF30D311C79E97FC3E0C\"></a>All MotionBuilder UI controls are exposed to Python. They behave mostly like their\n\
            OpenReality C++ counterparts. To help with UI building, helper classes are provided\n\
            in <span class=\"code\" translate=\"no\">pyfbsdk_additions</span>. \n\
         </p><span class=\"noindex\">\n\
            <div class=\"topic-list\">\n\
               <h4 class=\"related\">Topics in this section</h4>\n\
               <ul class=\"jumplist\">\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-B2D8C726-79EC-4C0B-BC75-BBF3E8083F0A.htm\">UI components</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-15C107CA-B043-4F12-B8DF-1C697CEB601D.htm\">Python tools: best practices</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-C9B1791F-23C9-4B16-BC77-C9ED2500C114.htm\">Layouts</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-17311C1D-06A5-41DF-A7EF-DA6C01F659F8.htm\">Manipulators</a></li>\n\
               </ul>\n\
            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";