var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-3D242E6C-0A04-4BE3-84A7-C7FF923527EE\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>FBCamera - Cameras</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-3D242E6C-0A04-4BE3-84A7-C7FF923527EE\"></a><div class=\"head\">\n\
            <h1>FBCamera - Cameras</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_D310AA730B8F4A47805A1718EA7DBB60\"></a> \n\
            <h2><a name=\"GUID-47E9169A-B4D6-4081-A2A9-692426A9D21A\"></a>Creating a Camera\n\
            </h2> \n\
            <p><a name=\"GUID-12D92271-1DE9-435C-888F-C7FB43BC9D2B\"></a>Cameras are encapsulated by the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCamera\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_camera.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_camera.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCamera</a></span> class. 3D stereo vision cameras are encapsulated by the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCameraStereo\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_camera_stereo.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_camera_stereo.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCameraStereo</a></span> class, a subclass of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCamera\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_camera.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_camera.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCamera</a></span>. A camera is created using the <span class=\"code\" translate=\"no\">FBCamera()</span> constructor. The interest point of a camera can be set via <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCamera.Interest\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_camera.html#a61b60409484b64c477a86ee1d5523d4f&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCamera.Interest</a></span>, which forces the camera to maintain its focus on a specific instance of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a></span> in the scene. Showing the camera (FBCamera.Show) allows you to view the camera as\n\
               a wireframe object in the scene. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">camera = <a href=\"javascript:void(0)\" data-symbol=\"FBCamera\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_camera.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCamera</a>(\'myCamera\')\n\
camera.Interest = pModel\n\
camera.Show = True</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_0FFFE496930240F6BB65DCC764CE13CA\"></a> \n\
            <h2><a name=\"GUID-96314324-6F2D-4E60-8A8D-8BC2C0C74F12\"></a>Camera Properties\n\
            </h2> \n\
            <p><a name=\"GUID-8F33F70D-2082-47EA-A2A6-91481C72E246\"></a>The properties documented in the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCamera\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_camera.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_camera.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCamera</a></span> class reference reflect the properties available through the MotionBuilder user interface.\n\
               These properties should be modified from their <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBProperty.Data\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_property.html#af5baa506e65b4caa6be6d1c6661dfe63&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBProperty.Data</a></span> field, as illustrated in the following code sample where we modify the camera\'s motion\n\
               blur properties. For more information on properties, see <span class=\"char_link\"><a href=\"#!/url=./files/GUID-7871AFE8-5209-4377-B4B4-2881840E7EDF.htm\">FBProperty - Object Properties</a></span>. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">camera.PropertyList.Find(\'UseMotionBlur\').Data = True\n\
camera.PropertyList.Find(\'UseRealTimeMotionBlur\').Data = True\n\
camera.PropertyList.Find(\'Motion Blur Intensity\').Data = 2</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_442BC60D333044C59DF47DFB5867F2FE\"></a> \n\
            <h2><a name=\"GUID-E28217D7-BA73-4F3D-B771-7772FD986DD1\"></a>Switching the Viewport to a Different Camera\n\
            </h2> \n\
            <p><a name=\"GUID-A978B28A-0987-4873-BFCA-B204CF3717B5\"></a>The viewport\'s perspective can be changed to a different camera using the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCameraSwitcher\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_camera_switcher.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_camera_switcher.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCameraSwitcher</a></span> class, and its <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCameraSwitcher.CurrentCamera\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_camera_switcher.html#a1fdadf0d9903f037c7497baa833cb695&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCameraSwitcher.CurrentCamera</a></span> property. Programmatic camera switching is disabled by default in the scene, so it\n\
               must be enabled via the scene\'s <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBRenderer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_renderer.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBRenderer</a></span> object and its <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBRenderer.UseCameraSwitcher\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_renderer.html#a87906e58506b5a21890097ad5c5150ea&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBRenderer.UseCameraSwitcher</a></span> property. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\"># Enable camera switching.\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBSystem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem</a>().Scene.Renderer.UseCameraSwitcher = True        \n\
    \n\
# <a href=\"javascript:void(0)\" data-symbol=\"Set\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a8b39bad9fda6bc73af75e4d6085bcf91&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Set</a> our <a href=\"javascript:void(0)\" data-symbol=\"view\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#acf20161ba2eafe657cb45d60dafefb51&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">view</a> to the newly created camera.\n\
cameraSwitcher = <a href=\"javascript:void(0)\" data-symbol=\"FBCameraSwitcher\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_camera_switcher.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCameraSwitcher</a>()\n\
cameraSwitcher.CurrentCamera = camera</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_0247889C7FDB468FB6D34A0873672FAF\"></a> \n\
            <h2><a name=\"GUID-F7AF24AE-13FE-4ECE-8B7F-01D9E44BF9F5\"></a>Example: Animating a Camera\n\
            </h2> \n\
            <p><a name=\"GUID-82131BED-CF77-4341-B0D1-28E8E3F03D05\"></a> <em class=\"strong\">Sample Viewport and FCurve Editor Output:</em> \n\
            </p> \n\
            <p><a name=\"GUID-7FE296B8-6BBA-4C14-850C-710CBE6D18AD\"></a></p> <img src=\"images/GUID-E0A99B44-0659-45FD-B129-4A26DF0A4393-low.png\"> \n\
            <p><a name=\"GUID-26518DD1-02A1-4890-A7EB-0EDAFFABD4A1\"></a><em class=\"strong\">Program Summary:</em> The program below creates a torus (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a></span>), and a camera (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCamera\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_camera.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_camera.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCamera</a></span>) with motion blur enabled. The program uses the scene\'s camera switcher (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCameraSwitcher\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_camera_switcher.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_camera_switcher.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCameraSwitcher</a></span>) to switch the viewport\'s perspective to the newly created camera. An animated translation\n\
               around the torus is then applied to the camera using one of two methods: <a name=\"UL_7C1559A586074244BAE93A957EE49365\"></a><ul>\n\
                  <li><span class=\"code\" translate=\"no\">applyKeys1()</span> - Applies keys to the camera\'s <em class=\"strong\">translation</em> animation node directly via <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBAnimationNode.SetCandidate()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_animation_node.html#a11f9f96e17fb091d1cafe008108f7550&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBAnimationNode.SetCandidate()</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBAnimationNode.KeyCandidate()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_animation_node.html#a1e97c7f6aeb4d723e423a9d1dc442694&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBAnimationNode.KeyCandidate()</a></span>. \n\
                  </li>\n\
                  <li><span class=\"code\" translate=\"no\">applyKeys2()</span> - Applies keys to the individual <span class=\"code\" translate=\"no\">FCurve</span>s of the <em class=\"strong\">X, Y, Z</em> elements contained within the camera\'s translation animation node. We additionally\n\
                     set a cubic interpolation at each key for a smoother camera motion around the torus.\n\
                     \n\
                  </li>\n\
               </ul> \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">from pyfbsdk import *\n\
\n\
# Define a list of keys to be used later in the applyKeys1()\n\
# and applyKeys2() functions.\n\
keyList = [\n\
    #(time: <a href=\"javascript:void(0)\" data-symbol=\"FBTime\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_time.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTime</a>  ,  coords: [<a href=\"javascript:void(0)\" data-symbol=\"x\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#a280f2393c503127fff91ecbc558e288d&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">x</a>,y,z] coordinate list)\n\
    (<a href=\"javascript:void(0)\" data-symbol=\"FBTime\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_time.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTime</a>(0, 0, 0),  [0, 100, -100]),\n\
    (<a href=\"javascript:void(0)\" data-symbol=\"FBTime\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_time.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTime</a>(0, 0, 1),  [100, 100, 0]),\n\
    (<a href=\"javascript:void(0)\" data-symbol=\"FBTime\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_time.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTime</a>(0, 0, 2),  [0, 100, 100]),\n\
    (<a href=\"javascript:void(0)\" data-symbol=\"FBTime\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_time.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTime</a>(0, 0, 3),  [-100, 100, 0]),\n\
    (<a href=\"javascript:void(0)\" data-symbol=\"FBTime\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_time.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTime</a>(0, 0, 4),  [0, 100, -100])\n\
]\n\
\n\
###############################################################\n\
# Helper Function(<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a>).                                         #\n\
###############################################################\n\
\n\
# Create a model to look at.\n\
def createModel():\n\
    model = <a href=\"javascript:void(0)\" data-symbol=\"FBCreateObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga6698333c163da7c3bc077537889b6c33&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCreateObject</a>( \'Browsing/Templates/Elements/Primitives\', \'Torus\', \'Torus\' )\n\
    model.Name = \'myModel\'\n\
    model.Translation = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(0, 75, 0)\n\
    model.Scaling = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(2, 2, 2)\n\
    model.Rotation = <a href=\"javascript:void(0)\" data-symbol=\"FBVector3d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_vector3d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector3d</a>(90, 0, 0)\n\
    model.Show = True\n\
    return model\n\
\n\
# Create a camera looking at the model.\n\
def createCamera(pModel):\n\
    camera = <a href=\"javascript:void(0)\" data-symbol=\"FBCamera\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_camera.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCamera</a>(\'myCamera\')\n\
    camera.Interest = pModel\n\
    camera.Show = True\n\
    \n\
    # Enable motion blurring for the camera.\n\
    camera.PropertyList.Find(\'UseMotionBlur\').Data = True\n\
    camera.PropertyList.Find(\'UseRealTimeMotionBlur\').Data = True\n\
    camera.PropertyList.Find(\'Motion Blur Intensity\').Data = 2\n\
    \n\
    # Enable camera switching.\n\
    <a href=\"javascript:void(0)\" data-symbol=\"FBSystem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem</a>().Scene.Renderer.UseCameraSwitcher = True        \n\
    \n\
    # <a href=\"javascript:void(0)\" data-symbol=\"Set\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a8b39bad9fda6bc73af75e4d6085bcf91&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Set</a> our <a href=\"javascript:void(0)\" data-symbol=\"view\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#acf20161ba2eafe657cb45d60dafefb51&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">view</a> to the newly created camera.\n\
    cameraSwitcher = <a href=\"javascript:void(0)\" data-symbol=\"FBCameraSwitcher\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_camera_switcher.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCameraSwitcher</a>()\n\
    cameraSwitcher.CurrentCamera = camera\n\
    \n\
    return camera\n\
    \n\
# First method of applying keys to an animation node.\n\
# Here, we add keys directly to the translation animation node.\n\
def applyKeys1(pTranslationAnimNode):\n\
    # keyList is defined at the top of this file.\n\
    global keyList\n\
    \n\
    for time, coords in keyList:\n\
        # time format: <a href=\"javascript:void(0)\" data-symbol=\"FBTime\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_time.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTime</a>(&lt;hour&gt;, &lt;minute&gt;, &lt;second&gt;)\n\
        # coords format: [&lt;<a href=\"javascript:void(0)\" data-symbol=\"x\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#a280f2393c503127fff91ecbc558e288d&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">x</a>&gt;, &lt;y&gt;, &lt;z&gt;]\n\
        <a href=\"javascript:void(0)\" data-symbol=\"FBPlayerControl\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_player_control.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPlayerControl</a>().Goto(time)              # set the player control\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> time.\n\
        pTranslationAnimNode.SetCandidate(coords) # set the candidate at the player control\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> current time.\n\
        pTranslationAnimNode.KeyCandidate()       # apply the candidate.\n\
\n\
# Get the parent\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> child animation <a href=\"javascript:void(0)\" data-symbol=\"node\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/node_8h.html#addb697c9bca6f8981a870daa4953af4f&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">node</a> with the given name.\n\
def getChildNode(pParentNode, pChildName):\n\
    for <a href=\"javascript:void(0)\" data-symbol=\"node\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/node_8h.html#addb697c9bca6f8981a870daa4953af4f&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">node</a> in pParentNode.Nodes:\n\
        if node.Name == pChildName:\n\
            return <a href=\"javascript:void(0)\" data-symbol=\"node\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/node_8h.html#addb697c9bca6f8981a870daa4953af4f&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">node</a>\n\
    return None\n\
\n\
# Second method of applying keys to an animation node.\n\
# Here, we are working with the X, Y, and Z child nodes of the translation node.\n\
def applyKeys2(pTranslationAnimNode):\n\
    # keyList is defined at the top of this file.\n\
    global keyList\n\
    \n\
    # Obtain the FCurves for each X, Y, Z element of the translation vector.\n\
    # We use the helper function getChildNode() defined above to get the animation\n\
    # nodes for these X, Y, Z elements.\n\
    xAnimNode = getChildNode(pTranslationAnimNode, \'X\')\n\
    yAnimNode = getChildNode(pTranslationAnimNode, \'Y\')\n\
    zAnimNode = getChildNode(pTranslationAnimNode, \'Z\')\n\
    xFCurve = xAnimNode.FCurve\n\
    yFCurve = yAnimNode.FCurve\n\
    zFCurve = zAnimNode.FCurve\n\
    \n\
    # Apply the keys to each FCurve using cubic interpolation.\n\
    interpolation = <a href=\"javascript:void(0)\" data-symbol=\"FBInterpolation.kFBInterpolationCubic\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_interpolation.html#a38fed98ce7cb96deb0aab29a27e4bc59&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBInterpolation.kFBInterpolationCubic</a>\n\
    for time, coords in keyList:\n\
        # <a href=\"javascript:void(0)\" data-symbol=\"key\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#ada6705808cbd8c921df38387db9a6aee&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">key</a> the <a href=\"javascript:void(0)\" data-symbol=\"x\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#a280f2393c503127fff91ecbc558e288d&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">x</a> coordinate (coords[0]) at the given time along the X FCurve.\n\
        xKeyIndex = xFCurve.KeyAdd(time, coords[0])\n\
        xKey = xFCurve.Keys[xKeyIndex]\n\
        xKey.Interpolation = interpolation\n\
        \n\
        # <a href=\"javascript:void(0)\" data-symbol=\"key\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#ada6705808cbd8c921df38387db9a6aee&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">key</a> the y coordinate (coords[1]) at the given time along the Y FCurve.\n\
        yKeyIndex = yFCurve.KeyAdd(time, coords[1])\n\
        yKey = yFCurve.Keys[yKeyIndex]\n\
        yKey.Interpolation = interpolation\n\
        \n\
        # <a href=\"javascript:void(0)\" data-symbol=\"key\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#ada6705808cbd8c921df38387db9a6aee&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">key</a> the z coordinate (coords[2]) at the given time along the Z FCurve.\n\
        zKeyIndex = zFCurve.KeyAdd(time, coords[2])\n\
        zKey = zFCurve.Keys[zKeyIndex]\n\
        zKey.Interpolation = interpolation\n\
    \n\
# Create a circling animation for the camera.\n\
def applyAnimationToCamera(pCamera):\n\
    # (!) IMPORTANT: Properties are not animatable by default.\n\
    #     you must explicitly call SetAnimated(True) to initialize\n\
    #     the animation nodes for animatable properties.\n\
    pCamera.Translation.SetAnimated(True) \n\
    translationAnimNode = pCamera.Translation.GetAnimationNode()\n\
\n\
    # <a href=\"javascript:void(0)\" data-symbol=\"Set\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a8b39bad9fda6bc73af75e4d6085bcf91&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Set</a> the useApplyKeys1 variable below to False to use a different keying method.        \n\
    useApplyKeys1 = True\n\
    #useApplyKeys1 = False\n\
    \n\
    if useApplyKeys1 == True:\n\
        # <a href=\"javascript:void(0)\" data-symbol=\"Add\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#ab9d92a0f505af42d2049e62ae49ef932a0d592a4b562059bc283e00b3704865c9&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Add</a> keys to the translation animation <a href=\"javascript:void(0)\" data-symbol=\"node\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/node_8h.html#addb697c9bca6f8981a870daa4953af4f&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">node</a> directly.\n\
        applyKeys1(translationAnimNode)        \n\
    else:\n\
        # <a href=\"javascript:void(0)\" data-symbol=\"Add\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#ab9d92a0f505af42d2049e62ae49ef932a0d592a4b562059bc283e00b3704865c9&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Add</a> keys to the FCurves of the X, Y, Z elements in the \n\
        # translation animation node.\n\
        applyKeys2(translationAnimNode)\n\
    \n\
    \n\
###############################################################\n\
# Main.                                                       #\n\
###############################################################\n\
# Clear the scene.\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a>().FileNew()\n\
\n\
model = createModel()\n\
camera = createCamera(model)\n\
applyAnimationToCamera(camera)\n\
\n\
# Playback\n\
lPlayer = <a href=\"javascript:void(0)\" data-symbol=\"FBPlayerControl\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_player_control.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPlayerControl</a>()\n\
lPlayer.LoopStart = <a href=\"javascript:void(0)\" data-symbol=\"FBTime\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_time.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTime</a>(0,0,0) # <a href=\"javascript:void(0)\" data-symbol=\"Set\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a8b39bad9fda6bc73af75e4d6085bcf91&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Set</a> the <a href=\"javascript:void(0)\" data-symbol=\"start\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/sliceobject_8h.html#ab80172fa2f374f0198e6186560ed619e&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">start</a> time in the player control.\n\
lPlayer.LoopStop = <a href=\"javascript:void(0)\" data-symbol=\"FBTime\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_time.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTime</a>(0,0,4)  # <a href=\"javascript:void(0)\" data-symbol=\"Set\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a8b39bad9fda6bc73af75e4d6085bcf91&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Set</a> the end time in the player control.\n\
lPlayer.LoopActive = True         # Enable playback looping.\n\
lPlayer.GotoStart()\n\
lPlayer.Play()</pre></div> \n\
         </div>\n\
         <p><a name=\"GUID-5C0489A4-3D40-47E5-88E4-6483AE9EAAD4\"></a></p>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";