var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-4C02C00D-C717-41A6-9DF9-E53E9519D5F6\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Customizing and Uninstalling the Shelf</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-4C02C00D-C717-41A6-9DF9-E53E9519D5F6\"></a><div class=\"head\">\n\
            <h1>Customizing and Uninstalling the Shelf</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_E87AD2CE41014F9A89D54F618FE1F15F\"></a> \n\
            <h2><a name=\"GUID-9B6442C5-D492-4E76-AB9A-F20F3E8548CE\"></a>Customizing the Shelf\n\
            </h2> \n\
            <p><a name=\"GUID-619DAD62-CE6E-4704-9937-328B337F69FB\"></a>You can extend and add objects to the shelf by editing the <span class=\"filePath\" translate=\"no\">Shelves.xml</span> configuration file in a text editor. In Windows, the <span class=\"filePath\" translate=\"no\">Shelves.xml</span> file is saved in <span class=\"filePath\" translate=\"no\">C:\\Users\\&lt;username&gt;\\Documents\\MB\\&lt;year&gt;-x64\\config</span>. In Linux, the <span class=\"code\" translate=\"no\">Shelves.xml</span> file is saved in <span class=\"filePath\" translate=\"no\">/home/&lt;username&gt;/MB/&lt;year&gt;/config</span>. The following section explains the <span class=\"filePath\" translate=\"no\">Shelves.xml</span> configuration file. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">&lt;Shelves&gt;  &lt;!-- This is the root node. Do not modify it. --&gt;\n\
  &lt;Shelf title=\"Files\"&gt; &lt;!-- This is a new shelf with its name. --&gt;\n\
    &lt;Item title=\"New File\" hint=\"New File\" image=\"python/newScript.png\"&gt;<a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a>().FileNew ()&lt;/Item&gt;\n\
    &lt;!-- This is a new shelf button with the <a href=\"javascript:void(0)\" data-symbol=\"label\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/structlabel.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">label</a>, hint, image, and inline code to execute. --&gt;\n\
    &lt;Item title=\"Open...\" hint=\"Open File\" image=\"python/openScript.png\" script=\"FBApplication_FileOpen\" /&gt;\n\
    &lt;!-- This is a new shelf button with the <a href=\"javascript:void(0)\" data-symbol=\"label\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/structlabel.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">label</a>, hint, image, and script reference to execute.\n\
    The reference is in the Scripts section. --&gt;\n\
\n\
    &lt;Item title=\"Open...\" hint=\"Open File\" image=\"python/openScript.png\" script=\"fullpathfilename.py\" /&gt;\n\
    &lt;!-- This is a new shelf button with the <a href=\"javascript:void(0)\" data-symbol=\"label\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/structlabel.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">label</a>, hint, image, and script file reference to execute.\n\
    The file must be ready to execute like in the script editor. --&gt;\n\
\n\
    &lt;Item title=\"Mapping\" hint=\"Mapping\" width=\"48\"&gt;<a href=\"javascript:void(0)\" data-symbol=\"FBConstraintManager\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_constraint_manager.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConstraintManager</a>().TypeCreateConstraint (12)&lt;/Item&gt;\n\
    &lt;!-- This is a new shelf button with the <a href=\"javascript:void(0)\" data-symbol=\"label\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/structlabel.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">label</a>, hint, no image, and inline code to execute.\n\
    The width parameter is used to make the button larger for displaying the full text. --&gt;\n\
\n\
\n\
...\n\
\n\
  &lt;Scripts&gt;\n\
    &lt;Script <a href=\"javascript:void(0)\" data-symbol=\"name\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#afcd1706c9144e6d6eee6127661ae3be2&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">name</a>=\"FBApplication_FileOpen\"&gt;\n\
      &lt;![CDATA[ &lt;!-- Code to execute --&gt; ]]&gt;\n\
    &lt;/Script&gt;\n\
\n\
\n\
    \n\
</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_4F254BE141804E899DA89CFAC7B65432\"></a> \n\
            <h2><a name=\"GUID-9C538FC6-1B04-4A39-B63B-C17863EDE02D\"></a>Uninstalling the Shelf\n\
            </h2> \n\
            <p><a name=\"GUID-D9D2B2DD-4552-45B3-9125-7F4EF834CBDA\"></a>The shelf plug-in is installed by default. To uninstall the shelf, you must delete\n\
               the plug-in from the plug-in folder as follows. \n\
            </p> <a name=\"UL_620F404B85014A1A89ED6731DB219DE5\"></a><ul>\n\
               <li>In Windows, delete the <span class=\"filePath\" translate=\"no\">ormotionbuilder_shelf.dll</span> file from <span class=\"filePath\" translate=\"no\">C:\\Program Files\\Autodesk\\MotionBuilder &lt;year&gt;\\bin\\x64\\plugins</span>. \n\
               </li>\n\
               <li>In Linux, delete the <span class=\"filePath\" translate=\"no\">libormotionbuilder_shelf.so*</span> file from <span class=\"filePath\" translate=\"no\">/usr/autodesk/MotionBuilder &lt;year&gt;/bin/linux_64/plugins</span>. \n\
               </li>\n\
            </ul> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";