var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-5716DA94-1312-4B03-AB30-FD0C2A451BD6\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Managing Animation using a Story</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-5716DA94-1312-4B03-AB30-FD0C2A451BD6\"></a><div class=\"head\">\n\
            <h1>Managing Animation using a Story</h1>\n\
         </div>\n\
         <p><a name=\"GUID-2DF3E592-8B1E-49BE-A640-3AA1F8118682\"></a> A story is a series of events. You can combine and manipulate objects such as, characters,\n\
            lights, cameras, audio, and animation along a timeline to create a story. The following\n\
            sections explain the story feature. To follow the instructions, download the files\n\
            and scripts from <a href=\"http://area.autodesk.com/downloads/scripts/motionbuilder-animation-scripts\" target=\"_blank\">http://area.autodesk.com/downloads/scripts/motionbuilder-animation-scripts</a>. \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_746978D4A2BB4DBBB744F8736A637B84\"></a> \n\
            <h2><a name=\"GUID-F41EFB49-7A6A-401E-BDC2-63CF001417CF\"></a>Manipulating the Story Folders, Tracks, and Clips\n\
            </h2> \n\
            <p><a name=\"GUID-73E49B63-2648-4E27-B399-5D888AD6C155\"></a>Media is contained in clips that you can access through <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBStoryClip\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_story_clip.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_story_clip.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBStoryClip</a></span>. Clips are contained in story tracks that you can access through <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBStoryTrack\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_story_track.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_story_track.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBStoryTrack</a></span>. Story tracks are contained in a story that you can access through <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBStory\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_story.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_story.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBStory</a></span>. \n\
            </p> \n\
            <p><a name=\"GUID-79EDD637-50D3-48AA-B4DD-DECA95B2CD54\"></a>Run the <span class=\"code\" translate=\"no\">manipulate_story_folders_and_tracks.py</span> script to see how the story tracks are organized into folders (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBStoryFolder\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_story_folder.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_story_folder.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBStoryFolder</a></span>) and how you can manipulate the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBStoryFolder\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_story_folder.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_story_folder.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBStoryFolder</a></span>. For example, you can make the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBStoryFolder\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_story_folder.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_story_folder.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBStoryFolder</a></span> appear collapsed or expanded, mute all the tracks in the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBStoryFolder\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_story_folder.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_story_folder.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBStoryFolder</a></span>, and so on. <a name=\"FIG_20A321415D464503BBFD2D790F88272B\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-EDC5FE53-1C96-45BD-8D02-E11806A3B76C-low.png\"></div> \n\
            </p> \n\
         </div><span class=\"noindex\">\n\
            <div class=\"topic-list\">\n\
               <h4 class=\"related\">Topics in this section</h4>\n\
               <ul class=\"jumplist\">\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-75501CA5-1982-4A0D-BD04-FFADDC03018C.htm\">Importing the Character Animation to a Story</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-6DB6807D-92A1-413A-934F-F88BFFA1F97B.htm\">Loading the Character Animation from a Take to a Story</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-9096574C-EF7C-4BBE-9F97-EA157A7D5F6D.htm\">Plotting the Character Animation from a Story to a Take</a></li>\n\
               </ul>\n\
            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";