var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-6389AA40-FF46-4F07-96E7-036E4C15F3F8\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Using the Help</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-6389AA40-FF46-4F07-96E7-036E4C15F3F8\"></a><div class=\"head\">\n\
            <h1>Using the Help</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_71EF6266553047F5A08AD453BFAE5FC7\"></a> \n\
            <h2><a name=\"GUID-76369B8E-C01F-467C-8F23-CC4B6DB000AA\"></a>Supported Browsers\n\
            </h2> \n\
            <p><a name=\"GUID-85ACA8F8-686E-4606-B7F4-A0E88C952DD5\"></a>The following browsers support the HTML help. \n\
            </p> <a name=\"UL_8C06668322414DC890F7FDB37FAF0278\"></a><ul>\n\
               <li>Internet Explorer version 7 or later. </li>\n\
               <li>Apple Safari version 4 or later. </li>\n\
               <li>Mozilla Firefox version 3.6 or later. </li>\n\
            </ul> \n\
            <div><a name=\"GUID-2890A37E-E411-4AF2-A1C5-924A2A191362\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Other browsers are not fully supported. Some search features might not be fully operational\n\
                  in other browsers. \n\
               </div>\n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_344A14CCA6CD43F09CDC5A7D4029F1EF\"></a> \n\
            <h2><a name=\"GUID-24FBE39C-3FED-456F-9896-C9A439BE9260\"></a>Search Feature\n\
            </h2> \n\
            <p><a name=\"GUID-29FE2D81-11D9-4972-97EC-39B600251B53\"></a>The search feature queries a wide variety of sources for each product, including the\n\
               user guide, the programmer\'s guide, the Autodesk YouTube channels, and Autodesk forums.\n\
               Each match includes an excerpt of text, the name of the source, and the date it was\n\
               last updated. A locally installed help does not show results from the online sources.\n\
               \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_08909123D1874982B8B99BD1B532CCDB\"></a> \n\
            <h2><a name=\"GUID-6A5D74A1-9E6A-4229-834A-18A9C4F67182\"></a>Resolving the Slow Running Script Error in Offline Help\n\
            </h2> \n\
            <p><a name=\"GUID-0CABD9AF-748A-4FF7-8E4A-FC49107B9A78\"></a> If you are using Internet Explorer 7.0 or later to view locally installed help, you\n\
               might see a dialog box prompting you to decide whether to continue running the scripts.\n\
               Internet Explorer tracks the total number of executed script statements and resets\n\
               the value each time a new script execution starts. The dialog box appears when that\n\
               value is over a threshold amount or when the scripts take a long time to run. However,\n\
               you can increase the amount of time before the dialog box appears by performing these\n\
               steps. \n\
            </p> \n\
            <div><a name=\"GUID-7B01FF5E-8F29-4EA4-A2AC-BD87F89E566C\"></a><div class=\"note-important\"><span class=\"label label-target-language\">IMPORTANT:</span>These steps show how to modify the registry. Please follow the steps carefully to\n\
                  prevent any problems. For added protection, back up the registry before you modify\n\
                  it. \n\
               </div>\n\
            </div> <a name=\"OL_354E30D6F0C94CC1996ED0682E99FD67\"></a><ol type=\"1\" start=\"1\">\n\
               <li> Using a Registry Editor, such as Regedt32.exe, open the following key: \n\
                  <p><a name=\"GUID-7B29F6E9-4B3C-417F-A1D8-5D7875B95D42\"></a> <span class=\"code\" translate=\"no\">HKEY_CURRENT_USER\\Software\\Microsoft\\Internet Explorer\\Styles</span> \n\
                     <div><a name=\"GUID-82FDE0EB-AD81-41F7-BA51-F143BC3EB9C4\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>If the <span class=\"code\" translate=\"no\">Styles</span> key is not present, create a new key that is called <span class=\"code\" translate=\"no\">Styles.</span> \n\
                        </div>\n\
                     </div> \n\
                  </p> \n\
               </li>\n\
               <li> Create a new DWORD value called <span class=\"code\" translate=\"no\">MaxScriptStatements</span> under this key and set the value to the desired number of script statements. If you\n\
                  are unsure of what value to set, you can set it to a DWORD value of <span class=\"code\" translate=\"no\">0xFFFFFFFF</span> to completely avoid the dialog. \n\
               </li>\n\
            </ol> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";