var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-6C0C0CC2-F247-45B7-9530-41FDEC58290C\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Using Python with MotionBuilder</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-6C0C0CC2-F247-45B7-9530-41FDEC58290C\"></a><div class=\"head\">\n\
            <h1>Using Python with MotionBuilder</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_1B38EAA0630E43E7B146CFA95229171A\"></a> \n\
            <h2><a name=\"GUID-588A604D-C7F7-4196-8882-6206C2B09FC5\"></a>Python and MotionBuilder\n\
            </h2> \n\
            <p><a name=\"GUID-F774BD45-7261-4B66-B2DA-29A4766FE7BF\"></a>The Python programming language can be used to customize the behavior of MotionBuilder.\n\
               MotionBuilder contains its own <span class=\"char_link\"><a href=\"#!/url=./files/GUID-6B00DBAE-EC34-4958-86F5-A5B644C2DB00.htm\">Python Editor</a></span>, and Python interpreter, which allows the user to write and run Python scripts from\n\
               within MotionBuilder. \n\
            </p> \n\
            <p><a name=\"GUID-FA02A34A-4EE8-4979-9065-B98B99E3EB91\"></a>To use the Python MotionBuilder API in your scripts, include the following lines:\n\
               \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">from pyfbsdk import *\n\
from pyfbsdk_additions import *</pre></div> Python scripts can be invoked when MotionBuilder starts up, or while MotionBuilder\n\
               is running. For a full list of ways to run Python scripts in MotionBuilder, see <span class=\"char_link\"><a href=\"#!/url=./files/GUID-391A97C9-35B9-4C98-A8CE-5CD718A7D70A.htm\">Running Python Scripts</a></span>. \n\
            </p> \n\
         </div><span class=\"noindex\">\n\
            <div class=\"topic-list\">\n\
               <h4 class=\"related\">Topics in this section</h4>\n\
               <ul class=\"jumplist\">\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-6B00DBAE-EC34-4958-86F5-A5B644C2DB00.htm\">Python Editor</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-3C84D961-DE28-4CF2-AE07-C1491BE85F40.htm\">Namespaces and Autocomplete</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-391A97C9-35B9-4C98-A8CE-5CD718A7D70A.htm\">Running Python Scripts</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-34FB0BD6-6FE8-479F-86C8-929E0FC09244.htm\">Managing Python Tools</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-2F3FA351-F733-4D84-94CE-CC3AA520512E.htm\">Debugging</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-82CF06D0-BC20-4F4A-A7E0-A61CDF2670D2.htm\">Python Telnet Console</a></li>\n\
               </ul>\n\
            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";