var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-768B72C0-EFA3-4FBB-97ED-6C9C03BFD28A\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>MotionBuilder 2014</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-768B72C0-EFA3-4FBB-97ED-6C9C03BFD28A\"></a><div class=\"head\">\n\
            <h1>MotionBuilder 2014</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_C32C1606411F440EB87DA0AEA64A4B31\"></a> \n\
            <h2><a name=\"GUID-BEA88040-2AA1-4015-987D-1A3112E4CBF2\"></a>Software Dependencies and Upgrades\n\
            </h2> <a name=\"UL_A644216C43154DBA885B881EAC774639\"></a><ul>\n\
               <li>Supported Operating Systems – Microsoft Windows 7.0 or later (64-bit only), Red Hat\n\
                  Linux 6.2 (64-bit only), and Fedora Core 14 (64-bit only). \n\
               </li>\n\
               <li>Support for hardware accelerated OpenGL 2.1 or later for MotionBuilder to run properly.\n\
                  \n\
               </li>\n\
               <li>Upgraded to QT 4.8.2 from QT 4.7.1. QT 4.8.2 is modified by Autodesk and also used\n\
                  in Maya 2014. \n\
               </li>\n\
               <li>Upgraded to Python 2.7.3 (also used in Maya 2014) from Python 2.6.4. </li>\n\
               <li>QT Python wrapper PySide (1.1) is packaged and shipped along with the application\n\
                  for easy UI scripting. \n\
               </li>\n\
               <li>FBX SDK upgraded to 2014.0.1 from 2013.0.0. </li>\n\
            </ul> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_AE3BAFEF1062409594617A67A31218B6\"></a> \n\
            <h2><a name=\"GUID-7B495870-A527-4206-BA97-53B7E60D914B\"></a>Plug-in Development Environment\n\
            </h2> <a name=\"UL_D9AB39EAC8F64DEA994594AD7B36C788\"></a><ul>\n\
               <li> <em class=\"strong\">Build and Compilation Platforms</em> <a name=\"UL_99BF9BD513EF43FFB7DBA0AB7A450552\"></a><ul>\n\
                     <li>Microsoft Windows 7.0 or later (64-bit only) – MotionBuilder 2014 and the distributed\n\
                        plug-ins are still compiled using the Visual Studio 2010 (Service Pack 1). \n\
                     </li>\n\
                     <li>GCC4.4.3 or later is required to compile the ORSDK samples in Linux. </li>\n\
                  </ul> \n\
               </li>\n\
               <li> <em class=\"strong\">Environment Variables</em> <a name=\"UL_C8F811F01E6E4268887168915C5C00F5\"></a><ul>\n\
                     <li><span class=\"code\" translate=\"no\">MOTIONBUILDER_PYTHON_STARTUP</span> – This environment variable can contain a list of directories, which are separated\n\
                        by a colon (<span class=\"code\" translate=\"no\">:</span>) in Windows and a semicolon (<span class=\"code\" translate=\"no\">;</span>) in Linux. The list of directories contained in this environment variable determines\n\
                        the location from which MotionBuilder loads the Python startup scripts. See the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBSystem::GetPythonStartupPath()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_system.html#a9eaf0ef319454f30031ae08e6c9ae9c8&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem::GetPythonStartupPath()</a></span> function reference. In MotionBuilder 2013, this environment variable can only contain\n\
                        a single directory path. \n\
                     </li>\n\
                     <li><span class=\"code\" translate=\"no\">MOTIONBUILDER_SAVELOAD_EMBEDMEDIAS</span> – This new environment variable is used for overriding the corresponding setting\n\
                        in a configuration file. Any other value except <span class=\"code\" translate=\"no\">Yes</span> is considered as false. \n\
                     </li>\n\
                     <li><span class=\"code\" translate=\"no\">MOTIONBUILDER_SAVELOAD_SHOWEMBEDMEDIASOPTION</span> – The <span class=\"code\" translate=\"no\">ShowEmbedMediasOption</span> preference item can be used in the <span class=\"code\" translate=\"no\">SaveLoad</span> section of a configuration file to control whether the <span class=\"MenuCascade\" id=\"GUID-E2E98C5A-E352-4AD1-8A5D-FC98C4A0F705\">Embed Medias</span> checkbox appears in the Save dialog box. This new environment variable can also be\n\
                        used for overriding the corresponding setting in a configuration file. Any other value\n\
                        except <span class=\"code\" translate=\"no\">Yes</span> is considered as false. \n\
                     </li>\n\
                  </ul> \n\
               </li>\n\
               <li>The SDK plug-in developers can now access command line arguments within a pair of\n\
                  delimiters (<span class=\"code\" translate=\"no\">--sdk-begin &amp; --sdk-end</span>). See the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBSystem::GetCommandLineArgs()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_system.html#a377a4c53bdb2c225f184acd27ab24f92&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem::GetCommandLineArgs()</a></span> function reference. \n\
               </li>\n\
            </ul> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_F7E3566458F64D6F93686D5E7F0D2F5E\"></a> \n\
            <h2><a name=\"GUID-5F103995-41C6-4EF6-861F-68B6B03B989B\"></a> New Features\n\
            </h2> <a name=\"UL_0606C97C15C9415FA50DEFEAC7F84CA0\"></a><ul>\n\
               <li><em class=\"strong\">Custom Renderer</em> – The new real-time custom renderer C++ API enables the SDK plug-in developers to\n\
                  implement their own rendering solution or to integrate an OpenGL based renderer into\n\
                  MotionBuilder. Unlike the previous shader based API (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBShader\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_shader.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_shader.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBShader</a></span>), which emphasized individual effects within a forward rendering framework, the custom\n\
                  renderer (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBRendererCallback\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_renderer_callback.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBRendererCallback</a></span>) completely replaces the default scene shading solution. The native UI display in\n\
                  the viewport (for locators, manipulator, and others) is still retained to avoid the\n\
                  implementation complexity. See the custom renderer example in <span class=\"filePath\" translate=\"no\">&lt;yourinstallationfolder&gt;/OpenRealitySDK/samples/shaders/CustomRenderer</span> for more information. \n\
               </li>\n\
               <li><em class=\"strong\">File Referencing</em> – This new feature enables you to manage the assets within production pipelines in\n\
                  a better way. This is particularly helpful when you have a project with a large number\n\
                  of assets, which are revised occasionally, but are used in a number of scenes or shots.\n\
                  In this case, you can use the referencing system to easily update multiple assets.\n\
                  See the <span class=\"char_link\"><a href=\"#!/url=./files/GUID-76FBC919-01B2-4DF5-9CAA-EC1FB43047E1.htm\">File Referencing</a></span> topics in the Programmer\'s Guide for more information. \n\
                  <div><a name=\"GUID-F35387ED-DD07-4939-9B76-DB0106304E88\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>You can access the file referencing feature in MotionBuilder 2014 using the SDK (C++\n\
                        and Python) only. \n\
                     </div>\n\
                  </div> \n\
               </li>\n\
               <li> <em class=\"strong\">Advanced Motion Capture Workflow Options</em> – Motion capture specialists can now directly assign the markers as a source for\n\
                  a character. This enables them to choose whether to create a proxy skeleton as an\n\
                  intermediate step or not. Artists can also override the default assigned constraints\n\
                  to affect how the markers drive the skeleton, which provides greater control over\n\
                  the solve. In addition, new spine and neck stretch properties deliver a higher quality\n\
                  solve and enables joints to precisely reach the goals of the original markers. \n\
               </li>\n\
               <li> <em class=\"strong\">FBXSDK Framework Based Custom File IO Plugin</em> – You can customize or extend certain file IO operations. See the <span class=\"code\" translate=\"no\">FBXExtension</span> example in <span class=\"filePath\" translate=\"no\">&lt;yourinstallationfolder&gt;/OpenRealitySDK/samples/importexport/FBXExtension</span> for more information. \n\
                  <p><a name=\"GUID-9C2CD79E-C6B9-4541-9EED-24AF23F569A1\"></a>The FBXSDK library is upgraded to 2014 version from the previous 2013 version. All\n\
                     the header, library, and runtime files are included. \n\
                  </p> \n\
               </li>\n\
               <li> <em class=\"strong\">Easy PySide UI Scripting</em> – PySide 1.1.1 is used with MotionBuilder 2014. It improves the UI scripting efficiency.\n\
                  You can now easily embed native PySide QT widgets within the MotionBuilder UI framework\n\
                  by using the improved <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBWidgetHolder\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_widget_holder.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBWidgetHolder</a></span> class. See the <span class=\"filePath\" translate=\"no\">MBFileRefDemo.py</span> example in <span class=\"filePath\" translate=\"no\">&lt;yourinstallationfolder&gt;/bin/config/Scripts/Samples/Referencing</span> for more information. \n\
               </li>\n\
            </ul> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_9F7DF537FAAC44008E72F3B3D44651BB\"></a> \n\
            <h2><a name=\"GUID-48A67548-8F91-4FF4-914F-C1C89F90F8FC\"></a>New Classes, Methods, Properties, and Other Improvements\n\
            </h2> \n\
            <p><a name=\"GUID-641D9FB7-1B0E-4ABF-AA95-20355BEB6B25\"></a>This section lists the changes in the SDK according to the relevant categories. \n\
            </p> \n\
            <p><a name=\"GUID-6EAADBF3-1257-4944-833D-D2177C269CE3\"></a>MotionBuilder emphasizes consistency between the C++ (ORSDK) and Python (pyfbsdk)\n\
               layers to achieve a similar interface. Most of the SDK changes apply to both C++ and\n\
               Python layers, except in some cases where it is not possible because of language limitations.\n\
               Variation between ORSDK and pyfbsdk include the following: <a name=\"UL_3B100F3A91A6472EA1CDB655C69C7A7A\"></a><ul>\n\
                  <li>Multi-thread python is not supported in pyfbsdk, so no callbacks from background thread\n\
                     are exposed in the past. \n\
                  </li>\n\
                  <li>In some cases, the direct memory addresses to the internal C/C++ objects are returned\n\
                     to allow high-performance operations or bridge certain workflow between different\n\
                     Python modules such as the following: <a name=\"UL_2CCA80FC1CFF4749B3E8724B87A492AC\"></a><ul>\n\
                        <li>You can use the high-performance Python Image Library (PIL) to manipulate the <em class=\"mild\">FBImage</em> instance\'s content accessible through <span class=\"code\" translate=\"no\">kReferenceFBImage::GetBufferAddress()</span>. \n\
                        </li>\n\
                        <li> Similar cases occur in these functions: <span class=\"code\" translate=\"no\">FBWidgetHolder::WidgetCreate()</span>, <span class=\"code\" translate=\"no\">FBVisualComponent::GetQWidgetAddress()</span>, and others. \n\
                        </li>\n\
                     </ul> \n\
                  </li>\n\
               </ul> \n\
            </p> \n\
            <div class=\"section\"><a name=\"SECTION_5E4A39C009024855B2DBE022D9276180\"></a> \n\
               <h3><a name=\"GUID-A62122E5-824E-4AB6-9CE0-CD2E4CD421FD\"></a> Animation and Characters\n\
               </h3> \n\
               <p><a name=\"GUID-257DA1EA-C128-4905-A0F7-2B5B2AFBAAC2\"></a> <a name=\"OL_EAC424EF75EC4BCEAD54D529C5881A69\"></a><ol type=\"1\" start=\"1\">\n\
                     <li>These new classes provide SDK access to the flexible mocap workflow: <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBControlSetState\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_control_set_state.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBControlSetState</a></span>, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBEffectorSetState\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_effector_set_state.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBEffectorSetState</a></span>, and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCharacterMarkerSet\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_character_marker_set.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_character_marker_set.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacterMarkerSet</a></span>. \n\
                     </li>\n\
                     <li>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCharacterInputType\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a625d11aeb8506d66cb0efcae43d7293d&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_character_input_type.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacterInputType</a></span> enum type has a new enumerator (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"kFBCharacterInputMoCap\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a625d11aeb8506d66cb0efcae43d7293dae3a2e8d9a27f6f502053c96f992d5681&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">kFBCharacterInputMoCap</a></span>). \n\
                     </li>\n\
                     <li> New argument (<span class=\"code\" translate=\"no\">pResetOrientation</span>) in the function <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBActor::GetCurrentSkeletonState()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_actor.html#ad8faa01a1ac00a25841f0f29a49cb36f&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBActor::GetCurrentSkeletonState()</a></span> – When it is set to true, all rotations in the state is reset to characterization\n\
                        values. For example code, see <span class=\"filePath\" translate=\"no\">&lt;yourinstallationfolder&gt;/bin/config/Scripts/Samples/Character/CharacterMarkerSetFromActor.py</span>. \n\
                     </li>\n\
                     <li>The following functions and properties are added to the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCharacter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_character.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_character.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacter</a></span> class. <a name=\"UL_E48D13E93717408794D3EED1B90E6D28\"></a><ul>\n\
                           <li> <span class=\"code\" translate=\"no\">GetGoalModel()</span> – To get the goal model associated with each body part in the character marker set\n\
                              of the character. \n\
                           </li>\n\
                           <li><span class=\"code\" translate=\"no\">CreateCharacterMarkerSet()</span> – To create the character marker set. \n\
                           </li>\n\
                           <li> <span class=\"code\" translate=\"no\">GetCharacterMarkerSet()</span> – To obtain the input character marker set. \n\
                           </li>\n\
                           <li> <span class=\"code\" translate=\"no\">GetControlSetEvaluationCache()</span> – To return the evaluation cache that is dedicated for control set and evaluation\n\
                              information. \n\
                           </li>\n\
                           <li> <span class=\"code\" translate=\"no\">GetEffectorEvaluationCache()</span> – To return the evaluation cache that is dedicated for effector set and evaluation\n\
                              information. \n\
                           </li>\n\
                           <li>New read/write properties <span class=\"code\" translate=\"no\">LockX</span>, <span class=\"code\" translate=\"no\">LockY</span>, and <span class=\"code\" translate=\"no\">LockZ</span> lock character skeleton in place on X, Y and Z axis respectively. \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                     <li>Following are the changes in the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCharacterSolver\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_character_solver.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_character_solver.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacterSolver</a></span> class: <a name=\"UL_9754470D773A4FDCA981BE49C6F5877A\"></a><ul>\n\
                           <li>New parameter (<span class=\"code\" translate=\"no\">pEvaluateCandidates</span>) in function <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCharacterSolver::BackgroundEvaluateInfoBegin()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_character_solver.html#a735d4cd9f53d6bf38ea53b10eeaf26f2&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacterSolver::BackgroundEvaluateInfoBegin()</a></span> to specify whether to resolve candidates. \n\
                           </li>\n\
                           <li>Added new functions: <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCharacterSolver::BackgroundEvaluateInfoRecursiveBegin()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_character_solver.html#adc396e2b273494f578876c44cf681ca7&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacterSolver::BackgroundEvaluateInfoRecursiveBegin()</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCharacterSolver::BackgroundEvaluateInfoNotify()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_character_solver.html#a041140e9ec9f790d0ddbcca4fe07ab27&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacterSolver::BackgroundEvaluateInfoNotify()</a></span>. For example code, see <span class=\"filePath\" translate=\"no\">&lt;yourinstallationfolder&gt;/OpenRealitySDK/Samples/constraints/CharacterSolver/IK2014Solver</span>. \n\
                           </li>\n\
                           <li>New virtual <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCharacterSolver::ResetExtraProperties()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_character_solver.html#a7088597f0429be1fd65949c4eec03d0f&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacterSolver::ResetExtraProperties()</a></span> function provides support for resetting properties that are defined and specific\n\
                              to the custom solver. \n\
                           </li>\n\
                           <li>New function <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCharacterSolver::GetDoubleSolve()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_character_solver.html#a314656e1ee4781f1a724ccea07edc56f&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacterSolver::GetDoubleSolve()</a></span> to indicate the control rig’s double solve property status. \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                     <li>You can now query or set the current character’s floor contact visibility using these\n\
                        new functions: <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBGetCharacterFloorContactsVisibility()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a53f3f3a9662c7834f7bee1c0411983ac&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga59ebff1c38974c6a1489d4d7524fd986&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBGetCharacterFloorContactsVisibility()</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBSetCharacterFloorContactsVisibility()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#af82b4adfb2a64a8e09e64305e0dabf63&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga6c20f3ab13cac109845c88f7934fd044&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSetCharacterFloorContactsVisibility()</a></span>. For finger visibility, you can use <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBGetCharacterFingerTipsVisibility()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a858b2c8ddc8646ccec551513467b4357&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga531045488e06c6e3ff3c910258b84bbc&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBGetCharacterFingerTipsVisibility()</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBSetCharacterFingerTipsVisibility()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#afdaf8c95f6acc6466427b10452db5da7&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga35d63fa8e49e0b20cb5825b8b9f4736f&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSetCharacterFingerTipsVisibility()</a></span>. \n\
                     </li>\n\
                     <li>The new <span class=\"code\" translate=\"no\">FBPlotPopup::EnablePlotLockedProperties</span> read/write property specifies whether to enable the Plot Locked Properties option\n\
                        for popup. \n\
                     </li>\n\
                     <li>The new data member <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPlotOptions::mPlotLockedProperties\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_plot_options.html#a4690aeba51f7261e88e6e2eb718799ae&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPlotOptions::mPlotLockedProperties</a></span> specifies whether to plot locked properties. \n\
                     </li>\n\
                     <li>Previously, to create a take and make it accessible in the Transport control using\n\
                        the SDK, you need to use <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBTake\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_take.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_take.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTake</a>* lTake = FBSystem::ThenOne().CurrentTake-&gt;CopyTake( \"new take\" )</span>. Now, you can do this using <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBSystem::TheOne()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_system.html#a948ce40b3214df66bddf56638c6d5675&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem::TheOne()</a>::Scene.Takes.Add( new <a href=\"javascript:void(0)\" data-symbol=\"FBTake\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_take.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_take.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTake</a>( \"new take\" ))</span>. \n\
                     </li>\n\
                     <li> Other improvements in the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBTake\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_take.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_take.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTake</a></span> class are the following: <a name=\"UL_11ECAD94232847B7BE60835F04DCDC10\"></a><ul>\n\
                           <li>New argument (<span class=\"code\" translate=\"no\">pMergeLockedProperties</span>) in the <span class=\"code\" translate=\"no\">MergeLayers()</span> function to specify whether the properties need to be merged even when they are locked.\n\
                              \n\
                           </li>\n\
                           <li>New argument (<span class=\"code\" translate=\"no\">pOnLockedProperties</span>) in the <span class=\"code\" translate=\"no\">ClearAllProperties()</span> function to specify if clear operation will be performed on locked properties. \n\
                           </li>\n\
                           <li>New <span class=\"code\" translate=\"no\">PlotTakeOnSelected(<a href=\"javascript:void(0)\" data-symbol=\"FBPlotOptions\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_plot_options.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_plot_options.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPlotOptions</a>* pPlotOptions)</span> function to plot the animation on selected models. \n\
                           </li>\n\
                           <li>New <span class=\"code\" translate=\"no\">PlotTakeOnSelectedProperties(<a href=\"javascript:void(0)\" data-symbol=\"FBPlotOptions\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_plot_options.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_plot_options.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPlotOptions</a>* pPlotOptions)</span> function to plot the animation on selected properties. \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                     <li>Following new enumerators in the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBTangentMode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a608c1ce69f1b3484a3bbb1a5d5c9ec93&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_tangent_mode.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTangentMode</a></span> class: <a name=\"UL_A83FDFB4D2AA4B30ACE8D076515DD94E\"></a><ul>\n\
                           <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"kFBTangentModeTimeIndependent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a608c1ce69f1b3484a3bbb1a5d5c9ec93a2a013751675715adb1bff53e971f3d41&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">kFBTangentModeTimeIndependent</a></span> – This is calculated based upon the slope between the previous and next key values.\n\
                              In the UI, it is identified as Spline. \n\
                           </li>\n\
                           <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"kFBTangentModeClampProgressive\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a608c1ce69f1b3484a3bbb1a5d5c9ec93a610b3aa4cfe0c15a1d6bf0b37580b9af&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">kFBTangentModeClampProgressive</a></span> – Flattens the tangent handles when the key value goes over or under the previous\n\
                              and next key values. In the UI, it is identified as Auto. \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                     <li>Following changes in the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBFCurve\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_f_curve.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_f_curve.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFCurve</a></span> class: <a name=\"UL_EE2E7FD3D99148D592039781653C5150\"></a><ul>\n\
                           <li>New parameters (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBInterpolation\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a494766ca2d8daad79072baa430199186&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_interpolation.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBInterpolation</a> pInterpolation=<a href=\"javascript:void(0)\" data-symbol=\"kFBInterpolationCubic\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a494766ca2d8daad79072baa430199186a3f1c537c01d4c52d358455d591c602e1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">kFBInterpolationCubic</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBTangentMode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a608c1ce69f1b3484a3bbb1a5d5c9ec93&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_tangent_mode.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTangentMode</a> pTangentMode=<a href=\"javascript:void(0)\" data-symbol=\"kFBTangentModeAuto\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a608c1ce69f1b3484a3bbb1a5d5c9ec93ad20e894c5198508ea81b2d00ecaf6264&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">kFBTangentModeAuto</a></span>) in the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBFCurve::KeyAdd()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_f_curve.html#aa3914952deb883cc58872ffa331e8b62&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFCurve::KeyAdd()</a></span> function. \n\
                           </li>\n\
                           <li>The function <span class=\"code\" translate=\"no\">FBFCurve::Replace()</span> is deprecated for naming consistency. Instead, you can use the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBFCurve::KeyReplaceBy()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_f_curve.html#a4e12dc4398dc0fd9a7bfd55b9fbb9739&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFCurve::KeyReplaceBy()</a></span> function. \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                     <li>Added new parameters (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBInterpolation\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a494766ca2d8daad79072baa430199186&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_interpolation.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBInterpolation</a> pInterpolation=<a href=\"javascript:void(0)\" data-symbol=\"kFBInterpolationCubic\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a494766ca2d8daad79072baa430199186a3f1c537c01d4c52d358455d591c602e1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">kFBInterpolationCubic</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBTangentMode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a608c1ce69f1b3484a3bbb1a5d5c9ec93&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_tangent_mode.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTangentMode</a> pTangentMode=<a href=\"javascript:void(0)\" data-symbol=\"kFBTangentModeAuto\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a608c1ce69f1b3484a3bbb1a5d5c9ec93ad20e894c5198508ea81b2d00ecaf6264&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">kFBTangentModeAuto</a></span>) in the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBAnimationNode::KeyAdd()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_animation_node.html#a789c329430faa78dd221654f3ba8e832&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBAnimationNode::KeyAdd()</a></span> function. \n\
                     </li>\n\
                     <li>New <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBEvaluateInfo::GetBufferID()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_evaluate_info.html#a273ff1402fd04a82ecd6e4184589475a&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBEvaluateInfo::GetBufferID()</a></span> function is useful for the custom constraint plug-in development with multiple threading\n\
                        evaluation support. \n\
                     </li>\n\
                     <li> Following are the changes in the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBProperty\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_property.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_property.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBProperty</a></span> class and its descendants: <a name=\"UL_888BDA3394B64312B7EE802D1ED47894\"></a><ul>\n\
                           <li>A set of functions related to the property locking feature are added to the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBProperty\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_property.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_property.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBProperty</a></span> class:<span class=\"code\" translate=\"no\">GetSubMemberCount()</span>, <span class=\"code\" translate=\"no\">AllowsLocking()</span>, <span class=\"code\" translate=\"no\">HasSomethingLocked()</span>, <span class=\"code\" translate=\"no\">IsLocked()</span>, <span class=\"code\" translate=\"no\">IsMemberLocked()</span>, <span class=\"code\" translate=\"no\">SetLocked()</span>, and <span class=\"code\" translate=\"no\">SetMemberLocked()</span>. Locking a property or any number of its channels prevents the modification of animation\n\
                              in the property. You cannot add, remove, or edit any key on any layer of a locked\n\
                              property or channel. Also, you cannot change the current value of the property. However,\n\
                              a locked property allows existing animation to flow through. The value of a locked\n\
                              property can change through time as it is being driven by existing animation or constraints.\n\
                              \n\
                           </li>\n\
                           <li>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPropertyAnimatable\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_property_animatable.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_property_animatable.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPropertyAnimatable</a></span> class has two new functions: <span class=\"code\" translate=\"no\">SetCandidate()</span> and <span class=\"code\" translate=\"no\">SetGlobalCandidate()</span> that are useful for keying candidate. \n\
                           </li>\n\
                           <li>A set of new functions related to the property mute feature are added to the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPropertyAnimatable\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_property_animatable.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_property_animatable.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPropertyAnimatable</a></span> class: <span class=\"code\" translate=\"no\">AllowsMuting()</span>, <span class=\"code\" translate=\"no\">HasSomethingMuted()</span>, <span class=\"code\" translate=\"no\">IsMuted()</span>,<span class=\"code\" translate=\"no\">IsMemberMuted()</span>, <span class=\"code\" translate=\"no\">SetMuted()</span>, and <span class=\"code\" translate=\"no\">SetMemberMuted()</span>. Muting an animatable property or its channels prevents animation from flowing through\n\
                              the property or its channels. The value of a muted property or its channels is the\n\
                              value upon muting, and does not change over time as it is being driven by existing\n\
                              animation or constraints. You can still modify a muted property to add, remove, and\n\
                              edit the existing keys. \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                     <li>New <span class=\"code\" translate=\"no\">FBConstraintManager::TypeCreateConstraint(const char* pName)</span> function allows to create a constraint by name. \n\
                     </li>\n\
                     <li>New argument (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBTimeMode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a7a0358a02ed3b6f18045939192c38b99&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_time_mode.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTimeMode</a> pTimeMode = <a href=\"javascript:void(0)\" data-symbol=\"kFBTimeModeDefault\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a7a0358a02ed3b6f18045939192c38b99ab79ec0b606425e55159c9d697746930b&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">kFBTimeModeDefault</a></span>) in the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPlayerControl::GetTransportFpsValue()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_player_control.html#afe6bb1fa37ef8796a2abe5be3983b379&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPlayerControl::GetTransportFpsValue()</a></span> function to specify the time mode whose frame rate will be returned. \n\
                     </li>\n\
                     <li>New functions added to the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBTimeCode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_time_code.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_time_code.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTimeCode</a></span> class: <span class=\"code\" translate=\"no\">GetRawSecond()</span>,<span class=\"code\" translate=\"no\">GetRawFrame()</span>, and <span class=\"code\" translate=\"no\">GetRawRate()</span>. Additionally, the equality comparison operator function overload. \n\
                     </li>\n\
                  </ol> \n\
               </p> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_D9D04E27948244AEA52B7085B8415EE4\"></a> \n\
               <h3><a name=\"GUID-8838FB65-997A-4923-9257-D2A26FB584DA\"></a> Story\n\
               </h3> \n\
               <p><a name=\"GUID-DDD550E6-1388-49D9-8CF5-98F2FF88A79F\"></a> <a name=\"OL_519C83F8607F4280B4A91ED8480122D4\"></a><ol type=\"1\" start=\"1\">\n\
                     <li>New <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBStoryFolder::Collapsed\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_story_folder.html#a9a0b224805e11e4e9605aa4f6137b5f1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBStoryFolder::Collapsed</a></span> read/write property to collapse/expand the story folder. \n\
                     </li>\n\
                     <li>New <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBStoryClip::MakeWritable()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_story_clip.html#a1cbd4bf0efe3f30aa12017ea63a6dc3d&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBStoryClip::MakeWritable()</a></span> function to import FCurves from a story clip and make them accessible to the user.\n\
                        \n\
                     </li>\n\
                     <li>New <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBStoryClip::GetFbxScene()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_story_clip.html#a1568abd09522f4f2cd06be809bac2390&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBStoryClip::GetFbxScene()</a></span> function to return the pointer inside <span class=\"code\" translate=\"no\">FBXSDK::FbxScene</span> for read-only animation clip. \n\
                     </li>\n\
                  </ol> \n\
               </p> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_97BA075D81DB48D5A1C51C88E3A5A3FA\"></a> \n\
               <h3><a name=\"GUID-D487566D-AE8E-4996-B14F-E3FA140889C6\"></a> File IO and Reference\n\
               </h3> \n\
               <p><a name=\"GUID-B9E3B34B-D652-4BD6-88E4-0B2395BEE923\"></a> <a name=\"OL_7FBAAC2FC8484A588C2DD9007568F44B\"></a><ol type=\"1\" start=\"1\">\n\
                     <li>New <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBFileReference\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_file_reference.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_file_reference.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFileReference</a></span> class provides the basic access to the file reference feature through various SDK\n\
                        functions. \n\
                     </li>\n\
                     <li>New <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent::GetOwnerFileReference()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_component.html#a4aa1a9e2e9d77ccd5dbb3fa4bb7aa36e&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent::GetOwnerFileReference()</a></span> function to get the owner file reference object. \n\
                     </li>\n\
                     <li>Changes to the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBScene\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_scene.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_scene.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBScene</a></span> class including the following: <a name=\"UL_823882E502D34B4AA63DF3A5793785BA\"></a><ul>\n\
                           <li>New <span class=\"code\" translate=\"no\">GetScriptsPaths()</span> function to get the path of all python script objects in a scene. \n\
                           </li>\n\
                           <li>New <span class=\"code\" translate=\"no\">NamespaceGetOwnerFileReference()</span> function to get the owner file reference object if the namespace originates from\n\
                              file reference. \n\
                           </li>\n\
                           <li>New argument (<span class=\"code\" translate=\"no\">pAsFileReference</span>) in the <span class=\"code\" translate=\"no\">NamespaceImport()</span> function to specify whether to import the file as file reference. \n\
                           </li>\n\
                           <li>New argument (<span class=\"code\" translate=\"no\">pAsFileReference</span>) in the <span class=\"code\" translate=\"no\">NamespaceImportToMultiple</span> function to specify whether to import the file as file reference. \n\
                           </li>\n\
                           <li>Following new object list properties are added to allow easy access to certain type\n\
                              of scene objects: <span class=\"code\" translate=\"no\">CharacterMarkerSets</span>, <span class=\"code\" translate=\"no\">FileReferences</span>, <span class=\"code\" translate=\"no\">KeyingGroups</span>, <span class=\"code\" translate=\"no\">ModelSkeletons</span>, and <span class=\"code\" translate=\"no\">ModelOpticals</span>. \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                     <li>New global functions: <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBMergeTransactionFileRefEditBegin()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/group___file.html#ga237f78c483e5945caf28032489461a38&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga4f1fc09aeb4af86269fe5691e8988037&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMergeTransactionFileRefEditBegin()</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBMergeTransactionFileRefEditEnd()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/group___file.html#gaa8812505953c577ac7eb7567d15ecde7&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga9d2db12eb9f52faa6ea047f3c579ec69&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMergeTransactionFileRefEditEnd()</a></span> can be called in pair to improve the performance during multiple file merging process\n\
                        with the file reference editing operation. \n\
                     </li>\n\
                     <li>Following are the changes to the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBFbxOptions\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_fbx_options.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_fbx_options.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFbxOptions</a></span> class. <a name=\"UL_2B9F7CF703D747C0AC37DD75EE7D0B63\"></a><ul>\n\
                           <li>New <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"kFBOptionsContextSaveSelection\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#ac70b9337a8c16c3b5cfed964502fadb6a6bc5edbab400a0fc297a73ed52c7500c&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">kFBOptionsContextSaveSelection</a></span> enumerator in <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBOptionsContext\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#ac70b9337a8c16c3b5cfed964502fadb6&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBOptionsContext</a></span> to save selection case. \n\
                           </li>\n\
                           <li>New <span class=\"code\" translate=\"no\">SaveToString()</span> function to serialize all options to a string. \n\
                           </li>\n\
                           <li>New <span class=\"code\" translate=\"no\">SetFromString()</span> function to set all options from a string. \n\
                           </li>\n\
                           <li>New <span class=\"code\" translate=\"no\">UpdateRecentFiles</span> read/write property to specify whether to update the recent file list. \n\
                           </li>\n\
                           <li>New <span class=\"code\" translate=\"no\">FileReference</span> read/write property to load/save scene as file reference. \n\
                           </li>\n\
                           <li>New <span class=\"code\" translate=\"no\">FileReferenceEdit</span> read/write property to specify whether to load/save the edits made to referenced\n\
                              objects. \n\
                           </li>\n\
                           <li>New <span class=\"code\" translate=\"no\">FileReferences</span> read/write property to specify the handling of the file reference elements. \n\
                           </li>\n\
                           <li>The default value of <span class=\"code\" translate=\"no\">KeepTransformHierarchy</span> property is changed to <span class=\"code\" translate=\"no\">False</span> to ensure consistent behavior with <span class=\"code\" translate=\"no\">SaveSelected</span> operation using the File menu. \n\
                           </li>\n\
                           <li>New <span class=\"code\" translate=\"no\">RemoveEmptyLayer</span> property indicates whether to remove empty animation layers that are in additive\n\
                              mode without child or parent. \n\
                           </li>\n\
                           <li>New <span class=\"code\" translate=\"no\">ConsiderMuteSolo</span> property considers the mute/solo settings to identify identical layer when merging.\n\
                              \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                     <li>New <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBFileMonitoringManager::OnFileChangeFileReference\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_file_monitoring_manager.html#a9ce0f09f27a4a38eb95ca8d51b90123e&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFileMonitoringManager::OnFileChangeFileReference</a></span> event callback property to monitor the change events for the referenced file. \n\
                     </li>\n\
                     <li>New argument (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBDataAsStringFlag\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a87462307f6c172a3657f817bf1ab6a96&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_data_as_string_flag.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBDataAsStringFlag</a> pFlag = <a href=\"javascript:void(0)\" data-symbol=\"kFBDataAsStringUI\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a87462307f6c172a3657f817bf1ab6a96a6e9f1b2293a112d3cd86e50d2adae36a&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">kFBDataAsStringUI</a></span>) in the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBProperty::AsString()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_property.html#a032c2cf29d0d7cfada1d8c85006e7b61&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBProperty::AsString()</a></span> function to specify whether the returned string is used for UI display or persistent.\n\
                        \n\
                     </li>\n\
                     <li>A set of new object list property types are added that allows easy access to the same\n\
                        type of objects in a scene. <a name=\"UL_05BD2B604B874793846C8092DF8B6A8E\"></a><ul>\n\
                           <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPropertyListCharacterMarkerSet\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_property_list_character_marker_set.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_property_list_character_marker_set.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPropertyListCharacterMarkerSet</a></span> <span class=\"MenuCascade\" id=\"GUID-B3349CBD-948D-4F9C-ADD8-E7F017E0F9D2\"> <img src=\"images/ac.menuaro.gif\"> </span> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBScene::CharacterMarkerSets\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_scene.html#ae943f61aaf1280e751266d600e89479f&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBScene::CharacterMarkerSets</a></span> \n\
                           </li>\n\
                           <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPropertyListKeyingGroup\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_property_list_keying_group.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_property_list_keying_group.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPropertyListKeyingGroup</a></span> <span class=\"MenuCascade\" id=\"GUID-2B92571C-6760-413B-91C1-0F87C426FDFD\"> <img src=\"images/ac.menuaro.gif\"> </span> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBScene::KeyingGroups\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_scene.html#a9b28b821b5d5f22d7dee73c8e7d79da2&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBScene::KeyingGroups</a></span> \n\
                           </li>\n\
                           <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPropertyListFileReference\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_property_list_file_reference.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_property_list_file_reference.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPropertyListFileReference</a></span> <span class=\"MenuCascade\" id=\"GUID-83D941DA-EB64-4D29-92F8-FA66E5511386\"> <img src=\"images/ac.menuaro.gif\"> </span> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBScene::FileReferences\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_scene.html#a5a2097be051e2fe352bb6652bc2f0f53&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBScene::FileReferences</a></span> \n\
                           </li>\n\
                           <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPropertyListModelSkeleton\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_property_list_model_skeleton.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_property_list_model_skeleton.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPropertyListModelSkeleton</a></span> <span class=\"MenuCascade\" id=\"GUID-11466CE7-76BD-4F58-8A17-34B5AA28CC3B\"> <img src=\"images/ac.menuaro.gif\"> </span> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBScene::ModelSkeletons\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_scene.html#af67862c10c14a017b9c8c3ab2b81ba58&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBScene::ModelSkeletons</a></span> \n\
                           </li>\n\
                           <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPropertyListModelOptical\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_property_list_model_optical.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_property_list_model_optical.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPropertyListModelOptical</a></span> <span class=\"MenuCascade\" id=\"GUID-AD09259D-A84E-40B3-A2AF-0C6B10E803D2\"> <img src=\"images/ac.menuaro.gif\"> </span> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBScene::ModelOpticals\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_scene.html#af46fa6953c11ad2e86edbce83926e4c6&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBScene::ModelOpticals</a></span> \n\
                           </li>\n\
                           <li> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPropertyListRendererCallback\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_property_list_renderer_callback.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPropertyListRendererCallback</a></span> <span class=\"MenuCascade\" id=\"GUID-CB7D13E4-75FF-4472-B3CF-D96D22FD41ED\"> <img src=\"images/ac.menuaro.gif\"> </span> <span class=\"code\" translate=\"no\">FBRenderer::RendererCallbacks</span> \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                  </ol> \n\
               </p> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_0504E9F7A6DE4483B23CCC74BA5232D3\"></a> \n\
               <h3><a name=\"GUID-9C906D10-3D41-403A-B2A9-319787E0A210\"></a> Renderer and Viewport\n\
               </h3> \n\
               <p><a name=\"GUID-F85F4D02-430C-4441-9F7C-791E25C8A31D\"></a> <a name=\"OL_426FF139A81841ABB6647FBAF6A9507C\"></a><ol type=\"1\" start=\"1\">\n\
                     <li>New <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBRendererCallback\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_renderer_callback.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBRendererCallback</a></span> class for the custom renderer feature. You can implement your complete custom rendering\n\
                        solution by subclassing this class. For example code, see <span class=\"filePath\" translate=\"no\">&lt;yourinstallationdirectory&gt;/OpenRealitySDK/Samples/shaders/CustomRenderer</span>. \n\
                     </li>\n\
                     <li>New <span class=\"code\" translate=\"no\">FBRendererCallbackLayout</span> class is the base layout class that is inherited by the custom renderer configuration\n\
                        UI. \n\
                     </li>\n\
                     <li>Following functions are added to the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBViewingOptions\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_viewing_options.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBViewingOptions</a></span> class: <a name=\"UL_30229BF682BD4D2893CFB704124C32E4\"></a><ul>\n\
                           <li>The <span class=\"code\" translate=\"no\">IsInSelectionBufferPicking()</span> function is the rendering routine during picking status with the GL selection buffer\n\
                              method. \n\
                           </li>\n\
                           <li>The <span class=\"code\" translate=\"no\">IsInColorBufferPicking()</span> function is the rendering routine during picking status with the GL color buffer\n\
                              method. \n\
                           </li>\n\
                           <li>The <span class=\"code\" translate=\"no\">RenderCallbackPrefIndex()</span> function gets the current render callback’s preference settings index. \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                     <li>Following functions are added to the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBRenderOptions\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_render_options.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_render_options.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBRenderOptions</a></span> class: <a name=\"UL_95C51F7267D347F4993CE10FFBFF49F4\"></a><ul>\n\
                           <li>The <span class=\"code\" translate=\"no\">IsIDBufferRendering()</span> function gets the IDBuffer rendering request status (for display or picking). \n\
                           </li>\n\
                           <li>The <span class=\"code\" translate=\"no\">GetViewerOptions()</span> function gets the current viewer’s option. \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                     <li>Following are the changes to the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBRenderer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_renderer.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBRenderer</a></span> class: <a name=\"UL_99504AE57F374472A86CD02E325DA962\"></a><ul>\n\
                           <li>The new <span class=\"code\" translate=\"no\">OGLSetupSceneLights()</span> function is used to setup the scene lights in OpenGL (maximum of eight lights are\n\
                              supported). \n\
                           </li>\n\
                           <li>The new <span class=\"code\" translate=\"no\">GetLastPickInfoList()</span> function returns the last picking info list in the current view pane. \n\
                           </li>\n\
                           <li>Following new properties are added: <a name=\"UL_2127D421BD71419AA42F5F35A36ED343\"></a><ul>\n\
                                 <li><span class=\"code\" translate=\"no\">SelectionForceSnapPointsDisplay</span> (read/write) – Force to show all feature points (pivots and others) on selected models\n\
                                    if true, ignore individual model\'s settings. \n\
                                 </li>\n\
                                 <li><span class=\"code\" translate=\"no\">RendererCallbacks</span> (read/write) – List of renderer callbacks. \n\
                                 </li>\n\
                                 <li><span class=\"code\" translate=\"no\">RegisteredCallbackCount</span> (read-only) – Registered renderer callbacks count. \n\
                                 </li>\n\
                                 <li><span class=\"code\" translate=\"no\">CurrentPaneCallbackIndex</span> (read/write) – Current pane\'s renderer callback index. \n\
                                 </li>\n\
                                 <li><span class=\"code\" translate=\"no\">CurrentPaneCallbackPrefIndex</span> (read/write) – Current pane\'s renderer callback preference index. \n\
                                 </li>\n\
                                 <li><span class=\"code\" translate=\"no\">AdvancedLightingMode</span> (read/write) – Turn on/turn off the advanced lighting setting UI widgets. \n\
                                 </li>\n\
                              </ul> \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                     <li>Changes to support area light type includes the following: <a name=\"UL_C082A4F7D69444B49553F326BE33E522\"></a><ul>\n\
                           <li>New enumerator <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"kFBLightTypeArea\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a6a60cd4271e15999ec13cfc452adaf18a0bd0452a0c13650b7513cf8aec2c4a9e&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">kFBLightTypeArea</a></span> in <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBLightType\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a6a60cd4271e15999ec13cfc452adaf18&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_light_type.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLightType</a></span>. However MotionBuilder does not support this natively in its default viewport. Custom\n\
                              render is required to use this additional pipeline benefit. \n\
                           </li>\n\
                           <li>New enum type <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBLight::EAreaLightShapes\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_light.html#a616b273d5afcc49b12637add08738671&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLight::EAreaLightShapes</a> { eRectangle, eSphere}</span>. \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                     <li>Following are the new read/write properties in the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBLight\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_light.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_light.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLight</a></span> class: <span class=\"code\" translate=\"no\">AreaLightShape</span>, <span class=\"code\" translate=\"no\">InnerAngle</span>, <span class=\"code\" translate=\"no\">OuterAngle</span>, <span class=\"code\" translate=\"no\">EnableBarnDoor</span>, <span class=\"code\" translate=\"no\">LeftBarnDoor</span>, <span class=\"code\" translate=\"no\">RightBarnDoor</span>, <span class=\"code\" translate=\"no\">TopBarnDoor</span>, and <span class=\"code\" translate=\"no\">BottomBarnDoor</span>. \n\
                     </li>\n\
                     <li> Following are the viewport picking related enhancements: <a name=\"UL_72B00475E5284211BC69CD43949AAA0D\"></a><ul>\n\
                           <li>New <span class=\"code\" translate=\"no\">mSubItemIndex</span> member variable added for sub item picking in the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPickInfos\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/struct_o_r_s_d_k2019_1_1_f_b_pick_infos.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPickInfos</a></span> class. \n\
                           </li>\n\
                           <li>New <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPickInfos::mNormal\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/struct_o_r_s_d_k2019_1_1_f_b_pick_infos.html#a595bf819a58a08e7be7da9004136c941&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPickInfos::mNormal</a></span> member variable allows you to query the normal direction in the world space of the\n\
                              intersection point between the picking ray and model’s surface. \n\
                           </li>\n\
                           <li>New argument (<span class=\"code\" translate=\"no\">pSubItemIndex</span>) in the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBFindModelByUniqueColorId()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a0b771598ef7e760a18d39c036e0df53b&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga4da79d4f8d3faf047fd948767bc42cbd&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFindModelByUniqueColorId()</a></span> function to pass out the sub-item index value. For example code, see <span class=\"code\" translate=\"no\">&lt;yourinstallationdirectory&gt;/OpenRealitySDK/samples/miscellaneous/model_template</span>. \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                     <li>Changes to <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a></span> class includes the following: <a name=\"UL_A49263B60E7041E28854989DF1C3B4B5\"></a><ul>\n\
                           <li>New <span class=\"code\" translate=\"no\">UniqueColorId</span> read-only property to provide the model’s unique color ID for OpenGL color ID buffer\n\
                              based viewer picking. \n\
                           </li>\n\
                           <li>A set of new functions to support multiple sub-items per model/geo selection and picking\n\
                              in OpenGL color buffer mode using the custom rendering routines: <span class=\"code\" translate=\"no\">SetAdditionalUniqueColorIDCount()</span> to request additional unique color IDs per model, <span class=\"code\" translate=\"no\">GetAdditionalUniqueColorIDCount()</span> to get additional unique color count, <span class=\"code\" translate=\"no\">GetAdditionalUniqueColorID()</span> to get additional unique color ID. For example code, see <span class=\"filePath\" translate=\"no\">&lt;yourinstallationdirectory&gt;/OpenRealitySDK/Samples/miscellaneous/marker_template</span>. \n\
                           </li>\n\
                           <li>The <span class=\"code\" translate=\"no\">PushZDepthClipOverride()</span> and <span class=\"code\" translate=\"no\">PopZDepthClipOverride()</span> functions are added to facilitate the custom render implementation to work with the\n\
                              Z-depth HideFront selection tool. \n\
                           </li>\n\
                           <li>New read-write properties: <span class=\"code\" translate=\"no\">PrimaryVisibility</span>, <span class=\"code\" translate=\"no\">CastsShadows</span>, and <span class=\"code\" translate=\"no\">ReceiveShadows</span> added to control a model’s render state and shadow rendering policy, and to increase\n\
                              rendering interop consistency with other DCC tools. \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                     <li>Following are the changes in the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCamera\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_camera.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_camera.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCamera</a></span> class: <a name=\"UL_C888727BB89A4DBEBB38882BDC5D5170\"></a><ul>\n\
                           <li>Two new enumerators are added to <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCameraMatrixType\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a5531194e336ef0e6c9e9d5d7b535791a&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_camera_matrix_type.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCameraMatrixType</a></span>: <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"kFBModelViewProj\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a5531194e336ef0e6c9e9d5d7b535791aa73aa30a558729b08ba8e87b1bf426846&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">kFBModelViewProj</a></span> for a camera’s model-view-projection matrix, and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"kFBProjInverse\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a5531194e336ef0e6c9e9d5d7b535791aaa64f2afd49d299d99adf9a10f954ba4e&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">kFBProjInverse</a></span> for a camera’s projection inverse matrix. \n\
                           </li>\n\
                           <li>Added the <span class=\"code\" translate=\"no\">WindowWidth</span>, <span class=\"code\" translate=\"no\">BackGroundTexture</span>,<span class=\"code\" translate=\"no\">ForeGroundTexture</span>, and <span class=\"code\" translate=\"no\"> ViewShowName</span> properties. \n\
                           </li>\n\
                           <li>Added the <span class=\"code\" translate=\"no\">GetCameraMatrix()</span> and <span class=\"code\" translate=\"no\">InverseProjection()</span> functions. \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                  </ol> \n\
               </p> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_36BFB1EC4F104EDE85D1936BA1E8A8DA\"></a> \n\
               <h3><a name=\"GUID-B751831A-56CB-4A02-908E-A2850F9E09B3\"></a> Geometry\n\
               </h3> \n\
               <p><a name=\"GUID-EA54EC5D-2C43-4BD4-9383-7B6A9458787E\"></a> <a name=\"OL_EFC478D155804E80A3C31095D5F1B26B\"></a><ol type=\"1\" start=\"1\">\n\
                     <li>Following improvements in the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBGeometry\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_geometry.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_geometry.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBGeometry</a></span> class: <a name=\"UL_3244FCCEEEFB4970860AB0CEE7EFC857\"></a><ul>\n\
                           <li>New <span class=\"code\" translate=\"no\">IsEditingEnabled()</span> function to determine if geometry editing is enabled. \n\
                           </li>\n\
                           <li>A set of new functions for directly manipulating geometry position, normal, tangent,\n\
                              bi-normal, color, UV, and material arrays: <span class=\"code\" translate=\"no\">VertexArrayInit()</span>, <span class=\"code\" translate=\"no\">VertexArrayClear()</span>, <span class=\"code\" translate=\"no\">GetPositionsArray()</span>, <span class=\"code\" translate=\"no\">GetTangentsIndexArray()</span>, <span class=\"code\" translate=\"no\">GetTangentsDirectArray()</span>, <span class=\"code\" translate=\"no\">GetBinormalsIndexArray()</span>, and <span class=\"code\" translate=\"no\">GetBinormalsDirectArray()</span>. For example code, see <span class=\"filePath\" translate=\"no\">&lt;yourinstallationdirectory&gt;/bin/config/scripts/Samples/Geometry/VertexArrayManipulation.py</span>. \n\
                           </li>\n\
                           <li>New read-only properties for tangent and bi-normal mapping/reference mode: <span class=\"code\" translate=\"no\">TangentMappingMode</span>, <span class=\"code\" translate=\"no\">TangentReferenceMode</span>, <span class=\"code\" translate=\"no\">BinormalMappingMode</span>, and <span class=\"code\" translate=\"no\">BinormalReferenceMode</span>. \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                     <li>Several new functions are added to the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_mesh.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_mesh.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMesh</a></span> class for faster mesh creation using the SDK. For example code, see <span class=\"filePath\" translate=\"no\">&lt;yourinstallationdirectory&gt;/bin/config/scripts/Samples/Geometry/VertexArrayManipulation.py</span>. <a name=\"UL_79486EF934FF4C2C969568C5EE82B505\"></a><ul>\n\
                           <li><span class=\"code\" translate=\"no\">TriangleListAdd()</span> for adding triangle list, <span class=\"code\" translate=\"no\">TriangleStripAdd()</span> for adding triangle strip, and <span class=\"code\" translate=\"no\">PolygonListAdd()</span> for adding polygon list. \n\
                           </li>\n\
                           <li><span class=\"code\" translate=\"no\">PolygonVertexArrayGet()</span> to get the array of polygon vertex (index to control points). \n\
                           </li>\n\
                           <li><span class=\"code\" translate=\"no\">IsTriangleMesh()</span> to determine if the mesh is composed entirely of triangles. \n\
                           </li>\n\
                           <li><span class=\"code\" translate=\"no\">PolygonMaterialIdGet()</span> to get the material ID for a polygon’s index. \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                  </ol> \n\
               </p> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_F4CCEC92006E47B78C374566479BE460\"></a> \n\
               <h3><a name=\"GUID-82532761-29A4-496B-BF44-FF5AB6213362\"></a>Model and Elements\n\
               </h3> \n\
               <p><a name=\"GUID-57B22038-E23F-4E40-93EC-DB478DF15F9B\"></a> <a name=\"OL_8E9EB90FD41F4E959FFC024DBE141F6D\"></a><ol type=\"1\" start=\"1\">\n\
                     <li>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBGroup\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_group.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_group.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBGroup</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBSet\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_set.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_set.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSet</a></span> classes can hold animatable properties and are now inherited from the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBBox\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_box.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_box.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBBox</a></span> class instead of the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_component.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent</a></span> class to be consistent with the other classes. \n\
                     </li>\n\
                     <li>Several changes to the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBHUDElement\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_h_u_d_element.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_h_u_d_element.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBHUDElement</a></span> class and its subclasses including the following: <a name=\"UL_D82423F34E5B411C8E44C488F5982F25\"></a><ul>\n\
                           <li>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBHUDElement\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_h_u_d_element.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_h_u_d_element.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBHUDElement</a></span> class is now inherited from the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBBox\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_box.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_box.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBBox</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_component.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent</a></span> class to support animatable properties. \n\
                           </li>\n\
                           <li>New <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBHUDElement::Show\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_h_u_d_element.html#a6bd28307314bbf84de50019e92ef1d38&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBHUDElement::Show</a></span> read/write property to specify whether the HUD element will be displayed. \n\
                           </li>\n\
                           <li>New virtual functions: <span class=\"code\" translate=\"no\">GetIntrinsicDimension()</span>, <span class=\"code\" translate=\"no\">DrawElement()</span>, <span class=\"code\" translate=\"no\">FbxStore()</span>, and <span class=\"code\" translate=\"no\">FbxRetrieve()</span> to allow users to implement their own custom <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBHUDElement\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_h_u_d_element.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_h_u_d_element.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBHUDElement</a></span> type with persistent capability. For example code, see <span class=\"filePath\" translate=\"no\">&lt;yourinstallationdirectory&gt;/OpenRealitySDK/Samples/miscellaneous/hudelement_template</span>. \n\
                           </li>\n\
                           <li>New type of HUD elements: <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBHUDBloopSlateElement\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_h_u_d_bloop_slate_element.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_h_u_d_bloop_slate_element.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBHUDBloopSlateElement</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBHUDTimelineElement\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_h_u_d_timeline_element.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_h_u_d_timeline_element.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBHUDTimelineElement</a></span>. \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                     <li>Following changes to the FBHUD class: <a name=\"UL_898B563EC91F4D1D9129AF5551D0A7C8\"></a><ul>\n\
                           <li>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBHUD\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_h_u_d.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_h_u_d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBHUD</a></span> class is now inherited from the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBBox\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_box.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_box.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBBox</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_component.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent</a></span> class to support animatable properties. \n\
                           </li>\n\
                           <li>The <span class=\"code\" translate=\"no\">EStockElement</span> type now has new enumerators: <span class=\"code\" translate=\"no\">eTextureElement</span>, <span class=\"code\" translate=\"no\">eBloopSlate</span>, and <span class=\"code\" translate=\"no\">eTimeline</span>. \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                     <li>Following changes to the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelPath3D\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_path3_d.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_path3_d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelPath3D</a></span> class: <a name=\"UL_D5F009BDAB724AAB83F6A0E89518F7DE\"></a><ul>\n\
                           <li>Now each control point in the path corresponds to an animatable <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBVector4d\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#ab2f4a3422c4b8533a183f9a5871cdc44&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_vector4d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVector4d</a></span> type property (with naming convention as <em class=\"mild\">Point_%d</em>), which allows each control point to have keyframe animation, relation constrain\n\
                              setup, or direct connection with model for attaching behavior. \n\
                           </li>\n\
                           <li>New <span class=\"code\" translate=\"no\">PathLength</span> read-only property to get the path’s length in centimeter (CM) and <span class=\"code\" translate=\"no\">PathLengthInString</span> for its string representation in the current choice of unit and precision. \n\
                           </li>\n\
                           <li>New read/write properties: <span class=\"code\" translate=\"no\">PathLengthUnit</span>, <span class=\"code\" translate=\"no\">PathLengthShow</span>, <span class=\"code\" translate=\"no\">TextScale</span>, <span class=\"code\" translate=\"no\">TextBackground</span>, <span class=\"code\" translate=\"no\">PathEndCapStyle</span>, and <span class=\"code\" translate=\"no\">PathEndCapScale</span> to specify the path and length label appearance in the viewport. \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                     <li>Other changes to the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a></span> class includes the following: <a name=\"UL_BE8CA57389AC4C1E8554EB6C4D62BCE3\"></a><ul>\n\
                           <li>New read/write properties: <span class=\"code\" translate=\"no\">TranslationActive</span>, <span class=\"code\" translate=\"no\">TranslationMin</span>, <span class=\"code\" translate=\"no\">TranslationMax</span>, <span class=\"code\" translate=\"no\">TranslationMinX</span>, <span class=\"code\" translate=\"no\">TranslationMinY</span>, <span class=\"code\" translate=\"no\">TranslationMinZ</span>, <span class=\"code\" translate=\"no\">TranslationMaxX</span>, <span class=\"code\" translate=\"no\">TranslationMaxY</span>, and <span class=\"code\" translate=\"no\">TranslationMaxZ</span> to access the translation limit information. \n\
                           </li>\n\
                           <li>New <span class=\"code\" translate=\"no\">Transformable</span> read/write property to indicate whether a model can be transformable in the viewer.\n\
                              This has a default value of true. \n\
                           </li>\n\
                           <li>New <span class=\"code\" translate=\"no\">IsEvaluationReady()</span> function for querying the model\'s evaluation task status. \n\
                           </li>\n\
                           <li>New <span class=\"code\" translate=\"no\">MatrixToRotation()</span> and <span class=\"code\" translate=\"no\">RotationToMatrix()</span> functions allow the conversion between rotation Matrix to Euler Vector based on a\n\
                              model\'s rotation order. \n\
                           </li>\n\
                           <li>New <span class=\"code\" translate=\"no\">LRMToDof()</span> and <span class=\"code\" translate=\"no\">DofToLRM()</span> functions allow the conversion between local rotation matrix to object space ration\n\
                              vector. \n\
                           </li>\n\
                           <li>You can override the new <span class=\"code\" translate=\"no\">ClosestRayIntersection()</span> virtual function to determine the first intersection point\'s position and normal\n\
                              between ray and model surface. \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                     <li>Following new enumerators are added in the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBMarkerLook\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#ad885928408624afb0c7f2910a9dee43e&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_marker_look.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMarkerLook</a></span> class: <a name=\"UL_8F502A4AC1CC4F87885D1ADE61B73302\"></a><ul>\n\
                           <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"kFBMarkerLookRigidGoal\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#ad885928408624afb0c7f2910a9dee43ea5f79479a314a89f6d3beaf1efd4bb2c6&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">kFBMarkerLookRigidGoal</a></span> for rigid goal. \n\
                           </li>\n\
                           <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"kFBMarkerLookRotationGoal\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#ad885928408624afb0c7f2910a9dee43ead98c8202a68cdf288e46c47c990958eb&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">kFBMarkerLookRotationGoal</a></span> for rotation goal. \n\
                           </li>\n\
                           <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"kFBMarkerLookAimRollGoal\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#ad885928408624afb0c7f2910a9dee43eacde8f2fb3306a3bc24133fe37af66eda&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">kFBMarkerLookAimRollGoal</a></span> for aim and roll goal. \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                     <li>The new <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelSkeleton::DrawLink\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_skeleton.html#af253e1f1cfd8a7b527b34016162ddec2&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelSkeleton::DrawLink</a></span> property determines whether to draw a link to the parent node. \n\
                     </li>\n\
                  </ol> \n\
               </p> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_1529B87D0FD3479B8C206E308E284D2F\"></a> \n\
               <h3><a name=\"GUID-3BED95FB-32C1-4AE7-B377-EA332646C86A\"></a>Application Framework\n\
               </h3> \n\
               <p><a name=\"GUID-F850EF0C-85EF-4B73-96AF-4B59E05EFD8B\"></a> <a name=\"OL_1FC943874F9B454DABEB917322F01721\"></a><ol type=\"1\" start=\"1\">\n\
                     <li>Following changes to the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBSystem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_system.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_system.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem</a></span> class: <a name=\"UL_616BEA1AAD4A41BBAF7055B19EB1F39D\"></a><ul>\n\
                           <li>New <span class=\"code\" translate=\"no\">GetCommandLineArgs()</span> function returns portion of the command line arguments within a pair of delimiters\n\
                              (<span class=\"code\" translate=\"no\">--sdk-begin and --sdk-end</span>). \n\
                           </li>\n\
                           <li>New <span class=\"code\" translate=\"no\">GetPythonStartupPath()</span> function returns the list of folders where MotionBuilder will search for Python scripts\n\
                              and execute them automatically at startup. \n\
                           </li>\n\
                           <li> \n\
                              <p><a name=\"GUID-662C36F8-BA9D-4B55-8E04-5B4A497BC38E\"></a>New <span class=\"code\" translate=\"no\">GetPluginPath()</span> function returns the list of folders where MotionBuilder will search for ORSDK plugins\n\
                                 and load them automatically at startup. \n\
                              </p> \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                     <li>Following changes to the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_application.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a></span> class: <a name=\"UL_754739CAADC34A6384E641EB70FDA24A\"></a><ul>\n\
                           <li>New <span class=\"code\" translate=\"no\">FlushEventQueue()</span> function flushes event queue, and processes all pending events for the calling thread\n\
                              until there are no more events to process. Useful for controlling main application\n\
                              loop to perform special tasks. For example code, see <span class=\"filePath\" translate=\"no\">&lt;yourinstallationfolder&gt;/bin/config/Scripts/Samples/Profiling/CreateProfilingEventsLog.py</span>. \n\
                           </li>\n\
                           <li>A set of new functions related to the One-Click workflow: <a name=\"UL_790FC0CC81AF4348B60307DF38BEE57B\"></a><ul>\n\
                                 <li>The <span class=\"code\" translate=\"no\">OneClickSendAsNewScene()</span> function to send the current scene as a new scene to the specified application (currently\n\
                                    supports Maya and 3ds Max only). \n\
                                 </li>\n\
                                 <li>The <span class=\"code\" translate=\"no\">OneClickUpdateCurrentScene()</span> function to send the scene to update the current scene in the specified application.\n\
                                    \n\
                                 </li>\n\
                                 <li>The <span class=\"code\" translate=\"no\">OneClickAddToCurrentScene()</span> function to Send the scene and add it to the current scene in the specified application.\n\
                                    \n\
                                 </li>\n\
                                 <li>The <span class=\"code\" translate=\"no\">OneClickSelectPreviouslySentObject()</span> function to select the object that was sent from MotionBuilder. \n\
                                 </li>\n\
                                 <li>The <span class=\"code\" translate=\"no\">OneClickIsConnectedTo()</span> function to return the identifier from the other application that is connected to\n\
                                    MotionBuilder. \n\
                                 </li>\n\
                              </ul> \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                     <li>Following changes to the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBEvaluateManager\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_evaluate_manager.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_evaluate_manager.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBEvaluateManager</a></span> class: <a name=\"UL_A77DEEA2E09544DCA9A02BD659EBA623\"></a><ul>\n\
                           <li>New <span class=\"code\" translate=\"no\">IsInteractiveMode()</span> function to check if the application main loop is in interactive or offline rendering\n\
                              mode. \n\
                           </li>\n\
                           <li>Enum <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBGlobalEvalCallbackTiming\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a7ea720960550dd697a78e389174a8cf2&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_global_eval_callback_timing.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBGlobalEvalCallbackTiming</a></span> has a new enumerator to allow registering per frame callbacks (global functions)\n\
                              into the rendering pipeline. <a name=\"UL_7C592D675FDC4298B04005E3E395600B\"></a><ul>\n\
                                 <li>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"kFBGlobalEvalCallbackSyn\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a7ea720960550dd697a78e389174a8cf2a707e2b7eea5b669eb8d6db4dc7132be9&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">kFBGlobalEvalCallbackSyn</a></span> is invoked when both evaluation and rendering pipelines (or threads) are stopped.\n\
                                    Useful in some complicated scene change tasks to avoid race condition. \n\
                                 </li>\n\
                                 <li>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"kFBGlobalEvalCallbackBeforeRender\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a7ea720960550dd697a78e389174a8cf2a126c8bfadd3a108b757e1b23951a544a&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">kFBGlobalEvalCallbackBeforeRender</a></span> is invoked in rendering pipeline before any rendering tasks start (immediately after\n\
                                    clearing GL back buffer). \n\
                                 </li>\n\
                                 <li>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"kFBGlobalEvalCallbackAfterRender\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a7ea720960550dd697a78e389174a8cf2ab95b80b8f72156565c2edb3de608b936&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">kFBGlobalEvalCallbackAfterRender</a></span> is invoked in rendering pipeline after any rendering tasks are finished (just before\n\
                                    swapping GL back/front buffer). \n\
                                 </li>\n\
                              </ul> \n\
                           </li>\n\
                           <li>New event callback properties: <span class=\"code\" translate=\"no\">OnEvaluationPipelineEvent</span>, <span class=\"code\" translate=\"no\">OnRenderingPipelineEvent</span>, and <span class=\"code\" translate=\"no\">OnSynchronizationEvent</span> to allow registration of per frame callbacks function (with <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"ICallback\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_i_callback.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">ICallback</a></span> interface) into various critical timing, stages, and pipelines in the application\n\
                              main loop. \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                  </ol> \n\
               </p> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_7D5B2F1EFAFD4CCBAA27DFA5A4208BD3\"></a> \n\
               <h3><a name=\"GUID-EBFAD8FF-BCDD-406E-BCB5-B6F9FF8AE178\"></a>UI\n\
               </h3> \n\
               <p><a name=\"GUID-B5822E01-8C6D-48BC-8542-9B45EE87B230\"></a> <a name=\"OL_FD2C6AB2A2DD4904B0A3DB6DAB886844\"></a><ol type=\"1\" start=\"1\">\n\
                     <li>The new <span class=\"code\" translate=\"no\">FBWidgetHolder::WidgetCreate()</span> virtual function can be overridden so that you have more flexibility in bridging\n\
                        native QT UI with the MotionBuilder UI framework. You can also do this using Python.\n\
                        For example code, see <span class=\"filePath\" translate=\"no\">&lt;yourinstalationdirectory&gt;/bin/config/Scripts/UI/ToolNativeWidgetHolder.py</span>. \n\
                     </li>\n\
                     <li>New <span class=\"code\" translate=\"no\">FBVisualComponent::GetQWidgetAddress()</span> function returns the memory address of the corresponding internal <span class=\"code\" translate=\"no\">QWidget</span> object. \n\
                     </li>\n\
                     <li>New <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBApplication::UpdateAllWidgets()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_application.html#a7225245dacbc68fc8af3ff85d10e7056&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication::UpdateAllWidgets()</a></span> function to request UI refresh for all widgets. \n\
                     </li>\n\
                     <li>New <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent::UseCustomPropertyViewSet()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_component.html#a6a8b703aaf8fd2b8595e36c5eead6fd2&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent::UseCustomPropertyViewSet()</a></span> virtual function can be overridden to indicate whether the subclass instance uses\n\
                        the custom property ViewSet. For example code, see the ORSDK sample project in <span class=\"filePath\" translate=\"no\">&lt;yourinstallationdirectory&gt;/OpenRealitySDK/Samples/miscellaneous/marker_template</span>. \n\
                     </li>\n\
                     <li>New <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBWebView\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_web_view.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBWebView</a></span> class is a simple UI widget that can load a webpage. For code example, see <span class=\"filePath\" translate=\"no\">&lt;yourinstallationdirectory&gt;/bin/config/Scripts/UI/WebView.py</span>. \n\
                     </li>\n\
                     <li>The new <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPropertyViewList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_property_view_list.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPropertyViewList</a></span>, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPropertyViewDefinition\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_property_view_definition.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPropertyViewDefinition</a></span>, and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPropertyViewManager\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_property_view_manager.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPropertyViewManager</a></span> classes provide ways to create new property views. For example code, see <span class=\"filePath\" translate=\"no\">&lt;yourinstallationdirectory&gt;/OpenRealitySDK/Samples/constraints/CharacterSolver/HIK2014Solver</span> and <span class=\"code\" translate=\"no\">&lt;yourinstallationdirectory&gt;/bin/Scripts/Samples/Properties/PropertyViewManager.py</span>. \n\
                     </li>\n\
                     <li>The new <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBActionManager\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_action_manager.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_action_manager.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBActionManager</a></span> class enables you to query and modify the current interaction mode, for example,\n\
                        switch to MotionBuilder, Maya, or 3ds Max keyboard. \n\
                     </li>\n\
                  </ol> \n\
               </p> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_99B66656C7E64E618281D17EDEDCA6F7\"></a> \n\
               <h3><a name=\"GUID-1D4C9612-8244-41D5-80CE-4BBB11C743D8\"></a> Video and Image Sequence\n\
               </h3> \n\
               <p><a name=\"GUID-B88D835C-E57D-4C05-AA1C-F3E258EE7357\"></a> <a name=\"OL_B591A5DD280040CBBE0F5E172E7E229F\"></a><ol type=\"1\" start=\"1\">\n\
                     <li>You can now subclass <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBLayeredTexture\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_layered_texture.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_layered_texture.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLayeredTexture</a></span> to support custom blending and composition modes. For example code, see <span class=\"filePath\" translate=\"no\">&lt;yourinstallationdirectory&gt;/OpenRealitySDK/Samples/miscellaneous/texture_template</span>. \n\
                     </li>\n\
                     <li>New <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBTexture::TextureOGLId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_texture.html#a76ced131e4964b86e2781b5222926ea2&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTexture::TextureOGLId</a></span> property allows you to query its OpenGL texture object ID. \n\
                     </li>\n\
                     <li>New <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBSystem::OnVideoFrameRendering\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_system.html#a2e9138a5fbeb94c0c590179649cafb3e&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem::OnVideoFrameRendering</a></span> event callback property is triggered when the scene is being off-line rendered into\n\
                        video files before and after every frame. \n\
                     </li>\n\
                     <li>Struct <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBVideoGrabOptions\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/struct_o_r_s_d_k2019_1_1_f_b_video_grab_options.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_video_grab_options.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVideoGrabOptions</a></span> has new data members: <span class=\"code\" translate=\"no\">mRendererCallbackIndex</span> and <span class=\"code\" translate=\"no\">mRendererCallbackPrefIndex</span> to specify renderer callback and preference index. \n\
                     </li>\n\
                     <li>New <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBImage::GetBufferAddress()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_image.html#a2c658d1d780318e072513ed9330234fb&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBImage::GetBufferAddress()</a></span> function to access the image data buffer and allow modifications. \n\
                     </li>\n\
                     <li>New <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBVideoCodecManager::RegisterExternalVideoFormat()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_video_codec_manager.html#aa018847535da0d5361809580be0836ee&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVideoCodecManager::RegisterExternalVideoFormat()</a></span> function enables you to register any image/video file suffix which MotionBuilder\n\
                        cannot recognize. However, it is the plug-in developer’s responsibility to load the\n\
                        file into memory. \n\
                     </li>\n\
                     <li>New <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBVideoOut::Online\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_video_out.html#add2f2ff0635a69dc22f8eddd6041dbb3&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVideoOut::Online</a></span> read/write property to control the video out and online status of the device. \n\
                     </li>\n\
                     <li>New <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBVideoClipImage::ImageSequence\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_video_clip_image.html#af80ef21948f39dbed070ca1caed0ac70&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVideoClipImage::ImageSequence</a></span> read/write property that when set true tries to search for files in a folder to compose\n\
                        an image sequence. \n\
                     </li>\n\
                     <li>Following changes to the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBStoryClip\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_story_clip.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_story_clip.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBStoryClip</a></span> class: <a name=\"UL_0DDE18D590984E299992532DBA47EA01\"></a><ul>\n\
                           <li>New<span class=\"code\" translate=\"no\">ImageSequence</span> read/write property to indicate whether to use Image sequence. \n\
                           </li>\n\
                           <li>New <span class=\"code\" translate=\"no\">UseSystemFrameRate</span> read/write property to indicate whether to always use the system frame rate. \n\
                           </li>\n\
                           <li>New <span class=\"code\" translate=\"no\">FrameRate</span> read/write property for frame rate value that is only effective when <span class=\"code\" translate=\"no\">UseSystemFrameRate</span> is false. \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                  </ol> \n\
               </p> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_EA03F2002D534D32BFEC1178E1A6BB9B\"></a> \n\
               <h3><a name=\"GUID-9F08A7E2-A87C-4A70-8A43-2B9F98DBE6F7\"></a>Miscellaneous\n\
               </h3> \n\
               <p><a name=\"GUID-968637FC-1A42-4EF1-A9DF-7A080947D7DB\"></a> <a name=\"OL_EC2CEC17D4604A08B0C8245666E57880\"></a><ol type=\"1\" start=\"1\">\n\
                     <li>New helper classes: <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"HdlFBPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_hdl_f_b_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">HdlFBPlug</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"HdlFBPlugTemplate\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_hdl_f_b_plug_template.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">HdlFBPlugTemplate</a></span> to handle dangling pointer issue of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_plug.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPlug</a></span> and its subclasses. For example, see <span class=\"filePath\" translate=\"no\">&lt;yourinstallationdirectory&gt;/OpenRealitySDK/Samples/tools/toolqttest</span>. \n\
                     </li>\n\
                     <li>The trace and log mechanism is re-designed and improved. Now, you can set the trace\n\
                        message level, redirect trace output to Python editor console, or even register external\n\
                        trace output target. See the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBTraceSetLevel()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/group___f_b_trace.html#ga8033744866710a051a63868fa7f55e18&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga6f3682e5f4b1767ff371b023b518b74d&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTraceSetLevel()</a></span>, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBTrace()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/group___f_b_trace.html#ga532c4b1e58f5799cf4561346b7200549&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#gabff3bea6577707a2053a1bea331b04b3&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTrace()</a></span>, and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBTraceWithLevel()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/group___f_b_trace.html#ga36e131bef09844787959239370df9e02&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#gaaa42b46884fca78e40769ca916861982&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTraceWithLevel()</a></span> functions. \n\
                     </li>\n\
                     <li>Improved the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBArrayTemplate\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_array_template.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBArrayTemplate</a></span> class for commonly used date type (bool, int, float, double, and others) in fbsdk\n\
                        library for convenient usage. \n\
                     </li>\n\
                     <li>Added copy constructor to the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBArrayTemplate\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_array_template.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBArrayTemplate</a></span> class to support proper deep copy behavior and avoid potential crash in certain usage\n\
                        scenarios. \n\
                     </li>\n\
                     <li>New argument (<span class=\"code\" translate=\"no\">pClearFile</span>) in the <span class=\"code\" translate=\"no\">FBConfigFile::FBConfigFile(const char* pConfigFileName, <a href=\"javascript:void(0)\" data-symbol=\"bool\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#af6a258d8f3ee5206d682d799316314b1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">bool</a> pVirtualMode = <a href=\"javascript:void(0)\" data-symbol=\"false\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#af6a258d8f3ee5206d682d799316314b1ae9de385ef6fe9bf3360d1038396b884c&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">false</a>,\n\
                           <a href=\"javascript:void(0)\" data-symbol=\"bool\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#af6a258d8f3ee5206d682d799316314b1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">bool</a> pClearFile = <a href=\"javascript:void(0)\" data-symbol=\"false\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#af6a258d8f3ee5206d682d799316314b1ae9de385ef6fe9bf3360d1038396b884c&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">false</a>)</span> constructor function, and new arguments (<span class=\"code\" translate=\"no\">pVirtualMode</span> and <span class=\"code\" translate=\"no\">pClearFile</span>) in the <span class=\"code\" translate=\"no\">FBConfigFile::FBConfigFile (const char* pConfigFileName, const char* pConfigFilePath,\n\
                           <a href=\"javascript:void(0)\" data-symbol=\"bool\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#af6a258d8f3ee5206d682d799316314b1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">bool</a> pVirtualMode = <a href=\"javascript:void(0)\" data-symbol=\"false\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#af6a258d8f3ee5206d682d799316314b1ae9de385ef6fe9bf3360d1038396b884c&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">false</a>, <a href=\"javascript:void(0)\" data-symbol=\"bool\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#af6a258d8f3ee5206d682d799316314b1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">bool</a> pClearFile = <a href=\"javascript:void(0)\" data-symbol=\"false\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#af6a258d8f3ee5206d682d799316314b1ae9de385ef6fe9bf3360d1038396b884c&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">false</a>)</span> constructor function to remove all existing content from the configuration file upon\n\
                        opening. \n\
                     </li>\n\
                     <li>Added two math utility functions: <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBMatrixToQuaternion()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a83629c5619886eeb421dd5c975049bab&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga666ef1f11a5f0f64075410d8492d8dfe&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMatrixToQuaternion()</a></span> for getting a quaternion from a matrix and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBQuaternionToMatrix()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a31265a2fa1db25cc115fbf5308463062&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga03ab5a42bc9abbf9c6a3dead88e29664&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBQuaternionToMatrix()</a></span> for getting a rotation matrix from a quaternion vector. \n\
                     </li>\n\
                     <li>Following changes to the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBStringList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_string_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_string_list.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBStringList</a></span> class: <a name=\"UL_F75ADBF64142438C880249861D63BAD1\"></a><ul>\n\
                           <li>New arguments (<span class=\"code\" translate=\"no\">pCaseSensitive</span> and <span class=\"code\" translate=\"no\">pStartWith</span>) in the <span class=\"code\" translate=\"no\">Find()</span> function to allow more flexible searching options. \n\
                           </li>\n\
                           <li>New argument (<span class=\"code\" translate=\"no\">pSeparator</span>) in the <span class=\"code\" translate=\"no\">AsString()</span> function to change the default string list separator. \n\
                           </li>\n\
                           <li>New argument (<span class=\"code\" translate=\"no\">pSeparator</span>) in <span class=\"code\" translate=\"no\">SetString()</span> function to choose a different string list separator. \n\
                           </li>\n\
                           <li> Overloaded assignment operator and copy constructor to support deep copy behavior.\n\
                              \n\
                           </li>\n\
                        </ul> \n\
                     </li>\n\
                     <li>Python callbacks registered to <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPropertyEvent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_property_event.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPropertyEvent</a></span> are unregistered automatically if they throw exception during runtime. \n\
                     </li>\n\
                     <li>New <span class=\"code\" translate=\"no\">GetStatStart()</span> and <span class=\"code\" translate=\"no\">GetStatStop()</span> functions in the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBProfiler\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_profiler.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_profiler.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBProfiler</a></span> class. For example code, see <span class=\"filePath\" translate=\"no\">&lt;yourinstallationdirectory&gt;/bin/config/Scripts/Samples/Profiling/CreateProfilingEventsLog.py</span>. \n\
                     </li>\n\
                  </ol> \n\
               </p> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_DDB43B9AB496473299E11AA5ABD0453D\"></a> \n\
               <h3><a name=\"GUID-106944E6-057D-467E-B582-9864D2249AE0\"></a> Deprecation\n\
               </h3> \n\
               <div class=\"section\"><a name=\"SECTION_780960402CAB4B0A9109476C8DF46BA1\"></a> \n\
                  <h4><a name=\"GUID-DBDAEEC0-20D1-4337-A6C2-63E1721529EE\"></a>New Deprecations\n\
                  </h4> \n\
                  <p><a name=\"GUID-60AF2AC0-01B4-4173-93BF-859216145C36\"></a> The following APIs are deprecated in this release. <a name=\"OL_82326B3E29D64E16A81A404EDD69E4D3\"></a><ol type=\"1\" start=\"1\">\n\
                        <li>The <span class=\"code\" translate=\"no\">qtool.py</span>(<span class=\"filePath\" translate=\"no\">&lt;yourinstallationdirectory&gt;/bin/config/Python/qtool.py</span>) is deprecated. You can use the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBWidgetHolder\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_widget_holder.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBWidgetHolder</a></span> instead. See <span class=\"filePath\" translate=\"no\">&lt;yourinstallationfolder&gt;/bin/config/Scripts/UI/ToolNativeWidgetHolder.py</span> for an example. \n\
                        </li>\n\
                        <li> The <span class=\"code\" translate=\"no\">FBImageContainer::ImageWidth</span> and <span class=\"code\" translate=\"no\">ImageHeight</span> properties are deprecated. \n\
                        </li>\n\
                        <li>The <span class=\"code\" translate=\"no\">FBVisualContainer::ItemIconSet()</span> function is deprecated. \n\
                        </li>\n\
                        <li>The following elements are deprecated in the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCamera\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_camera.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_camera.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCamera</a></span> class: <a name=\"UL_B1DCDDCCB76A4A88BEF447E0A724CCE1\"></a><ul>\n\
                              <li><span class=\"code\" translate=\"no\">BackGroundMedia</span> property. You can use <span class=\"code\" translate=\"no\">BackGroundTexture</span> instead. \n\
                              </li>\n\
                              <li><span class=\"code\" translate=\"no\">ForeGroundMedia</span> property. You can use <span class=\"code\" translate=\"no\">ForeGroundTexture</span> instead. \n\
                              </li>\n\
                              <li><span class=\"code\" translate=\"no\">GetMatrix()</span> function. You can use <span class=\"code\" translate=\"no\">GetCameraMatrix()</span> instead. \n\
                              </li>\n\
                           </ul> \n\
                        </li>\n\
                        <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBObjectFlag\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a942db30fd5248ad81ec2af5e1256c38d&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_object_flag.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBObjectFlag</a></span> type enumerator <span class=\"code\" translate=\"no\">kFBFlagCustomObject</span> is deprecated. \n\
                        </li>\n\
                        <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBObjectStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a4f624f88ba2b5cda7066f39f8a76d6b3&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_object_status.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBObjectStatus</a></span> type enumerator <span class=\"code\" translate=\"no\">kFBStatusOwnedByUndo</span> is deprecated. You can use the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPlugStatusFlag\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#ad9e6aaef479043c8bebcb4c04479d539&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_plug_status_flag.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPlugStatusFlag</a></span> type enumerator <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"kFBOwnedByUndo\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#ad9e6aaef479043c8bebcb4c04479d539a28d87fdb5617ee29c10b768ed13368ee&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">kFBOwnedByUndo</a></span> on <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_plug.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPlug</a></span> instead. \n\
                        </li>\n\
                        <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBAnimationLayerMergeOptions\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#aeb4dc48a0553f9e58774c001a6d920ea&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_animation_layer_merge_options.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBAnimationLayerMergeOptions</a></span> type enumerator <span class=\"code\" translate=\"no\">kFBAnimLayerMerge_SelectedLayer_CompleteScene</span> was misspelled and is deprecated now. You can use <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"kFBAnimLayerMerge_SelectedLayers_CompleteScene\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#aeb4dc48a0553f9e58774c001a6d920eaa7050de374d3578985f1d9e1456b761d6&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">kFBAnimLayerMerge_SelectedLayers_CompleteScene</a></span> instead. \n\
                        </li>\n\
                        <li><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBGeometryArrayID\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a093c68eb3541c4bd12e6a51781f0f0cd&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_geometry_array_i_d.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBGeometryArrayID</a></span> type enumerator <span class=\"code\" translate=\"no\">kFBGeometryArrayID_NormalByPoint</span> and<span class=\"code\" translate=\"no\"> kFBGeometryArrayID_VertexColor</span> are replaced by <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"kFBGeometryArrayID_Normal\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a093c68eb3541c4bd12e6a51781f0f0cda215179bf965c1f9a80ef201d7191ab1d&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">kFBGeometryArrayID_Normal</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"kFBGeometryArrayID_Color\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a093c68eb3541c4bd12e6a51781f0f0cdabb2488b98825f4aaf42b914bb394f1de&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">kFBGeometryArrayID_Color</a></span> respectively. \n\
                        </li>\n\
                        <li>Constructor of the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBConstraintManager\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_constraint_manager.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_constraint_manager.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConstraintManager</a></span> class is deprecated. You can use the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBConstraintManager::TheOne()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_constraint_manager.html#a33c98ebe219c2ea8554e1b789d52de3b&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConstraintManager::TheOne()</a></span> singleton function instead. \n\
                        </li>\n\
                        <li>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBHUDElement::Visibility\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_h_u_d_element.html#a807d2b3d5ffd9bc70e4f82ab12b647a0&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBHUDElement::Visibility</a></span> property is deprecated. You can use the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBHUDElement::Show\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_h_u_d_element.html#a6bd28307314bbf84de50019e92ef1d38&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBHUDElement::Show</a></span> property instead. \n\
                        </li>\n\
                        <li><span class=\"code\" translate=\"no\">FBImage::GetDataBuffer()</span> is deprecated and replaced by <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBImage::GetBufferAddress()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_image.html#a2c658d1d780318e072513ed9330234fb&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBImage::GetBufferAddress()</a></span> for naming consistency. \n\
                        </li>\n\
                        <li>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBLight::ConeAngle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_light.html#a2b73e7d685c2dfa7a0c464ab0cc35488&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLight::ConeAngle</a></span> property is depreciated. You can use the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBLight::OuterAngle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_light.html#ad07530d79d93dd8f0337be7e22ed2539&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLight::OuterAngle</a></span> property instead. \n\
                        </li>\n\
                        <li>The <span class=\"code\" translate=\"no\">InPicking()</span> function in the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBViewingOptions\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_viewing_options.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBViewingOptions</a></span> class is deprecated and replaced by <span class=\"code\" translate=\"no\">IsInSelectionBufferPicking()</span> or <span class=\"code\" translate=\"no\">IsInColorBufferPicking()</span> for precise semantics. \n\
                        </li>\n\
                        <li>The <span class=\"code\" translate=\"no\">IsIDBufferPicking()</span> function in the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBRenderOptions\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_render_options.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_render_options.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBRenderOptions</a></span> class is deprecated and replaced by <span class=\"code\" translate=\"no\">IsIDBufferRendering()</span> for precise semantics. \n\
                        </li>\n\
                     </ol> \n\
                  </p> \n\
               </div> \n\
               <div class=\"section\"><a name=\"SECTION_A84E6D89FD3E41B2A2A94ECC21C859AC\"></a> \n\
                  <h4><a name=\"GUID-DD1C5BB1-0073-4340-9801-7F5DB5D61F44\"></a>Removed APIs\n\
                  </h4> \n\
                  <p><a name=\"GUID-139DBF15-1D4E-47C4-B90B-50C27B5CBF91\"></a>The following APIs are either already deprecated in the previous releases, or never\n\
                     worked as expected. They are removed in this release for a cleaner API. <a name=\"OL_6F2A6023385E4A58A42735198DB03DD1\"></a><ol type=\"1\" start=\"1\">\n\
                        <li>The <span class=\"code\" translate=\"no\">FBFindModelByName()</span> function. \n\
                        </li>\n\
                        <li>The following functions in the <span class=\"code\" translate=\"no\">FBModelPath3d</span> class: <span class=\"code\" translate=\"no\">PathSetKeyLeftRightTangeant()</span>, <span class=\"code\" translate=\"no\">PathKeySetLeftTangeant()</span>,<span class=\"code\" translate=\"no\"> PathKeySetRightTangeant()</span>, <span class=\"code\" translate=\"no\">PathKeyGetLeftTangeant()</span>, <span class=\"code\" translate=\"no\">PathKeyGetRightTangeant()</span>, <span class=\"code\" translate=\"no\">PatKeyGetLeftTangeantLength()</span>, and <span class=\"code\" translate=\"no\">PatKeyGetRightTangeantLength()</span>. \n\
                        </li>\n\
                        <li>The <span class=\"code\" translate=\"no\">FBPlug::ConnectAt()</span> function. \n\
                        </li>\n\
                        <li>The functions in the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_application.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a></span> class: <span class=\"code\" translate=\"no\">FBXFileOpen()</span>, <span class=\"code\" translate=\"no\">FBXFileMerge()</span>, <span class=\"code\" translate=\"no\">FBXFileAppend()</span>, and <span class=\"code\" translate=\"no\">FBXFileSave()</span>. \n\
                        </li>\n\
                        <li>The <span class=\"code\" translate=\"no\">FBTexture::Filename</span> property. You can use <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBTexture::Video\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_texture.html#a8f4880f1a3c6b274731cc991806c2b26&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTexture::Video</a></span> instead to find out the source of the media. \n\
                        </li>\n\
                        <li>Starting from this release, the predefined pointer type for ORSDK C++ classes with\n\
                           the <em class=\"mild\">H</em> prefix is removed. You can use pointer suffix <em class=\"mild\">* </em> directly. For example, <span class=\"code\" translate=\"no\">HFBPlug</span> is replaced with <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_plug.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPlug</a>*</span>. This change is intended to facilitate the use of the documentation system, and to\n\
                           be consistent with the rest. All the existing ORSDK sample projects are updated for\n\
                           this change. \n\
                        </li>\n\
                     </ol> \n\
                  </p> \n\
               </div> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_6978395D3F9747C48C61D8018DEAB2B4\"></a> \n\
               <h3><a name=\"GUID-29594ABB-3F21-4B00-A8F7-671107786C17\"></a> SDK Sample Changes\n\
               </h3> \n\
               <p><a name=\"GUID-C58B4240-3994-4BA1-ACDC-291D5936E0C9\"></a>In MotionBuilder 2014, several ORSDK C++ sample projects and Python sample scripts\n\
                  are updated to fix known bugs. Some SDK samples are newly created to demonstrate the\n\
                  new capabilities. \n\
               </p> \n\
               <div class=\"section\"><a name=\"SECTION_40DC6B5D36C34316B5900B767B097442\"></a> \n\
                  <h4><a name=\"GUID-2753903E-8F2E-4E59-9128-9BDA96F6B349\"></a>New ORSDK C++ Sample Projects\n\
                  </h4> \n\
                  <p><a name=\"GUID-6616BD36-C6FE-437C-A3BF-0E33C75E9DFD\"></a>The following ORSDK C++ sample projects that are added in the <span class=\"filePath\" translate=\"no\">&lt;yourinstallationfolder&gt;/OpenRealitySDK/samples</span> folder demonstrates the new extension capability introduced in MotionBuilder 2014.\n\
                     <a name=\"OL_2DCBA44828B046FCB5B59625860ACB52\"></a><ol type=\"1\" start=\"1\">\n\
                        <li><span class=\"filePath\" translate=\"no\">Importexport/FBXExtension</span> – Demonstrates how to filter FBXSDK IO and implement custom reader/writer using FBXSDK\n\
                           framework. \n\
                        </li>\n\
                        <li><span class=\"filePath\" translate=\"no\">Importexport/FBXExtension-Surface</span> – Demonstrates how to perform custom material replacement on import/export routines\n\
                           using FBXSDK framework. \n\
                        </li>\n\
                        <li><span class=\"filePath\" translate=\"no\">Tools/toolclipscene</span> – This tool lists all story clips in the scene. When read-only animation clip is\n\
                           chosen, it displays all nodes from its FBX SDK scene (shows how to link and access\n\
                           FBX SDK elements). \n\
                        </li>\n\
                        <li><span class=\"filePath\" translate=\"no\">Miscellaneous/hudelement_template</span> – Demonstrates how to create a custom HUD element. \n\
                        </li>\n\
                        <li><span class=\"filePath\" translate=\"no\">Miscellaneous/marker_template</span> – Demonstrates how to create a custom marker type. \n\
                        </li>\n\
                        <li><span class=\"filePath\" translate=\"no\">Miscellaneous/texture_template</span> – Shows how to create custom layered texture classes to support the user-defined\n\
                           composition/blending modes. \n\
                        </li>\n\
                        <li><span class=\"filePath\" translate=\"no\">Shaders/CustomRenderer</span> – Demonstrates how to implement a custom renderer within the MotionBuilder rendering\n\
                           framework. \n\
                        </li>\n\
                        <li><span class=\"filePath\" translate=\"no\">Constraints/CharacterSolver/HIK2014Sovler</span> – Demonstrates how to glue MotionBuilder with the 2014 version of HIK solver. \n\
                        </li>\n\
                     </ol> \n\
                  </p> \n\
               </div> \n\
               <div class=\"section\"><a name=\"SECTION_CC7F0C739E0F494B9806E7C12FBD2BC6\"></a> \n\
                  <h4><a name=\"GUID-291BD45A-4A2C-40A9-8FE5-D63CA69530F7\"></a>Changes in Other ORSDK C++ Sample Projects\n\
                  </h4> \n\
                  <p><a name=\"GUID-0AABCF6B-397B-4DD2-A2F2-F9CD6464DDD6\"></a>The following ORSDK C++ sample projects have changed significantly to reflect the\n\
                     new SDK functionality, or for fixing bugs. <a name=\"UL_AF201488FFEA47249E2D0618995D290D\"></a><ul>\n\
                        <li><span class=\"filePath\" translate=\"no\">Constraints/CharacterSolver/HIK2013Solver</span> – The connection between MotionBuilder and HumanIK has always been a point of weakness,\n\
                           and this was mostly addressed in the 2014 release. Also, the <span class=\"code\" translate=\"no\">Constraints/CharacterSolver/HIK45Solver</span> sample project is removed. \n\
                        </li>\n\
                        <li><span class=\"filePath\" translate=\"no\">Miscellaneous/material_template</span> – Added new code to demonstrate how to wrap ORSDK C++ Plugin to Python. \n\
                        </li>\n\
                        <li><span class=\"filePath\" translate=\"no\">Miscellaneous/model_template</span> – Added new code to demonstrate how to implement sub-item picking behavior for custom\n\
                           model using either selection buffer or color buffer approach with OpenGL. \n\
                        </li>\n\
                        <li><span class=\"filePath\" translate=\"no\">Tools/toolaudio and Tools/tool_template</span> – Modified existing code to demonstrate how to use <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"HdlFBPlugTemplate\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_hdl_f_b_plug_template.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">HdlFBPlugTemplate</a></span> to avoid crash because of dangling pointer in certain workflows. \n\
                        </li>\n\
                     </ul> \n\
                  </p> \n\
               </div> \n\
               <div class=\"section\"><a name=\"SECTION_8E76CDF5E5714A9FB934FA63496AC823\"></a> \n\
                  <h4><a name=\"GUID-738F2DF4-DA15-4889-BED3-20299C1874AD\"></a>New Python Sample Scripts\n\
                  </h4> \n\
                  <p><a name=\"GUID-B0D8574D-EDC1-4609-970C-EA332B449AD2\"></a>The following python sample scripts that are added in the <span class=\"filePath\" translate=\"no\">&lt;yourinstallationdirectory&gt;/bin/config/Scripts</span> folder demonstrates the new scripting functionality in MotionBuilder 2014. <a name=\"OL_DEF601332F2D49C2B65A671561394616\"></a><ol type=\"1\" start=\"1\">\n\
                        <li><span class=\"filePath\" translate=\"no\">BasicOperations/LockProperty.py</span> – Shows how to lock the properties using the SDK. \n\
                        </li>\n\
                        <li><span class=\"filePath\" translate=\"no\">BasicOperations/PlotClearProperties.py</span> – Shows plotting or clearing of locked properties. \n\
                        </li>\n\
                        <li><span class=\"filePath\" translate=\"no\">Samples/Character/CharacterMarkerSet.py</span> – Shows how to convert an actor solver into a character marker set. It includes creating\n\
                           skeleton from an actor, creating character, and characterizing a skeleton, creating\n\
                           character marker set, querying marker setup from an actor, and applying it on a character\n\
                           marker set, and changing solvers on the character. \n\
                        </li>\n\
                        <li><span class=\"filePath\" translate=\"no\">Samples/CharacterMarkerSetFromActor.py</span> – Shows how to create a character marker set from an actor. \n\
                        </li>\n\
                        <li><span class=\"filePath\" translate=\"no\">Samples/Geometry/VertexArrayManipulation.py</span> – Demonstrates the fast mesh creation by direct manipulation of vertex array data,\n\
                           and how to interact with the CGFX shader through Python scripting. \n\
                        </li>\n\
                        <li><span class=\"filePath\" translate=\"no\">Samples/HUD/BloopSlate.py</span> – Demonstrates the manipulation of the Bloop-Slate HUD element. \n\
                        </li>\n\
                        <li><span class=\"filePath\" translate=\"no\">Samples/HUD/Timeline.py</span> – Demonstrates the usage of the timeline HUD element. \n\
                        </li>\n\
                        <li><span class=\"filePath\" translate=\"no\">Samples/Properties/PropertyViewManager.py</span> – Shows how to create a new property view. \n\
                        </li>\n\
                        <li><span class=\"filePath\" translate=\"no\">Samples/Referencing/MBFileRefDemo.py</span> – Demonstrates file referencing API with the UI created by pySide. \n\
                        </li>\n\
                        <li><span class=\"filePath\" translate=\"no\">Samples/Story/FBStoryFolder.py</span> – Shows how to utilize the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBStoryFolder\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_story_folder.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_story_folder.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBStoryFolder</a></span> class to organize a story view. \n\
                        </li>\n\
                        <li><span class=\"filePath\" translate=\"no\">Samples/Story/ImageSequenceFrameRateChange.py</span> – Demonstrates the ability to change the frame rate of an image sequence object.\n\
                           \n\
                        </li>\n\
                        <li><span class=\"filePath\" translate=\"no\">Samples/Story/VideoClip.py</span> – Shows how to utilize the image sequence within a story video clip. \n\
                        </li>\n\
                        <li><span class=\"filePath\" translate=\"no\">Samples/Utilities/DebugMemoryLeak.py</span> – Demonstrates how to use the object creation/deletion logging and trace for detecting\n\
                           memory leak. \n\
                        </li>\n\
                        <li><span class=\"filePath\" translate=\"no\">Samples/Video/VideoInput.py</span> – Shows how to setup a cube with a live video input. \n\
                        </li>\n\
                        <li><span class=\"filePath\" translate=\"no\">Samples/Video/VideoMemory.py</span> – Demonstrates the usage of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBVideoMemory\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_video_memory.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_video_memory.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVideoMemory</a></span>. \n\
                        </li>\n\
                        <li><span class=\"filePath\" translate=\"no\">Samples/Video/VideoOutput.py</span> – Shows how to put video output online. \n\
                        </li>\n\
                        <li><span class=\"filePath\" translate=\"no\">UI/ToolNativeWidgetHolder.py</span> – Creates a tool that demonstrates how to embed native QT widgets created by PySide\n\
                           into MotionBuilder UI framework. \n\
                        </li>\n\
                        <li><span class=\"filePath\" translate=\"no\">UI/WebView.py</span> – Creates a tool with a <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBWebView\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_web_view.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBWebView</a></span> showing the Autodesk web page. \n\
                        </li>\n\
                        <li><span class=\"filePath\" translate=\"no\">OpenRealitySDK/Scripts/CustomMaterialMarker.py</span> – Demonstrates the usage of Python wrappers in the custom <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBMaterial\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_material.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_material.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMaterial</a></span>, <span class=\"code\" translate=\"no\">FBMarker</span>, and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBShader\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_shader.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_shader.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBShader</a></span> ORSDK C++ samples plug-ins. \n\
                        </li>\n\
                     </ol> \n\
                  </p> \n\
               </div> \n\
            </div> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";