var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-76FBC919-01B2-4DF5-9CAA-EC1FB43047E1\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>File Referencing System</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-76FBC919-01B2-4DF5-9CAA-EC1FB43047E1\"></a><div class=\"head\">\n\
            <h1>File Referencing System</h1>\n\
         </div>\n\
         <p><a name=\"GUID-56895566-5F4B-4870-B00F-74532AA08D52\"></a>You can manage the assets within production pipelines in a better way using the file\n\
            referencing system. This is particularly helpful when you have a project with a large\n\
            number of assets, which are revised occasionally, but are used in a number of scenes\n\
            or shots. In this case, you can use the referencing system to easily update multiple\n\
            assets. \n\
         </p>\n\
         <p><a name=\"GUID-B59AB085-08C3-4CCF-80DF-E4862714ABD7\"></a>The following terms are used in the documentation to explain the referencing system.\n\
            <a name=\"UL_13AD65604528482C936C395927D09874\"></a><ul>\n\
               <li><em class=\"strong\">Referenced Object</em> – A referenced object is a top level object that contains zero or more referenced\n\
                  items. \n\
               </li>\n\
               <li><em class=\"strong\">Referenced Item</em> – A referenced item is any node (in a hierarchy or alone) within a referenced object.\n\
                  \n\
               </li>\n\
            </ul> \n\
         </p><span class=\"noindex\">\n\
            <div class=\"topic-list\">\n\
               <h4 class=\"related\">Topics in this section</h4>\n\
               <ul class=\"jumplist\">\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-3E40210C-0BE5-4059-AB8C-87A8030286A3.htm\">Referencing an FBX File</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-9CAF4183-B1B1-4CCE-81F2-7D8D61E0CF87.htm\">Understanding the Referenced Objects and Referenced Items </a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-31143776-6E20-4A4E-B082-E3F2DDFFE841.htm\">Instancing a Referenced Object</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-B90256BC-DA6C-423F-9945-4F25FF2D2607.htm\">Getting Notified of Source File Changes</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-50E5CC54-3623-477D-BDCD-CD53F1CCF84A.htm\">Modifying the Items in a Referenced Object</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-9729D523-8231-4D43-A3EE-E9A427C9B19E.htm\">Keyframe Animation on Referenced Items</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-22252E01-F32A-4063-A78B-FDF8B8421297.htm\">Unloading and Reloading a Referenced Object</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-7C75DC85-DB08-422A-BE27-BE750B3D56B7.htm\">Restoring a Referenced Object</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-AC4F3560-D3FB-4943-892A-90B7BFC95861.htm\">Saving an FBX File with Referenced Objects</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-64F061B3-45ED-4745-9B26-804ED41CBC38.htm\">Merging the FBX files</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-E80B6143-0A1B-4AED-986B-F59B395DC2A3.htm\">Connections Between Referenced Items </a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-FBF062F7-6805-4609-987F-CCADA7BECCD9.htm\">Loading the Referenced Items</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-3FF302FD-FC19-41D5-A520-7563ABA47345.htm\">Deleting a Referenced Object</a></li>\n\
               </ul>\n\
            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";