var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-78118823-66EB-421B-9C37-6CB6D068B248\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Using the Kinect Plug-in</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-78118823-66EB-421B-9C37-6CB6D068B248\"></a><div class=\"head\">\n\
            <h1>Using the Kinect Plug-in</h1>\n\
         </div>\n\
         <p><a name=\"GUID-A14BFB18-6DA4-4CC6-BD62-196A51364F6A\"></a> For using the Kinect plug-in, you must install the Kinect for Windows SDK v1.8 or\n\
            Kinect for Windows Runtime v1.8 . You can download the Kinect for Windows SDK from\n\
            <a href=\"http://www.microsoft.com/en-us/kinectforwindowsdev/Downloads.aspx\" target=\"_blank\">http://www.microsoft.com/en-us/kinectforwindowsdev/Downloads.aspx</a>. The Kinect for Windows Runtime is available in the MotionBuilder installation package\n\
            inside the <span class=\"filePath\" translate=\"no\">3rdParty\\x86\\KinectRuntime</span> folder. Alternatively, you can download the runtime from <a href=\"http://www.microsoft.com/en-us/download/details.aspx?id=40277\" target=\"_blank\">http://www.microsoft.com/en-us/download/details.aspx?id=40277</a>. \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_CBD722507F1C49D8958DA0EF034EA284\"></a> \n\
            <h2><a name=\"GUID-6CBD29BA-1F97-4994-8559-3C7AC9EF6039\"></a> FBMocapJointsState\n\
            </h2> \n\
            <p><a name=\"GUID-BD0C2DC6-4149-457C-82CC-230C02CCEEBD\"></a>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBMocapJointsState\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_mocap_joints_state.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMocapJointsState</a></span> class is used for storing a frame of skeleton tracking data from the motion capture\n\
               device. It contains the tracking state and position of the whole skeleton, number\n\
               of joints set by the motion capture device, arrays for positions, tracking state of\n\
               each joint, and global orientation of each bone. The arrays are dynamically allocated\n\
               according to the number of joints in the motion capture device specification. The\n\
               tracking state indicates whether a joint is tracked or not, and whether the position\n\
               of the joint is inferred by the motion capture device SDK. The tracking ID of the\n\
               skeleton is not contained because the plug-in can manage multiple user tracking. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"int\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/code_8h.html#aa4332194bf83cd22038ee4511e4decea&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">int</a> mSkeletonJointsCount; //!&lt; Number of joints set by the motion capture device.\n\
double mFloorClipPlaneW;  //!&lt; Floor Clip Plane W <a href=\"javascript:void(0)\" data-symbol=\"value\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a3a0f45a8cd645a6ab8f2c793db266109&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">value</a> for camera reposition.\n\
FBSkeletonTrackingState mSkeletonTrackingState; //!&lt; State of the skeleton tracking.\n\
FBTVector mSkeletonPosition; //!&lt; Position of the skeleton.\n\
FBTVector* mSkeletonJointsPositions; //!&lt; Position of each joint.\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBMatrix\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_matrix.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMatrix</a>* mSkeletonJointsGlobalOrientations; //!&lt; <a href=\"javascript:void(0)\" data-symbol=\"Global\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a84df3f9175f02c4e11e66859646892f7&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Global</a> orientation of each bone.\n\
FBSkeletonJointTrackingState* mSkeletonJointTrackingState; //!&lt; State of the skeleton joint tracking.\n\
</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_4B27067BEC15446E9B5C0D35C6FBE9D6\"></a> \n\
            <h2><a name=\"GUID-6803DFD9-F1F7-408D-A0A0-3D3310B78A5B\"></a>FBCharacter::PassDeviceMocapData()\n\
            </h2> \n\
            <p><a name=\"GUID-7950B0D1-2E2F-4650-8069-5D9746A85786\"></a>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCharacter::PassDeviceMocapData()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_character.html#a8539f95ba26dc2b0425fbbfc0cc8641d&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacter::PassDeviceMocapData()</a></span> method is called by the motion capture device to pass the skeleton joints state data\n\
               to an internal character skeleton. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_788B248721A74C5AA1AEBBC07394D80A\"></a> \n\
            <h2><a name=\"GUID-A31E2195-8D7C-4531-8473-6E9D3533FEFD\"></a>FBCharacter::SetupDeviceMocap()\n\
            </h2> \n\
            <p><a name=\"GUID-D095FCD5-95AD-4F4C-92D7-A478AAA64805\"></a>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCharacter::SetupDeviceMocap()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_character.html#abbcb67047216137071507536ce71e1f3&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacter::SetupDeviceMocap()</a></span> method initializes a character with the motion capture device as the animation source.\n\
               Additionally, it sets the skeleton hierarchy used by the motion capture device. \n\
            </p> \n\
            <p><a name=\"GUID-08E38D67-25A7-48C5-8D8A-294F683E092E\"></a>This method defines the number and order of joints used by a motion capture device.\n\
               The number of joints and their order defines a skeleton hierarchy corresponding to\n\
               a specific device. For example, in Kinect, the number of joints are 20, and the first\n\
               joint in the joint order is the hip, second is the spine, and so on. You can define\n\
               any skeleton hierarchy corresponding to a motion capture device using this interface.\n\
               For example, in PrimeSense, the number of joints are 24, and the first joint in the\n\
               joint order is the head, second is the neck, and so on. Internally, a map is used\n\
               for recording the joint order. Through this mapping, the index to get the position\n\
               data from the position array is determined. \n\
            </p> \n\
            <p><a name=\"GUID-129B52DE-B1CD-41F0-8047-77C436D48D4C\"></a>The interface and internal implementation is not bound to Kinect only. It can support\n\
               different motion capture devices. You can optimize motion in any skeleton hierarchy\n\
               for any motion capture device because the internal character has the motion capture\n\
               device information. You can use the default general implementation to support a general\n\
               skeleton hierarchy. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_0E53F42D46364153A8E440AB39787253\"></a> \n\
            <h2><a name=\"GUID-91454C89-AA3A-46A1-9AC7-0462BFB14BEE\"></a>FBCharacter::SetMocapCalibrationState()\n\
            </h2> \n\
            <p><a name=\"GUID-DA246A84-1D66-495D-8CB4-FF2167A5B661\"></a>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCharacter::SetMocapCalibrationState()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_character.html#aa78849b5f47db279d1830ea81649bebb&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacter::SetMocapCalibrationState()</a></span> method sets the mocap calibration state. It is called when doing calibration for\n\
               T-Stance. State 0 means no calibration request, so setting to 0 resets the calibration\n\
               state. State 1 means processing a calibration request and performing detection. State\n\
               2 means calibration detected successfully. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_146602EB24B54246A3E453503508278E\"></a> \n\
            <h2><a name=\"GUID-BC323EC0-595D-4922-82ED-87283B2E5B33\"></a>FBCharacter::GetMocapCalibrationState()\n\
            </h2> \n\
            <p><a name=\"GUID-A7BC2694-EF7A-41FC-9E57-A7E9EB584D03\"></a>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCharacter::GetMocapCalibrationState()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_character.html#a6da756bd47f845140e54e4782bb73300&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacter::GetMocapCalibrationState()</a></span> gets the current calibration state. This method is called to see if the calibration\n\
               detection is successful. If the calibration detection is successful, some calibration\n\
               operations are performed by the plug-in. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_07FCE3BAAD92432B9637D72FCEC068EA\"></a> \n\
            <h2><a name=\"GUID-AD7D05D6-9739-4593-9235-FCFCE796CFA3\"></a>FBCharacter::SetSensorFloorOffset()\n\
            </h2> \n\
            <p><a name=\"GUID-E666F5FF-A2A5-46C1-8CE2-03739289F484\"></a>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCharacter::SetSensorFloorOffset()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_character.html#a2ee64bfc1bbadb98b7559c34646bac35&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacter::SetSensorFloorOffset()</a></span> method is called after a successful T-Stance calibration to set the height of the\n\
               sensor above the floor. This is used for moving the skeleton roughly to the ground.\n\
               \n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";