var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-7F758D4B-E9FD-42C0-980D-8E2C3FEDF7CE\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Flexible Pipeline</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-7F758D4B-E9FD-42C0-980D-8E2C3FEDF7CE\"></a><div class=\"head\">\n\
            <h1>Flexible Pipeline</h1>\n\
         </div>\n\
         <p><a name=\"GUID-0AB41F21-4447-4FBA-9F01-B5DAB02A5C98\"></a> The flexible mocap pipeline consists of the following steps: \n\
         </p><a name=\"UL_DE57360B5E8A44A3A1509F1D8E1BA9A7\"></a><ul>\n\
            <li>Extraction – Takes a set of markers as input and extracts a set of goals from them.\n\
               The input (set of markers) is usually imported from a motion capture system and it\n\
               represents the 3D position (without the rotation information) of the optical markers.\n\
               \n\
            </li>\n\
            <li>Goals – Controls a character’s rig. They are used for solving to the final skeleton\n\
               and to animate the actual character. \n\
            </li>\n\
         </ul>\n\
         <p><a name=\"GUID-D12C5813-9BF1-4695-BF99-8392BB99BF6E\"></a>You can access the input, intermediate, and output data through these steps. This\n\
            enhances the flexibility of the pipeline. The following figure shows the flexible\n\
            mocap pipeline. \n\
         </p><a name=\"FIG_E83ECEBE80EC489F907ABC1FEE85E174\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-5F376A8F-F6A3-4278-8EE6-42A21561CFFF-low.png\"></div>\n\
         <p><a name=\"GUID-78A9D6BF-B696-4054-A0A9-06804774A173\"></a>You can customize the flexible mocap pipeline at multiple insertion points. \n\
         </p>\n\
         <p><a name=\"GUID-51BBE485-1BA9-4F36-AFED-3FDA1DB629DC\"></a>You can modify the input markers for low-level corrections in the motion capture data.\n\
            For example, you can constrain markers in different ways to enforce a given configuration\n\
            or to correct artifacts such as, marker sliding. You can also perform complex operations\n\
            on markers such as, combining several markers into new ones. Additionally, the motion\n\
            capture hardware manufacturer\'s clean-up software can apply average or filtering schemes\n\
            in real-time instead of applying them offline. \n\
         </p>\n\
         <p><a name=\"GUID-2DE86BCD-D3B1-41C1-BA5D-BD23F6C98EDD\"></a>You can apply custom logic on the extracted goals. You can consider these goals as\n\
            temporary IK goals, which the next solving step uses as input. It is better to apply\n\
            correction in the high-level extracted goals than in the lower-level input markers\n\
            or output bones. You can perform corrections in the whole character structure easily\n\
            using the high-level goals than the low-level markers. You can use the default (relation)\n\
            constraints to add custom logic to the extraction. For example, you can constrain\n\
            the goals to not allow knee snapping. Additionally, you can use the story tool to\n\
            add animation on top of the extracted goals, which is very useful. For example, you\n\
            can use this to fix the mesh penetration issues. It is also possible to use custom\n\
            constraints on the goals for any type of correction such as, controlling the way rotation\n\
            is spread on each part of the spine. The constraints can either use the extracted\n\
            goals as an input and modify them, or override the value from the extraction step.\n\
            \n\
         </p>\n\
         <p><a name=\"GUID-FA90741C-BB27-4667-83F2-FC5110CEFFFF\"></a>You can also customize the solving from the goals to the bones. Usually, the solving\n\
            is performed using the HIK solver or MotionBuilder\'s internal solver, but you can\n\
            also use your own custom solver. As a post-processing step, you can modify or override\n\
            parts of a solve output such as, an arm in a complex rig situation. \n\
         </p>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";