var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-8513D910-DD67-4344-9CB5-0119ACEA5904\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Relation Constraints</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-8513D910-DD67-4344-9CB5-0119ACEA5904\"></a><div class=\"head\">\n\
            <h1>Relation Constraints</h1>\n\
         </div>\n\
         <p><a name=\"GUID-28697803-D162-471A-8409-D6624A4EB299\"></a>Relation constraints are made of multiple boxes (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBBox\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_box.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_box.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBBox</a></span>), which are connected to one another through operators. You can use relation constraints\n\
            to create relationships between the objects with greater control than other constraint\n\
            types. Following boxes are used for creating relation constraints: <a name=\"UL_2139BBE8DED24BFEA02BCCD0AB4E0188\"></a><ul>\n\
               <li> Senders – Any object with animatable properties (the animatable property must be\n\
                  set) can act as a sender. A sender transmits data to operators and receivers. \n\
               </li>\n\
               <li> Operators – An operator performs mathematical operations, comparisons, or conversions\n\
                  in a relation constraint. It is placed between a sender and receiver. Operators can\n\
                  receive and send data. You cannot connect two operators that output different results\n\
                  directly such as, vectors and numbers. To connect two operators that output different\n\
                  results, a converter box is inserted between the two operators. \n\
               </li>\n\
               <li> Receiver – Any object with animatable properties (the animatable property must be\n\
                  set) can act as a receiver. A receiver receives data that is transmitted by operators\n\
                  and senders. \n\
               </li>\n\
            </ul> \n\
         </p>\n\
         <p><a name=\"GUID-CF3F423F-A795-4A80-86A5-8C9968B7D08C\"></a> For information about how to use relation constraints in the UI, see the Relations\n\
            Constraints topic in the User\'s Guide. \n\
         </p>\n\
         <p><a name=\"GUID-41A0AC88-BF0C-4199-B16B-80C4B4EBEBF9\"></a>Download the <span class=\"filePath\" translate=\"no\">create_relationship_constraint.py</span> script from <a href=\"http://area.autodesk.com/downloads/scripts/motionbuilder-animation-scripts\" target=\"_blank\">http://area.autodesk.com/downloads/scripts/motionbuilder-animation-scripts</a>. Run the script in MotionBuilder and see how it creates a relation constraint to\n\
            drive a cube animation. <a name=\"FIG_DF3ADBAFA40E4AB98CD0240AD6A756E3\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-EFBE2756-CA4C-4309-8810-DDCDC944EA25-low.png\"></div> \n\
         </p>\n\
         <p><a name=\"GUID-59DEFDC1-4C30-4F71-A99F-8965B2EAE00D\"></a>Following are the points to keep in mind: <a name=\"UL_70A1B2FDC5064EEFABAA47A8973C4007\"></a><ul>\n\
               <li><span class=\"code\" translate=\"no\">lConstraintRelation = <a href=\"javascript:void(0)\" data-symbol=\"FBConstraintRelation\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_constraint_relation.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_constraint_relation.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBConstraintRelation</a>(\'AConstraintRelation\')</span> is used to create a relation constraint. \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\">lConstraintRelation.CreateFunctionBox(\'Sources\', \'Sine Ramp\')</span> is used to create a <span class=\"code\" translate=\"no\">sine ramp</span> type function box in a relation constraint. \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\"> lConstraintRelation.SetBoxPosition(lNumberToVectorBox, 400, 30)</span> sets the box\'s position in the relation constraint panel. \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\">FBConnect (lSineRampOut, lNumberToVectorIn)</span> connects the two animation nodes to make the first one drive the second one. \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\"> lConstraintRelation.Active = True</span> to set the constraint active. \n\
               </li>\n\
            </ul> \n\
         </p>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";