var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-899C83A3-1E30-40B2-8F39-5A9F0050D9CB\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Plotting Animation for the Basic Models in a Take</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-899C83A3-1E30-40B2-8F39-5A9F0050D9CB\"></a><div class=\"head\">\n\
            <h1>Plotting Animation for the Basic Models in a Take</h1>\n\
         </div>\n\
         <p><a name=\"GUID-52BC3C41-4D2B-4C3F-97D4-1FD3AEC0C574\"></a> Run the <span class=\"filePath\" translate=\"no\">plot_clear_properties.py</span> script as explained in the following section to understand how to plot animation\n\
            with different options such as, selected and unselected object, locked and unlocked\n\
            channel, and others. It is important to understand the usage of locks that do not\n\
            allow to plot on some channels. Running the script block by block makes it easier\n\
            to understand what is plotted for the different lock status. You can download the\n\
            <span class=\"filePath\" translate=\"no\">plot_clear_properties.py</span> script from <a href=\"http://area.autodesk.com/downloads/scripts/motionbuilder-animation-scripts\" target=\"_blank\">http://area.autodesk.com/downloads/scripts/motionbuilder-animation-scripts</a>. \n\
         </p>\n\
         <p><a name=\"GUID-A8E63FCD-35B1-4BCC-83FA-C7249B85EFB3\"></a> <a name=\"UL_D6F0DCC1AB3046D9AED9C1E45B6F5E9B\"></a><ul>\n\
               <li>Run Step#1 in the script to create a scene with a cube animation and a locked channel\n\
                  as shown in the following figure. The locked channel y is highlighted in red color\n\
                  in the left panel. It appears in gray color in the FCurve view (right panel). <a name=\"FIG_D19714D974CA4237854C1654E05D64AD\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-AE4EC08F-1995-4B8A-B359-361BEFE80394-low.png\"></div> \n\
               </li>\n\
               <li>Run Step#2 in the script to plot everything except the locked channel as shown in\n\
                  the following figure. <a name=\"FIG_FF66E96316C74164A6A698B4489AC226\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-1B23BC4C-B1F9-42DD-A8FF-985C620AE77C-low.png\"></div> \n\
               </li>\n\
               <li> Run Step#3 in the script to plot everything as shown in the following figure. <a name=\"FIG_62B4F16DC7824D66BD7505588A02870B\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-767DFE6C-A61A-4C11-B6C7-1B7042102C01-low.png\"></div> \n\
               </li>\n\
               <li> Run Step#4 in the script to clear all animation except the locked channel as shown\n\
                  in the following figure. <a name=\"FIG_77E9B74062474DA7902344989A9A2DDA\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-36AE7946-4771-4B46-B480-C92F8962E6B5-low.png\"></div> \n\
               </li>\n\
               <li> Run Step#5 in the script to clear all animation including the locked channel as shown\n\
                  in the following figure. <a name=\"FIG_8B3C47A20C644A6DA39C628D92588C73\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-1B9B6C92-C004-48C7-AEF6-A8EA4F0FA41F-low.png\"></div> \n\
               </li>\n\
            </ul> \n\
         </p>\n\
         <p><a name=\"GUID-5D554421-9C41-4303-9C04-39582114A781\"></a>Following are the points to keep in mind: <a name=\"UL_4D4DD9CB3359452F951029BCC8419F25\"></a><ul>\n\
               <li><span class=\"code\" translate=\"no\">lSystem.CurrentTake.PlotTakeOnSelected(lOptions)</span> – Plots the selected objects with options like plot locked properties by setting\n\
                  <span class=\"code\" translate=\"no\">lOptions.PlotLockedProperties</span> to True or False. \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\">lSystem.CurrentTake.ClearAllProperties(False)</span> – Clears animation for all properties in the current take except the locked ones.\n\
                  You can use <span class=\"code\" translate=\"no\">lSystem.CurrentTake.ClearAllProperties(False, True)</span> to clear all animation including the locked ones. \n\
               </li>\n\
            </ul> \n\
         </p>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";