var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-9094779E-7DD4-4D4F-9F71-1F04603938C9\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Updated Objects</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-9094779E-7DD4-4D4F-9F71-1F04603938C9\"></a><div class=\"head\">\n\
            <h1>Updated Objects</h1>\n\
         </div>\n\
         <p><a name=\"GUID-2AD70F28-BAD6-4F98-BC5C-8341BFCED4FE\"></a> Many objects are updated to meet the needs of the higher quality renderers and to\n\
            increase the pipeline interoperability with other DCC tools. \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_D6ED2D483ED74C9481DD5FBC277AE8A0\"></a> \n\
            <h2><a name=\"GUID-1D7909E0-F26A-45D1-9E9A-0C9BB946FD68\"></a>Lights\n\
            </h2> \n\
            <p><a name=\"GUID-8DAAC287-A826-4DAB-8B69-3D954976F49B\"></a>The light models now include more features such as, animatable barn door properties,\n\
               spot light type includes inner and outer cone settings to create penumbra, and area\n\
               light type (rectangle and sphere shapes) are available for soft shadow. The FBX file\n\
               format can transfer these properties seamlessly to Maya and other DCC tools. The new\n\
               light types and properties are shown in the following figure. \n\
            </p> <a name=\"FIG_1FE3F4867A504F5A911A2CEBA3B69E51\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-A3DAD4BF-C295-4BF4-A40E-A0B929B03FD3-low.png\"></div> \n\
            <p><a name=\"GUID-36AC2C7A-516B-4333-AA66-2B81BE3A2012\"></a>To enable the UI widgets setting for these new lighting properties, you need to turn\n\
               on the <span class=\"code\" translate=\"no\">FBRenderer::AdvancedLightingMode</span> upon custom renderer object creation, or permanently by using <span class=\"code\" translate=\"no\">Rendering</span><span class=\"MenuCascade\" id=\"GUID-CA212BB5-A064-461B-AF07-878A0E8B2EB9\"> <img src=\"images/ac.menuaro.gif\"> </span><span class=\"code\" translate=\"no\">AdvancedLightinUISetting</span> preference in the configuration file. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"bool\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#af6a258d8f3ee5206d682d799316314b1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">bool</a> ORCustomRendererCallback::FBCreate()\n\
{\n\
    …\n\
    //  Enabled advanced lighting <a href=\"javascript:void(0)\" data-symbol=\"mode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/dtoa_8h.html#a1ea5d0cb93f22f7d0fdf804bd68c3326&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">mode</a>, include UI widgets for various advanced lighting \n\
    //  setting, includes: \n\
    //   Light: area light, spot light inner/outer angles, barn doors, and others. \n\
    //   Model: PrimaryVisibility, CastsShadows, and ReceiveShadows.\n\
    FBSystem::TheOne().Renderer-&gt;AdvancedLightingMode = <a href=\"javascript:void(0)\" data-symbol=\"true\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#af6a258d8f3ee5206d682d799316314b1a08f175a5505a10b9ed657defeb050e4b&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">true</a>;</pre></div> \n\
            <p><a name=\"GUID-465C3503-87C4-4459-B853-E0E6009B8765\"></a> Currently, the default renderer does not use these new properties for viewport rendering.\n\
               \n\
            </p> \n\
            <p><a name=\"GUID-5CA9F04E-3619-47D5-ACA4-453C3695783C\"></a>You can subclass <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBLight\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_light.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_light.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLight</a></span> to provide custom rig display in the viewport and add additional properties. You\n\
               can use the FBX file format to store and retrieve the custom light types. It uses\n\
               a similar extension mechanism like the custom marker type. For example, see <span class=\"filePath\" translate=\"no\">&lt;yourinstallationfolder&gt;/OpenRealitySDK/samples/miscellaneous/marker_template</span>. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_1D7C9B8E99C64E289480C081F257118A\"></a> \n\
            <h2><a name=\"GUID-122677E0-1EE2-4CFB-A2F2-525EC1DA1996\"></a>Models\n\
            </h2> \n\
            <p><a name=\"GUID-6002A6CB-9F10-4DD9-9BD5-12EBB4A0B3EC\"></a>Three new properties are added to the models: <span class=\"MenuCascade\" id=\"GUID-EE78C95D-F68B-4EE4-999B-7C9B050B734F\">Primary Visibility</span>, <span class=\"MenuCascade\" id=\"GUID-88E7A3E6-A819-4CD3-8CE7-B30271ABE738\">Casts Shadows</span>, and <span class=\"MenuCascade\" id=\"GUID-C6BF16FB-E932-43F7-88BE-073F23DC390B\">Receive Shadows</span>. The custom renderer uses these properties to access the shadow setting for each\n\
               model and align with other DCC tools. The following figure shows these properties\n\
               for the Model object. \n\
            </p> <a name=\"FIG_244D36C05F73474DA4BDBBBF6C9C3DF8\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-A1E2135A-BF9E-412B-BDC6-4709659F1EA4-low.png\"></div> \n\
            <p><a name=\"GUID-F0693DE5-C805-4CEB-8503-32FD85869FB3\"></a>To view these new properties in the property editor, you need to turn on the <span class=\"code\" translate=\"no\">AdvancedLightingMode</span> (see the <span class=\"char_link\"><a href=\"#!/url=./files/GUID-9094779E-7DD4-4D4F-9F71-1F04603938C9.htm#SECTION_D6ED2D483ED74C9481DD5FBC277AE8A0\">Lights</a></span> section). You can also subclass <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a></span> to create a custom model type. For example, see <span class=\"filePath\" translate=\"no\">&lt;yourinstallationfolder&gt;/OpenRealitySDK/samples/miscellaneous/model_template</span>. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_18704B504CC14600BEA49419AFEBA9C3\"></a> \n\
            <h2><a name=\"GUID-D9A4AA2D-AE2A-4194-AB50-EF0FEF57B2BB\"></a>Geometry\n\
            </h2> \n\
            <p><a name=\"GUID-8D7A2707-0E61-48DE-8881-2CD4699E2CBD\"></a>MotionBuilder supports the mesh, nurbs, and patch type surfaces (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_mesh.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_mesh.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMesh</a></span>, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBNurbs\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_nurbs.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_nurbs.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBNurbs</a></span>, and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPatch\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_patch.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_patch.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPatch</a></span>). For rendering performance and implementation simplicity, all the surface types\n\
               are tessellated into a triangle list. Depending on the material, texture mapping relationships,\n\
               and other vertex attributes, some vertexes might be duplicated. The resulting vertex\n\
               arrays take part in the skinning (if necessary) and rendering procedures. \n\
            </p> \n\
            <p><a name=\"GUID-1B89D0F1-7169-4523-A056-EE3F56F9D3D5\"></a> You can access <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel::Geometry\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model.html#a38ee3b8f917717f445fefa8bb5ff5327&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel::Geometry</a></span> for the original geometry, <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel::TessellatedMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model.html#ac56ab7877c9967c4e4d5e6cf70b5218d&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel::TessellatedMesh</a></span> for the tessellated mesh, and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel::ModelVertexData\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model.html#a9b57864caadc6b8a1bf3fa7755474d34&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel::ModelVertexData</a></span> for the final rendering ready geometry. \n\
            </p> \n\
            <p><a name=\"GUID-F68527F4-E5BA-4202-9DDC-E30B3EA339FC\"></a>You can use a set of new API functions for fast mesh creation and editing by directly\n\
               manipulating the vertex (position, normal, tangent, binormal, and UV) and polygon\n\
               index (material mapping) arrays. Similar APIs exist both in the ORSDK and Python layers.\n\
               For example, see <span class=\"filePath\" translate=\"no\">&lt;yourinstallationfolder&gt;/bin/config/Scripts/Samples/Geometry/VertexArrayManipulation.py</span>. \n\
            </p> \n\
            <p><a name=\"GUID-6339177A-6D3E-4A73-94CC-4DBACE7356D0\"></a>It is a best practice to combine the static background entities into a single model\n\
               to reduce runtime overhead and save memory. Refer to the following sections for more\n\
               information on how you can use the APIs to implement this optimization procedure in\n\
               your workflow and pipeline. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_439A319D24FF4B078422ED5CE66F7FD3\"></a> \n\
            <h2><a name=\"GUID-BFF8E4CF-402E-45F1-B2E5-28A71E5635EB\"></a> Instancing\n\
            </h2> \n\
            <p><a name=\"GUID-307A1673-01D8-413A-9F58-7B3C742BEA7E\"></a> MotionBuilder supports geometry instancing that can save memory and IO time significantly.\n\
               In the viewport, simply select a model, copy, and then paste it. By performing this\n\
               action, you are actually creating a new model instance that shares the same geometry\n\
               instancing with the source model. \n\
            </p> \n\
            <p><a name=\"GUID-6DC83803-E9F5-4568-8854-1695559477EF\"></a>It is easy to instance geometry by using the SDK. For example, see <span class=\"filePath\" translate=\"no\">&lt;yourinstallationfolder&gt;/bin/config/Scripts/Samples/Geometry/GeometryInstancing.py</span>. \n\
            </p> \n\
            <div><a name=\"GUID-9964F389-EF52-4321-B890-CAA4296F4F11\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>The geometry instancing does not work with deformable models properly. This is a known\n\
                  limitation. \n\
               </div>\n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_8DC180599F0A47788151840011D243C9\"></a> \n\
            <h2><a name=\"GUID-9690F3A2-005E-463C-A424-07A195F08685\"></a>Deformation\n\
            </h2> \n\
            <p><a name=\"GUID-E99E66BF-0BB1-47CE-9E8E-A3C5A0C9292E\"></a>MotionBuilder supports different deformation techniques such as, skinning, blendshape,\n\
               and point cache. The deformation evaluation tasks are either executed in the background\n\
               threads of the CPU cores concurrently, or at the beginning of the rendering pipeline\n\
               using a powerful GPU (for skinning and blendshape types). To enable the GPU deformation,\n\
               you need a CUDA™ enabled video card installed. You can use the configurable shortcut\n\
               (press <em class=\"strong\">Ctrl</em>+<em class=\"strong\">Shift</em>+<em class=\"strong\">T</em>) or preference (<span class=\"code\" translate=\"no\">Display</span><span class=\"MenuCascade\" id=\"GUID-4A3A8317-33CB-4E06-B993-825640C342BB\"> <img src=\"images/ac.menuaro.gif\"> </span> <span class=\"code\" translate=\"no\">UseGPUSkinDeform</span>) to toggle globally. Depending on the hardware used for deployment, the overall evaluation\n\
               and rendering performance for the same scene might vary. \n\
            </p> \n\
            <p><a name=\"GUID-3C2D4E4F-1F61-4DC5-8C0D-8BB0E1B9E2CD\"></a>The following Python script shows how to create multiple cluster skinning meshes.\n\
               \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">from pyfbsdk import *\n\
\n\
def CreateDeformQuad():\n\
    lModel = <a href=\"javascript:void(0)\" data-symbol=\"FBModelCube\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_cube.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelCube</a>(\"myMesh\");\n\
    # Create a mesh and replace the mesh on the <a href=\"javascript:void(0)\" data-symbol=\"FBModelCube\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_cube.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelCube</a>\n\
    lGeom = <a href=\"javascript:void(0)\" data-symbol=\"FBMesh\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_mesh.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMesh</a>(\"myMesh\")\n\
    # use GeometryBegin()/GeometryEnd() to enclose geometry editing code.\n\
    lGeom.GeometryBegin()\n\
    lModel.Geometry = lGeom\n\
\n\
    lGeom.VertexInit(0, False);\n\
    lV1 = lGeom.VertexAdd(-10.0, -10.0, -10.0)\n\
    lV2 = lGeom.VertexAdd(-10.0, -10.0, 10.0)\n\
    lV3 = lGeom.VertexAdd(10.0, -10.0, 10.0)\n\
\n\
    lGeom.PolygonBegin(0)\n\
    lGeom.PolygonVertexAdd(lV1);\n\
    lGeom.PolygonVertexAdd(lV2);\n\
    lGeom.PolygonVertexAdd(lV3);\n\
    lGeom.PolygonEnd()\n\
\n\
    lGeom.GeometryEnd()\n\
\n\
    lBone = <a href=\"javascript:void(0)\" data-symbol=\"FBModelCube\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_cube.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelCube</a>(\"myBone\")\n\
    skinCluster = <a href=\"javascript:void(0)\" data-symbol=\"FBCluster\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_cluster.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCluster</a>(lModel)\n\
    # use ClusterBegin()/ClusterEnd() to enclose weigh editing code.\n\
    skinCluster.ClusterBegin(0) \n\
    skinCluster.VertexAdd(lV1, 1.0)\n\
    skinCluster.VertexAdd(lV2, 1.0)\n\
    skinCluster.VertexAdd(lV3, 1.0)\n\
    skinCluster.LinkSetModel(lBone)\n\
    skinCluster.ClusterEnd()\n\
\n\
    lModel.Show = True\n\
    lBone.Show = True\n\
\n\
for <a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a> in range(0, 3):\n\
    CreateDeformQuad()</pre></div> \n\
            <p><a name=\"GUID-CF1FFDF2-020D-414E-9344-D080F18D6C8F\"></a>For creating blendshape deformation, see <span class=\"filePath\" translate=\"no\">&lt;yourinstallationfolder&gt;/bin/config/Scripts/Samples/Geometry/ShapeCreation.py</span>. \n\
            </p> \n\
            <p><a name=\"GUID-F007415E-FDDD-4F96-A6D3-7241768416BE\"></a>You can also extend the custom constraint deformer if a different deformation method\n\
               is required. For implementation details, see the sample in <span class=\"filePath\" translate=\"no\">&lt;yourinstallationfolder&gt;/OpenRealitySDK/samples/constraints/constraintdeformer</span>. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_CC68FDA1E04E4614962A0930CD4C1C7F\"></a> \n\
            <h2><a name=\"GUID-375ABAF9-59D0-4DB0-8129-4B58E03ED680\"></a>Vertex Buffer Object\n\
            </h2> \n\
            <p><a name=\"GUID-EE985CB7-6A92-463D-9167-3E9E092FC303\"></a>You need to use an instance of the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelVertexData\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_vertex_data.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_vertex_data.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelVertexData</a></span> class through the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel::ModelVertexData\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model.html#a9b57864caadc6b8a1bf3fa7755474d34&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel::ModelVertexData</a></span> property to access the rendering ready geometry data in the OpenGL vertex buffer\n\
               object (VBO) format. \n\
            </p> \n\
            <p><a name=\"GUID-6C39591D-BC36-450E-BB64-4E6E9324EEC7\"></a>A single geometry might have multiple regions and each region can be mapped with different\n\
               material. Each region can have several patches and each patch might have different\n\
               primitive types such as, points, lines, line strip, triangle list, triangle strip,\n\
               and others. See <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBGeometryPrimitiveType\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a9f4baafff962531b7bb8f42df9fe97e7&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBGeometryPrimitiveType</a></span> for the complete primitive list. \n\
            </p> \n\
            <p><a name=\"GUID-98EBCA3F-FD6C-4F63-9D86-8BA3215CBF0E\"></a>MotionBuilder wraps some common OpenGL drawing commands inside the SDK functions to\n\
               facilitate quick prototyping. It is quite easy to use as illustrated in the following\n\
               sample. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelVertexData\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_vertex_data.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelVertexData</a>* lModelVertexData = lModel-&gt;ModelVertexData;\n\
\n\
const <a href=\"javascript:void(0)\" data-symbol=\"int\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/code_8h.html#aa4332194bf83cd22038ee4511e4decea&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">int</a> lSubRegionCount = lModelVertexData-&gt;GetSubRegionCount();\n\
lModelVertexData-&gt;EnableOGLVertexData();  //Bind Vertex Array or Vertex Buffer Object.\n\
\n\
for(<a href=\"javascript:void(0)\" data-symbol=\"int\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/code_8h.html#aa4332194bf83cd22038ee4511e4decea&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">int</a> lSubRegionIdx = 0; lSubRegionIdx &lt; lSubRegionCount; ++lSubRegionIdx)\n\
{\n\
    <a href=\"javascript:void(0)\" data-symbol=\"FBMaterial\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_material.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMaterial</a>* lMaterial = lModel-&gt;Materials[lSubRegionIdx];\n\
    lMaterial-&gt;OGLInit();\n\
    // Draw all the sub patches inside this sub region.\n\
    lModelVertexData-&gt;DrawSubRegion(lSubRegionIdx); \n\
}\n\
\n\
lModelVertexData-&gt;DisableOGLVertexData(); //Unbind Vertex Array or Vertex Buffer Object.</pre></div> \n\
            <p><a name=\"GUID-ACFF9F84-85A4-48A1-B91C-CE752B5B3EAF\"></a>Generally, these vertex buffer arrays are accessible in the CPU main memory. MotionBuilder\n\
               also takes care of the vertex buffer object when uploading to the GPU device for rendering\n\
               (if using the CPU deformation mode). In the GPU deformation mode, to access certain\n\
               model’s deformation result in the CPU main memory, you need to call the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelVertexData::VertexArrayMappingRequest()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_vertex_data.html#a815841dbe899c6ba372cb946551b8177&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelVertexData::VertexArrayMappingRequest()</a></span> function beforehand. Also, it is common to combine certain model’s vertex array data\n\
               into a single VBO for better performance, and thus they only differ in the vertex\n\
               array offset. For more information, see <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelVertexData::GetVertexArrayVBOId()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_vertex_data.html#acf5901017565024581d42026a47035d3&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelVertexData::GetVertexArrayVBOId()</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelVertexData::GetVertexArrayVBOOffset()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_vertex_data.html#accce19506e8af994e1b43d6ef3c23937&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelVertexData::GetVertexArrayVBOOffset()</a></span>. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_9F806FC03D0F46938E07987404AB03F3\"></a> \n\
            <h2><a name=\"GUID-9009C0C3-C961-4469-BA26-ED34C86EBEA3\"></a>Displayable Entities\n\
            </h2> \n\
            <p><a name=\"GUID-7D03C727-04C7-4454-A87A-E3941937AABC\"></a>The following determine whether the models are displayed in the viewport: <a name=\"UL_1108832BEF814A01B6104BFF6B6852D4\"></a><ul>\n\
                  <li>The model’s <span class=\"MenuCascade\" id=\"GUID-BFC44A4C-3499-4EEA-8051-00E1A820A831\">Show</span> property is off. \n\
                  </li>\n\
                  <li>The animatable <span class=\"MenuCascade\" id=\"GUID-A292D928-D18A-45E9-AC28-FB8436DBCFB9\">Visibility</span> property is off. \n\
                  </li>\n\
                  <li>Any node’s <span class=\"MenuCascade\" id=\"GUID-083755CC-42F9-478B-8882-4BFB1990FFAA\">Visibility</span> in the upper level parent/child hierarchy is off, and all the <span class=\"MenuCascade\" id=\"GUID-201C6CB7-4730-4731-92D0-6598DE79D6B0\">Visibility Inheritance</span> properties in between the hierarchy are on. <a name=\"FIG_880258CD5EFE49EEBB7231018A6AC339\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-7E9E6B61-C7C7-4141-9C53-2E1D0663A250-low.png\"></div> \n\
                  </li>\n\
                  <li>Owner group\'s <span class=\"MenuCascade\" id=\"GUID-8AF84A13-59A0-4185-BC91-FDB9338337B4\">Show</span> property and owner set’s <span class=\"MenuCascade\" id=\"GUID-92A3D989-3B1B-4722-A424-A1B538290370\">Visibility</span> value. <a name=\"FIG_052F6B3FBFEA4E1AAA002B42061386D1\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-2843107B-3B12-45A2-B395-F04275E558D6-low.png\"></div> \n\
                  </li>\n\
               </ul> \n\
            </p> \n\
            <p><a name=\"GUID-A13D8F39-2866-47CA-A95B-F09640CF870C\"></a>You can use the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel::IsVisible()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model.html#afaea92375b001a77f7809727221e3c52&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel::IsVisible()</a></span> function to get the visibility information at the current frame without handling\n\
               this visibility determination logic. \n\
            </p> \n\
            <p><a name=\"GUID-538AACD2-4301-460F-AE6C-A31A9A952399\"></a>All of the displayable entities are not rendered in the viewport as in the following\n\
               cases: <a name=\"UL_9242B3B6CDD0416D94A907D3466FE429\"></a><ul>\n\
                  <li>Locators are not rendered in the <span class=\"MenuCascade\" id=\"GUID-E382AEC6-7799-41B3-88D8-45880FA825DC\">Model Only</span> display mode. \n\
                  </li>\n\
                  <li>Models outside of the current camera’s frustum. </li>\n\
               </ul> \n\
            </p> \n\
            <p><a name=\"GUID-4A1D0583-50EF-4844-BAA1-601044E8FC4A\"></a>The following set of functions and properties in the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBRenderer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_renderer.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBRenderer</a></span> class are useful for determining the displayable models and lights in a scene: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\"><a href=\"javascript:void(0)\" data-symbol=\"FBPropertyInt\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_property_int.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPropertyInt</a> DisplayableGeometryCount;\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a>* GetDisplayableGeometry(<a href=\"javascript:void(0)\" data-symbol=\"int\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/code_8h.html#aa4332194bf83cd22038ee4511e4decea&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">int</a> pIndex);\n\
\n\
const <a href=\"javascript:void(0)\" data-symbol=\"FBModelList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_list.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelList</a>&amp; GetDisplayableGeometryInCameraFrustum(<a href=\"javascript:void(0)\" data-symbol=\"FBModelList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_list.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelList</a>*, <a href=\"javascript:void(0)\" data-symbol=\"FBCamera\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_camera.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCamera</a>*);\n\
<a href=\"javascript:void(0)\" data-symbol=\"bool\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#af6a258d8f3ee5206d682d799316314b1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">bool</a> IsModelInsideCameraFrustum(<a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a>* pGeometry, <a href=\"javascript:void(0)\" data-symbol=\"FBCamera\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_camera.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCamera</a>* pCamera = <a href=\"javascript:void(0)\" data-symbol=\"NULL\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/kaydara_8h.html#a070d2ce7b6bb7e5c05602aa8c308d0c4&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">NULL</a>);\n\
\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBPropertyInt\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_property_int.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPropertyInt</a> DisplayableLightCount;\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBLight\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_light.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLight</a>* GetDisplayableLight(<a href=\"javascript:void(0)\" data-symbol=\"int\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/code_8h.html#aa4332194bf83cd22038ee4511e4decea&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">int</a> pIndex);</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_7105E0F229C749268661DDE0D32E1556\"></a> \n\
            <h2><a name=\"GUID-2DC7E258-DAEA-4BF9-8ED8-6880F2685BE1\"></a>Frame Skip Optimization\n\
            </h2> \n\
            <p><a name=\"GUID-D0244E6D-6761-4859-BDFA-B2CC9451A98D\"></a>Dense geometry rendering and deformation are demanding tasks that affect the performance.\n\
               A visibility based optimization is implemented in MotionBuilder to resolve this performance\n\
               issue. If a deformable model’s roughly estimated bound box is not inside any display\n\
               volume such as, the current camera’s view frustum, the light’s shadow volume or reflection\n\
               view frustum, and if it does not contribute to the final viewport image for several\n\
               frames, then the deformation tasks are avoided for a while until the time when the\n\
               model is required for rendering. \n\
            </p> \n\
            <p><a name=\"GUID-A8FB216C-2E65-4DB8-8416-768C783D18AB\"></a>Sometimes even a node\'s transformation need not be evaluated if the <span class=\"MenuCascade\" id=\"GUID-84B2DADE-D609-4951-9FAD-22996F54BF59\">Show</span> and <span class=\"MenuCascade\" id=\"GUID-1E94F0BF-9A01-4F95-8C93-72A748DB9FD9\">Visibility</span> properties are off, and there are no other dependant nodes (either through parent/child\n\
               hierarchy or constraint relationship) whose transformation needs to be evaluated.\n\
               \n\
            </p> \n\
            <p><a name=\"GUID-09565391-0F66-45B1-B947-75EBB98B7293\"></a>While this optimization works well in most cases, sometimes you might encounter an\n\
               unexpected behavior. \n\
            </p> \n\
            <p><a name=\"GUID-2E9E807D-5625-4FCB-95B1-2E943FA321BA\"></a>The optimization can be toggled on and off at different levels and aspects in the\n\
               following ways: \n\
            </p> <a name=\"UL_B0D7A1D593CA479EAF3BD0103CFBFFA9\"></a><ul>\n\
               <li>Use the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBEvaluateManager::FrameSkipOptimization\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_evaluate_manager.html#a90efed7b4ddefe5cc370e1cc2c0ed05f&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBEvaluateManager::FrameSkipOptimization</a></span> property to toggle frame skip optimization globally. \n\
               </li>\n\
               <li>Use the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel::ForceAlwaysEvaluate()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model.html#adff80bda83c46b640084bea38cc6cfed&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel::ForceAlwaysEvaluate()</a></span> function to always evaluate a model or stop skipping. \n\
               </li>\n\
               <li>The shortcut (<em class=\"strong\">Ctrl</em>+<em class=\"strong\">Shift</em>+<em class=\"strong\">P</em>) can toggle the frustum culling globally. You can also use the <span class=\"code\" translate=\"no\">Display</span> <span class=\"MenuCascade\" id=\"GUID-9CD39844-8757-4BF8-900E-2C6846CB14EC\"> <img src=\"images/ac.menuaro.gif\"> </span> <span class=\"code\" translate=\"no\">EarlyFrustumCulling</span> preference. \n\
               </li>\n\
               <li>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel::NoFrustumCullingRequire()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model.html#a0ac3df9031ad62e737484bc0bc35709b&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel::NoFrustumCullingRequire()</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel::NoFrustumCullingRelease()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model.html#ad3bb913bd9f77aaa044e1e50c5747d62&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel::NoFrustumCullingRelease()</a></span> functions are used for controlling the frustum culling behavior for each model. \n\
               </li>\n\
            </ul> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_EEA4872D789743B185CD7ECAA941D8C1\"></a> \n\
            <h2><a name=\"GUID-37334175-0D70-415C-AC95-7B4E188AF460\"></a>Material\n\
            </h2> \n\
            <p><a name=\"GUID-162553F3-E158-4929-9685-CF66460D5D96\"></a>MotionBuilder provides the Phong type material only. You can use this material to\n\
               set up the Emissive, Ambient, Diffuse, Specularity, and Shiness properties. Other\n\
               properties (includes Transparency, Reflectivity, Displacement, Bump Map, and Normal\n\
               Map) are also available if the <span class=\"code\" translate=\"no\">FBRenderer::AdvancedMaterialMode</span> property is on. \n\
            </p> \n\
            <p><a name=\"GUID-1B09D17F-C4A9-4392-AF93-534CB369EA36\"></a> Most of the material properties are animatable color vectors, and you can also connect\n\
               texture objects (<span class=\"code\" translate=\"no\">FBTextrue</span> type) to each material channel for mapping with the default UV set. For more information,\n\
               see the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBMaterial\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_material.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_material.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMaterial</a></span> class interface. A single material object can be shared by multiple models, and a\n\
               single model can be mapped by multiple materials (if the underling geometry has multiple\n\
               material regions). \n\
            </p> \n\
            <p><a name=\"GUID-A3090785-6903-4F81-A726-4E79B50242BF\"></a>The following figure shows the Material Settings pane. You can connect many properties\n\
               in this pane to the texture objects. \n\
            </p> <a name=\"FIG_4295696E44D3415F9238A5AF6FF781F9\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-51046245-3F24-445A-ADC7-0986B023CAA2-low.png\"></div> \n\
            <p><a name=\"GUID-BD4D5EF5-EF59-462C-9038-EF9DCCAEED76\"></a>As shown in the above figure, you can drag the material icon from the <span class=\"MenuCascade\" id=\"GUID-2C7078CD-E83B-41F3-A7A0-B6D0E553E5DD\">Asset Browser <img src=\"images/ac.menuaro.gif\"> Templates <img src=\"images/ac.menuaro.gif\"> Shading Elements</span>, and drop it on a model in the viewport. MotionBuilder automatically creates a new\n\
               instance of the material and connects it to the model (or replaces any existing material).\n\
               The sample Python script in <span class=\"filePath\" translate=\"no\">&lt;yourinstallationfolder&gt;/bin/config/Scripts/Samples/MaterialAndTexture/MaterialAndTexture.py</span> demonstrates how to stich the model, material, and texture together. \n\
            </p> \n\
            <p><a name=\"GUID-D4E1BEA0-B27D-46F0-A5E5-6271024ED0F1\"></a>You might want to use custom materials with additional properties flowing through\n\
               the data pipeline. This can be achieved by subclassing <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBMaterial\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_material.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_material.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMaterial</a></span>. For example, see the sample in <span class=\"filePath\" translate=\"no\">&lt;yourinstallationfolder&gt;/OpenRealitySDK/samples/miscellaneous/material_template</span>. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_09D3B062C7274F93A5E456822217A2E6\"></a> \n\
            <h2><a name=\"GUID-7421A6E7-8B5D-4C72-B781-507C345C1076\"></a>Textures and Video\n\
            </h2> \n\
            <p><a name=\"GUID-8959311A-F254-4FA5-BEF9-29767149F406\"></a>MotionBuilder can load a range of image formats (including BMP, DDS, JPG, PNG, SGI,\n\
               TAG, TIF, and others). You can also import some common video codecs through QuickTime\n\
               framework, but make sure that the latest version of the Apple QuickTime is installed.\n\
               Currently, MotionBuilder does not support video in Linux, but you can use the image\n\
               sequence instead. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_D1303E2B07B345AB8A6A144418077DC2\"></a> \n\
            <h2><a name=\"GUID-AAB13576-6E44-49A2-896B-99726ED61012\"></a>Enhanced DirectDraw Surface (DDS) Support\n\
            </h2> \n\
            <p><a name=\"GUID-5F17D87E-9AA3-41CE-97B8-CD55CBCF7065\"></a>The DDS compressed texture format support is updated. You can load ATI1, ATI2, BC4,\n\
               and BC5 texture files from the disk. It is a preferable method because the fast texture\n\
               uploading and optimal GPU memory consumption provides a high rendering quality. Unlike\n\
               the other image formats, MotionBuilder does not decompress the DDS texture into the\n\
               CPU main memory. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_7E3A7A96C22740A4BDD27A2E3D1FE6CE\"></a> \n\
            <h2><a name=\"GUID-26B89DC9-0F6E-4342-92C6-F4ED514065A6\"></a>Uniform Resource Identifier (URI) Only Texture \n\
            </h2> \n\
            <p><a name=\"GUID-B9B10BD0-41F9-4ED7-98C2-301693C85C5C\"></a>You might want to load other image types directly in plug-ins using the standard UIs\n\
               (such as the File Open dialog) to provide a consistent end user interaction. To achieve\n\
               this, you can register the external image file extension (suffix) in the codec manager\n\
               (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBVideoCodecManager\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_video_codec_manager.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_video_codec_manager.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVideoCodecManager</a></span>), which allows the extension to appear in the file dialog’s filter section, and ensure\n\
               that the file path of the external image exists in the FBX file. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">/** Register the external video <a href=\"javascript:void(0)\" data-symbol=\"format\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a93c2e0b236610d80553359a9bb3fdb44&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">format</a> suffix. Only alphabets and numbers are allowed in the suffix, \n\
*  and it cannot be empty or an existing suffix. This allows the suffix to  \n\
*  appear in the filters of the file dialog when importing video, also allows to create a texture/video\n\
*  <a href=\"javascript:void(0)\" data-symbol=\"object\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#a904fdf014f8cdbefe8320ca2bfd6daf6&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">object</a> with a path containing this suffix using the SDK. However it is the custom SDK plug-in \n\
*  developer\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> responsibility to load the file into memory.\n\
*\n\
*  \\remarks After registering an external video <a href=\"javascript:void(0)\" data-symbol=\"format\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a93c2e0b236610d80553359a9bb3fdb44&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">format</a>, and saving a scene with this kind of video. \n\
*           when MotionBuilder starts next time and before loading the scene back,\n\
*  \\remarks it is necessary to call RegisterExternalVideoFormat to register this kind of video <a href=\"javascript:void(0)\" data-symbol=\"format\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a93c2e0b236610d80553359a9bb3fdb44&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">format</a> \n\
*           again, otherwise this kind of video will not be loaded.\n\
*  \\param   pFormatSuffix	Suffix/File extension of the external video file <a href=\"javascript:void(0)\" data-symbol=\"format\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a93c2e0b236610d80553359a9bb3fdb44&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">format</a>\n\
*  \\return  <a href=\"javascript:void(0)\" data-symbol=\"true\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#af6a258d8f3ee5206d682d799316314b1a08f175a5505a10b9ed657defeb050e4b&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">true</a> if register is successful\n\
*/\n\
static <a href=\"javascript:void(0)\" data-symbol=\"bool\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#af6a258d8f3ee5206d682d799316314b1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">bool</a> RegisterExternalVideoFormat( const char* pFormatSuffix );</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_372C13FED6ED41C48C8781F6670DF341\"></a> \n\
            <h2><a name=\"GUID-EE1FBC03-1C24-406F-A240-D1DAFBC5C14A\"></a>Layered Texture\n\
            </h2> \n\
            <p><a name=\"GUID-90EA822B-6505-43EB-A9D2-79384B0A0CB7\"></a>Layered texture provides a simple and efficient way for real-time blending between\n\
               the multiple texture layers. Each layer can have animatable properties, and it can\n\
               refer to a static image, video sequence, or even live stream input. The following\n\
               figure shows the Layer Settings pane. \n\
            </p> <a name=\"FIG_85DDD92889364C36A422D76FA67A7716\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-DC4FE1B7-ED31-4BFD-A703-D10548009A83-low.png\"></div> \n\
            <p><a name=\"GUID-3A08C1D6-DA64-40A5-920A-6212C5E09EBB\"></a>By default, MotionBuilder supports Translucent, Additive, Modulate, and Modulate2\n\
               blending modes, but you can subclass the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBLayeredTexture\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_layered_texture.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_layered_texture.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBLayeredTexture</a></span> class and extend its functionality easily. For example, see the sample in <span class=\"filePath\" translate=\"no\">&lt;yourinstallationfolder&gt;/OpenRealitySDK/samples/miscellaneous/texture_template</span>. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_CDE4540FF4A54F7AB4BB3E2CD3C02B4F\"></a> \n\
            <h2><a name=\"GUID-57B0C9CD-F5F5-42CD-A6D0-44AC041F2A71\"></a>Procedure Texture\n\
            </h2> \n\
            <p><a name=\"GUID-7C7BC55D-BFF5-45D0-9AEC-743D159FDBEC\"></a>You can also use the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBVideoMemory\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_video_memory.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_video_memory.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBVideoMemory</a></span> class to provide arbitrary texture content such as, the static image file, video\n\
               sequence, or dynamic procedure content. First, you need to provide a valid OpenGL\n\
               texture buffer object’s ID with its data properly updated, and its dimension information.\n\
               Next, set this video object as the source of the texture and it joins the rest of\n\
               the regular MotionBuilder rendering workflow seamlessly. For example, see <span class=\"filePath\" translate=\"no\">&lt;yourinstallationfolder&gt;/bin/config/Scripts/Scripts/Samples/Video/VideoMemory.py</span>. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_99831FD88A8C4B2CA5B3EFE239828027\"></a> \n\
            <h2><a name=\"GUID-7725CA2A-6826-467D-8C50-DFEE6F3323BD\"></a>Heads Up Display (HUD)\n\
            </h2> \n\
            <p><a name=\"GUID-F0BB5267-57EB-45D1-B6F6-E565795FF78A\"></a>The HUD system is updated for a flexible layout, enhanced display quality through\n\
               Scaleform technique, easier information retrieving (for example, you can reference\n\
               any properties and get its current value displayed in the viewport), and for some\n\
               common built-in element types (for example, Bloop Slate, Record Light, Timeline, and\n\
               others). Please refer to the user\'s guide for more information. \n\
            </p> \n\
            <p><a name=\"GUID-58D7CC37-9090-43A8-9214-D6A912CF433B\"></a> You can also extend the default provision by subclassing the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBHUDElement\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_h_u_d_element.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_h_u_d_element.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBHUDElement</a></span> class. For example, see the sample in <span class=\"filePath\" translate=\"no\">&lt;yourinstallationfolder&gt;/OpenRealitySDK/samples/miscellaneous/hudelement_template</span>. This sample HUD element can render the currently selected model in the viewport.\n\
               \n\
            </p> \n\
            <p><a name=\"GUID-E372FBCA-B937-4B14-A816-9C9FC2EF6451\"></a>In the following figure, the sample custom HUD element shows a currently selected\n\
               model in the viewport. \n\
            </p> <a name=\"FIG_BBFE6CCA2BAE4BB2A7136947046A7571\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-349CB97A-E12A-4EDE-9EBF-2558609EE1A2-low.png\"></div> \n\
            <p><a name=\"GUID-AB2C7D9F-DCDF-49D4-8D73-466F241F9954\"></a>You can also create a custom <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBManipulator\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_manipulator.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBManipulator</a></span> to allow interaction with the HUD elements using mouse buttons and move operations\n\
               in the viewport. \n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";