var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-989682FC-305F-4925-8B37-66490BC45C4C\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Command Line Options</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-989682FC-305F-4925-8B37-66490BC45C4C\"></a><div class=\"head\">\n\
            <h1>Command Line Options</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_A32EA215A4B84188A482CA907B3C2117\"></a> \n\
            <h2><a name=\"GUID-3BEB5D13-941A-4082-A280-E96E5C5E692E\"></a>Command Line Options\n\
            </h2> \n\
            <p><a name=\"GUID-50C4F890-00D9-4766-A41E-F868E3856EA4\"></a>MotionBuilder\'s command line options are useful for script or batch processing. The\n\
               syntax to run MotionBuilder with specific flags is as follows: \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">motionbuilder.exe [<a href=\"javascript:void(0)\" data-symbol=\"flags\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a4ba10aaac5975fb2c7d5e997dced28ee&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">flags</a>] [Python script or filename]</pre></div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_246BF83784814218B74EDC93D426FD54\"></a> \n\
            <h2><a name=\"GUID-E4DCC296-3ACB-4066-BF77-DD200968A8E0\"></a>Startup Flags\n\
            </h2> \n\
            <p><a name=\"GUID-A54AEE3A-FF6A-48D5-94A9-DEED0C3AA3EA\"></a>The following table lists the flags that you can use in the <span class=\"code\" translate=\"no\">[<a href=\"javascript:void(0)\" data-symbol=\"flags\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a4ba10aaac5975fb2c7d5e997dced28ee&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">flags</a>]</span> section of the command line syntax. \n\
            </p> <a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6C23\"></a><div class=\"table-ruled\">\n\
               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n\
                  <colgroup>\n\
                     <col width=\"30.508474576271183%\">\n\
                     <col width=\"69.4915254237288%\">\n\
                  </colgroup>\n\
                  <tr class=\"ruled-heading\">\n\
                     <th class=\"table-heading\">Flag </th>\n\
                     <th class=\"table-heading\">Description </th>\n\
                  </tr>\n\
                  <tr class=\"ruled-odd-row\">\n\
                     <td class=\"table-body\"> <span class=\"code\" translate=\"no\">-console</span> \n\
                     </td>\n\
                     <td class=\"table-body\"> Opens an output window used by <span class=\"code\" translate=\"no\">FBTrace</span> in the ORSDK, where the appropriate stdout/err stream goes. If you choose to use\n\
                        this console output window for Python output, you also need to use the <span class=\"code\" translate=\"no\">-verbosePython</span> flag. \n\
                     </td>\n\
                  </tr>\n\
                  <tr class=\"ruled-even-row\">\n\
                     <td class=\"table-body\"> <span class=\"code\" translate=\"no\">-F [filename]</span> \n\
                     </td>\n\
                     <td class=\"table-body\">This is an alternative way to open a file with MotionBuilder at startup. If this flag\n\
                        is omitted, you must specify the filename you want to open as the last parameter in\n\
                        the list. \n\
                     </td>\n\
                  </tr>\n\
                  <tr class=\"ruled-odd-row\">\n\
                     <td class=\"table-body\"> <span class=\"code\" translate=\"no\">-g [width][height]</span> \n\
                     </td>\n\
                     <td class=\"table-body\">Sets the window size of MotionBuilder to the values specified. The default state is\n\
                        maximized. \n\
                     </td>\n\
                  </tr>\n\
                  <tr class=\"ruled-even-row\">\n\
                     <td class=\"table-body\"> <span class=\"code\" translate=\"no\">-S</span> \n\
                     </td>\n\
                     <td class=\"table-body\">Starts MotionBuilder in full screen mode. This is equivalent to selecting <span class=\"code\" translate=\"no\">Display &gt; Full Screen</span> inside the Viewer. To exit full screen mode, press <span class=\"code\" translate=\"no\">Alt+Enter</span> or <span class=\"code\" translate=\"no\">Esc</span>. \n\
                     </td>\n\
                  </tr>\n\
                  <tr class=\"ruled-odd-row\">\n\
                     <td class=\"table-body\"> <span class=\"code\" translate=\"no\">-suspendMessages</span> \n\
                     </td>\n\
                     <td class=\"table-body\">Disables all the warnings and pop-up dialogs. This flag is useful for automation purposes\n\
                        when you do not want the script to be interrupted by dialog boxes. By default, all\n\
                        warnings and dialog boxes are shown. \n\
                     </td>\n\
                  </tr>\n\
                  <tr class=\"ruled-even-row\">\n\
                     <td class=\"table-body\"> <span class=\"code\" translate=\"no\">-T[UI <a href=\"javascript:void(0)\" data-symbol=\"Name\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a3e9f22c154a65956ebd413d2d8dafc0f&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Name</a>]</span> \n\
                     </td>\n\
                     <td class=\"table-body\">Finds a tool with the matching name among the tools that MotionBuilder has registered,\n\
                        and activates it. This flag parameter is case sensitive. \n\
                        <div><a name=\"GUID-C75128B4-CEF3-40E3-B736-18E9349F694C\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>There is no space between the <span class=\"code\" translate=\"no\">-T</span> and the <span class=\"code\" translate=\"no\">[UI <a href=\"javascript:void(0)\" data-symbol=\"Name\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a3e9f22c154a65956ebd413d2d8dafc0f&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Name</a>]</span> parameter. \n\
                           </div>\n\
                        </div> \n\
                     </td>\n\
                  </tr>\n\
                  <tr class=\"ruled-odd-row\">\n\
                     <td class=\"table-body\"> <span class=\"code\" translate=\"no\">-verbosePython</span> \n\
                     </td>\n\
                     <td class=\"table-body\"> <a name=\"GUID-5BA2808C-E0AE-4384-AC86-4A386E67A93D\"></a><p class=\"table-body\">Outputs all Python messages to the appropriate stdout/err stream. This puts the Python\n\
                           <span class=\"code\" translate=\"no\">print</span> messages to the window that you activate using the <span class=\"code\" translate=\"no\">-console</span> flag as well as to the <span class=\"char_link\"><a href=\"#!/url=./files/GUID-6B00DBAE-EC34-4958-86F5-A5B644C2DB00.htm\">Python Editor</a></span>. \n\
                        </p> <a name=\"GUID-96ADFF7B-8D25-4B9B-BBDF-E7B95BB9C1B2\"></a><p class=\"table-body\">This is the same location that <span class=\"code\" translate=\"no\">FBTrace</span> outputs to when using the OR SDK. By default, Python output is only presented in\n\
                           the <span class=\"char_link\"><a href=\"#!/url=./files/GUID-6B00DBAE-EC34-4958-86F5-A5B644C2DB00.htm\">Python Editor</a></span>. \n\
                        </p> \n\
                     </td>\n\
                  </tr>\n\
               </table>\n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_0DC954DEAD0C4E53A98F4E8FFDB5EF74\"></a> \n\
               <h3><a name=\"GUID-AB98C99E-9DF2-49F2-B775-05BFD7C5D7B3\"></a>Command Line Usage Examples\n\
               </h3> \n\
               <p><a name=\"GUID-37B3DBB2-1DD0-484D-9AB9-77433C32707C\"></a> <a name=\"UL_DBC2342FA7D941DAAFE2C3F374944473\"></a><ul>\n\
                     <li>Opens the scene contained in <span class=\"filePath\" translate=\"no\">mia_blue.fbx</span> on startup. \n\
                        <div class=\"codeBlock\"><pre class=\"prettyprint\">motionbuilder.exe mia_blue.fbx</pre></div> \n\
                     </li>\n\
                     <li>Launches in full screen mode and opens the scene contained in <span class=\"filePath\" translate=\"no\">mia_blue.fbx</span> \n\
                        <div class=\"codeBlock\"><pre class=\"prettyprint\">motionbuilder.exe -S mia_blue.fbx</pre></div> \n\
                     </li>\n\
                     <li>Launches the <span class=\"filePath\" translate=\"no\">testScript.py</span> script on startup and suppresses all message boxes that the script might generate.\n\
                        \n\
                        <div class=\"codeBlock\"><pre class=\"prettyprint\">motionbuilder.exe -suspendMessages testScript.py</pre></div> \n\
                     </li>\n\
                     <li>Launches the <span class=\"code\" translate=\"no\">Audio</span> tool located in the sample tools folder on startup. \n\
                        <div><a name=\"GUID-C1791287-94F9-431B-920D-7A8305D55D66\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>The <span class=\"code\" translate=\"no\">Audio</span> tool needs to be compiled first. \n\
                           </div>\n\
                        </div> \n\
                        <div class=\"codeBlock\"><pre class=\"prettyprint\">motionbuilder.exe -TAudio</pre></div> \n\
                     </li>\n\
                     <li>Launches the <span class=\"filePath\" translate=\"no\">Script.py</span> script and sends the output to the console output window. \n\
                        <div class=\"codeBlock\"><pre class=\"prettyprint\">motionbuilder.exe -console -verbosePython Script.py</pre></div> \n\
                     </li>\n\
                     <li>Launches with an active window of 500 x 500, and opens the scene <span class=\"filePath\" translate=\"no\">mia_blue.fbx</span>. \n\
                        <div class=\"codeBlock\"><pre class=\"prettyprint\">motionbuilder.exe -g 500 500 mia_blue.fbx</pre></div> \n\
                     </li>\n\
                     <li>Launches the console, the <span class=\"char_link\"><a href=\"#!/url=./files/GUID-6B00DBAE-EC34-4958-86F5-A5B644C2DB00.htm\">Python Editor</a></span> tool, and opens the scene contained in <span class=\"filePath\" translate=\"no\">mia_blue.fbx</span>. \n\
                        <div><a name=\"GUID-3F421682-2E76-42F6-982F-C122FBA2621A\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>The quotes surrounding <span class=\"code\" translate=\"no\">\"-TPython Editor\"</span> ensure that the <span class=\"code\" translate=\"no\">Python Editor</span> tool is launched. Without these quotes, only the <span class=\"code\" translate=\"no\">Python</span> tool is launched, if it exists. \n\
                           </div>\n\
                        </div> \n\
                        <div class=\"codeBlock\"><pre class=\"prettyprint\">motionbuilder.exe -console \"-TPython Editor\" mia_blue.fbx</pre></div> \n\
                     </li>\n\
                  </ul> \n\
               </p> \n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_A3B8763123F74837A559582F43B5CF33\"></a> \n\
            <h2><a name=\"GUID-61713188-A121-4A99-B614-866F795F9FAD\"></a>Environment Variables\n\
            </h2> \n\
            <p><a name=\"GUID-90AEC5FC-9A5D-4D5E-9DC1-A6A0A71FAC4D\"></a>You can use the following environment variables for modifying the behavior of MotionBuilder.\n\
               \n\
            </p> <a name=\"UL_D87CED1485674052B9364CFDEE8BFA85\"></a><ul>\n\
               <li><span class=\"code\" translate=\"no\">MB_CONFIG_DIR</span> – You can set this environment variable to specify the directory where the MotionBuilder\n\
                  configuration files are stored. If not set, the files are stored in the default location\n\
                  (document or home directory). \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\">MOTIONBUILDER_PLUGIN_PATH</span> – The list of directories contained in this environment variable determines the location\n\
                  from which MotionBuilder loads the compiled plug-ins. \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\">MOTIONBUILDER_PYTHON_STARTUP</span> – The list of directories contained in this environment variable determines the location\n\
                  from which MotionBuilder loads the Python startup scripts. \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\"> MOBU_FBX_EXTENSION_PATH</span> – The list of directories contained in this environment variable determines the location\n\
                  from which MotionBuilder loads the FBX MB extension plug-ins. \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\">FILMBOX_CONSOLE</span> – The console appears when this environment variable is set to <span class=\"code\" translate=\"no\">1</span> (Windows only). Otherwise, the console does not appear. \n\
               </li>\n\
               <li><span class=\"code\" translate=\"no\">K_NO_CRASH_RECOVERY</span> – Setting this environment variable to any value disables the crash signal handling\n\
                  mechanism (Linux only). To enable the crash signal handling mechanism, do not set\n\
                  this variable. When enabled, the handler might interfere with actions like crash debugging.\n\
                  \n\
               </li>\n\
               <li> <span class=\"code\" translate=\"no\">MOTIONBUILDER_SAVELOAD_EMBEDMEDIAS</span> – This environment variable is used for overriding the corresponding setting in a\n\
                  configuration file. Any other value except <span class=\"code\" translate=\"no\">Yes</span> is considered as false. \n\
               </li>\n\
               <li> <span class=\"code\" translate=\"no\">MOTIONBUILDER_SAVELOAD_SHOWEMBEDMEDIASOPTION</span> – The <span class=\"code\" translate=\"no\">ShowEmbedMediasOption</span> preference item can be used in the <span class=\"code\" translate=\"no\">SaveLoad</span> section of a configuration file to control whether the Embed Medias checkbox appears\n\
                  in the Save dialog box. This environment variable can also be used for overriding\n\
                  the corresponding setting in a configuration file. Any other value except <span class=\"code\" translate=\"no\">Yes</span> is considered as false. \n\
               </li>\n\
            </ul> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";