var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-A214721A-1E8F-4F00-ADDC-F5A420F9BF29\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>FBPlug - Object Connection Management</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-A214721A-1E8F-4F00-ADDC-F5A420F9BF29\"></a><div class=\"head\">\n\
            <h1>FBPlug - Object Connection Management</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_1DF6EFEDB4D84E638424F28B94AAE03E\"></a> \n\
            <h2><a name=\"GUID-4DF616BB-0EAC-480B-BBBE-8845A97D2EB1\"></a>FBPlug - The Connection Management Base Class.\n\
            </h2> <img src=\"images/GUID-469304C5-33D1-4F3A-A8A8-C1BE3D2A91B6-low.png\"> \n\
            <p><a name=\"GUID-03EEFD72-1907-470E-B08B-629B947E1DB6\"></a>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_plug.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPlug</a></span> class is the base class of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_component.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBProperty\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_property.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_property.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBProperty</a></span>. The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_plug.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPlug</a></span> class is responsible for managing the connections among components and properties.\n\
               There are two types of connections: \n\
            </p> <a name=\"UL_513F02B31E5A42C9B986F83FB04E998D\"></a><ul>\n\
               <li><em class=\"strong\">Component-Property</em> connections. \n\
               </li>\n\
               <li><em class=\"strong\">Component-Component</em> connections. \n\
               </li>\n\
            </ul> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_112F7DE8F8154E77A4612D81D16A473F\"></a> \n\
            <h2><a name=\"GUID-3A3FA2BA-F0C7-456F-A255-78825FD69D5E\"></a>Component-Property Connection\n\
            </h2> \n\
            <p><a name=\"GUID-37689515-38B6-42C1-8F76-CB41186F26A1\"></a><em class=\"strong\">Component-Property</em> connections define the state and behavior of a component through its properties.\n\
               A component owns a list of properties, as described in <span class=\"char_link\"><a href=\"#!/url=./files/GUID-7871AFE8-5209-4377-B4B4-2881840E7EDF.htm\">FBProperty - Object Properties</a></span>. The following figure describes the <em class=\"strong\">owned/owner</em> relationship between an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_component.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent</a></span> and its <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBProperty\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_property.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_property.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBProperty</a></span>. \n\
            </p> \n\
            <p><a name=\"GUID-9236012F-F737-4298-ACDD-40DE3B0D7A4F\"></a></p> <img src=\"images/GUID-2B96B6B9-D505-4F5F-9406-0E0A84A61112-low.png\"> \n\
            <p><a name=\"GUID-FAD6C6A1-C37A-4E32-92ED-39655E0FFDB7\"></a>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBProperty\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_property.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_property.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBProperty</a></span> \"<em class=\"strong\">p</em>\" is <em class=\"strong\">owned</em> <em class=\"strong\">by</em> the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_component.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent</a></span> \"<em class=\"strong\">c</em>\". It is accessed via <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPlug.GetOwned()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_plug.html#af9c9d17d7fd9595a6ad721cf6d166b13&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPlug.GetOwned()</a></span>. \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\"># Assume that <a href=\"javascript:void(0)\" data-symbol=\"FBProperty\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_property.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBProperty</a> <a href=\"javascript:void(0)\" data-symbol=\"p\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/floatobject_8h.html#af18a92ce774f4c499544fbcc894db7e8&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">p</a> is indexed at 0.\n\
<a href=\"javascript:void(0)\" data-symbol=\"p\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/floatobject_8h.html#af18a92ce774f4c499544fbcc894db7e8&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">p</a> = c.GetOwned(0)</pre></div> \n\
            </p> \n\
            <p><a name=\"GUID-B47EF37D-F970-4F9A-A981-5CBD95756136\"></a>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_component.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent</a></span> \"<em class=\"strong\">c</em>\" is the <em class=\"strong\">owner</em> <em class=\"strong\">of</em> <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBProperty\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_property.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_property.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBProperty</a></span> \"<em class=\"strong\">p</em>\". It is accessed via <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPlug.GetOwner()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_plug.html#aed5287363c519554d2c3a6e81aa54293&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPlug.GetOwner()</a></span>. \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\"># An <a href=\"javascript:void(0)\" data-symbol=\"FBProperty\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_property.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBProperty</a> can only have one owner, so there is no <a href=\"javascript:void(0)\" data-symbol=\"index\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#aed9361a6a6957b25e08992d6392020a4&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">index</a> required.\n\
c = p.GetOwner()</pre></div> \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_AE6A9D94B68F4A83B67627531CA13FAD\"></a> \n\
            <h2><a name=\"GUID-B3CCEAB3-4696-4BB8-9907-EE4CF32FDE2C\"></a>Component-Component Connection\n\
            </h2> \n\
            <p><a name=\"GUID-AF9B0F73-C971-4D88-9D42-E904B5937CDE\"></a><em class=\"strong\">Component-Component</em> connections allow for components to be organized in a parent-child hierarchy. Such\n\
               a hierarchy is present in the scene graph organization (see <span class=\"char_link\"><a href=\"#!/url=./files/GUID-D04CD336-5D6A-4FB3-A75E-E50EC79819FA.htm\">Scene Elements</a></span>). The following figure describes the <em class=\"strong\">source/destination</em> relationship between two instances of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_component.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent</a></span>. \n\
            </p> \n\
            <p><a name=\"GUID-246E9D66-2631-43C7-815C-EA6848A83E69\"></a></p> <img src=\"images/GUID-C33E5EFA-AA57-4A4F-A277-B5F5D9BBA9AE-low.png\"> \n\
            <p><a name=\"GUID-F50C2F37-7681-4C41-9D36-53A20E6623CC\"></a>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_component.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent</a></span> \"<em class=\"strong\">child</em>\" is the <em class=\"strong\">source</em> <em class=\"strong\">of</em> the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_component.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent</a></span> \"<em class=\"strong\">parent</em>\". It is accessible via <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPlug.GetSrc()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_plug.html#a740947d1459f166a4d83804c8bb2e396&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPlug.GetSrc()</a></span>. \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\"># Assume that <a href=\"javascript:void(0)\" data-symbol=\"FBComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent</a> child is indexed at 0.\n\
child = parent.GetSrc(0)</pre></div> \n\
            </p> \n\
            <p><a name=\"GUID-12216103-1724-490E-9700-EF3ECBD24E72\"></a>The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_component.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent</a></span> \"<em class=\"strong\">parent</em>\" is the <em class=\"strong\">destination</em> <em class=\"strong\">of</em> the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_component.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent</a></span> \"<em class=\"strong\">child</em>\". It is accessible via <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPlug.GetDst()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_plug.html#a159052be7e5fb92b1aaf240fdc8333db&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPlug.GetDst()</a></span>. \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\"># Assume that <a href=\"javascript:void(0)\" data-symbol=\"FBComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent</a> parent is indexed at 0.\n\
parent = child.GetDst(0)</pre></div> \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_D2277F21099C47E995D1301D51493114\"></a> \n\
            <h2><a name=\"GUID-C06D3269-3BD3-4A04-B628-327BAE1D0C66\"></a>Connection Example\n\
            </h2> \n\
            <p><a name=\"GUID-03A36983-506E-46F5-B354-E0E87D11AC35\"></a>The diagram below illustrates the <em class=\"mild\">source-destination</em> relationships among components, and the <em class=\"mild\">owned-owner</em> relationships among components and properties. \n\
            </p> \n\
            <p><a name=\"GUID-13D86357-87CF-44ED-8FAD-4BB892746870\"></a></p> <img src=\"images/GUID-BD103434-3705-424E-8B55-5B85D7DFA18A-low.png\"> \n\
            <p><a name=\"GUID-22B0FFA0-E59A-413A-A6DB-721772663EC8\"></a>Accessing the <em class=\"strong\">source</em> components of <span class=\"code\" translate=\"no\">c0</span>. \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\"># Assume c1 is indexed at 0.\n\
c1 = c0.GetSrc(0)\n\
\n\
# Assume c2 is indexed at 1.\n\
c2 = c0.GetSrc(1)</pre></div> \n\
            </p> \n\
            <p><a name=\"GUID-B3DDBFEA-92C4-4059-8ECD-B56A92E348AC\"></a>Accessing the <em class=\"strong\">owned</em> property of <span class=\"code\" translate=\"no\">c0</span>. \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">p0 = c0.GetOwned(0)</pre></div> \n\
            </p> \n\
            <p><a name=\"GUID-12416DBD-CAEE-4B79-A3C5-4F13C641D696\"></a>Accessing the <em class=\"strong\">destination</em> component of <span class=\"code\" translate=\"no\">c2</span>. \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">c0 = c2.GetDst(0)</pre></div> \n\
            </p> \n\
            <p><a name=\"GUID-537FB637-9FE5-46CA-86B4-3C2C4E1E1FCD\"></a>Accessing the property <span class=\"code\" translate=\"no\">p4</span> from property <span class=\"code\" translate=\"no\">p1</span>. \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\"># A property can only have one owner.\n\
c1 = p1.GetOwner()\n\
\n\
# Assume c0 is indexed at 0.\n\
c0 = c1.GetDst(0)\n\
\n\
# Assume c2 is indexed at 1.\n\
c2 = c0.GetSrc(1)\n\
\n\
# Assume p4 is indexed at 2.\n\
p4 = c2.GetOwned(2)</pre></div> \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_E9B7BC05072843C6B2D369E3113F2283\"></a> \n\
            <h2><a name=\"GUID-CAB8DDEC-F05E-4F32-AB50-2DB60E6E7E69\"></a>Inspecting an FBModel\'s Connections\n\
            </h2> \n\
            <p><a name=\"GUID-C21E738D-BBD7-4E4F-82B7-ADEAC35B1209\"></a>Click on a model in the scene to select it, and run the program below. It will output\n\
               all the connections of the selected <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a></span> in the scene. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">from pyfbsdk import *\n\
\n\
\n\
###############################################################\n\
# Helper Function(<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a>).                                         #\n\
###############################################################\n\
\n\
# <a href=\"javascript:void(0)\" data-symbol=\"Print\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a6e4d6b1145275e9c1d89c9aa5b778546&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Print</a> the class and <a href=\"javascript:void(0)\" data-symbol=\"object\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#a904fdf014f8cdbefe8320ca2bfd6daf6&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">object</a> <a href=\"javascript:void(0)\" data-symbol=\"name\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#afcd1706c9144e6d6eee6127661ae3be2&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">name</a> of the FBPlug.\n\
def printPlug(pPlug):\n\
    try:\n\
        print pPlug.ClassName() + \": \" + pPlug.LongName\n\
    except:\n\
        pass\n\
\n\
# <a href=\"javascript:void(0)\" data-symbol=\"Print\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a6e4d6b1145275e9c1d89c9aa5b778546&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Print</a> the sources of the plug.\n\
def printSources(pPlug):\n\
    print \"Source Components: \"\n\
    print \"-----------------------\"\n\
    numSrc = pPlug.GetSrcCount()\n\
    for <a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a> in range(0, numSrc):\n\
        printPlug(pPlug.GetSrc(<a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a>))\n\
    print \"\"\n\
    \n\
# <a href=\"javascript:void(0)\" data-symbol=\"Print\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a6e4d6b1145275e9c1d89c9aa5b778546&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Print</a> the destinations of the plug.\n\
def printDestinations(pPlug):\n\
    print \"Destination Components: \"\n\
    print \"-----------------------\"\n\
    numDst = pPlug.GetDstCount()\n\
    for <a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a> in range(0, numDst):\n\
        printPlug(pPlug.GetDst(<a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a>))\n\
    print \"\"\n\
\n\
# <a href=\"javascript:void(0)\" data-symbol=\"Print\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a6e4d6b1145275e9c1d89c9aa5b778546&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Print</a> the owned properties of the component.\n\
def printOwned(pPlug):\n\
    print \"Owned Properties: \"\n\
    print \"-----------------------\"\n\
    numOwned = pPlug.GetOwnedCount()\n\
    for <a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a> in range(0, numOwned):\n\
        printPlug(pPlug.GetOwned(<a href=\"javascript:void(0)\" data-symbol=\"i\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a13235ab5ddf5c2ccd5ca35ab01d91328&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">i</a>))\n\
    print \"\"\n\
\n\
# <a href=\"javascript:void(0)\" data-symbol=\"Print\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a6e4d6b1145275e9c1d89c9aa5b778546&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Print</a> the owner of the property.\n\
def printOwner(pPlug):\n\
    print \"Owner Component: \"\n\
    print \"-----------------------\"\n\
    printPlug(pPlug.GetOwner())\n\
\n\
# Inspect the plug.\n\
def inspectConnections(pPlug):\n\
    print \"Plug inspected: \" + pPlug.LongName + \' (\' + pPlug.ClassName() + \')\\<a href=\"javascript:void(0)\" data-symbol=\"n\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/longobject_8h.html#a0a1cb627ccae562872efc91e5b752be1&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">n</a>\'    \n\
    printSources(pPlug)\n\
    printDestinations(pPlug)    \n\
    printOwned(pPlug)\n\
    printOwner(pPlug)\n\
    \n\
\n\
\n\
###############################################################\n\
# Main.                                                       #\n\
###############################################################\n\
\n\
# Inspect the selected models.\n\
models = <a href=\"javascript:void(0)\" data-symbol=\"FBModelList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_list.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelList</a>()\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBGetSelectedModels\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#gafd7afc537327ebfd99dc4b41d08ed90b&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBGetSelectedModels</a>(models)\n\
for model in models:\n\
    inspectConnections(model)\n\
</pre></div> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";