var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-AC4F3560-D3FB-4943-892A-90B7BFC95861\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Saving an FBX File with Referenced Objects</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-AC4F3560-D3FB-4943-892A-90B7BFC95861\"></a><div class=\"head\">\n\
            <h1>Saving an FBX File with Referenced Objects</h1>\n\
         </div>\n\
         <p><a name=\"GUID-C8730C68-4020-4ADA-9BBB-765D05AD698E\"></a> You can save an FBX file that contains referenced objects. You can choose to save\n\
            or not to save the reference edits. \n\
         </p>\n\
         <p><a name=\"GUID-4B2B6923-BB17-4AFF-88DB-615901B98096\"></a>For example, consider that you are about to save a scene that contains a reference\n\
            object named NS after performing some operations on the referenced items. You can\n\
            choose to save or not to save the reference edits by setting the <span class=\"code\" translate=\"no\">FileReferenceEdit</span> attribute on <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBFbxOptions\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_fbx_options.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_fbx_options.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFbxOptions</a></span>. In the following code, the reference edits in the scene are saved because the <span class=\"code\" translate=\"no\">FileReferenceEdit</span> attribute is set to True. \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">lOptions = <a href=\"javascript:void(0)\" data-symbol=\"FBFbxOptions\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_fbx_options.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFbxOptions</a>(False)\n\
lOptions.FileReferenceEdit = True \n\
<a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a>().FileSave( {SceneFilePath}, lOptions )\n\
</pre></div>\n\
         <p><a name=\"GUID-F625BAD7-43B7-4BA6-97E5-8E9AEF6ACE48\"></a>Another attribute named <span class=\"code\" translate=\"no\">FileReference</span> controls whether the file reference objects are loaded or saved. In the following\n\
            code, the file reference objects contained inside the scene file are not loaded because\n\
            the <span class=\"code\" translate=\"no\">FileReference</span> attribute is set to False. \n\
         </p>\n\
         <div class=\"codeBlock\"><pre class=\"prettyprint\">lOptions = <a href=\"javascript:void(0)\" data-symbol=\"FBFbxOptions\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_fbx_options.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFbxOptions</a>(True)\n\
lOptions.FileReference = False\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a>().FileOpen( {SceneFilePath}, False, lOptions )\n\
</pre></div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";