var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-AEE3FB2D-D6D4-436F-9FBB-46E9591EDCAE\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Grid layout</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-AEE3FB2D-D6D4-436F-9FBB-46E9591EDCAE\"></a><div class=\"head\">\n\
            <h1>Grid layout</h1>\n\
         </div>\n\
         <p><a name=\"WS73099CC142F48755-57AF30D311C79E97FC3E1E\"></a> <span class=\"code\" translate=\"no\">GridLayout</span> gives more flexibility to layout control since you can do layout according to grid\n\
            coordinates, but at the price of more complexity. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-57AF30D311C79E97FC3E1F\"></a>When you add a control to this layout you specify at which row and column to add it.\n\
            When the layout is recomputed, the number of rows and columns is checked, as are their\n\
            configuration (whether fixed-size or ratio). Controls are then placed accordingly,\n\
            and fit to the grid. A control can span multiple rows or columns with the function\n\
            <span class=\"code\" translate=\"no\">add_range</span>. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-57AF30D311C79E97FC3E21\"></a>When using a <span class=\"code\" translate=\"no\">GridLayout</span> it is always a good idea to sketch the look of the controls to understand where they\n\
            will be placed in the grid. It also helps to decide the different attributes of rows\n\
            and columns. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-57AF30D311C79E97FC3E22\"></a>The code sample TutorialGrid.py shows how to build a small OK/Cancel Tool that allows\n\
            us to enter text in a memo. \n\
         </p>\n\
         <p><a name=\"WS73099CC142F48755-57AF30D311C79E97FC3E23\"></a>Execute the script and note that when you resize the dialog, the OK and Cancel buttons\n\
            are right-justified and the memo always stretches to take all available space. \n\
         </p>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";