var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-B2D8C726-79EC-4C0B-BC75-BBF3E8083F0A\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>UI components</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-B2D8C726-79EC-4C0B-BC75-BBF3E8083F0A\"></a><div class=\"head\">\n\
            <h1>UI components</h1>\n\
         </div>\n\
         <p><a name=\"WS1A9193826455F5FF-29C43AA61173633F416-5F26\"></a>In Python, using existing derivatives of <span class=\"code\" translate=\"no\">pyfbsdk::FBVisualComponent</span> you can create most of the basic elements. They are used throughout the code samples\n\
            because they are essential in providing you with an adequate user interface. \n\
         </p><a name=\"GUID-D3BD1DD4-1812-414F-B926-E2CB55947FCF\"></a><h2><a name=\"GUID-A2DCB367-07ED-4443-B990-1DD5C813E8E7\"></a>UI components:\n\
         </h2>\n\
         <dl>\n\
            <dt><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-6136\"></a><span class=\"term\"><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-6135\"></a>Buttons</span></dt>\n\
            <dd>\n\
               <div class=\"definition\"><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-6134\"></a> \n\
                  <p><a name=\"WS73099CC142F48755-57AF30D311C79E97FC3E0F\"></a>Use <span class=\"code\" translate=\"no\">pyfbsdk::FBButton</span> to manage buttons. For usage, see the sample Button.py. \n\
                  </p> \n\
                  <p><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-6133\"></a> <span class=\"code\" translate=\"no\">pyfbsdk::FBArrowButton</span> creates a button, which when pushed, opens a layout to display content (another control\n\
                     or a layout). A small arrow, left of the button title, shows when the content is shown\n\
                     (arrow points down) or hidden (arrow points to button title). For usage, see the code\n\
                     sample ArrowButton.py. \n\
                  </p> \n\
               </div>\n\
            </dd>\n\
            <dt><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-610E\"></a><span class=\"term\"><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-610D\"></a>Color edit</span></dt>\n\
            <dd>\n\
               <div class=\"definition\"><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-610C\"></a> \n\
                  <p><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-610B\"></a> <span class=\"code\" translate=\"no\">pyfbsdk::FBEditColor</span>, (for usage see Edit.py) \n\
                  </p> \n\
               </div>\n\
            </dd>\n\
            <dt><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-6116\"></a><span class=\"term\"><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-6115\"></a>Edit boxes</span></dt>\n\
            <dd>\n\
               <div class=\"definition\"><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-6114\"></a> \n\
                  <p><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-6113\"></a> <span class=\"code\" translate=\"no\">pyfbsdk::FBEdit</span> (text box, for usage see Edit.py), <span class=\"code\" translate=\"no\">pyfbsdk::FBMemo</span> (an editable file, see Memo.py, <span class=\"code\" translate=\"no\">pyfbsdk::FBEditNumber</span> (for usage see Edit.py) \n\
                  </p> \n\
               </div>\n\
            </dd>\n\
            <dt><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-610A\"></a><span class=\"term\"><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-6109\"></a>Image</span></dt>\n\
            <dd>\n\
               <div class=\"definition\"><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-6108\"></a> \n\
                  <p><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-6107\"></a> <span class=\"code\" translate=\"no\">pyfbsdk::FBImage</span>, (for usage see ImageContainer.py) \n\
                  </p> \n\
               </div>\n\
            </dd>\n\
            <dt><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-6106\"></a><span class=\"term\"><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-6105\"></a>Label</span></dt>\n\
            <dd>\n\
               <div class=\"definition\"><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-6104\"></a> \n\
                  <p><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-6103\"></a> <span class=\"code\" translate=\"no\">pyfbsdk::FBLabel</span>, (for usage see Label.py) \n\
                  </p> \n\
               </div>\n\
            </dd>\n\
            <dt><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-6132\"></a><span class=\"term\"><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-6131\"></a>Lists</span></dt>\n\
            <dd>\n\
               <div class=\"definition\"><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-6130\"></a> \n\
                  <p><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-612F\"></a> <span class=\"code\" translate=\"no\">pyfbsdk::FBList</span> creates a list of items. <span class=\"code\" translate=\"no\">pyfbsdk::FBContainer</span> creates a container-like object. For usage, see Container.py. <span class=\"code\" translate=\"no\">pyfbsdk::FBTree</span> creates a hierarchical list. For usage see Tree.py. \n\
                  </p> \n\
               </div>\n\
            </dd>\n\
            <dt><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-6102\"></a><span class=\"term\"><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-6101\"></a>Property editor</span></dt>\n\
            <dd>\n\
               <div class=\"definition\"><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-6100\"></a> \n\
                  <p><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-60FF\"></a> <span class=\"code\" translate=\"no\">pyfbsdk::FBEditProperty</span> and <span class=\"code\" translate=\"no\">pyfbsdk::FBEditPropertyModern</span> let you edit property values. For usage, see PropertyDrop.py. \n\
                  </p> \n\
               </div>\n\
            </dd>\n\
            <dt><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-612E\"></a><span class=\"term\"><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-612D\"></a>Slider</span></dt>\n\
            <dd>\n\
               <div class=\"definition\"><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-612C\"></a> \n\
                  <p><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-612B\"></a> <span class=\"code\" translate=\"no\">pyfbsdk::FBSlider</span>; see the code sample in Slider.py. \n\
                  </p> \n\
               </div>\n\
            </dd>\n\
            <dt><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-612A\"></a><span class=\"term\"><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-6129\"></a>Spreadsheet</span></dt>\n\
            <dd>\n\
               <div class=\"definition\"><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-6128\"></a> \n\
                  <p><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-6127\"></a>See <span class=\"char_link\"><a href=\"#!/url=./files/GUID-DF39D862-D6CC-4706-BDA4-7125C46CAC28.htm\">Spreadsheets</a></span>. \n\
                  </p> \n\
               </div>\n\
            </dd>\n\
            <dt><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-6126\"></a><span class=\"term\"><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-6125\"></a>Tab</span></dt>\n\
            <dd>\n\
               <div class=\"definition\"><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-6124\"></a> \n\
                  <p><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-6123\"></a>See <span class=\"char_link\"><a href=\"#!/url=./files/GUID-680EB72C-3F33-44CA-99D3-5B770567CF09.htm\">Tabs</a></span>. \n\
                  </p> \n\
               </div>\n\
            </dd>\n\
            <dt><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-6122\"></a><span class=\"term\"><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-6121\"></a>Thermometer</span></dt>\n\
            <dd>\n\
               <div class=\"definition\"><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-6120\"></a> \n\
                  <p><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-611F\"></a> <span class=\"code\" translate=\"no\">pyfbsdk::FBThermometer</span> creates a tool showing minimum / maximum values; see the code sample in Thermometer.py.\n\
                     \n\
                  </p> \n\
               </div>\n\
            </dd>\n\
            <dt><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-611E\"></a><span class=\"term\"><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-611D\"></a>Time</span></dt>\n\
            <dd>\n\
               <div class=\"definition\"><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-611C\"></a> \n\
                  <p><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-611B\"></a> <span class=\"code\" translate=\"no\">pyfbsdk::FBTimeCode</span> for usage see Edit.py. \n\
                  </p> \n\
               </div>\n\
            </dd>\n\
            <dt><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-611A\"></a><span class=\"term\"><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-6119\"></a>Tree layout</span></dt>\n\
            <dd>\n\
               <div class=\"definition\"><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-6118\"></a> \n\
                  <p><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-6117\"></a> <span class=\"code\" translate=\"no\">pyfbsdk::FBTree</span> for usage see Tree.py. \n\
                  </p> \n\
               </div>\n\
            </dd>\n\
            <dt><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-6112\"></a><span class=\"term\"><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-6111\"></a>Vector edit</span></dt>\n\
            <dd>\n\
               <div class=\"definition\"><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-6110\"></a> \n\
                  <p><a name=\"WS73099CC142F487551FEA285E1221E4F9FF8-610F\"></a> <span class=\"code\" translate=\"no\">pyfbsdk::FBEditVector</span>, (for usage see CustomProperty.py). \n\
                  </p> \n\
               </div>\n\
            </dd>\n\
         </dl><span class=\"noindex\">\n\
            <div class=\"topic-list\">\n\
               <h4 class=\"related\">Topics in this section</h4>\n\
               <ul class=\"jumplist\">\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-DF39D862-D6CC-4706-BDA4-7125C46CAC28.htm\">Spreadsheets</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-680EB72C-3F33-44CA-99D3-5B770567CF09.htm\">Tabs</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-793C5C01-63EB-433E-BF5F-4869BDCCA741.htm\">Message boxes</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-1830727C-7C13-49F6-8EC6-9E9465987896.htm\">Progress feedback</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-47D1C717-95FF-4C41-9855-53922A247003.htm\">Widgets</a></li>\n\
               </ul>\n\
            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";