var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-B90256BC-DA6C-423F-9945-4F25FF2D2607\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Getting Notified of Source File Changes</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-B90256BC-DA6C-423F-9945-4F25FF2D2607\"></a><div class=\"head\">\n\
            <h1>Getting Notified of Source File Changes</h1>\n\
         </div>\n\
         <p><a name=\"GUID-77CC33B1-4A4A-4093-8233-3075ED0EFCA4\"></a> The users can be notified through a pop-up dialog or through the SDK when the source\n\
            file of a referenced object is changed. This is useful when you have made changes\n\
            to a common file and you want the changes to propagate to all users. The user can\n\
            choose to accept or reject the new version. However, the file is updated on reload,\n\
            if rejected. \n\
         </p>\n\
         <p><a name=\"GUID-E74557ED-2F25-4FF4-8E70-40FAC980E9C8\"></a>You can respond to the file change event using <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBFileMonitoringManager\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_file_monitoring_manager.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_file_monitoring_manager.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFileMonitoringManager</a></span>. The <span class=\"code\" translate=\"no\">EventFileChangeFileReference</span> function is called when the external file is changed. The callback function displays\n\
            a dialog with two options: <span class=\"MenuCascade\" id=\"GUID-A36CECC0-0008-47FD-92E6-03ABD5546375\">Load</span> and <span class=\"MenuCascade\" id=\"GUID-87661431-8DBB-4434-9EF1-E211EC64CAF0\">Merge</span>. If you choose <span class=\"MenuCascade\" id=\"GUID-DE012320-104D-4F6B-85BB-23DF15A8629D\">Load</span>, the file reference object is loaded along with the reference edit of others. If\n\
            you choose <span class=\"MenuCascade\" id=\"GUID-11095B57-74D9-4C8B-ADC1-56B3518EE506\">Merge</span>, the new reference edits from the external sources are merged into the current file\n\
            reference object. \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">def EventFileChangeFileReference(control,event):\n\
    lFileRefObj = <a href=\"javascript:void(0)\" data-symbol=\"FBFindObjectByFullName\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga980a7ebfc02171f683b0bfed6527faa2&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFindObjectByFullName</a>( \'FileReference::NS\' )\n\
    lOption = <a href=\"javascript:void(0)\" data-symbol=\"FBMessageBox\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga911b954221bb1fcc892a47156186caf1&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBMessageBox</a>( \"External File Changed\", \"Please choose the following action for Reference: NS!\", \"<a href=\"javascript:void(0)\" data-symbol=\"Load\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a7cc9da6a6307ea8052f27a18bd3d7d5bac40ec5db2990469fc236f4c5dea23edb&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Load</a>\", \"Merge\", \"Ignore\" )\n\
    if lOption &lt;&gt; 3:\n\
        lUndo = <a href=\"javascript:void(0)\" data-symbol=\"FBUndoManager\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_undo_manager.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBUndoManager</a>()\n\
        lUndo.Clear()\n\
        lFileRefObj.IsLoaded = False\n\
        lFileRefObj.IsLoaded = True\n\
\n\
    if lOption == 2:\n\
        if lFileRefObj.GetContentModified( <a href=\"javascript:void(0)\" data-symbol=\"FBPlugModificationFlag.kFBContentAllModifiedMask\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_plug_modification_flag.html#ae2c6b2fdf115da1cecff3e6691420235&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPlugModificationFlag.kFBContentAllModifiedMask</a> ):\n\
            lFileRefObj.ApplyRefEditPyScriptFromString( lFileRefObj.GetRefEdit() )\n\
\n\
\n\
lFileMonitoring = <a href=\"javascript:void(0)\" data-symbol=\"FBFileMonitoringManager\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_file_monitoring_manager.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFileMonitoringManager</a>()\n\
lFileMonitoring.OnFileChangeFileReference.Add(EventFileChangeFileReference)\n\
</pre></div> \n\
         </p>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";