var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-CCCFD1BB-6875-4DC9-8433-4DF4B792E296\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>What is the MotionBuilder SDK?</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-CCCFD1BB-6875-4DC9-8433-4DF4B792E296\"></a><div class=\"head\">\n\
            <h1>What is the MotionBuilder SDK?</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_3997F5B3209B47C585D573400A565388\"></a> \n\
            <h2><a name=\"GUID-DFDA62DA-E564-4D04-854A-56B1009DF9D3\"></a>What is the MotionBuilder SDK?\n\
            </h2> \n\
            <p><a name=\"WS73099CC142F4875539000486122982E6AA8-75BE\"></a>The MotionBuilder Software Development Kit (SDK) allows users to automate repetitive,\n\
               time-consuming tasks and extend features without leaving the Autodesk MotionBuilder\n\
               environment. It supports the popular, easy-to-use Python programming language which\n\
               lets production facilities better integrate MotionBuilder into their production pipeline.\n\
               It can also be used to create custom tools, features, and filetypes which plug directly\n\
               into MotionBuilder and extend its functionality. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_06FB507D226040F19BD81A2139D81753\"></a> \n\
            <h2><a name=\"GUID-75ED0445-3BC4-4B4B-928D-1AAA950BD2E6\"></a>API Organization\n\
            </h2> \n\
            <p><a name=\"GUID-6C1E3D81-165A-4B8C-8858-6CC1F8B57DF9\"></a>The MotionBuilder SDK provides two Application Programming Interfaces (APIs), one\n\
               in C++ and the other in Python. \n\
            </p> <a name=\"UL_84C1FC29D1C14EF0833D697117989069\"></a><ul>\n\
               <li>The <span class=\"char_link\"><a href=\"#!/url=./files/GUID-EEDEA4B7-EB09-4FBC-8F30-245328763D0D.htm\">MotionBuilder C++ API</a></span> is contained in the <em class=\"strong\">Open Reality SDK</em> (<em class=\"strong\">OR SDK</em>). \n\
               </li>\n\
               <li>The <span class=\"char_link\"><a href=\"#!/url=./files/GUID-747BA9FF-F7F4-4637-BB99-F130AD48BB00.htm\">MotionBuilder Python API</a></span> is contained in the <em class=\"strong\">pyfbsdk</em> module. \n\
               </li>\n\
            </ul> \n\
            <p><a name=\"GUID-34E0B92E-36A2-44CC-BCFA-A3E1299739BD\"></a>The majority of MotionBuilder\'s functionality is exposed in the C++ API. The Python\n\
               API is a subset of the C++ API, and was generated using the Boost Python library.\n\
               As a result, the function signatures of one language are analogous to the other. \n\
            </p> \n\
            <p><a name=\"GUID-0B621A13-2967-436E-A09C-0E81189F6987\"></a></p> <img src=\"images/GUID-52821FA0-9DAF-4F4A-8651-FBA497619DFF-low.png\"> \n\
         </div><span class=\"noindex\">\n\
            <div class=\"topic-list\">\n\
               <h4 class=\"related\">Topics in this section</h4>\n\
               <ul class=\"jumplist\">\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-EEDEA4B7-EB09-4FBC-8F30-245328763D0D.htm\">MotionBuilder C++ API</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-747BA9FF-F7F4-4637-BB99-F130AD48BB00.htm\">MotionBuilder Python API</a></li>\n\
               </ul>\n\
            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";