var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-D55AA18D-309A-4221-A4DD-FE2DD76393BB\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Example: Cube Counter</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-D55AA18D-309A-4221-A4DD-FE2DD76393BB\"></a><div class=\"head\">\n\
            <h1>Example: Cube Counter</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_128F906CC87E43BCA4E093B4849D975F\"></a> \n\
            <h2><a name=\"GUID-D0BC835F-A92D-433E-93D4-DD53EBFB02D1\"></a>Example: Cube Counter\n\
            </h2> \n\
            <p><a name=\"GUID-3F9FEAF3-EBA3-4D7F-BCC8-0D3577F06E51\"></a>The following program creates one cube (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelCube\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_cube.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_cube.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelCube</a></span>) and saves the scene to \"<span class=\"filePath\" translate=\"no\">one_cube.fbx</span>\". It then creates a second cube and saves the scene to \"<span class=\"code\" translate=\"no\">two_cubes.fbx</span>\". The number of cubes are then counted in both files; the first file contains one\n\
               cube, and the second file contains two cubes. The cubes are counted according to the\n\
               instances of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_component.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent</a></span> whose names start with \"<span class=\"code\" translate=\"no\">Cube</span>\" (this name is arbitrary, and is specified by the <span class=\"code\" translate=\"no\">cubeBaseName</span> variable in the code sample). \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">from pyfbsdk import *\n\
import os\n\
\n\
# Declare a <a href=\"javascript:void(0)\" data-symbol=\"base\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#af89ed82bba25b3f21c2294d4f56636f9&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">base</a> <a href=\"javascript:void(0)\" data-symbol=\"name\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#afcd1706c9144e6d6eee6127661ae3be2&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">name</a> for our cube.\n\
cubeBaseName = \'Cube\'\n\
\n\
###############################################################\n\
# Helper Function(<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a>).                                         #\n\
###############################################################\n\
# Save the scene.\n\
def SaveScene(pFilename):\n\
    \'\'\' Save the scene to MyDocuments\\MB using the specified filename. \'\'\'\n\
    directory = os.path.expanduser(\'~\') + \'\\Documents\\MB\'\n\
    path = os.path.join(directory, pFilename)\n\
    <a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a>().FileSave(path)\n\
    return path\n\
\n\
\n\
# Create a cube using the global variable cubeBaseName,\n\
# followed by the specified suffix.\n\
def CreateCube(pSuffix):\n\
    global cubeBaseName\n\
    cube = <a href=\"javascript:void(0)\" data-symbol=\"FBModelCube\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_cube.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelCube</a>(cubeBaseName + pSuffix)\n\
    cube.Show = True   \n\
    return cube\n\
\n\
\n\
# Count the cubes in the scene whose <a href=\"javascript:void(0)\" data-symbol=\"names\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/code_8h.html#a6d70b6a7be698d5bd5953a831fc49278&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">names</a> begin with cubeBaseName.\n\
def CountCubes():\n\
    global cubeBaseName\n\
\n\
    # Initialize a component list to be populated.\n\
    cl = <a href=\"javascript:void(0)\" data-symbol=\"FBComponentList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_component_list.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponentList</a>()\n\
\n\
    # Find the objects whose <a href=\"javascript:void(0)\" data-symbol=\"names\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/code_8h.html#a6d70b6a7be698d5bd5953a831fc49278&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">names</a> <a href=\"javascript:void(0)\" data-symbol=\"start\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/sliceobject_8h.html#ab80172fa2f374f0198e6186560ed619e&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">start</a> with\n\
    # the <a href=\"javascript:void(0)\" data-symbol=\"value\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#a3a0f45a8cd645a6ab8f2c793db266109&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">value</a> of cubeBaseName.\n\
    pattern = cubeBaseName + \'*\'\n\
    <a href=\"javascript:void(0)\" data-symbol=\"FBFindObjectsByName\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#gab01c92b353ac33ab4ec9f2e5d8181130&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFindObjectsByName</a>(pattern, cl, False, True)\n\
    return <a href=\"javascript:void(0)\" data-symbol=\"len\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#abc8b352d6723c361fc39710e5b10b502&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">len</a>(cl)\n\
\n\
\n\
# <a href=\"javascript:void(0)\" data-symbol=\"Print\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a6e4d6b1145275e9c1d89c9aa5b778546&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Print</a> the number of cubes in the specified file.\n\
def PrintCubesInFile(pFilename):\n\
    <a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a>().FileOpen(pFilename, False)\n\
    print \'Filename: \' + <a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a>().FBXFileName + \'.\'\n\
    print \'Number of cubes: \' + <a href=\"javascript:void(0)\" data-symbol=\"str\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/node_8h.html#a62b34ca1362fe946082b7aa0cd9be844&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">str</a>(CountCubes()) + \'.\'\n\
    print \'\'\n\
\n\
\n\
###############################################################\n\
# Main.                                                       #\n\
###############################################################\n\
# Create a new scene.\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBApplication\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_application.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBApplication</a>().FileNew()\n\
\n\
# Create a first cube \'Cube1\' and save the scene.\n\
CreateCube(\'1\')\n\
filename1 = SaveScene(\'one_cube.fbx\')\n\
\n\
# Create a second cube \'Cube2\' and save the scene.\n\
CreateCube(\'2\')\n\
filename2 = SaveScene(\'two_cubes.fbx\')\n\
\n\
# <a href=\"javascript:void(0)\" data-symbol=\"Print\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a6e4d6b1145275e9c1d89c9aa5b778546&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Print</a> the number of cubes in the first file.\n\
# There should be 1 cube in this file.\n\
PrintCubesInFile(filename1)\n\
\n\
# <a href=\"javascript:void(0)\" data-symbol=\"Print\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a6e4d6b1145275e9c1d89c9aa5b778546&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Print</a> the number of cubes in the second file.\n\
# There should be 2 cubes in this file.\n\
PrintCubesInFile(filename2)</pre></div> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";