var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-E1D20A52-4B78-43C2-B2E8-385EFE4D355E\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Animation using Function Curves</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-E1D20A52-4B78-43C2-B2E8-385EFE4D355E\"></a><div class=\"head\">\n\
            <h1>Animation using Function Curves</h1>\n\
         </div>\n\
         <p><a name=\"GUID-749CBB50-9FAF-4F06-96A0-1DB236658667\"></a>Animations are stored in function curves (FCurves). FCurves contain keys to define\n\
            a value in an assigned time. Usually, many FCurves (x, y, and z) belong to one FCurveNode.\n\
            \n\
         </p>\n\
         <p><a name=\"GUID-2D3381FD-CC61-41BE-BF85-08090275B341\"></a>The FCurveNodes map to the properties of an object. An object has both animatable\n\
            and non-animatable properties. You can edit the animatable properties of an object\n\
            by modifying the corresponding FCurves. In the UI, the function curves appear in the\n\
            <span class=\"MenuCascade\" id=\"GUID-0E37A476-5D59-4446-9C97-384733AFBB96\">FCurves</span> tab when you select an animatable property in the Property list. \n\
         </p>\n\
         <p><a name=\"GUID-3929D067-0CCC-4C7A-991A-9EB39EEA508E\"></a>To edit the animation, you need to modify the FCurves and keys. In animation using\n\
            SDK scripting, you need to consider the FCurveNode, FCurve, and key three levels.\n\
            \n\
         </p>\n\
         <p><a name=\"GUID-C3FEC26B-4F8B-4FCC-A1CC-0DD8F87DA736\"></a>The following sections explain how to use the SDK to perform simple animation tasks.\n\
            To follow the instructions, download the files and scripts from <a href=\"http://area.autodesk.com/downloads/scripts/motionbuilder-animation-scripts\" target=\"_blank\">http://area.autodesk.com/downloads/scripts/motionbuilder-animation-scripts</a>. \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_9195560B430C4AB398B37A354D552B23\"></a> \n\
            <h2><a name=\"GUID-46BBE61B-81C3-4B86-B76C-51360F4274C1\"></a>Creating Animation\n\
            </h2> \n\
            <p><a name=\"GUID-5CC89BB1-D764-4FF8-B8AB-4969FA76E681\"></a>Run the <span class=\"filePath\" translate=\"no\">create_animation_on_cube.py</span> script in the Python Editor to get a simple FCurve. \n\
            </p> <a name=\"FIG_6E610F7B028745DAABAE230AC597E652\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-627533C8-6FCF-40AE-99C9-FA23EF890753-low.png\"></div> \n\
            <p><a name=\"GUID-E7AF6759-C5E9-42FB-855C-706908C99D27\"></a>Following are the points to keep in mind: <a name=\"UL_8068FC790F5143558671990E7F972415\"></a><ul>\n\
                  <li><span class=\"code\" translate=\"no\"> KeyAdd()</span> – Adds a key with an assigned value in an assigned time. \n\
                  </li>\n\
                  <li><span class=\"code\" translate=\"no\"> SetCandidate()</span> – Changes the value in the current time but does not key it, until <span class=\"code\" translate=\"no\">KeyCandidate()</span> is executed. \n\
                  </li>\n\
                  <li><span class=\"code\" translate=\"no\">KeyCandidate()</span> – Adds the key with the candidate value in the current time. \n\
                  </li>\n\
               </ul> \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_48FDE1B1E0244B9C8D33E443AD780E6A\"></a> \n\
            <h2><a name=\"GUID-9B3EDC6C-4513-483C-AAAB-F6460CE740C8\"></a>Copying Animation\n\
            </h2> \n\
            <p><a name=\"GUID-C002CD22-11B2-4B7F-8DB1-2ADBFA4F4EA5\"></a>Keep the last scene open, and then run the <span class=\"code\" translate=\"no\">copy_animation.py</span> script to copy the animation from the <em class=\"mild\">Cube</em> and create a new cube called <em class=\"mild\">DST</em>. <a name=\"FIG_4BF36626129E4C3981C70791084EB351\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-A1FA7AC4-DB40-4383-866C-C1C52F843804-low.png\"></div> \n\
            </p> \n\
            <p><a name=\"GUID-42F581BE-5853-4531-8DB8-B0E05C5822E4\"></a> <a name=\"FIG_DF3507925E4346998FC7DE35B9E7CDDC\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-E2F03A4B-A8DA-4DE4-9FCD-AC05CB5ACA2C-low.png\"></div> \n\
            </p> \n\
            <p><a name=\"GUID-D8D4F8BB-EAC8-4AB9-99D4-95C9B656B4BE\"></a>Following are the points to keep in mind: <a name=\"UL_5157B9BEB929436CA0B98138EE6ACCFD\"></a><ul>\n\
                  <li><span class=\"code\" translate=\"no\"> <a href=\"javascript:void(0)\" data-symbol=\"FBFindModelByLabelName()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#aff5d93ad5cb7d8e581d94ab69555540a&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga7572e2672e95a9d964c46b67c70097a6&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFindModelByLabelName()</a></span> – Finds a model by name. \n\
                  </li>\n\
                  <li><span class=\"code\" translate=\"no\"> lDstNode.FCurve.KeyReplaceBy(lSrcNode.FCurve)</span> – Replaces the keys in the destination FCurve with the source FCurve. \n\
                  </li>\n\
                  <li> FCurves like x, y, z are stored in FCurveNode. These are for translation, rotation,\n\
                     and scaling. \n\
                  </li>\n\
               </ul> \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_A4DA6D123E95444198A6C2C150289EEC\"></a> \n\
            <h2><a name=\"GUID-7BB4CE04-A89E-4A5D-B8D3-BDFB9CA532BB\"></a>Clearing Animation\n\
            </h2> \n\
            <p><a name=\"GUID-F15CD705-B90C-4666-82B3-EE3BFF610CB6\"></a>Keep the last scene open, select the DST object, and run the <span class=\"code\" translate=\"no\">clear_animation.py</span> script to clear the selected animation. <a name=\"FIG_9FB836A7F29745E2B16AA8DDB8A1B963\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-9763A485-E410-4EFC-94C1-C3D39A149311-low.png\"></div> \n\
            </p> \n\
            <p><a name=\"GUID-3EA5053F-0CFE-4D92-882B-0E6972A874ED\"></a>Following are the points to keep in mind: <a name=\"UL_83747B19F5F04D6D830BBDE9A0B0D543\"></a><ul>\n\
                  <li><span class=\"code\" translate=\"no\"> pNode.FCurve.EditClear()</span> – Clears all the keys in the FCurve. \n\
                  </li>\n\
                  <li><span class=\"code\" translate=\"no\"> <a href=\"javascript:void(0)\" data-symbol=\"FBGetSelectedModels()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/namespace_o_r_s_d_k2019.html#a0ae085300e7d217e92de40b29d752e02&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#gafd7afc537327ebfd99dc4b41d08ed90b&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBGetSelectedModels()</a></span> – Gets all the selected models. \n\
                  </li>\n\
               </ul> \n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";