var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-E47A0026-9D57-4C18-845F-CF5712EDF798\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>FBComponent - The Base Entity Class</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-E47A0026-9D57-4C18-845F-CF5712EDF798\"></a><div class=\"head\">\n\
            <h1>FBComponent - The Base Entity Class</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_AC72536CFD1749B5821820F59564FF2A\"></a> \n\
            <h2><a name=\"GUID-9451E11F-40FC-460C-8792-81A024612AE2\"></a>Memory Management\n\
            </h2> \n\
            <p><a name=\"GUID-D89FCECD-9CEF-47E8-807F-691CAEF3DB7A\"></a>You can consider the <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_component.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent</a></span> class as the base entity class in the MotionBuilder SDK. It defines the basic memory\n\
               management methods for object creation and destruction. The following Python example\n\
               shows how to create and destroy an instance of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelCube\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_cube.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_cube.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelCube</a></span> (a subclass of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_component.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent</a></span>). \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">from pyfbsdk import *\n\
\n\
# A cube is created in the scene with the <a href=\"javascript:void(0)\" data-symbol=\"name\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#afcd1706c9144e6d6eee6127661ae3be2&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">name</a> \'Cube\'.\n\
cube = <a href=\"javascript:void(0)\" data-symbol=\"FBModelCube\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_cube.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelCube</a>(\'Cube\')\n\
\n\
# ...\n\
\n\
# The cube is destroyed.\n\
cube.FBDelete()</pre></div> \n\
            <div><a name=\"GUID-78EC88B3-F638-495F-940F-B02EA835389D\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Calling <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModelCube\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model_cube.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model_cube.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelCube</a>(\'Cube\')</span> in succession creates cubes named <span class=\"code\" translate=\"no\">Cube</span>, <span class=\"code\" translate=\"no\">Cube 1</span>, <span class=\"code\" translate=\"no\">Cube 2</span>, <span class=\"code\" translate=\"no\">Cube 3</span>, and so on. \n\
               </div>\n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_A9F919F34F594BBCBD41DC6088511742\"></a> \n\
            <h2><a name=\"GUID-A3C9F6D9-A7CB-4E95-AF5F-5C0249752FFB\"></a> Names and Namespaces\n\
            </h2> \n\
            <p><a name=\"GUID-34364B20-795D-458E-9260-985A944C994A\"></a>You can uniquely identify an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_component.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent</a></span> using a combination of two strings: a <em class=\"mild\">namespace</em> and <em class=\"mild\">name</em>. The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent.LongName\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_component.html#af41c3b0ac591ec7d8aabee2ff71c1dd9&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent.LongName</a></span> property returns these two strings in the following format: <span class=\"code\" translate=\"no\">Namespace:Name</span>. The <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent.Name\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_component.html#a60dc707ba36b71d8339ef283e2ba713f&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent.Name</a></span> property returns the name of the component without its namespace. \n\
            </p> \n\
            <p><a name=\"GUID-F9D05117-18B5-4652-90C7-6B8C54BCCA79\"></a>You can use namespaces to facilitate object organization. For example, you can assign\n\
               a namespace to the various body parts (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a></span>) of a character (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCharacter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_character.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_character.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacter</a></span>) in a scene. This helps you identify the character to which a body part belongs.\n\
               In the following image, <span class=\"code\" translate=\"no\">PlasticMan:Hips</span> refers to the hips of the PlasticMan character, identified by the <span class=\"code\" translate=\"no\">PlasticMan</span> namespace. \n\
            </p> <img src=\"images/GUID-57412395-50AF-40A5-852D-59055E7EF83B-low.png\"> \n\
            <div class=\"section\"><a name=\"SECTION_8C2C1775FC7646699386E433369C9029\"></a> \n\
               <h3><a name=\"GUID-CCCD8C6A-D00F-4443-AE10-0F1162CE1525\"></a>Specifying a Namespace for All the Components using the SDK\n\
               </h3> \n\
               <p><a name=\"GUID-36910B27-96A4-43B9-A27D-05C0A326A854\"></a>You can specify a namespace for all of the components in a scene as follows: \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">from pyfbsdk import * \n\
\n\
lScene = <a href=\"javascript:void(0)\" data-symbol=\"FBSystem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem</a>().Scene \n\
\n\
for comp in lScene.Components: \n\
  if hasattr(comp, \'LongName\') and comp.LongName == comp.Name and not comp.Is(<a href=\"javascript:void(0)\" data-symbol=\"FBTake_TypeInfo\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga5985801b79c1f402f1c8f3c021a93621&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTake_TypeInfo</a>()): \n\
    comp.ProcessObjectNamespace(<a href=\"javascript:void(0)\" data-symbol=\"FBNamespaceAction.kFBConcatNamespace\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_namespace_action.html#afeeb0b5b68e27500761c74556a14f313&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBNamespaceAction.kFBConcatNamespace</a>, pNamespace)</pre></div> \n\
               <p><a name=\"GUID-F3CE3F61-2AD0-4DC3-9A07-8CC1DD2F03E5\"></a>If you specify a namespace for all of the components in a scene, and then open another\n\
                  scene, certain default components are not destroyed. The namespace is carried over\n\
                  to the new scene with the components that are not destroyed. If the new scene has\n\
                  the same namespace, it is incremented by one automatically. For example, consider\n\
                  that you have specified the name <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"test\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/graminit_8h.html#af04af1bc6d042a68a2b24d6e1312d253&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">test</a></span> as the namespace for all of the components in a scene. Now, you open another scene\n\
                  with a component name such as, <span class=\"code\" translate=\"no\">test:cube</span>. This action increments the namespace automatically and the component name becomes\n\
                  <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"test\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/graminit_8h.html#af04af1bc6d042a68a2b24d6e1312d253&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">test</a> 1:cube</span>. You can use the following workaround to prevent the namespace increment. \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">from pyfbsdk import * \n\
\n\
lScene = <a href=\"javascript:void(0)\" data-symbol=\"FBSystem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_system.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBSystem</a>().Scene \n\
\n\
for comp in lScene.Components: \n\
  if not comp.HasObjectFlags(<a href=\"javascript:void(0)\" data-symbol=\"FBObjectFlag.kFBFlagDeletable\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_object_flag.html#a288b541eeec7ebf8e3308beb50ff227e&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBObjectFlag.kFBFlagDeletable</a>): continue \n\
\n\
  if hasattr(comp, \'LongName\') and comp.LongName == comp.Name and not comp.Is(<a href=\"javascript:void(0)\" data-symbol=\"FBTake_TypeInfo\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#ga5985801b79c1f402f1c8f3c021a93621&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBTake_TypeInfo</a>()): \n\
    comp.ProcessObjectNamespace(<a href=\"javascript:void(0)\" data-symbol=\"FBNamespaceAction.kFBConcatNamespace\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_namespace_action.html#afeeb0b5b68e27500761c74556a14f313&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBNamespaceAction.kFBConcatNamespace</a>, pNamespace)\n\
</pre></div> \n\
            </div> \n\
            <div class=\"section\"><a name=\"SECTION_28D090E2152343078539AD6A45F186B7\"></a> \n\
               <h3><a name=\"GUID-DF99E871-57C7-4100-B68F-1514B6395535\"></a>Searching\n\
               </h3> \n\
               <p><a name=\"GUID-A3FD7B7A-815B-4895-BDB5-8D0C3B5B9607\"></a>You can use the component names for searching. In the following Python example, a\n\
                  regular expression pattern is used to match the name of a newly created cube in a\n\
                  scene. \n\
               </p> \n\
               <div class=\"codeBlock\"><pre class=\"prettyprint\">from pyfbsdk import *\n\
\n\
# Create a cube in the scene with the <a href=\"javascript:void(0)\" data-symbol=\"name\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#afcd1706c9144e6d6eee6127661ae3be2&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">name</a> \'placeholder\' \n\
cube = <a href=\"javascript:void(0)\" data-symbol=\"FBModelCube\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_cube.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelCube</a>(\'placeholder\')\n\
\n\
# Replace the cube\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> <a href=\"javascript:void(0)\" data-symbol=\"name\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#afcd1706c9144e6d6eee6127661ae3be2&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">name</a> with \'TestCube\' to illustrate the\n\
# use of the <a href=\"javascript:void(0)\" data-symbol=\"FBComponent.Name\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_component.html#a60dc707ba36b71d8339ef283e2ba713f&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent.Name</a> property.\n\
cube.Name = \'TestCube\'\n\
\n\
# Initialize an empty <a href=\"javascript:void(0)\" data-symbol=\"FBComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent</a> list. This list will contain the search\n\
# results after calling <a href=\"javascript:void(0)\" data-symbol=\"FBFindObjectsByName\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#gab01c92b353ac33ab4ec9f2e5d8181130&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFindObjectsByName</a>().\n\
cl = <a href=\"javascript:void(0)\" data-symbol=\"FBComponentList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_component_list.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponentList</a>()\n\
\n\
# Look for objects which end in \'Cube\'. <a href=\"javascript:void(0)\" data-symbol=\"In\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#aeae2807c86997ffad2fa6d972a29ee1fad8ff8dfc9381018e97fce86d909f8975&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">In</a> the following\n\
# pattern, the \'*\' is a wildcard. This pattern will match the <a href=\"javascript:void(0)\" data-symbol=\"string\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#aafa21ae74f7a3e4ac0c645f0f30ee853&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">string</a> \'TestCube\'.\n\
pattern = \'*Cube\'\n\
\n\
# <a href=\"javascript:void(0)\" data-symbol=\"FBFindObjectsByName\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#gab01c92b353ac33ab4ec9f2e5d8181130&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFindObjectsByName</a>() Parameters:\n\
#    pattern - The pattern we are looking for in the <a href=\"javascript:void(0)\" data-symbol=\"object\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/asdl_8h.html#a904fdf014f8cdbefe8320ca2bfd6daf6&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">object</a> name.\n\
#    cl - The list which will contain the search results.\n\
#    False - Do not include the namespace in the search.\n\
#    True - Look for instances of <a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a> (which is a subclass of <a href=\"javascript:void(0)\" data-symbol=\"FBComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent</a>)\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBFindObjectsByName\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#gab01c92b353ac33ab4ec9f2e5d8181130&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFindObjectsByName</a>(pattern, cl, False, True)\n\
\n\
# The following line prints \"Objects found: 1\".\n\
print \"Objects found: \" + <a href=\"javascript:void(0)\" data-symbol=\"str\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/node_8h.html#a62b34ca1362fe946082b7aa0cd9be844&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">str</a>(<a href=\"javascript:void(0)\" data-symbol=\"len\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#abc8b352d6723c361fc39710e5b10b502&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">len</a>(cl))\n\
\n\
# <a href=\"javascript:void(0)\" data-symbol=\"Delete\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/_python-ast_8h.html#a7892570e9ff41fd7a083f300e4b81068&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">Delete</a> the cube from the scene.\n\
cube.FBDelete()\n\
\n\
# Re-initialize the cl variable with an empty component list, and run <a href=\"javascript:void(0)\" data-symbol=\"FBFindObjectsByName\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#gab01c92b353ac33ab4ec9f2e5d8181130&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFindObjectsByName</a>() again.\n\
cl = <a href=\"javascript:void(0)\" data-symbol=\"FBComponentList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_component_list.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponentList</a>()\n\
<a href=\"javascript:void(0)\" data-symbol=\"FBFindObjectsByName\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/group__pyfbsdk.html#gab01c92b353ac33ab4ec9f2e5d8181130&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBFindObjectsByName</a>(pattern, cl, False, True)\n\
\n\
# The following line indicates that no objects are found after the cube\'<a href=\"javascript:void(0)\" data-symbol=\"s\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/stringobject_8h.html#ad912d811fca4c9cfee37905bed81eb65&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">s</a> deletion.\n\
print \"Objects found after cube deletion:\" + <a href=\"javascript:void(0)\" data-symbol=\"str\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/node_8h.html#a62b34ca1362fe946082b7aa0cd9be844&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">str</a>(<a href=\"javascript:void(0)\" data-symbol=\"len\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/abstract_8h.html#abc8b352d6723c361fc39710e5b10b502&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">len</a>(cl))</pre></div> \n\
               <p><a name=\"GUID-D7F3E285-D2B6-4E5D-B565-DE0AEA347ED8\"></a>For more information, see the <span class=\"filePath\" translate=\"no\">BasicOperations/FindObjectsWithWildcard.py</span> sample as well as the <span class=\"code\" translate=\"no\">pyfbsdk.FBFindObjectsByName()</span> documentation. \n\
               </p> \n\
            </div> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_CF95C98BBD694764BAB5B35A1941014D\"></a> \n\
            <h2><a name=\"GUID-4FDDED53-72CA-4E05-9814-363D38E1E973\"></a>Properties\n\
            </h2> \n\
            <p><a name=\"GUID-2FFFB411-4040-4F38-989D-F60B74DAE92B\"></a>Each instance of an <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_component.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent</a></span> contains a list of properties (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBProperty\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_property.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_property.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBProperty</a></span>), accessible through <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent.PropertyList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_component.html#a8a4fc4a031d937704ae36899e10cb6d1&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent.PropertyList</a></span>. Properties are used to specify an object\'s data attributes such as, the translation,\n\
               rotation and scaling information of a cube. For more information, see <span class=\"char_link\"><a href=\"#!/url=./files/GUID-7871AFE8-5209-4377-B4B4-2881840E7EDF.htm\">FBProperty - Object Properties</a></span>. \n\
            </p> \n\
            <p><a name=\"GUID-2F08E2D4-DFA1-4866-9AF3-90013E594647\"></a>The following Python example prints the name and data of each property for a newly\n\
               created cube (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBModel\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_model.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_model.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModel</a></span>). The <span class=\"code\" translate=\"no\">try/except</span> block within the <span class=\"code\" translate=\"no\">for</span> loop lets the program continue its execution if <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"str\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/node_8h.html#a62b34ca1362fe946082b7aa0cd9be844&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">str</a>(p.Data)</span> causes an exception due to the lack of a string representation. \n\
            </p> \n\
            <div class=\"codeBlock\"><pre class=\"prettyprint\">from pyfbsdk import *\n\
\n\
cube = <a href=\"javascript:void(0)\" data-symbol=\"FBModelCube\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_f_b_model_cube.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBModelCube</a>(\'Cube\')\n\
propertyList = cube.PropertyList\n\
for <a href=\"javascript:void(0)\" data-symbol=\"p\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/floatobject_8h.html#af18a92ce774f4c499544fbcc894db7e8&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">p</a> in propertyList:\n\
    try:\n\
        print \'Name: \"\' + p.Name + \'\", Data: [\' + <a href=\"javascript:void(0)\" data-symbol=\"str\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/node_8h.html#a62b34ca1362fe946082b7aa0cd9be844&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">str</a>(p.Data) + \']\'\n\
    except Exception:\n\
        pass\n\
\n\
cube.FBDelete()</pre></div> \n\
            <p><a name=\"GUID-C6F91BA5-4383-437C-BF47-9C32FD808522\"></a> \n\
               <div><a name=\"GUID-388F7474-783C-4172-B575-341CC49198D1\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span><span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_component.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBProperty\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_property.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_property.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBProperty</a></span> both inherit from <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_plug.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBPlug</a></span>. This inheritance enables instances of <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBComponent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_component.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_component.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBComponent</a></span> and <span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBProperty\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_property.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_property.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBProperty</a></span> to connect with one another at runtime. For more information, see the <span class=\"char_link\"><a href=\"#!/url=./files/GUID-A214721A-1E8F-4F00-ADDC-F5A420F9BF29.htm\">FBPlug - Object Connection Management</a></span> topic. \n\
                  </div>\n\
               </div> \n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";