var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-EBB95B3D-E75B-4033-ABB4-29EE7B1F9F4A\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Custom Renderer API</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-EBB95B3D-E75B-4033-ABB4-29EE7B1F9F4A\"></a><div class=\"head\">\n\
            <h1>Custom Renderer API</h1>\n\
         </div>\n\
         <p><a name=\"GUID-1C9C7624-E068-4CC5-919A-31B6100118BB\"></a>You can use the custom renderer to replace the default renderer by integrating an\n\
            OpenGL based shader plug-in into the MotionBuilder viewport. You can use this feature\n\
            to develop your own rendering solution that suits your requirements. \n\
         </p>\n\
         <div class=\"section\"><a name=\"SECTION_77742A6CC60049EAB91480EEB8E2A6BF\"></a> \n\
            <h2><a name=\"GUID-9DAAFF4B-A44B-4E07-84C3-55062F862F06\"></a>Quick Start\n\
            </h2> \n\
            <p><a name=\"GUID-5AF4BAE9-D713-4BD0-AA91-8A6F75E52E7E\"></a>To quickly start using the custom renderer feature: \n\
            </p> <a name=\"OL_F9C436D8659D440E85438CDFA65B83D0\"></a><ol type=\"1\" start=\"1\">\n\
               <li>Copy the <span class=\"filePath\" translate=\"no\">CustomRenderer</span> sample from <span class=\"code\" translate=\"no\">&lt;yourinstallationfolder&gt;/OpenRealitySDK/samples/shaders/CustomRenderer</span> to another folder and modify the project setting or source code accordingly. \n\
                  <div><a name=\"GUID-B94E56D6-2DA3-49BF-8700-43B80C45559E\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Copying the sample to another folder is optional. \n\
                     </div>\n\
                  </div> \n\
               </li>\n\
               <li>Compile and build the sample project in your development environment. \n\
                  <p><a name=\"GUID-F1827818-1C99-4A32-B502-B7097BC1EAA8\"></a>After the project is built successfully, the resulting library is saved in <span class=\"filePath\" translate=\"no\">&lt;yourinstallationfolder&gt;/bin/x64/plugins</span>. Make sure that you have <em class=\"mild\">write</em> access to this folder, or configure the Visual Studio project setting (or Makefile\n\
                     in Linux) and specify the destination folder as one of the additional plug-in directories.\n\
                     You can add additional plug-in paths either by setting the <span class=\"code\" translate=\"no\">MOTIONBUILDER_PLUGIN_PATH</span> environment variable or by using the Preferences dialog as shown in the following\n\
                     figure. \n\
                  </p> <a name=\"FIG_6E723042A07C4321B5B77F96FD97A653\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-FEE560B7-B36B-4156-AE88-FA89A1276160-low.png\"></div> \n\
                  <p><a name=\"GUID-A7AF1AE8-1836-48C0-A790-E4A84DFF515B\"></a>The plug-ins that are saved in these specified folders are automatically loaded at\n\
                     startup. \n\
                  </p> \n\
               </li>\n\
               <li>Run MotionBuilder. An additional Renderer menu appears. You can choose a method for\n\
                  rendering the scene as shown in the following figure. \n\
                  <p><a name=\"GUID-80C6F22D-F70E-47F9-9773-68DBCE3DF225\"></a> <a name=\"FIG_48B20B6F0F924A9C8901ECA405348397\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-99659A4B-65F9-4F9A-80C8-942AE60D78B9-low.png\"></div> \n\
                  </p> \n\
               </li>\n\
            </ol> \n\
            <p><a name=\"GUID-131A49EA-44A8-4080-9E5A-71EA78C4D9EF\"></a>For more information about accessing the custom renderer, see <span class=\"char_link\"><a href=\"#!/url=./files/GUID-0D3D5186-8BA1-433A-A7B0-44E7C10DD352.htm\">Accessing the Custom Renderer in the User Interface</a></span>. \n\
            </p> \n\
         </div><span class=\"noindex\">\n\
            <div class=\"topic-list\">\n\
               <h4 class=\"related\">Topics in this section</h4>\n\
               <ul class=\"jumplist\">\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-22FAEE30-201E-421A-98B7-2BB5F5175455.htm\">Overview of the Architecture</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-0D3D5186-8BA1-433A-A7B0-44E7C10DD352.htm\">Accessing the Custom Renderer in the User Interface</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-F1549E8A-3281-4CD6-B3B7-DB5687B7994E.htm\">About the SDK Components</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-1E06CAC4-A61A-41A6-8B61-47128DF7355F.htm\"> Using Python to Implement a Custom Renderer</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-9094779E-7DD4-4D4F-9F71-1F04603938C9.htm\">Updated Objects</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-1C21349C-A4B9-454E-BB9A-CF5689801D03.htm\">Viewport Picking, Selection, and Manipulation</a></li>\n\
                  <li class=\"topiclist-litem\"><a href=\"#!/url=./files/GUID-5A09D53A-B7A1-4099-B81C-21F83A64CDB1.htm\">Offline Rendering</a></li>\n\
               </ul>\n\
            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";