var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-EEDEA4B7-EB09-4FBC-8F30-245328763D0D\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>MotionBuilder C++ API</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-EEDEA4B7-EB09-4FBC-8F30-245328763D0D\"></a><div class=\"head\">\n\
            <h1>MotionBuilder C++ API</h1>\n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_CBF9B6E94F4042009996907C41D836C1\"></a> \n\
            <h2><a name=\"GUID-347BA848-A245-4422-9D08-3A90F815B443\"></a>MotionBuilder C++ API\n\
            </h2> \n\
            <p><a name=\"GUID-4E8188F4-172C-4085-8D5F-DDCD9E08527C\"></a>The MotionBuilder C++ API is contained in the <em class=\"strong\">Open Reality SDK</em> (<em class=\"strong\">ORSDK</em>). This C++ API provides access to MotionBuilder\'s native user interface tools, as\n\
               well as most of the application\'s functionality. To run a C++ program in MotionBuilder,\n\
               its code must be compiled as a Dynamically Linked Library (<span class=\"filePath\" translate=\"no\">.dll</span>) and placed in MotionBuilder\'s plugin directory. At startup, MotionBuilder loads\n\
               these <span class=\"filePath\" translate=\"no\">.dll</span> files and executes them as plugins. \n\
            </p> \n\
            <p><a name=\"GUID-585AC6A7-DA79-4AE9-B677-DE4ECA611B21\"></a>For more information on getting started with C++ and MotionBuilder, including how\n\
               to set up a Visual Studio project, see <span class=\"char_link\"><a href=\"#!/url=./files/GUID-8338E373-7DA9-4A7D-BC96-941E2D89AAFC.htm\">Using C++ with MotionBuilder</a></span>. \n\
            </p> \n\
         </div>\n\
         <div class=\"section\"><a name=\"SECTION_25B0BC4711B443FBA3B00B84431B8751\"></a> \n\
            <h2><a name=\"GUID-25E3B8B2-B047-4DD2-8FA3-D2D174D49449\"></a>Why would I want to use C++ with MotionBuilder?\n\
            </h2> \n\
            <p><a name=\"GUID-6EBEEF83-1086-473A-8986-D8DA9E1841F8\"></a>For tasks which require high computational performance, C++ code is generally better\n\
               suited than Python code. \n\
            </p> \n\
            <p><a name=\"GUID-90EDBA01-759C-4D77-9E58-97B6F6A8B001\"></a>In terms of the MotionBuilder SDK, more classes and functions are exposed in its C++\n\
               API. For example, custom device as well as manipulator creation is only available\n\
               through the Open Reality SDK. \n\
            </p> \n\
            <p><a name=\"GUID-69606BB8-C08C-4FD3-9FFD-A2AC92DC3C1A\"></a>Another advantage to using the C++ API is that it can invoke Python scripts. Conversely,\n\
               Python scripts cannot execute C++ plugins in MotionBuilder. \n\
            </p> \n\
         </div>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";