var topic = "<!DOCTYPE html>\n\
\n\
<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script>\n\
      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n\
      <meta name=\"product\" content=\"MOBPRO\">\n\
      <meta name=\"release\" content=\"2019\">\n\
      <meta name=\"book\" content=\"Developer\">\n\
      <meta name=\"created\" content=\"2019-01-07\">\n\
      <meta name=\"topicid\" content=\"GUID-FD33DF70-9E1E-47E8-8F0D-D2680D75D736\">\n\
      <meta name=\"topic-type\" content=\"concept\">\n\
      <title>Transferring Animation from Markers to a Character</title></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><script language=\"javascript\">var index = \'index.html\';</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/ac_common.js\"); });</script><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script>$(\"div#WidgetFloaterPanels,link[href*=\'microsofttranslator.com\'],script[src*=\'microsofttranslator.com\'],script[src*=\'bing.com\']\").remove();</script><script type=\'text/javascript\'>$(\"div#navigation,div#breadcrumbs,div#banner\").attr(\"translate\",\"no\"); var mtLocation = ((location && location.href && location.href.indexOf(\'https\') == 0)?\'https://ssl.microsofttranslator.com\':\'http://www.microsofttranslator.com\')+\'/ajax/v3/WidgetV3.ashx?ctf=True&ui=true&settings=Manual&from=en&hidelanguages=\'; yepnope.injectJs(mtLocation, function() {}, { charset:\'utf-8\', type:\'text/javascript\' } );</script><script></script><script></script><!-- begin MT -->\n\
            \n\
            <div id=\'MicrosoftTranslatorWidget\' class=\'Dark\' style=\'float:right;z-index:100;color:white;background-color:#bbbbbb;height:58px;overflow:hidden\'></div><div id=\"reflinkdiv\"></div>\n\
      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-FD33DF70-9E1E-47E8-8F0D-D2680D75D736\"></a><div class=\"head\">\n\
            <h1>Transferring Animation from Markers to a Character</h1>\n\
         </div>\n\
         <p><a name=\"GUID-EB10A26B-7DEB-4D2A-B69A-1932519A7568\"></a> An actor (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBActor\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_actor.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_actor.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBActor</a></span>) connects the animation data from a source (for example, an optical motion capture\n\
            device or marker) to a character (<span class=\"code\" translate=\"no\"><a href=\"javascript:void(0)\" data-symbol=\"FBCharacter\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_o_r_s_d_k2019_1_1_f_b_character.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;},{&quot;path&quot;:&quot;py_ref/class_f_b_character.html&quot;,&quot;title&quot;:&quot;Python API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../&quot;}]\">FBCharacter</a></span>). The actor converts the positional information from the marker into joint rotations\n\
            that are retargeted onto a character. Actor is a kind of constraint between the source\n\
            data and the character. \n\
         </p>\n\
         <p><a name=\"GUID-D3D6B75A-F216-4D13-9669-328F7CE81D72\"></a>To follow the instructions in this topic, download the files and script from <a href=\"http://area.autodesk.com/downloads/scripts/motionbuilder-animation-scripts\" target=\"_blank\">http://area.autodesk.com/downloads/scripts/motionbuilder-animation-scripts</a>. \n\
         </p>\n\
         <p><a name=\"GUID-BBBD9C84-9837-4107-926A-22BC554CD183\"></a> Open the <span class=\"filePath\" translate=\"no\">ActorDrivedByMarkers.fbx</span> file and run the <span class=\"filePath\" translate=\"no\">character_animation_from_markerset.py</span> script step by step as explained in the following section to understand how to transfer\n\
            the animation from an actor and marker set to a character. <a name=\"OL_C8E843558BB745EF8622E5E7A8724227\"></a><ol type=\"1\" start=\"1\">\n\
               <li>Create a skeleton from the actor. <span class=\"code\" translate=\"no\">CreateSkeletonForActor(pActor,pPrefix)</span> creates a skeleton as shown in the following figure. <a name=\"FIG_3B9A40C0E3364298809D599B7918300C\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-823B49A1-6196-4CA1-A66B-8585AB66B9C7-low.png\"></div> \n\
               </li>\n\
               <li>Set up the characterization and lock the character. <span class=\"code\" translate=\"no\">CharacterizeActorSkeleton(pPrefix)</span> characterizes the skeleton. <a name=\"FIG_4AF5798FD86F4A4098E1EF647C1A084B\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-3A0FADCF-6370-447F-8556-966113D7798A-low.png\"></div> \n\
               </li>\n\
               <li>Prepare for snap. <a name=\"OL_59CD0D5CCCFA4C868B3FEB43B2923D2D\"></a><ol type=\"1\" start=\"1\">\n\
                     <li>Move the cursor forward so that the skeleton is not following the actor. <a name=\"FIG_E82E1F5181A447FCAD52AB110090AA93\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-BA772A39-8AFE-4F0E-AC82-1BD88DECC23F-low.png\"></div> \n\
                     </li>\n\
                     <li>Run <span class=\"code\" translate=\"no\">ApplyStateFor(lChar, pActor.GetCurrentSkeletonState(False))</span> to link the current state of the actor to the current state of the character. Then,\n\
                        the skeleton must be driven using the actor. <a name=\"FIG_670E55A328DB4DE18B4ECEF4BDA099EE\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-625E554B-0C77-419E-8CA5-6BF484377CE1-low.png\"></div> \n\
                        <p><a name=\"GUID-53BB0A37-C8EE-4CB3-A463-54F6034263D5\"></a> \n\
                           <div><a name=\"GUID-DACFC55F-08A2-45FB-8DF1-248B37E30AE7\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>State is a collection of transformation of all joints. Joints can be from an actor,\n\
                                 skeleton, FK, or IK. \n\
                              </div>\n\
                           </div> \n\
                        </p> \n\
                     </li>\n\
                  </ol> \n\
               </li>\n\
               <li>Snap markers on the character marker set. Initially, there is no marker for the character\n\
                  as shown in the following figure. <a name=\"FIG_252D468A0BDD466997AEE031897357A3\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-85C0D9B3-B609-4383-BCF4-42150C2ECA41-low.png\"></div> \n\
                  <p><a name=\"GUID-EECFC2F2-C9D0-407E-9A06-A2DBF3FC034D\"></a><span class=\"code\" translate=\"no\">CopyMarkerMappingFromActorToCharacter(lChar, pActor)</span> creates a marker set for the character, then snaps the actor’s markers to the character’s\n\
                     marker set. It uses <span class=\"code\" translate=\"no\">lMarkersProp.ConnectSrc(lMarker)</span> to connect the character\'s marker property with the actor’s marker. The actor’s marker\n\
                     is the driving source. The character marker set is shown in the following figure.\n\
                     <a name=\"FIG_F2436321FF1C4CE3B6E38150ECA8EF22\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-9508835E-BFF9-437F-8B75-6D334B07E38B-low.png\"></div> \n\
                  </p> \n\
               </li>\n\
               <li>Set the character marker as the input. Then, set the character\'s input to its character\n\
                  marker set that is created in the previous step, and set the input as active. <a name=\"FIG_DCEEC6C391084B9CA9BFE53B0ADE849B\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-3A5DECEC-CE73-4A04-B4E4-6E110DDE9EAD-low.png\"></div> \n\
               </li>\n\
               <li>Plot the animation to the skeleton. You can play the character with the animation.\n\
                  However, the character\'s skeleton does not contain the animation. You can select the\n\
                  hip of the skeleton to see that there is no animation. <a name=\"FIG_F574157E40E043B4A7C74AB93E44D8B6\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-D67B0A0D-BCDD-4C30-9A66-582082C84867-low.png\"></div> \n\
                  <p><a name=\"GUID-B9003078-B85B-4241-8BE4-8D752F567170\"></a><span class=\"code\" translate=\"no\">lChar.PlotAnimation()</span> can plot the animation to the character’s skeleton or control rig. Running this step\n\
                     plots the animation to the skeleton. <a name=\"FIG_ECBC564CFC9F48E097E32412BBCF6BA5\"></a><div class=\"figure-anchor\"><img src=\"images/GUID-4AB33462-6099-4738-97C1-9EF1129C4AA7-low.png\"></div> \n\
                  </p> \n\
                  <p><a name=\"GUID-37D46566-0956-4BD9-8584-5B6B2F1228EB\"></a>Now, the skeleton contains the animation that you can export as an animation clip.\n\
                     \n\
                  </p> \n\
               </li>\n\
            </ol> \n\
         </p>\n\
         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n\
   </div></body>\n\
</html>";